# PyGFN0

This is a Python version for [GFN0-xTB](https://github.com/pprcht/gfn0) based on F2PY.

---

## Usage

There is an `ase.Calculator` subclass termed `GFN0` for non-PBC system. And a more low function called `gfn0` can be found in [the code](https://github.com/LiuGaoyong/PyGFNFF/blob/main/pygfn0/_pygfn0.py).

```python
from ase import Atoms
from ase.build import molecule
from ase.optimize import BFGS
from scipy.spatial.distance import pdist

from pygfn0 import GFN0

atoms = Atoms(molecule("CO"), calculator=GFN0())
opt = BFGS(atoms, logfile="-", trajectory=None)
opt.run(fmax=0.03, steps=50)
print(f"Energy: {e:.3f}eV")
print(f"C=O Length: {bl:.3f}\u212b")

# Output:
#       Step     Time          Energy          fmax
# BFGS:    0 21:48:56     -145.434618        3.546420
# BFGS:    1 21:48:56     -145.184501        9.984024
# BFGS:    2 21:48:56     -145.493902        0.833465
# BFGS:    3 21:48:56     -145.496822        0.175982
# BFGS:    4 21:48:56     -145.496955        0.004404
# Energy: -145.497eV
# C=O Length: 1.116Å
```



### Reference

1. P. Pracht, S. Grimme, et.al. A Robust Non-Self-Consistent Tight-Binding Quantum Chemistry Method for large Molecules (2019), DOI: https://doi.org/10.26434/chemrxiv.8326202.v1
2. A standalone library of the GFN-FF method. https://github.com/pprcht/gfn0/

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!

!> Non-polar solvent accessible surface area model
module solvation_solv_sasa
   use iso_fortran_env, only : wp => real64
   implicit none
   private

   public :: compute_numsa

   !> Smoothing dielectric function parameters
   real(wp), parameter :: autoaa = 0.52917726_wp
   real(wp), parameter :: aatoau = 1.0_wp / autoaa
   real(wp), parameter :: w = 0.3_wp*aatoau
   real(wp), parameter :: w3 = w*(w*w)
   real(wp), parameter :: ah0 = 0.5_wp
   real(wp), parameter :: ah1 = 3._wp/(4.0_wp*w)
   real(wp), parameter :: ah3 = -1._wp/(4.0_wp*w3)

   !> real space cut-offs
   real(wp), parameter :: tolsesp=1.e-6_wp

contains


subroutine compute_numsa(nat, nnsas, nnlists, xyz, vdwsa, &
      & wrp, trj2, angWeight, angGrid, sasa, dsdrt)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of neighbours to consider
   integer, intent(in) :: nnsas(:)

   !> Neighbourlist
   integer, intent(in) :: nnlists(:, :)

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   !> Van-der-Waals radii including probe radius of solvent
   real(wp), intent(in) :: vdwsa(:)

   !> Radial weights for the numerical integration
   real(wp), intent(in) :: wrp(:)

   !> Radial smoothing function
   real(wp), intent(in) :: trj2(:, :)

   !> Angular weights for the numerical integration
   real(wp), intent(in) :: angWeight(:)

   !> Angular grid for each atom
   real(wp), intent(in) :: angGrid(:, :)

   !> Surface area for each atom, including surface tension
   real(wp), intent(out) :: sasa(:)

   !> Derivative of surface area w.r.t. cartesian coordinates
   real(wp), intent(out) :: dsdrt(:, :, :)

   integer :: iat, jat, ip, jj, nnj, nnk, nni, nno
   real(wp) :: rsas, sasai, xyza(3), xyzp(3), sasap, wr, wsa, drjj(3)
   real(wp), allocatable :: grds(:, :), grads(:, :)
   integer, allocatable :: grdi(:)

   sasa(:) = 0.0_wp
   dsdrt(:, :, :) = 0.0_wp

   ! allocate space for the gradient storage
   allocate(grads(3,nat), source = 0.0_wp)
   allocate(grds(3,maxval(nnsas)))
   allocate(grdi(maxval(nnsas)))

   !$omp parallel do default(none) shared(sasa, dsdrt) &
   !$omp shared(nat, vdwsa, nnsas, xyz, wrp, angGrid, angWeight, nnlists, trj2) &
   !$omp private(iat, rsas, nno, grads, sasai, xyza, wr, ip, xyzp, wsa, &
   !$omp& sasap, jj, nni, nnj, grdi, grds, drjj)
   do iat = 1, nat

      rsas = vdwsa(iat)
      nno = nnsas(iat)

      ! initialize storage
      grads = 0.0_wp
      sasai = 0.0_wp

      ! atomic position
      xyza(:) = xyz(:,iat)
      ! radial atomic weight
      wr = wrp(iat)

      ! loop over grid points
      do ip = 1, size(angGrid, 2)
         ! grid point position
         xyzp(:) = xyza(:) + rsas*angGrid(1:3,ip)
         ! atomic surface function at the grid point
         call compute_w_sp(nat, nnlists(:nno, iat), trj2, vdwsa, xyz, nno, xyzp, &
            & sasap, grds, nni, grdi)

         if(sasap.gt.tolsesp) then
            ! numerical quadrature weight
            wsa = angWeight(ip)*wr*sasap
            ! accumulate the surface area
            sasai = sasai + wsa
            ! accumulate the surface gradient
            do jj = 1, nni
               nnj = grdi(jj)
               drjj(:) = wsa*grds(:,jj)
               grads(:,iat) = grads(:,iat)+drjj(:)
               grads(:,nnj) = grads(:,nnj)-drjj(:)
            end do
         end if
      end do

      sasa(iat) = sasai
      dsdrt(:,:,iat) = grads

   end do

end subroutine compute_numsa


pure subroutine compute_w_sp(nat,nnlists,trj2,vdwsa,xyza,nno,xyzp,sasap,grds, &
      &                      nni,grdi)
   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: nnlists(nno)
   integer, intent(in)  :: nno
   integer, intent(out) :: nni
   real(wp),intent(in)  :: xyza(3,nat)
   real(wp),intent(in)  :: xyzp(3)
   real(wp),intent(out) :: sasap
   real(wp),intent(out) :: grds(3,nno)
   integer, intent(out) :: grdi(nno)
   real(wp),intent(in)  :: trj2(2,nat)
   real(wp),intent(in)  :: vdwsa(nat)

   integer  :: i,ia
   real(wp) :: tj(3),tj2,sqtj
   real(wp) :: uj,uj3,ah3uj2
   real(wp) :: sasaij,dsasaij

   ! initialize storage
   nni=0
   sasap=1.0_wp
   do i = 1, nno
      ia = nnlists(i)
      ! compute the distance to the atom
      tj(:)=xyzp(:)-xyza(:,ia)
      tj2=tj(1)*tj(1)+tj(2)*tj(2)+tj(3)*tj(3)
      ! if within the outer cut-off compute
      if(tj2.lt.trj2(2,ia)) then
         if(tj2.le.trj2(1,ia)) then
            sasap=0.0_wp
            return
         else
            sqtj = sqrt(tj2)
            uj = sqtj - vdwsa(ia)
            ah3uj2 = ah3*uj*uj
            dsasaij = ah1+3.0_wp*ah3uj2
            sasaij =  ah0+(ah1+ah3uj2)*uj

            ! accumulate the molecular surface
            sasap = sasap*sasaij
            ! compute the gradient wrt the neighbor
            dsasaij = dsasaij/(sasaij*sqtj)
            nni=nni+1
            grdi(nni)=ia
            grds(:,nni) = dsasaij*tj(:)
         endif
         ! check if the point is already buried
!        if(sasap.lt.tolsesp) return
      endif
   enddo

end subroutine compute_w_sp


end module solvation_solv_sasa

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module eeq_module
!> Implementation of the electronegativity equilibration model
   use iso_fortran_env, only: wp=>real64
   use gfn0_math_wrapper
#ifdef WITH_GBSA
   use solvation_solv_gbsa, only: TBorn
#endif
   implicit none
   private

   public :: chargeEquilibration

   real(wp),private,parameter :: pi=3.1415926535897932385_wp
   real(wp),private,parameter :: sqrtpi  = sqrt(pi)

contains
!========================================================================================!
subroutine chargeEquilibration(nat, at, xyz, chrg, cn, dcndr, &
      & chi, kcn, gam, rad,&
      & energy, gradient, qat, dqdr &
#ifdef WITH_GBSA
      & ,gbsa,gsolv & 
#endif
      & )


   !> Source for error generation
   character(len=*), parameter :: source = 'eeq_chargeEquilibration'

   !> Number of atoms
   integer, intent(in) :: nat
   !> Atom types via the atomic number
   integer, intent(in) :: at(nat)
   !> Cartesian coordinates (a.u.)
   real(wp),intent(in) :: xyz(3,nat)
   !> Molecular charge
   integer, intent(in) :: chrg

   !> Electronegativity of each species 
   real(wp), intent(in) :: chi(:)
   !> Coordination number dependence of each species
   real(wp), intent(in) :: kcn(:)
   !> Chemical hardness of each species
   real(wp), intent(in) :: gam(:)
   !> Shell/Atomic hardnesses for each species (referred as 'alpha' in older versions)
   real(wp), intent(in) :: rad(:)
   !> Coordination number
   real(wp), intent(in) :: cn(:)
   !> Derivative of the coordination number w.r.t. Cartesian coordinates
   real(wp), intent(in) :: dcndr(:, :, :)
#ifdef WITH_GBSA
   !> GBSA/ALPB object
   type(TBorn),intent(inout),optional :: gbsa 
   real(wp),intent(inout),optional    :: gsolv
#endif
   !> Electrostatic energy
   real(wp), intent(inout), optional :: energy
   !> Molecular gradient
   real(wp), intent(inout), optional :: gradient(:, :)
   !> Atomic partial charges
   real(wp), intent(out), optional :: qat(:)
   !> Derivative of the partial charges w.r.t. Cartesian coordinates
   real(wp), intent(out), optional :: dqdr(:, :, :)

   real(wp), allocatable :: jmat(:, :), inv(:, :)
   real(wp), allocatable :: djdr(:, :, :), djdtr(:, :)
   real(wp), allocatable :: xvec(:), qvec(:), dxdcn(:), shift(:)
   real(wp), allocatable :: dxdr(:, :, :)
   logical :: deriv, response, exitRun
   integer :: nsh, ndim
   integer :: iat, ish, ii, iid
   real(wp) :: tmp,gborn,ghb

   deriv = present(gradient)
   response = present(dqdr)
   !nsh = sum(coulomb%itbl(2, :))
   nsh = nat
   ndim = nsh + 1
   allocate(jmat(ndim, ndim))
   allocate(xvec(ndim))
   allocate(qvec(ndim))
   allocate(dxdcn(nsh))

   call getCoulombMatrixSmeared(nat, at, xyz, rad, jmat)


   do iat = 1, nat
      iid = at(iat) !> atom type
      tmp = kcn(iid) / (sqrt(cn(iat)) + 1.0e-14_wp)
      xvec(iat) = -chi(iid) + tmp*cn(iat)
      dxdcn(iat) = 0.5_wp*tmp
      jmat(iat, iat) = jmat(iat, iat) + gam(iid)
      jmat(iat, ndim) = 1.0_wp
      jmat(ndim, iat) = 1.0_wp
   end do

#ifdef WITH_GBSA
   !> add BornMat
   if(present(gbsa))then
    jmat(:nat, :nat) = jmat(:nat, :nat) + gbsa%bornMat
   endif
#endif
   xvec(ndim) = float(chrg)
   jmat(ndim, ndim) = 0.0_wp

   inv = jmat
   if (response) then
      call solve_sytri(inv, xvec, qvec)
   else
      call solve_sysv(inv, xvec, qvec)
   end if

   if (present(qat)) then
      qat(:) = 0.0_wp
      do iat = 1, nat
        qat(iat) = qat(iat) + qvec(iat)
      end do
   end if

   if (present(energy)) then
      shift = xvec
      call symv(jmat, qvec, shift, alpha=0.5_wp, beta=-1.0_wp)
      energy = energy + dot(qvec, shift)
   end if

   if (deriv .or. response) then
      allocate(djdr(3, nat, ndim))
      allocate(djdtr(3, ndim))
!      allocate(dxdr(3, nat, ndim))
      call getCoulombDerivsSmeared(nat, at, xyz, rad, qvec, djdr, djdtr)
      do iat = 1, nat
!        dxdr(:, :, iat) = -dxdcn(iat)*dcndr(:, :, iat)
         djdr(:,:,iat) = djdr(:,:,iat) - dxdcn(iat)*dcndr(:, :, iat)
      end do
!      dxdr(:, :, ndim) = 0.0_wp

#ifdef WITH_GBSA
     !> implicit solvation contribution 
     if(present(gbsa))then
     call gbsa%addBornDeriv(qvec, gborn, ghb, djdr, djdtr)
     if(present(gsolv))then
     gsolv = gsolv + gborn + ghb + gbsa%gshift
     endif
     endif   
#endif

      if (present(gradient)) then
         call contract(djdr, qvec, gradient, beta=1.0_wp) !>contract312
!         call contract(dxdr, qvec, gradient, beta=1.0_wp) !>contract312
      end if

      if (response) then
         do iat = 1, nat
           djdr(:, iat, iat) = djdr(:, iat, iat) + djdtr(:, iat)
         end do

         if (present(dqdr)) then
            dqdr(:, :, :) = 0.0_wp
            call contract(djdr, inv(:, :nsh), dqdr, alpha=-1.0_wp, beta=0.0_wp) !>contract323
!            call contract(dxdr, inv(:, :nsh), dqdr, alpha=-1.0_wp, beta=1.0_wp) !>contract323
         end if

      end if
   end if

end subroutine chargeEquilibration


!========================================================================================!
subroutine solve_sysv(mat, rhs, vec)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_sysv'

   real(wp), intent(inout) :: mat(:, :)

   real(wp), intent(in) :: rhs(:)

   real(wp), intent(out), target :: vec(:)

   integer :: lwork, ndim, info
   real(wp), pointer :: ptr(:, :)
   real(wp) :: test(1)
   real(wp), allocatable :: work(:)
   integer, allocatable :: ipiv(:)

   ndim = size(mat, dim=1)
   if (size(mat, dim=2) < ndim .or. size(vec) < ndim .or. size(rhs) < ndim) then
      write(0,'(a,1x,a)')"A not so carefully crafted algorithm did mess up", source
      return
   end if

   vec(:ndim) = rhs(:ndim)
   allocate(ipiv(ndim))
   ptr(1:ndim, 1:1) => vec(1:ndim)

   ! assume work space query, set best value to test after first dsysv call
   call dsysv('l', ndim, 1, mat, ndim, ipiv, ptr, ndim, test, -1, info)
   lwork = int(test(1))
   allocate(work(lwork))

   call dsysv('l', ndim, 1, mat, ndim, ipiv, ptr, ndim, work, lwork, info)

   if (info > 0) then
      write(0,'(a,1x,a)')"LAPACK linear equation solver failed", source
      return
   end if

   deallocate(work)
   deallocate(ipiv)
end subroutine solve_sysv


!========================================================================================!
subroutine solve_sytri(mat, rhs, vec)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_sytri'

   real(wp), intent(inout) :: mat(:, :)

   real(wp), intent(in) :: rhs(:)

   real(wp), intent(out), target :: vec(:)

   integer :: ndim
   logical :: exitRun

   ndim = size(mat, dim=1)
   if (size(mat, dim=2) < ndim .or. size(vec) < ndim .or. size(rhs) < ndim) then
      write(0,'(a,1x,a)')"A not so carefully crafted algorithm did mess up", source 
      return
   end if

   call invert_sytri(mat)

   call symv(mat, rhs, vec)

end subroutine solve_sytri

!========================================================================================!
subroutine invert_sytri(mat)

   !> Source for error generation
   character(len=*), parameter :: source = 'eeq_sytri'

   real(wp), intent(inout) :: mat(:, :)

   integer :: ii, jj
   integer :: lwork, ndim, info
   real(wp) :: test(1)
   real(wp), allocatable :: work(:)
   integer, allocatable :: ipiv(:)

   ndim = size(mat, dim=1)
   if (size(mat, dim=2) < ndim) then
      write(0,'(a,1x,a)')"A not so carefully crafted algorithm did mess up", source
      return
   end if

   allocate(ipiv(ndim))

   ! assume work space query, set best value to test after first dsytrf call
   call lapack_sytrf('L', ndim, mat, ndim, ipiv, test, -1, info)
   lwork = int(test(1))
   allocate(work(lwork))

   ! Bunch-Kaufman factorization A = L*D*L**T
   call lapack_sytrf('L', ndim, mat, ndim, ipiv, work, lwork, info)
   if(info > 0)then
      write(0,'(a,1x,a)') 'Bunch-Kaufman factorization failed', source
      return
   endif

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in matrix
   ! matrix is overwritten with lower triangular part of A⁻¹
   call lapack_sytri('L', ndim, mat, ndim, ipiv, work, info)
   if (info > 0) then
      write(0,'(a,1x,a)') 'Bunch-Kaufman inversion failed', source
      return
   endif

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do ii = 1, ndim
      do jj = ii+1, ndim
         mat(ii,jj) = mat(jj,ii)
      enddo
   enddo

   deallocate(work)
   deallocate(ipiv)
end subroutine invert_sytri

!========================================================================================!
!> subroutine getCoulombMatrix
!> Compute all elements |r_ij|⁻¹
subroutine getCoulombMatrix(nat, xyz, jmat)
   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp),intent(in) :: xyz(3,nat)
   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   integer :: iat, jat, ish, jsh, ii, jj
   real(wp) :: r1, rterm
   jmat(:, :) = 0.0_wp

   !$omp parallel do default(none) shared(nat, xyz, jmat) &
   !$omp private(iat, jat, r1, rterm)
   do iat = 1, nat
      do jat = 1, iat-1
         r1 = sqrt(sum((xyz(:, jat) - xyz(:, iat))**2))
         rterm = 1.0_wp/r1
         jmat(jat, iat) = rterm
         jmat(iat, jat) = rterm
      end do
   end do
   !$omp end parallel do
end subroutine getCoulombMatrix
!> subroutine getCoulombMatrixSmeard
!> Compute all elements of the Coulomb matrix with smeard Gaussian charges
subroutine getCoulombMatrixSmeared(nat, at, xyz, rad, jmat)

   !> Number of atoms
   integer, intent(in) :: nat
   !> Atomic types by atom number
   integer, intent(in) :: at(nat)
   !> Cartesian coordinates
   real(wp),intent(in) :: xyz(3,nat)

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: rad(:)

   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   integer :: iat, jat, ish, jsh, ii, jj, iid, jid
   real(wp) :: r1, rterm, gij

   jmat(:, :) = 0.0_wp

   !$omp parallel do default(none) shared(nat, at, xyz, rad, jmat) &
   !$omp private(iat, jat, iid, jid, r1, rterm, gij)
   do iat = 1, nat
      iid = at(iat)
      do jat = 1, iat-1
         jid = at(jat)
         r1 = sqrt(sum((xyz(:, jat) - xyz(:, iat))**2))
         gij = 1.0_wp/sqrt(rad(iid)**2 + rad(jid)**2)
         rterm = erf(gij*r1)/r1
         jmat(jat, iat) = rterm
         jmat(iat, jat) = rterm
      end do
      gij = sqrt(0.5_wp)/rad(iid)
      jmat(iat, iat) = 2.0_wp/sqrtpi*gij
   end do
   !$omp end parallel do

end subroutine getCoulombMatrixSmeared


!========================================================================================!
!> subroutine getCoulombDerivs
!> Compute all derivaties ∂(q_j|r_ij|⁻¹)/∂r_i 
subroutine getCoulombDerivs(nat, xyz, qvec, djdr, djdtr)

   !> Number of atoms
   integer, intent(in) :: nat
   !> Cartesian coordinates
   real(wp),intent(in) :: xyz(3,nat)

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   integer :: iat, jat, ish, jsh, ii, jj
   real(wp) :: r1, vec(3), dG(3), dS(3, 3)

   djdr(:, :, :) = 0.0_wp
   djdtr(:, :) = 0.0_wp

   !$omp parallel do default(none) reduction(+:djdr, djdtr) &
   !$omp shared(nat, xyz, qvec) &
   !$omp private(iat, jat, r1, vec, dG, dS)
   do iat = 1, nat
      do jat = 1, iat-1
         vec(:) = xyz(:, jat) - xyz(:, iat)
         r1 = norm2(vec)
         dG(:) = -vec/r1**3
         dS(:, :) = 0.5_wp * spread(dG, 1, 3) * spread(vec, 2, 3)
         djdr(:, iat, jat) = djdr(:, iat, jat) - dG*qvec(iat)
         djdr(:, jat, iat) = djdr(:, jat, iat) + dG*qvec(jat)
         djdtr(:, jat) = djdtr(:, jat) + dG*qvec(iat)
         djdtr(:, iat) = djdtr(:, iat) - dG*qvec(jat)
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombDerivs
!> subroutine getCoulombDerivsSmeared
!> Compute all Coulomb matrix derivatives with smeared Gaussian charges
subroutine getCoulombDerivsSmeared(nat, at, xyz, rad, qvec, djdr, djdtr)

   !> Number of atoms
   integer, intent(in) :: nat
   !> Atomic types by atom number
   integer, intent(in) :: at(nat)
   !> Cartesian coordinates
   real(wp),intent(in) :: xyz(3,nat)

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: rad(:)

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   integer :: iat, jat, ish, jsh, ii, jj, iid, jid
   real(wp) :: r2, g1, gij, vec(3), dG(3), dS(3, 3)

   djdr(:, :, :) = 0.0_wp
   djdtr(:, :) = 0.0_wp

   !$omp parallel do default(none) reduction(+:djdr, djdtr) &
   !$omp shared(nat, at, xyz, qvec, rad) &
   !$omp private(iat, jat, iid, jid, r2, g1, gij, vec, dG, dS)
   do iat = 1, nat
      iid = at(iat)
      do jat = 1, iat-1
         jid = at(jat)
         vec(:) = xyz(:, jat) - xyz(:, iat)
         r2 = sum(vec**2)
         gij = 1.0_wp/(rad(iid)**2 + rad(jid)**2)
         g1 = erf(sqrt(gij*r2))/sqrt(r2)
         dG(:) = (2*sqrt(gij)*exp(-gij*r2)/sqrtpi - g1) * vec/r2
         dS(:, :) = 0.5_wp * spread(dG, 1, 3) * spread(vec, 2, 3)
         djdr(:, iat, jat) = djdr(:, iat, jat) - dG*qvec(iat)
         djdr(:, jat, iat) = djdr(:, jat, iat) + dG*qvec(jat)
         djdtr(:, jat) = djdtr(:, jat) + dG*qvec(iat)
         djdtr(:, iat) = djdtr(:, iat) - dG*qvec(jat)
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombDerivsSmeared


!========================================================================================!
end module eeq_module

! This file is part of xtb.
!
! Copyright (C) 2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Define reference states of solution
module solvation_solv_state
   use iso_fortran_env, only : wp => real64
   implicit none
   private

   public :: solutionState, getStateShift


   !> Possible reference states for the solution
   type :: TSolutionStateEnum

      !> 1 l of ideal gas and 1 l of liquid solution
      integer :: gsolv = 1

      !> 1 bar of ideal gas and 1 mol/L of liquid solution at infinite dilution
      integer :: reference = 2

      !> 1 bar of ideal gas and 1 mol/L of liquid solution
      integer :: mol1bar = 3

   end type TSolutionStateEnum

   !> Actual solvation state enumerator
   type(TSolutionStateEnum), parameter :: solutionState = TSolutionStateEnum()

   real(wp), parameter :: kB = 3.166808578545117e-06_wp
   real(wp), parameter :: refDensity = 1.0e-3_wp ! kg__au/(1.0e10_wp*AA__Bohr)**3
   real(wp), parameter :: refMolecularMass = 1.0_wp ! amu__au
   real(wp), parameter :: idealGasMolVolume = 24.79_wp
   real(wp), parameter :: ambientTemperature = 298.15_wp ! * Boltzman


contains


pure function getStateShift(state, temperature, density, molecularMass) &
      & result(freeEnergyShift)

   !> Reference state
   integer, intent(in) :: state

   !> Temperature of the solution
   real(wp), intent(in) :: temperature

   !> Mass density of the solvent
   real(wp), intent(in) :: density

   !> Molecular mass of the solvent
   real(wp), intent(in) :: molecularMass

   !> Resulting shift to the solvation free energy
   real(wp) :: freeEnergyShift

   select case(state)
   case default
      freeEnergyShift = 0.0_wp
   case(solutionState%reference)
      freeEnergyShift = temperature * kB &
         & * (log(idealGasMolVolume * temperature / ambientTemperature) &
         & + log(density/refDensity * refMolecularMass/molecularMass))
   case(solutionState%mol1bar)
      freeEnergyShift = temperature * kB &
         & * log(idealGasMolVolume * temperature / ambientTemperature)
   end select

end function getStateShift


end module solvation_solv_state

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!================================================================================!
module gfn0_qm
  use iso_fortran_env,only:wp => real64,stdout => output_unit

  use gfn0_types
  use gfn0_parameter
  use gfn0_basisset
  use wfn_module

  implicit none
  public :: wfnsetup
  public :: getSelfEnergy
  public :: build_SH0
  public :: fermismear
  interface fermismear
    module procedure :: fermismear_original
    module procedure :: fermismear_nmax
  end interface fermismear
  public :: occ_nmax

  private :: lin
  private :: ncore

  real(wp),private,parameter :: pi = 3.1415926535897932385_wp
  real(wp),private,parameter :: autoev = 27.21138505_wp
  real(wp),private,parameter :: evtoau = 1.0_wp / autoev

contains
!========================================================================================!
  subroutine wfnsetup(xtbData,basis,nat,at,uhf,chrg,wfn)
    type(TxtbData_mod),intent(in)  :: xtbData
    type(TBasisset),intent(in) :: basis
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    integer,intent(in) :: uhf
    integer,intent(in) :: chrg
    type(TWavefunction),intent(inout) :: wfn
    integer,allocatable :: z(:)

    call wfn%allocate(nat,basis%nshell,basis%nao)
    allocate (z(nat),source=0)
    call getZcore(nat,at,z)
    wfn%nel = sum(z) - chrg
    wfn%nel = max(0,wfn%nel)
    deallocate (z)

    wfn%nopen = uhf
    if (wfn%nopen == 0 .and. mod(wfn%nel,2) /= 0) wfn%nopen = 1

    if (wfn%nel .ne. 0) then
      call occu(wfn%nao,wfn%nel,wfn%nopen,wfn%ihomoa,wfn%ihomob,wfn%focca,wfn%foccb)
      wfn%focc = wfn%focca + wfn%foccb
      wfn%ihomo = wfn%ihomoa
!      call wfn%refresh_occu(wfn%nel, uhf)
    else
      wfn%focc = 0.0_wp
      wfn%ihomo = 0
      wfn%ihomoa = 0
      wfn%nopen = 0
    end if

    return
  end subroutine wfnsetup

!========================================================================================!
  subroutine getSelfEnergy(hData,nShell,at,cn,qat,selfEnergy,dSEdcn,dSEdq)
    type(THamiltonianData),intent(in) :: hData
    integer,intent(in) :: nShell(:)
    integer,intent(in) :: at(:)
    real(wp),intent(in),optional :: cn(:)
    real(wp),intent(in),optional :: qat(:)
    real(wp),intent(out) :: selfEnergy(:,:)
    real(wp),intent(out),optional :: dSEdcn(:,:)
    real(wp),intent(out),optional :: dSEdq(:,:)

    integer :: iAt,iZp,iSh

    selfEnergy(:,:) = 0.0_wp
    if (present(dSEdcn)) dSEdcn(:,:) = 0.0_wp
    if (present(dSEdq)) dSEdq(:,:) = 0.0_wp

    !>--- parametrized self-energy
    do iAt = 1,size(cn)
      iZp = at(iAt)
      do iSh = 1,nShell(iZp)
        selfEnergy(iSh,iAt) = hData%selfEnergy(iSh,iZp)
      end do
    end do
    !>--- CN dependent contribution
    if (present(dSEdcn) .and. present(cn)) then
      do iAt = 1,size(cn)
        iZp = at(iAt)
        do iSh = 1,nShell(iZp)
          selfEnergy(iSh,iAt) = selfEnergy(iSh,iAt) &
             & - hData%kCN(iSh,iZp) * cn(iAt)
          dSEdcn(iSh,iAt) = -hData%kCN(iSh,iZp)
        end do
      end do
    end if
    !>--- atomic charge (EEQ) dependent contribution
    if (present(dSEdq) .and. present(qat)) then
      do iAt = 1,size(cn)
        iZp = at(iAt)
        do iSh = 1,nShell(iZp)
          selfEnergy(iSh,iAt) = selfEnergy(iSh,iAt) &
             & - hData%kQShell(iSh,iZp) * qat(iAt) - hData%kQAtom(iZp) * qat(iAt)**2
          dSEdq(iSh,iAt) = -hData%kQShell(iSh,iZp) &
             & - hData%kQAtom(iZp) * 2 * qat(iAt)
        end do
      end do
    end if

  end subroutine getSelfEnergy
!========================================================================================!

  subroutine build_SH0(nShell,hData,selfEnergy,nat,at,basis,nao, &
        & xyz,intcut,sint,h0)
    use overlap_module
    implicit none

    integer,intent(in) :: nShell(:)
    type(THamiltonianData),intent(in) :: hData
    !type(tb_wsc), intent(in) :: wsc
    type(TBasisset),intent(in) :: basis
    real(wp),intent(in) :: selfEnergy(:,:)

    integer,intent(in)  :: nat
    integer,intent(in)  :: nao
    integer,intent(in)  :: at(nat)
    real(wp),intent(in)  :: xyz(3,nat)
    !real(wp),intent(in)  :: lattice(3,3)
    real(wp),intent(in)  :: intcut

    !> overlap matrix S
    real(wp),intent(out) :: sint(nao,nao)
    !> H0 matrix
    real(wp),intent(out) :: h0(nao * (1 + nao) / 2)

    integer,parameter :: llao(0:3) = (/1,3,6,10/)
    integer,parameter :: llao2(0:3) = (/1,3,5,7/)

    integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij
    real(wp) tmp1,tmp2,tmp3,tmp4,step,step2
    real(wp) dx,dy,dz,s00r,s00l,s00,alpj
    real(wp) skj,r1,r2,tt,t1,t2,t3,t4,f,ci,cc,cj,alpi,rab2,ab,est

    real(wp) :: den,den2,den4,enpoly
    real(wp) :: zi,zj,zetaij
    real(wp) :: hii,hjj,hav
    real(wp) :: shpoly,km
    logical  :: valaoi,valaoj

    real(wp) ri(3),rj(3),t(3),f1,f2
    real(wp),parameter ::point(3) = 0.0_wp
    real(wp) dtmp(3),qtmp(6),ss(6,6),dd(3,6,6),qq(6,6,6),tmp(6,6)
    real(wp) sstmp(6,6) !TESTST
    integer ip,jp,iat,jat,ati,atj,ish,jsh,icao,jcao,iao,jao,jshmax,il,jl
    integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
    integer itt(0:3)

    integer kat

    parameter(itt=(/0,1,4,10/))
    real(wp) :: saw(10)

    sint = 0.0_wp
    h0 = 0.0_wp

    !$omp parallel do default(none) schedule(dynamic) &
    !$omp private(iat,jat,ij,ati,cc,ci,rab2,atj,ish,ishtyp,valaoi,valaoj, &
    !$omp&        ri,rj,icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp, &
    !$omp&        ss,saw,est,alpi,alpj,ab,iprim,jprim,ip,jp,km,shpoly, &
    !$omp&        mli,mlj,tmp,zi,zj,zetaij,enpoly,iao,jao, &
    !$omp&        ii,jj,k,den,den2,den4,i,j,il,jl,hii,hjj,hav,t) &
    !$omp shared(sint,h0) &
    !$omp shared(basis,at,nShell,hData,xyz,intcut,nat,selfEnergy)
    do iat = 1,nat
      ri = xyz(:,iat)
      ati = at(iat)
      do jat = 1,iat - 1
        atj = at(jat)

        den = hData%electronegativity(ati) - hData%electronegativity(atj)
        den2 = den**2
        den4 = den2**2

        ishells: do ish = 1,nShell(ati)
          ishtyp = hData%angShell(ish,ati)
          icao = basis%caoshell(ish,iat)
          naoi = llao(ishtyp)
          iptyp = itt(ishtyp)
          jshmax = nShell(atj)
          if (iat == jat) jshmax = ish

          jshells: do jsh = 1,jshmax
            jshtyp = hData%angShell(jsh,atj)
            jcao = basis%caoshell(jsh,jat)
            naoj = llao(jshtyp)
            jptyp = itt(jshtyp)

            il = ishtyp + 1
            jl = jshtyp + 1
            !>--- diagonals are the same for all H0 elements
            hii = selfEnergy(ish,iat)
            hjj = selfEnergy(jsh,jat)

            !>--- evaluate the EN polynom for this shells
            enpoly = (1.0_wp + hData%enScale(jshtyp,ishtyp) * den2 &
            &  + hData%enScale4 * hData%enScale(jshtyp,ishtyp) * den4)

            !>--- scale the two shells depending on their exponent
            zi = hData%slaterExponent(ish,ati)
            zj = hData%slaterExponent(jsh,atj)
            zetaij = 2 * sqrt(zi * zj) / (zi + zj)

            !>--- now do the real magic (called EHT enhancement factor)
            km = hData%kScale(jshtyp,ishtyp) * hData%pairParam(ati,atj) &
                &    * zetaij * enpoly

            !>--- check for valence orbitals
            valaoi = hData%valenceShell(ish,ati) .eq. 0
            valaoj = hData%valenceShell(jsh,atj) .eq. 0
            !>--- and scale appropiately
            if (valaoi) then
              if (valaoj) then
                km = 0.0_wp
              else
                km = km * hData%kDiff
              end if
            else
              if (valaoj) km = km * hData%kDiff
            end if

            !>--- averaged H0 element (without overlap contribution!)
            hav = 0.5_wp * km * (hii + hjj)

            !wscAt: do kat = 1, wsc%itbl(jat,iat)
            ss = 0.0_wp
            rj = xyz(:,jat)

            !>--- distance dependent polynomial
            shpoly = shellPoly(hData%shellPoly(il,ati),hData%shellPoly(jl,atj),&
               &      hData%atomicRad(ati),hData%atomicRad(atj),ri,rj)

            !>--- get overlap integral
            call get_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj,point, &
               &             intcut,basis%nprim,basis%primcount, &
               &             basis%alp,basis%cont,ss)

            !>--- transform from CAO to SAO
            call dtrf2(ss,ishtyp,jshtyp)

            do ii = 1,llao2(ishtyp)
              iao = ii + basis%saoshell(ish,iat)
              do jj = 1,llao2(jshtyp)
                jao = jj + basis%saoshell(jsh,jat)
                if (jao > iao) cycle
                ij = lin(iao,jao)
                sint(jao,iao) = sint(jao,iao) + ss(jj,ii)
                !> Hamiltonian construction
                H0(ij) = H0(ij) + hav * shpoly * ss(jj,ii)
              end do
            end do

            !enddo wscAt
          end do jshells
        end do ishells
      end do
    end do
    !$omp parallel do default(none) shared(nao, sint) private(iao, jao)
    do iao = 1,nao
      do jao = 1,iao - 1
        sint(iao,jao) = sint(jao,iao)
      end do
    end do

    !> diagonal elements
    do iat = 1,nat
      ati = at(iat)
      do ish = 1,nShell(ati)
        iao = 1 + basis%saoshell(ish,iat)
        ishtyp = hData%angShell(ish,ati)
        il = ishtyp + 1
        do iao = 1,llao2(ishtyp)
          i = iao + basis%saoshell(ish,iat)
          sint(i,i) = 1.0_wp + sint(i,i)
          !> H0 is packed, note i*(i-1)/2+i = i*(1+i)/2
          ii = i * (1 + i) / 2

          !> calculate environment dependent shift
          hii = selfEnergy(ish,iat)
          H0(ii) = hii
        end do
      end do
    end do

  end subroutine build_SH0
!> DERIVATIVES of SH0
  subroutine build_dSH0(nShell,hData,selfEnergy,dSEdcn,dSEdq,nat,basis, &
        & thr,nao,at,xyz,P,Pew,g,dHdcn,dHdq)
    use overlap_module
    implicit none

    !> INPUT
    integer,intent(in) :: nShell(:)
    type(THamiltonianData),intent(in) :: hData
    real(wp),intent(in) :: selfEnergy(:,:)
    real(wp),intent(in) :: dSEdcn(:,:)
    real(wp),intent(in) :: dSEdq(:,:)
    integer,intent(in)      :: nat
    !type(tb_wsc), intent(in) :: wsc
    type(TBasisset),intent(in) :: basis
    real(wp),intent(in)      :: thr
    integer,intent(in)      :: nao
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    !real(wp),intent(in) :: lattice(3,3)
    real(wp),intent(in) :: P(nao,nao)
    real(wp),intent(in) :: Pew(nao,nao)
    !> OUTPUT
    real(wp),intent(inout) :: dHdq(nat)
    real(wp),intent(inout) :: dHdcn(nat)
    real(wp),intent(inout) :: g(3,nat)
    !real(wp),intent(inout) :: sigma(3,3)

    integer,parameter :: llao(0:3) = (/1,3,6,10/)
    integer,parameter :: llao2(0:3) = (/1,3,5,7/)

    integer itt(0:3)
    parameter(itt=(/0,1,4,10/))
    real(wp) tmp1,tmp2,tmp3,step,step2,step3,s00r,s00l,s00,alpj
    real(wp) skj,r1,r2,tt,t1,t2,t3,t4
    real(wp) thr2,f,ci,cc,cj,alpi,rab2,ab,est
    real(wp) f1,f2,tmp(6,6),rij(3),ri(3),rj(3),rij2,t(3)
    real(wp) stmp,ral(3,3),rar(3,3),rbl(3,3),pre
    real(wp) dtmp,qtmp,rbr(3,3),r2l(3),r2r(3),qqa(6,6,6,3)
    real(wp) ss(6,6,3),ddc(3,6,6,3),qqc(6,6,6,3),dda(3,6,6,3)
    integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij,lin,jshmax
    integer ip,jp,iat,jat,kat,ati,atj,ish,jsh,icao,jcao,iao,jao,ixyz,jxyz
    integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
    real(wp) :: dumdum(3),dum,sdq(6,6),sdqg(3,6,6)
    real(wp),parameter :: point(3) = 0.0_wp

    integer  :: il,jl
    real(wp) :: Hij,Pii,Pij,HPij,H0sr
    real(wp) :: den,den2,den4,enpoly
    real(wp) :: zi,zj,zetaij
    real(wp) :: hii,hjj,hav
    real(wp) :: shpoly,dshpoly(3),km
    logical  :: valaoi,valaoj
    real(wp) :: g_xyz(3)

    !$omp parallel default(none) &
    !$omp private(iat,jat,ixyz,ati,cc,ci,rab2,atj,ish,ishtyp,valaoi,valaoj,g_xyz, &
    !$omp&        ri,rj,icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp,rij2, &
    !$omp&        sdq,sdqg,est,alpi,alpj,ab,iprim,jprim,ip,jp,km,shpoly,dshpoly, &
    !$omp&        mli,mlj,dum,dumdum,tmp,stmp,rij,zi,zj,zetaij,enpoly,iao,jao,t, &
    !$omp&        ii,jj,k,den,den2,den4,i,j,il,jl,hii,hjj,hav,Pij,Hij,HPij,H0sr) &
    !$omp reduction (+:g,dhdcn,dhdq) &
    !$omp shared(basis,at,nShell,hData,xyz,thr,nat,selfEnergy, &
    !$omp        dSEdcn,dSEdq,P,Pew)
    !$omp do schedule(runtime)
    do iat = 1,nat
      ri = xyz(:,iat)
      ati = at(iat)
      do jat = 1,iat - 1
        atj = at(jat)

        den = hData%electronegativity(ati) - hData%electronegativity(atj)
        den2 = den**2
        den4 = den2**2

        ishells: do ish = 1,nShell(ati)
          ishtyp = hData%angShell(ish,ati)
          icao = basis%caoshell(ish,iat)
          naoi = llao(ishtyp)
          iptyp = itt(ishtyp)
          jshmax = nShell(atj)
          if (iat == jat) jshmax = ish

          jshells: do jsh = 1,jshmax
            jshtyp = hData%angShell(jsh,atj)
            jcao = basis%caoshell(jsh,jat)
            naoj = llao(jshtyp)
            jptyp = itt(jshtyp)

            il = ishtyp + 1
            jl = jshtyp + 1
            !>--- diagonals are the same for all H0 elements
            hii = selfEnergy(ish,iat)
            hjj = selfEnergy(jsh,jat)

            !>--- evaluate the EN polynom for this shells
            enpoly = (1.0_wp + hData%enScale(jl - 1,il - 1) * den2 &
               & + hData%enScale4 * hData%enScale(jl - 1,il - 1) * den4)

            !>--- we scale the two shells depending on their exponent
            zi = hData%slaterExponent(ish,ati)
            zj = hData%slaterExponent(jsh,atj)
            zetaij = 2 * sqrt(zi * zj) / (zi + zj)

            !>--- now do the real magic (called EHT enhancement factor)
            km = hData%kScale(jl - 1,il - 1) * hData%pairParam(ati,atj) * zetaij * enpoly

            !>--- check for valence orbitals
            valaoi = hData%valenceShell(ish,ati) .eq. 0
            valaoj = hData%valenceShell(jsh,atj) .eq. 0
            !>--- and scale appropiately
            if (valaoi) then
              if (valaoj) then
                km = 0.0_wp
              else
                km = km * hData%kDiff
              end if
            else
              if (valaoj) km = km * hData%kDiff
            end if

            !>--- averaged H0 element (without overlap contribution!)
            hav = 0.5_wp * km * (hii + hjj)

            !  wscAt: do kat = 1,wsc%itbl(jat,iat)
            !     t = wsc%lattr(:,kat,jat,iat)
            !     rj = xyz(:,jat) + matmul(lattice,t)
            rj = xyz(:,jat)
            rij = ri - rj
            rij2 = sum(rij**2)

            ! distance dependent polynomial
            call dshellPoly(hData%shellPoly(il,ati),hData%shellPoly(jl,atj),&
               & hData%atomicRad(ati),hData%atomicRad(atj),rij2,ri,rj,&
               & shpoly,dshpoly)

            call get_grad_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj, &
               &                  point,thr,basis%nprim,basis%primcount, &
               &                  basis%alp,basis%cont,sdq,sdqg)

            call dtrf2(sdq,ishtyp,jshtyp)
            do ixyz = 1,3
              !>--- transform from CAO to SAO, only transform the gradient
              tmp = sdqg(ixyz,:,:)
              call dtrf2(tmp,ishtyp,jshtyp)
              sdqg(ixyz,:,:) = tmp
            end do

            do ii = 1,llao2(ishtyp)
              iao = ii + basis%saoshell(ish,iat)
              do jj = 1,llao2(jshtyp)
                jao = jj + basis%saoshell(jsh,jat)

                Pij = P(jao,iao) * evtoau

                !>--- Hamiltonian element without overlap
                Hij = hav * shpoly
                HPij = Hij * Pij

                !>--- overlap contribution
                stmp = 2 * (HPij - Pew(jao,iao))

                !>--- distance dependent polynomial contribution
                H0sr = 2 * HPij * sdq(jj,ii)
                g_xyz = stmp * sdqg(:,jj,ii) + H0sr * dshpoly / shpoly

                !>--- distribute to atom i
                g(:,iat) = g(:,iat) + g_xyz

                !>--- distribute to atom j
                g(:,jat) = g(:,jat) - g_xyz

                        !!>--- reduce to strain
                !sigma(:,1) = sigma(:,1) + g_xyz*rij(1)
                !sigma(:,2) = sigma(:,2) + g_xyz*rij(2)
                !sigma(:,3) = sigma(:,3) + g_xyz*rij(3)

                !>--- Hamiltonian without Hav
                HPij = km * shpoly * Pij * sdq(jj,ii)

                !>--- save dE/dCN for CNi
                dhdcn(iat) = dhdcn(iat) + HPij * dSEdcn(ish,iat)
                !>--- save dE/dCN for CNj
                dhdcn(jat) = dhdcn(jat) + HPij * dSEdcn(jsh,jat)

                !>--- save dE/dq for qi
                dhdq(iat) = dhdq(iat) + HPij * dSEdq(ish,iat)
                !>--- save dE/dq for qj
                dhdq(jat) = dhdq(jat) + HPij * dSEdq(jsh,jat)

              end do
            end do

            !enddo wscAt

          end do jshells
        end do ishells

      end do !> jat
    end do  !> iat
    !$omp end do
    !$omp end parallel
    !>-- diagonal contributions
    do iat = 1,nat
      ati = at(iat)
      do ish = 1,nShell(ati)
        iao = 1 + basis%saoshell(ish,iat)
        ishtyp = hData%angShell(ish,ati)
        il = ishtyp + 1
        do iao = 1,llao2(ishtyp)
          i = iao + basis%saoshell(ish,iat)
          ii = i * (1 + i) / 2
          !>--- H0 is packed, note i*(i-1)/2+i = i*(1+i)/2

          Pii = P(i,i) * evtoau

          !>--- save dE/dCN for CNi
          dhdcn(iat) = dhdcn(iat) + Pii * dSEdcn(ish,iat)
          !>--- save dE/dq for qi
          dhdq(iat) = dhdq(iat) + Pii * dSEdq(ish,iat)
        end do
      end do
    end do

  end subroutine build_dSH0

!=========================================================================================!

!! ========================================================================
!  eigenvalue solver
!! ========================================================================
  subroutine solve(ndim,H,S,X,P,e,fail)
    use gfn0_math_wrapper,only:lapack_sygvd
    !> INPUT
    integer,intent(in)   :: ndim
    real(wp),intent(in)  :: H(ndim * (ndim + 1) / 2)
    real(wp),intent(in)   :: S(ndim,ndim)
    !> OUTPUT
    real(wp),intent(out)  :: X(ndim,ndim)
    real(wp),intent(out)  :: P(ndim,ndim)
    real(wp),intent(out)  :: e(ndim)
    logical,intent(out)  :: fail
    !> LOCAL
    integer :: i,j,k,info

    !>--- SETUP
    fail = .false.

    do i = 1,ndim
      do j = 1,i
        k = j + i * (i - 1) / 2
        X(j,i) = H(k)
        X(i,j) = X(j,i)
      end do
    end do
    P = S
    !>--- DIAG IN NON-ORTHORGONAL BASIS
    call lapack_sygvd(1,'v','u',ndim,X,ndim,P,ndim,e,info)
    if (info .ne. 0) then
      fail = .true.
      return
    end if

    return
  end subroutine solve

!=========================================================================================!

  subroutine setzshell(xtbData,n,at,nshell,z,zsh,e)
    type(TxTBData_mod),intent(in) :: xtbData
    integer,intent(in)  :: n
    integer,intent(in)  :: at(n)
    integer,intent(in)  :: nshell
    real(wp),intent(in)  :: z(n)
    real(wp),intent(out) :: zsh(nshell)
    real(wp),intent(out) :: e

    real(wp) ntot,fracz
    integer i,j,k,m,l,ll(0:3),iat,lll,iver
    data ll/1,3,5,7/

    k = 0
    e = 0.0_wp
    do i = 1,n
      iat = at(i)
      ntot = -1.d-6
      do m = 1,xtbData%nShell(iat)
        l = xtbData%hamiltonian%angShell(m,iat)
        k = k + 1
        zsh(k) = xtbData%hamiltonian%referenceOcc(m,iat)
        ntot = ntot + zsh(k)
        if (ntot .gt. z(i)) zsh(k) = 0
        e = e + xtbData%hamiltonian%selfEnergy(m,iat) * zsh(k)
      end do
    end do

  end subroutine setzshell

!! ========================================================================
!  S(R) enhancement factor
!! ========================================================================
  pure function shellPoly(iPoly,jPoly,iRad,jRad,xyz1,xyz2)
    real(wp),intent(in) :: iPoly,jPoly
    real(wp),intent(in) :: iRad,jRad
    real(wp),intent(in) :: xyz1(3),xyz2(3)
    real(wp) :: shellPoly
    real(wp) :: rab,k1,rr,r,rf1,rf2,dx,dy,dz,a

    a = 0.5_wp       ! R^a dependence 0.5 in GFN1

    dx = xyz1(1) - xyz2(1)
    dy = xyz1(2) - xyz2(2)
    dz = xyz1(3) - xyz2(3)

    rab = (dx * dx + dy * dy + dz * dz)
    rab = sqrt(rab)

    ! this sloppy conv. factor has been used in development, keep it
    rr = jRad + iRad

    r = rab / rr

    rf1 = 1.0_wp + (0.01_wp * iPoly) * (r**a)
    rf2 = 1.0_wp + (0.01_wp * jPoly) * (r**a)

    shellPoly = rf1 * rf2

  end function shellPoly

!! ========================================================================
!  derivative of S(R) enhancement factor
!! ========================================================================
  pure subroutine dshellPoly(iPoly,jPoly,iRad,jRad,rab2,xyz1,xyz2,rf,dxyz)
    real(wp),intent(in)  :: iPoly,jPoly
    real(wp),intent(in)  :: iRad,jRad
    real(wp),intent(in)  :: rab2
    real(wp),intent(out) :: dxyz(3),rf
    real(wp),intent(in)  :: xyz1(3),xyz2(3)
    real(wp) :: rab,k1,k2,rr,r,a,dum,rf1,rf2,dx,dy,dz
    real(wp) :: t14,t15,t17,t22,t20,t23,t10,t11,t35,t13

    a = 0.5_wp   ! R^a dependence 0.5 in GFN1

    dx = xyz1(1) - xyz2(1)
    dy = xyz1(2) - xyz2(2)
    dz = xyz1(3) - xyz2(3)

    rab = sqrt(rab2)

    ! this sloppy conv. factor has been used in development, keep it
    r = iRad + jRad

    rr = rab / r

    k1 = iPoly * 0.01_wp
    k2 = jPoly * 0.01_wp

    t14 = rr**a
    t15 = k1 * t14
    t17 = 1.0_wp / rab2
    t22 = rr**a
    t23 = k2 * t22
    rf = (1.0_wp + t15) * (1.0_wp + k2 * t22)
    dxyz(:) = (t15 * (1.0_wp + t23) + (1.0_wp + t15) * k2 * t22) * a * t17*[dx,dy,dz]

  end subroutine dshellPoly

!=========================================================================================!

  subroutine occu(ndim,nel,nopen,ihomoa,ihomob,focca,foccb)
    integer  :: nel
    integer  :: nopen
    integer  :: ndim
    integer  :: ihomoa
    integer  :: ihomob
    real(wp) :: focca(ndim)
    real(wp) :: foccb(ndim)
    integer  :: focc(ndim)
    integer  :: i,na,nb,ihomo

    focc = 0
    focca = 0
    foccb = 0
!>--- even nel
    if (mod(nel,2) .eq. 0) then
      ihomo = nel / 2
      do i = 1,ihomo
        focc(i) = 2
      end do
      if (2 * ihomo .ne. nel) then
        ihomo = ihomo + 1
        focc(ihomo) = 1
        if (nopen .eq. 0) nopen = 1
      end if
      if (nopen .gt. 1) then
        do i = 1,nopen / 2
          focc(ihomo - i + 1) = focc(ihomo - i + 1) - 1
          focc(ihomo + i) = focc(ihomo + i) + 1
        end do
      end if
!>--- odd nel
    else
      na = nel / 2 + (nopen - 1) / 2 + 1
      nb = nel / 2 - (nopen - 1) / 2
      do i = 1,na
        focc(i) = focc(i) + 1
      end do
      do i = 1,nb
        focc(i) = focc(i) + 1
      end do
    end if

    do i = 1,ndim
      if (focc(i) .eq. 2) then
        focca(i) = 1.0d0
        foccb(i) = 1.0d0
      end if
      if (focc(i) .eq. 1) focca(i) = 1.0d0
    end do

    ihomoa = 0
    ihomob = 0
    do i = 1,ndim
      if (focca(i) .gt. 0.99) ihomoa = i
      if (foccb(i) .gt. 0.99) ihomob = i
    end do

  end subroutine occu

!=========================================================================================!
  subroutine occ_nmax(nao,occ,nmaxa,nmaxb,ihomoa,ihomob)
    implicit none
    !> INPUT
    integer,intent(in) :: nao
    real(wp),intent(in) :: occ(nao)
    !> OUTPUT
    integer,allocatable,intent(out) :: nmaxa(:)
    integer,allocatable,intent(out) :: nmaxb(:)
    integer,intent(out) :: ihomoa,ihomob
    !> LOCAL
    integer,allocatable :: iocc(:),iocca(:),ioccb(:)
    integer :: i,na,nb

    if (.not. allocated(nmaxa)) allocate (nmaxa(nao))
    if (.not. allocated(nmaxb)) allocate (nmaxb(nao))

    allocate (iocc(nao),source=0)
    allocate (iocca(nao),ioccb(nao),source=0)
    iocc(:) = nint(occ(:))

    ihomoa = 0
    ihomob = 0
    na = 0
    nb = 0
    nmaxa(:) = 1
    nmaxb(:) = 1
    do i = 1,nao
      if (iocc(i) == 2) then
        iocca(i) = 1
        na = na + 1
        ioccb(i) = 1
        nb = nb + 1
      elseif (iocc(i) == 1) then
        iocca(i) = 1
        na = na + 1
        ioccb(i) = 0
      else
        iocca(i) = 0
        ioccb(i) = 0
      end if
    end do
    do i = 1,nao
      if (iocca(i) == 1) ihomoa = i
      if (ioccb(i) == 1) ihomob = i
    end do
    do i = 1,nao
      if (i < ihomoa) then
        if (iocca(i) == 0) nmaxa(i) = 0
      end if
      if (i < ihomob) then
        if (ioccb(i) == 0) nmaxb(i) = 0
      end if
    end do

    deallocate (ioccb,iocca)
    deallocate (iocc)
  end subroutine occ_nmax

!=========================================================================================!

  subroutine fermismear_original(prt,norbs,nel,t,eig,occ,fod,e_fermi,s)
    integer,intent(in)  :: norbs
    integer,intent(in)  :: nel
    real(wp),intent(in)  :: eig(norbs)
    real(wp),intent(out) :: occ(norbs)
    real(wp),intent(in)  :: t
    real(wp),intent(out) :: fod
    real(wp),intent(out) :: e_fermi
    logical,intent(in)  :: prt

    real(wp) :: bkt,occt,total_number
    real(wp) :: total_dfermi,dfermifunct,fermifunct,s,change_fermi

    real(wp),parameter :: autoev = 27.21138505_wp
    real(wp),parameter :: kB = 3.166808578545117e-06_wp
    real(wp),parameter :: boltz = kB * autoev
    real(wp),parameter :: thr = 1.d-9
    integer :: ncycle,i,j,m,k,i1,i2

    bkt = boltz * t

    e_fermi = 0.5 * (eig(nel) + eig(nel + 1))
    occt = nel

    do ncycle = 1,200
      total_number = 0.0
      total_dfermi = 0.0
      do i = 1,norbs
        fermifunct = 0.0
        if ((eig(i) - e_fermi) / bkt .lt. 50) then
          fermifunct = 1.0 / (exp((eig(i) - e_fermi) / bkt) + 1.0)
          dfermifunct = exp((eig(i) - e_fermi) / bkt) / &
          &       (bkt * (exp((eig(i) - e_fermi) / bkt) + 1.0)**2)
        else
          dfermifunct = 0.0
        end if
        occ(i) = fermifunct
        total_number = total_number + fermifunct
        total_dfermi = total_dfermi + dfermifunct
      end do
      change_fermi = (occt - total_number) / total_dfermi
      e_fermi = e_fermi + change_fermi
      if (abs(occt - total_number) .le. thr) exit
    end do

    fod = 0
    s = 0
    do i = 1,norbs
      if (occ(i) .gt. thr .and. 1.0d00 - occ(i) .gt. thr) &
      &   s = s + occ(i) * log(occ(i)) + (1.0d0 - occ(i)) * log(1.0d00 - occ(i))
      if (eig(i) .lt. e_fermi) then
        fod = fod + 1.0d0 - occ(i)
      else
        fod = fod + occ(i)
      end if
    end do
    s = s * kB * t

    if (prt) then
      write (*,'('' t,e(fermi),nfod : '',2f10.3,f10.6)') t,e_fermi,fod
    end if

  end subroutine fermismear_original

!=========================================================================================!

  subroutine fermismear_nmax(prt,norbs,ihomo,nmax,t,eig,occ,ef,TS)
    !> INPUT
    logical,intent(in)  :: prt    !> print statement
    integer,intent(in)  :: norbs  !> number of orbitals
    integer,intent(in)  :: ihomo  !> position of the H(S)OMO
    integer,intent(in)  :: nmax(norbs) !> maximum allowed occupation
    real(wp),intent(in)  :: t     !> (electronic) temperature
    real(wp),intent(in)  :: eig(norbs) !> orbital energies
    !> OUTPUT
    real(wp),intent(out) :: occ(norbs)  !> orbital occupations
    real(wp),intent(out),optional :: ef !> fermi temperature
    real(wp),intent(out),optional :: TS !> electronic free energy
    !> LOCAL
    real(wp) :: e_fermi,s
    real(wp) :: bkt,occt,total_number,fod
    real(wp) :: total_dfermi,dfermifunct,fermifunct,change_fermi

    real(wp),parameter :: autoev = 27.21138505_wp
    real(wp),parameter :: kB = 3.166808578545117e-06_wp
    real(wp),parameter :: boltz = kB * autoev
    real(wp),parameter :: thr = 1.d-9
    integer :: ncycle,i,j,m,k,i1,i2,nholes
    real(wp) :: deigkt
    !integer :: nfermi,ncycle2
    !real(wp),allocatable :: efermis(:),occsum(:)

    bkt = boltz * t

    e_fermi = 0.5 * (eig(ihomo) + eig(ihomo + 1))
    nholes = count((nmax(:) < 1),1)
    occt = ihomo - nholes

    do ncycle = 1,200
        total_number = 0.0
        total_dfermi = 0.0
        do i = 1,norbs
          fermifunct = 0.0
          dfermifunct = 0.0

          deigkt = (eig(i) - e_fermi) / bkt

          if ((deigkt .lt. 50)) then
            if ((nmax(i) > 0)) then !> smear electrons
              fermifunct = 1.0 / (exp(deigkt) + 1.0)
              dfermifunct = exp(deigkt) / &
              &       (bkt * (exp(deigkt) + 1.0)**2)
            else !> smear holes
              fermifunct = 1.0 - (1.0 / (exp(deigkt) + 1.0))
              dfermifunct = -(exp(deigkt) / &
              &       (bkt * (exp(deigkt) + 1.0)**2))
            end if
          end if
          occ(i) = fermifunct
          total_number = total_number + fermifunct
          total_dfermi = total_dfermi + dfermifunct
        end do
        change_fermi = (occt - total_number) / total_dfermi
        e_fermi = e_fermi + change_fermi
        if (abs(occt - total_number) .le. thr) exit
      end do

    fod = 0
    s = 0
    do i = 1,norbs
      if (occ(i) .gt. thr .and. 1.0d00 - occ(i) .gt. thr) &
      &   s = s + occ(i) * log(occ(i)) + (1.0d0 - occ(i)) * log(1.0d00 - occ(i))
      if (eig(i) .lt. e_fermi) then
        fod = fod + 1.0d0 - occ(i)
      else
        fod = fod + occ(i)
      end if
    end do
    s = s * kB * t

    if (prt) then
      write (*,'('' t,e(fermi),nfod : '',2f10.3,f10.6)') t,e_fermi,fod
    end if

    if (present(ef)) ef = e_fermi
    if (present(TS)) TS = s

  end subroutine fermismear_nmax
!=========================================================================================!
  subroutine dmat(ndim,focc,C,P)
    !> density matrix
    !> C: MO coefficient
    !> P  dmat
    use gfn0_math_wrapper,only:gemm
    integer,intent(in)  :: ndim
    real(wp),intent(in)  :: focc(:)
    real(wp),intent(in)  :: C(:,:)
    real(wp),intent(out) :: P(:,:)
    integer :: i,m
    real(wp),allocatable :: Ptmp(:,:)

    allocate (Ptmp(ndim,ndim))
    Ptmp = 0.0_wp

    do m = 1,ndim
      do i = 1,ndim
        Ptmp(i,m) = C(i,m) * focc(m)
      end do
    end do
    call gemm(C,Ptmp,P,transb='t')

    deallocate (Ptmp)
  end subroutine dmat

!=========================================================================================!

  pure elemental integer function lin(i1,i2)
    integer,intent(in) :: i1,i2
    integer :: idum1,idum2
    idum1 = max(i1,i2)
    idum2 = min(i1,i2)
    lin = idum2 + idum1 * (idum1 - 1) / 2
    return
  end function lin
!=========================================================================================!
  pure elemental integer function ncore(at)
    integer,intent(in) :: at
    if (at .le. 2) then
      ncore = 0
    elseif (at .le. 10) then
      ncore = 2
    elseif (at .le. 18) then
      ncore = 10
    elseif (at .le. 29) then   !zn
      ncore = 18
    elseif (at .le. 36) then
      ncore = 28
    elseif (at .le. 47) then
      ncore = 36
    elseif (at .le. 54) then
      ncore = 46
    elseif (at .le. 71) then
      ncore = 54
    elseif (at .le. 79) then
      ncore = 68
    elseif (at .le. 86) then
      ncore = 78
    end if
  end function ncore
!=========================================================================================!
  pure subroutine getZcore(nat,at,z)
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    integer,intent(out) :: z(nat)
    integer :: i
    z = 0
    do i = 1,nat
      z(i) = at(i) - ncore(at(i))
    end do
  end subroutine getZcore

!=========================================================================================!
end module gfn0_qm

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!================================================================================!
module solvation_math_wrapper
!> module solvation_math_wrapper
!> contains some interfaces to LAPACK and BLAS routines
!> which must be included via a suitable library.
  use iso_fortran_env,only:wp => real64,sp => real32,stderr => error_unit
  implicit none
  public

  interface dot
    module procedure sdot_wrap
    module procedure ddot_wrap
  end interface dot

  interface symv
    module procedure ssymv_wrap
    module procedure dsymv_wrap
  end interface symv

  interface gemv
    module procedure sgemv_wrap
    module procedure dgemv_wrap
    module procedure dgemv312_wrap
  end interface gemv

contains

!========================================================================================!

!> Determinat of 3×3 matrix
  pure function matDet3x3(a) result(det)

    !> Matrix
    real(wp),intent(in) :: a(3,3)

    !> Determinant
    real(wp) :: det

    det = a(1,1)*a(2,2)*a(3,3)  &
       & -a(1,1)*a(2,3)*a(3,2)  &
       & -a(1,2)*a(2,1)*a(3,3)  &
       & +a(1,2)*a(2,3)*a(3,1)  &
       & +a(1,3)*a(2,1)*a(3,2)  &
       & -a(1,3)*a(2,2)*a(3,1)

  end function matDet3x3

!========================================================================================!
!> The DOT routines perform the dot product of two vectors
!> dot = ∑ᵢ xᵢyᵢ
  function sdot_wrap(xvec,yvec) result(dotp)
    real(sp) :: dotp
    real(sp),intent(in) :: xvec(:)
    real(sp),intent(in) :: yvec(:)
    integer :: incx,incy,n
    !> BLAS
    real(sp),external :: sdot
    incx = 1
    incy = 1
    n = size(xvec)
    dotp = sdot(n,xvec,incx,yvec,incy)
  end function sdot_wrap
  function ddot_wrap(xvec,yvec) result(dotp)
    real(wp) :: dotp
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(in) :: yvec(:)
    integer :: incx,incy,n
    !> BLAS
    real(wp),external :: ddot
    incx = 1
    incy = 1
    n = size(xvec)
    dotp = ddot(n,xvec,incx,yvec,incy)
  end function ddot_wrap
!=======================================================================================!
!> SYMV  performs the matrix-vector  operation
!>
!>   y := α*A*x + β*y,
!>
!> where α and β are scalars, x and y are n element vectors and
!> A is an n by n symmetric matrix.
  subroutine ssymv_wrap(amat,xvec,yvec,uplo,alpha,beta)
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(in) :: xvec(:)
    real(sp),intent(inout) :: yvec(:)
    character(len=1),intent(in),optional :: uplo
    real(sp),intent(in),optional :: alpha
    real(sp),intent(in),optional :: beta
    character(len=1) :: ula
    real(sp) :: a,b
    integer :: incx,incy,n,lda
    !> BLAS
    external :: ssymv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_sp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    n = size(amat,2)
    call ssymv(ula,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine ssymv_wrap
  subroutine dsymv_wrap(amat,xvec,yvec,uplo,alpha,beta)
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(inout) :: yvec(:)
    character(len=1),intent(in),optional :: uplo
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    character(len=1) :: ula
    real(wp) :: a,b
    integer :: incx,incy,n,lda
    !> BLAS
    external :: dsymv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_wp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    n = size(amat,2)
    call dsymv(ula,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine dsymv_wrap

!=======================================================================================!
!> DGEMV  performs one of the matrix-vector operations
!>
!>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
!>
!> where alpha and beta are scalars, x and y are vectors and A is an
!> m by n matrix.
  subroutine sgemv_wrap(amat,xvec,yvec,alpha,beta,trans)
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(in) :: xvec(:)
    real(sp),intent(inout) :: yvec(:)
    real(sp),intent(in),optional :: alpha
    real(sp),intent(in),optional :: beta
    character(len=1),intent(in),optional :: trans
    real(sp) :: a,b
    character(len=1) :: tra
    integer :: incx,incy,m,n,lda
    !> BLAS
    external :: sgemv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_sp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(trans)) then
      tra = trans
    else
      tra = 'n'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    m = size(amat,1)
    n = size(amat,2)
    call sgemv(tra,m,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine sgemv_wrap
  subroutine dgemv_wrap(amat,xvec,yvec,alpha,beta,trans)
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(inout) :: yvec(:)
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    character(len=1),intent(in),optional :: trans
    real(wp) :: a,b
    character(len=1) :: tra
    integer :: incx,incy,m,n,lda
    !> BLAS
    external :: dgemv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_wp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(trans)) then
      tra = trans
    else
      tra = 'n'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    m = size(amat,1)
    n = size(amat,2)
    call dgemv(tra,m,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine dgemv_wrap
  subroutine dgemv312_wrap(amat,xvec,yvec,alpha,beta,trans)
    real(wp),intent(in),contiguous,target :: amat(:,:,:)
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(inout),contiguous,target :: yvec(:,:)
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    character(len=1),intent(in),optional :: trans
    real(wp),pointer :: aptr(:,:),yptr(:)
    character(len=1) :: tra
    if (present(trans)) then
      tra = trans
    else
      tra = 'n'
    end if
    if (any(tra == ['n','N'])) then
      aptr(1:size(amat,1)*size(amat,2),1:size(amat,3)) => amat
      yptr(1:size(yvec,1)*size(yvec,2)) => yvec
    else
      aptr(1:size(amat,1),1:size(amat,2)*size(amat,3)) => amat
      yptr(1:size(yvec,1)*size(yvec,2)) => yvec
    end if
    call dgemv_wrap(aptr,xvec,yptr,alpha,beta,tra)
  end subroutine dgemv312_wrap
!=======================================================================================!
end module solvation_math_wrapper

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!

!> Generalized Born interaction kernels
module solvation_solv_kernel
   use iso_fortran_env, only : wp => real64
   use solvation_math_wrapper, only: dot, gemv, symv
   implicit none
   private

   public :: gbKernel
   public :: addBornMatSaltStill, addBornMatStill, addBornMatP16
   public :: addGradientSaltStill, addGradientStill, addGradientP16
   public :: addBornDerivSaltStill, addBornDerivStill


   !> Possible kernels for the generalized Born model
   type :: TGBKernelEnum

      !> Classical Still kernel
      integer :: still = 1

      !> P16 kernel by Lange (JCTC 2012, 8, 1999-2011)
      integer :: p16 = 2

   end type TGBKernelEnum

   !> Actual enumerator for the generalized Born kernels
   type(TGBKernelEnum), parameter :: gbKernel = TGBKernelEnum()


   !> P16 zeta parameter
   real(wp), parameter :: zetaP16 = 1.028_wp

   !> P16 zeta parameter over 16
   real(wp), parameter :: zetaP16o16 = zetaP16 / 16.0_wp

   real(wp), parameter :: pi = 3.1415926535897932384626433832795029_wp
   real(wp), parameter :: fourpi = 4.0_wp * pi

contains


subroutine addGradientSaltStill(nat, ntpair, ppind, ddpair, qat, kappa, &
      & brad, brdr, ionscr, discr, energy, gradient)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Debye screening length
   real(wp), intent(in) :: kappa

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(in) :: brdr(:, :, :)

   !> Ion screening
   real(wp), intent(in) :: ionscr(:)

   !> Derivative of ion screening w.r.t. Born radii
   real(wp), intent(in) :: discr(:)

   !> Total Born solvation energy
   real(wp), intent(out) :: energy

   !> Deriatives of Born solvation energy
   real(wp), intent(inout) :: gradient(:, :)

   integer :: i, j, k, nnj
   integer :: kk
   real(wp), parameter :: a13=1._wp/3._wp
   real(wp), parameter :: a4=0.25_wp
   real(wp) :: aa, r2, fgb, fgb2, br3
   real(wp) :: qq, dd, expd, dfgb, dfgb2, dfgb3, egb, ap, bp, qfg
   real(wp) :: gg, expa
   real(wp) :: r0vdw, r01, r02, ar02
   real(wp) :: grddbi, grddbj
   real(wp) :: dr(3), r
   real(wp), allocatable :: grddb(:)

   allocate(grddb(nat), source = 0.0_wp )

   egb = 0._wp
   grddb(:) = 0._wp

   ! GB-SE energy and gradient

   ! compute energy and fgb direct and radii derivatives
   do kk = 1, ntpair
      r = ddpair(1, kk)
      r2 = r*r

      i = ppind(1, kk)
      j = ppind(2, kk)

      qq = qat(i)*qat(j)
      aa = brad(i)*brad(j)
      dd = a4*r2/aa
      expd = exp(-dd)
      dfgb = r2+aa*expd
      fgb = sqrt(dfgb)
      aa = kappa*fgb
      expa = exp(-aa)
      gg = (ionscr(i)+ionscr(j))*expa
      qfg = qq/fgb

      egb = egb + qfg*(gg-1.0_wp)

      dfgb3 = qfg*(gg*(1._wp+aa)-1.0_wp)/dfgb

      ap = (1._wp-a4*expd)*dfgb3
      dr = ap*ddpair(2:4, kk)
      gradient(:, i) = gradient(:, i) - dr
      gradient(:, j) = gradient(:, j) + dr

      qfg = qfg*expa
      bp = -0.5_wp*expd*(1._wp+dd)*dfgb3
      grddbi = (brad(j)*bp+qfg*discr(i))
      grddbj = (brad(i)*bp+qfg*discr(j))
      grddb(i) = grddb(i) + grddbi
      grddb(j) = grddb(j) + grddbj

   enddo

   ! self-energy part
   do i = 1, nat
      gg = exp(-kappa*brad(i))
      aa = 2._wp*ionscr(i)*gg-1.0_wp
      qq = qat(i)/brad(i)
      egb = egb + 0.5_wp*qq*qat(i)*aa
      ap = aa-brad(i)*2._wp*(discr(i)+ionscr(i)*kappa)*gg
      grddbi = -0.5_wp*qq*qq*ap
      grddb(i) = grddb(i) + grddbi
   enddo

   ! contract with the Born radii derivatives
   call gemv(brdr, grddb, gradient, beta=1.0_wp)

   energy = egb

end subroutine addGradientSaltStill


subroutine addGradientStill(nat, ntpair, ppind, ddpair, qat, keps, &
      & brad, brdr, energy, gradient)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Dielectric screening
   real(wp), intent(in) :: keps

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(in) :: brdr(:, :, :)

   !> Total Born solvation energy
   real(wp), intent(out) :: energy

   !> Deriatives of Born solvation energy
   real(wp), intent(inout) :: gradient(:, :)

   integer :: i, j, k, nnj
   integer :: kk
   real(wp), parameter :: a13=1._wp/3._wp
   real(wp), parameter :: a4=0.25_wp
   real(wp) :: aa, r2, fgb, fgb2, br3
   real(wp) :: qq, dd, expd, dfgb, dfgb2, dfgb3, egb, ap, bp, qfg
   real(wp) :: gg, expa
   real(wp) :: r0vdw, r01, r02, ar02
   real(wp) :: grddbi, grddbj
   real(wp) :: dr(3), r
   real(wp), allocatable :: grddb(:)

   allocate(grddb(nat), source = 0.0_wp )

   egb = 0._wp
   grddb(:) = 0._wp

   ! GB energy and gradient

   ! compute energy and fgb direct and radii derivatives
   do kk = 1, ntpair
      r = ddpair(1, kk)
      r2 = r*r

      i = ppind(1, kk)
      j = ppind(2, kk)

      ! dielectric scaling of the charges
      qq = qat(i)*qat(j)
      aa = brad(i)*brad(j)
      dd = a4*r2/aa
      expd = exp(-dd)
      fgb2 = r2+aa*expd
      dfgb2 = 1._wp/fgb2
      dfgb = sqrt(dfgb2)
      dfgb3 = dfgb2*dfgb*keps

      egb = egb + qq*keps*dfgb

      ap = (1._wp-a4*expd)*dfgb3
      dr = ap*ddpair(2:4, kk)
      gradient(:, i) = gradient(:, i) - dr*qq
      gradient(:, j) = gradient(:, j) + dr*qq

      bp = -0.5_wp*expd*(1._wp+dd)*dfgb3
      grddbi = brad(j)*bp
      grddbj = brad(i)*bp
      grddb(i) = grddb(i) + grddbi*qq
      !gradient = gradient + brdr(:, :, i) * grddbi*qq
      grddb(j) = grddb(j) + grddbj*qq
      !gradient = gradient + brdr(:, :, j) * grddbj*qq

   enddo

   ! self-energy part
   do i = 1, nat
      bp = 1._wp/brad(i)
      qq = qat(i)*bp
      egb = egb + 0.5_wp*qat(i)*qq*keps
      grddbi = -0.5_wp*keps*qq*bp
      grddb(i) = grddb(i) + grddbi*qat(i)
      !gradient = gradient + brdr(:, :, i) * grddbi*qat(i)
   enddo

   ! contract with the Born radii derivatives
   call gemv(brdr, grddb, gradient, beta=1.0_wp)

   energy = egb

end subroutine addGradientStill


subroutine addGradientP16(nat, ntpair, ppind, ddpair, qat, keps, &
      & brad, brdr, energy, gradient)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Dielectric screening
   real(wp), intent(in) :: keps

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(in) :: brdr(:, :, :)

   !> Total Born solvation energy
   real(wp), intent(out) :: energy

   !> Deriatives of Born solvation energy
   real(wp), intent(inout) :: gradient(:, :)

   integer :: iat, jat, kk
   real(wp) :: vec(3), r2, r1, ab, arg1, arg16, qq, fgb, fgb2, dfgb, dfgb2, egb
   real(wp) :: dEdbri, dEdbrj, dG(3), ap, bp, dS(3, 3)
   real(wp), allocatable :: dEdbr(:)

   allocate(dEdbr(nat), source = 0.0_wp )

   egb = 0._wp
   dEdbr(:) = 0._wp

   ! GB energy and gradient
   ! omp parallel do default(none) reduction(+:egb, gradient, dEdbr) &
   ! omp private(iat, jat, vec, r1, r2, ab, arg1, arg16, fgb, dfgb, dfgb2, ap, &
   ! omp& bp, qq, dEdbri, dEdbrj, dG, dS) &
   ! omp shared(keps, qat, ntpair, ddpair, ppind, brad)
   do kk = 1, ntpair
      vec(:) = ddpair(2:4, kk)
      r1 = ddpair(1, kk)
      r2 = r1*r1

      iat = ppind(1, kk)
      jat = ppind(2, kk)
      qq = qat(iat)*qat(jat)

      ab = sqrt(brad(iat) * brad(jat))
      arg1 = ab / (ab + zetaP16o16*r1) ! 1 / (1 + ζR/(16·ab))
      arg16 = arg1 * arg1 ! 1 / (1 + ζR/(16·ab))²
      arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))⁴
      arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))⁸
      arg16 = arg16 * arg16 ! 1 / (1 + ζR/(16·ab))¹⁶

      fgb = r1 + ab*arg16
      dfgb = 1.0_wp / fgb
      dfgb2 = dfgb * dfgb

      egb = egb + qq*keps*dfgb

      ! (1 - ζ/(1 + Rζ/(16 ab))^17)/(R + ab/(1 + Rζ/(16 ab))¹⁶)²
      ap = (1.0_wp - zetaP16 * arg1 * arg16) * dfgb2
      dG(:) = ap * vec * keps / r1 * qq
      gradient(:, iat) = gradient(:, iat) - dG
      gradient(:, jat) = gradient(:, jat) + dG

      ! -(Rζ/(2·ab²·(1 + Rζ/(16·ab))¹⁷) + 1/(2·ab·(1 + Rζ/(16·ab))¹⁶))/(R + ab/(1 + Rζ/(16·ab))¹⁶)²
      bp = -0.5_wp*(r1 * zetaP16 / ab * arg1 + 1.0_wp) / ab * arg16 * dfgb2
      dEdbri = brad(jat) * bp * keps * qq
      dEdbrj = brad(iat) * bp * keps * qq
      dEdbr(iat) = dEdbr(iat) + dEdbri
      dEdbr(jat) = dEdbr(jat) + dEdbrj

   end do

   ! self-energy part
   do iat = 1, nat
      bp = 1._wp/brad(iat)
      qq = qat(iat)*bp
      egb = egb + 0.5_wp*qat(iat)*qq*keps
      dEdbri = -0.5_wp*keps*qq*bp
      dEdbr(iat) = dEdbr(iat) + dEdbri*qat(iat)
      !gradient = gradient + brdr(:, :, i) * dEdbri*qat(i)
   enddo

   ! contract with the Born radii derivatives
   call gemv(brdr, dEdbr, gradient, beta=1.0_wp)

   energy = egb

end subroutine addGradientP16


pure subroutine addBornDerivSaltStill(nat, ntpair, ppind, ddpair, qat, kappa, &
      & brad, brdr, ionscr, discr, gborn, dAmatdr, Afac)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Debye screening length
   real(wp), intent(in) :: kappa

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(in) :: brdr(:, :, :)

   !> Ion screening
   real(wp), intent(in) :: ionscr(:)

   !> Derivative of ion screening w.r.t. Born radii
   real(wp), intent(in) :: discr(:)

   real(wp), intent(inout) :: dAmatdr(:, :, :)
   real(wp), intent(inout) :: Afac(:, :)
   real(wp), intent(out)   :: gborn

   integer :: i,j,k,nnj
   integer :: kk
   real(wp), parameter :: a13=1._wp/3._wp
   real(wp), parameter :: a4=0.25_wp
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp) :: aa,r2,fgb,fgb2,br3
   real(wp) :: qq,dd,expd,dfgb,dfgb2,dfgb3,ap,bp,qfg
   real(wp) :: gg,expa,aii,egb
   real(wp) :: r0vdw,r01,r02,ar02
   real(wp) :: grddbi,grddbj
   real(wp) :: dr(3),r

   egb = 0._wp

   ! GB-SE energy and dAmatdr

   ! compute energy and fgb direct and radii derivatives
   do kk = 1, ntpair
      r = ddpair(1,kk)
      r2 = r*r

      i = ppind(1,kk)
      j = ppind(2,kk)

      qq = qat(i)*qat(j)
      aa = brad(i)*brad(j)
      dd = a4*r2/aa
      expd = exp(-dd)
      fgb2 = r2+aa*expd
      fgb = sqrt(fgb2)
      dfgb2 = 1._wp/fgb2
      dfgb = sqrt(dfgb2)
      aa = kappa*fgb
      expa = exp(-aa)
      gg = (ionscr(i)+ionscr(j))*expa

      egb = egb + qq*dfgb*(gg-1.0_wp)

      dfgb3 = (gg*(1._wp+aa)-1.0_wp)*dfgb*dfgb2

      ap = (1._wp-a4*expd)*dfgb3
      dr = ap*ddpair(2:4,kk)
      dAmatdr(:,i,j) = dAmatdr(:,i,j) - dr*qat(i)
      dAmatdr(:,j,i) = dAmatdr(:,j,i) + dr*qat(j)
      Afac(:,i) = Afac(:,i) - dr*qat(j)
      Afac(:,j) = Afac(:,j) + dr*qat(i)

      qfg = dfgb*expa
      bp = -0.5_wp*expd*(1._wp+dd)*dfgb3
      grddbi = (brad(j)*bp+qfg*discr(i))*qat(j)
      grddbj = (brad(i)*bp+qfg*discr(j))*qat(i)

      dAmatdr(:,:,i) = dAmatdr(:,:,i) + brdr(:,:,i)*grddbi
      dAmatdr(:,:,j) = dAmatdr(:,:,j) + brdr(:,:,j)*grddbj

   enddo

   ! self-energy part
   do i = 1, nat
      gg = exp(-kappa*brad(i))
      aa = 2._wp*ionscr(i)*gg-1.0_wp
      qq = qat(i)/brad(i)
      egb = egb + 0.5_wp*qq*qat(i)*aa
      ap = aa-brad(i)*2._wp*(discr(i)+ionscr(i)*kappa)*gg
      grddbi = -0.5_wp*qq*ap/brad(i)
      dAmatdr(:,:,i) = dAmatdr(:,:,i) + brdr(:,:,i)*grddbi
   enddo

   gborn = egb

end subroutine addBornDerivSaltStill


pure subroutine addBornDerivStill(nat, ntpair, ppind, ddpair, qat, keps, &
      & brad, brdr, gborn, dAmatdr, Afac)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Dielectric screening
   real(wp), intent(in) :: keps

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(in) :: brdr(:, :, :)

   real(wp), intent(inout) :: dAmatdr(:, :, :)
   real(wp), intent(inout) :: Afac(:, :)
   real(wp), intent(out)   :: gborn

   integer :: i,j,k,nnj
   integer :: kk
   real(wp), parameter :: a13=1._wp/3._wp
   real(wp), parameter :: a4=0.25_wp
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp) :: aa,r2,fgb,fgb2,br3
   real(wp) :: qq,dd,expd,dfgb,dfgb2,dfgb3,ap,bp,qfg
   real(wp) :: gg,expa,aii,egb
   real(wp) :: r0vdw,r01,r02,ar02
   real(wp) :: grddbi,grddbj
   real(wp) :: dr(3),r

   egb = 0._wp

   ! GB energy and gradient

   ! compute energy and fgb direct and radii derivatives
   do kk = 1, ntpair
      r = ddpair(1,kk)
      r2 = r*r

      i = ppind(1,kk)
      j = ppind(2,kk)

      ! dielectric scaling of the charges
      qq = qat(i)*qat(j)*keps
      aa = brad(i)*brad(j)
      dd = a4*r2/aa
      expd = exp(-dd)
      fgb2 = r2+aa*expd
      dfgb2 = 1._wp/fgb2
      dfgb = sqrt(dfgb2)
      dfgb3 = dfgb2*dfgb*keps

      egb = egb + qq*dfgb

      ap = (1._wp-a4*expd)*dfgb3
      dr = ap*ddpair(2:4,kk)
      dAmatdr(:,i,j) = dAmatdr(:,i,j) - dr*qat(i)
      dAmatdr(:,j,i) = dAmatdr(:,j,i) + dr*qat(j)
      Afac(:,i) = Afac(:,i) - dr*qat(j)
      Afac(:,j) = Afac(:,j) + dr*qat(i)

      bp = -0.5_wp*expd*(1._wp+dd)*dfgb3
      grddbi = brad(j)*bp
      grddbj = brad(i)*bp

      dAmatdr(:,:,j) = dAmatdr(:,:,j) + brdr(:,:,j)*grddbj*qat(i)
      dAmatdr(:,:,i) = dAmatdr(:,:,i) + brdr(:,:,i)*grddbi*qat(j)

   enddo

   ! self-energy part
   do i = 1, nat
      bp = 1._wp/brad(i)
      qq = qat(i)*bp
      egb = egb + 0.5_wp*qat(i)*qq*keps
      grddbi = -keps*bp*bp*0.5_wp
      dAmatdr(:,:,i) = dAmatdr(:,:,i) + brdr(:,:,i)*grddbi*qat(i)
   enddo

   gborn = egb

end subroutine addBornDerivStill


pure subroutine addBornMatSaltStill(nat, ntpair, ppind, ddpair, kappa, brad, ionscr, &
      & Amat)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Debye screening length
   real(wp), intent(in) :: kappa

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Ion screening
   real(wp), intent(in) :: ionscr(:)

   !> Interaction matrix
   real(wp), intent(inout) :: Amat(:, :)

   integer  :: i, j, nnj
   integer  :: kk
   real(wp), parameter :: a13=1.0_wp/3.0_wp
   real(wp), parameter :: a4=0.25_wp
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp) :: aa, r2, gg, arg, bp
   real(wp) :: dd, expd, fgb, fgb2, dfgb

   ! compute energy and Amat direct and radii derivatives
   do kk = 1, ntpair
      r2=ddpair(1, kk)
      r2=r2*r2

      i=ppind(1, kk)
      j=ppind(2, kk)

      aa=brad(i)*brad(j)
      dd=a4*r2/aa
      expd=exp(-dd)
      fgb2=r2+aa*expd
      fgb=sqrt(r2+aa*expd)
      dfgb=1._wp/fgb
      gg=ionscr(i)+ionscr(j)
      Amat(i, j)=(exp(-kappa*fgb)*gg-1.0_wp)*dfgb + Amat(i, j)
      Amat(j, i)=(exp(-kappa*fgb)*gg-1.0_wp)*dfgb + Amat(j, i)
   enddo

   ! self-energy part
   do i = 1, nat
      gg=ionscr(i)*2.0_wp
      Amat(i, i)= Amat(i, i) + (exp(-kappa*brad(i))*gg-1.0_wp)/brad(i)
   enddo

end subroutine addBornMatSaltStill


pure subroutine addBornMatStill(nat, ntpair, ppind, ddpair, keps, brad, Amat)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Dielectric screening
   real(wp), intent(in) :: keps

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Interaction matrix
   real(wp), intent(inout) :: Amat(:, :)

   integer  :: i, j, nnj
   integer  :: kk
   real(wp), parameter :: a13=1.0_wp/3.0_wp
   real(wp), parameter :: a4=0.25_wp
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp) :: aa, r2, gg, arg, bp
   real(wp) :: dd, expd, fgb, fgb2, dfgb

   ! compute energy and Amat direct and radii derivatives
   do kk = 1, ntpair
      r2 = ddpair(1, kk)
      r2 = r2*r2

      i = ppind(1, kk)
      j = ppind(2, kk)

      aa = brad(i)*brad(j)
      dd = a4*r2/aa
      expd = exp(-dd)
      fgb2 = r2+aa*expd
      dfgb = 1.0_wp/sqrt(fgb2)
      Amat(i, j) = keps*dfgb + Amat(i, j)
      Amat(j, i) = keps*dfgb + Amat(j, i)
   enddo

   ! self-energy part
   do i = 1, nat
      bp = 1._wp/brad(i)
      Amat(i, i) = Amat(i, i) + keps*bp
   enddo

end subroutine addBornMatStill


subroutine addBornMatP16(nat, ntpair, ppind, ddpair, keps, brad, Amat)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of all interacting pairs
   integer, intent(in) :: ntpair

   !> Index list
   integer, intent(in) :: ppind(:, :)

   !> Distances of all pairs
   real(wp), intent(in) :: ddpair(:, :)

   !> Dielectric screening
   real(wp), intent(in) :: keps

   !> Born radii
   real(wp), intent(in) :: brad(:)

   !> Interaction matrix
   real(wp), intent(inout) :: Amat(:, :)

   integer :: kk
   integer :: iat, jat
   real(wp) :: r1, ab, arg, eab, fgb, dfgb, bp

   ! omp parallel do default(none) shared(Amat, ntpair, ppind, ddpair, brad, keps) &
   ! omp private(kk, iat, jat, r1, ab, arg, fgb, dfgb)
   do kk = 1, ntpair
      r1 = ddpair(1, kk)

      iat = ppind(1, kk)
      jat = ppind(2, kk)

      ab = sqrt(brad(iat) * brad(jat))
      arg = ab / (ab + zetaP16o16*r1) ! ab / (1 + ζR/(16·ab))
      arg = arg * arg ! ab / (1 + ζR/(16·ab))²
      arg = arg * arg ! ab / (1 + ζR/(16·ab))⁴
      arg = arg * arg ! ab / (1 + ζR/(16·ab))⁸
      arg = arg * arg ! ab / (1 + ζR/(16·ab))¹⁶
      fgb = r1 + ab*arg
      dfgb = 1.0_wp / fgb

      Amat(iat, jat) = keps*dfgb + Amat(iat, jat)
      Amat(jat, iat) = keps*dfgb + Amat(jat, iat)
   enddo

   ! self-energy part
   do iat = 1, nat
      bp = 1.0_wp/brad(iat)
      Amat(iat, iat) = Amat(iat, iat) + keps*bp
   enddo

end subroutine addBornMatP16


end module solvation_solv_kernel

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!

!> Implementation for generalized Born and related solvation models
module solvation_solv_gbsa
   use iso_fortran_env, only : wp => real64
   use solvation_math_wrapper, only : matDet3x3, dot, gemv, symv

   use solvation_solv_search, only : bisectSearch
   use solvation_solv_born, only : compute_bornr
   use solvation_solv_kernel, only : gbKernel, addBornMatSaltStill, addBornMatStill, &
      & addBornMatP16, addGradientSaltStill, addGradientStill, addGradientP16, &
      & addBornDerivSaltStill, addBornDerivStill
   use solvation_solv_lebedev, only : gridSize, getAngGrid
   use solvation_solv_sasa, only : compute_numsa
   use solvation_solv_state, only : solutionState

   use solvation_type_solvation, only : TSolvation
   implicit none
   private

   public :: TBorn, init
   public :: addGradientHBond
   public :: addHBondDeriv
   public :: getADet, addADetDeriv
   public :: compute_fhb, getDebyeHueckel, update_nnlist_gbsa


   type, extends(TSolvation) :: TBorn

      !> meta info
      character(len=:), allocatable :: solvent
      character(len=:), allocatable :: paramFile
      integer :: state
      real(wp) :: temperature
      real(wp) :: density
      real(wp) :: molarMass
      real(wp) :: bornOffset
      real(wp) :: ionStrength

      !> number of atoms
      integer :: nat

      !> atom types
      integer, allocatable :: at(:)

      !> number of pairs
      integer :: ntpair

      !> number of angular grid points
      integer :: nang 

      !> angular grid
      real(wp), allocatable :: angGrid(:, :)
      real(wp), allocatable :: angWeight(:)

      !> van der Waals radii of the particles
      real(wp), allocatable :: vdwr(:)

      !> pair descreening approximation radii
      real(wp), allocatable :: rho(:)

      !> offset van der Waals radii
      real(wp), allocatable :: svdw(:)

      !> cut-off radius for the Born radius NN list
      real(wp) :: lrcut

      !> cut-off radius for the SASA NN list
      real(wp) :: srcut

      !> number of neighbors for Born radii
      integer :: nnrad

      !> number of neighbors for SASA computation
      integer, allocatable :: nnsas(:)

      !> neighbors of an atom for Born radii
      integer, allocatable :: nnlistr(:, :)

      !> neighbors of an atom for SASA
      integer, allocatable :: nnlists(:, :)

      !> all pairs indeces array
      integer, allocatable :: ppind(:, :)

      !> all pairs vector differences and magnitudes array
      real(wp), allocatable :: ddpair(:, :)

      !> Atom specific surface data
      real(wp), allocatable :: vdwsa(:)
      real(wp), allocatable :: wrp(:)
      real(wp), allocatable :: trj2(:, :)

      !> Dielectric data
      real(wp) :: gborn

      !> Born radii
      real(wp), allocatable :: brad(:)

      !> Salt screening
      real(wp), allocatable :: ionscr(:)
      real(wp), allocatable :: discr(:)

      !> Atomic surfaces
      real(wp) :: gsasa
      real(wp) :: sasagam
      real(wp), allocatable :: gamsasa(:)
      real(wp), allocatable :: sasa(:)

      !> Molecular Surface gradient
      real(wp), allocatable :: dsdr(:, :)
      real(wp), allocatable :: dsdrt(:, :, :)

      !> Hydrogen bond contribution
      real(wp), allocatable :: hbmag(:)

      !> Hydrogen bond contribution
      real(wp), allocatable :: hbw(:)

      !> Hydrogen bond gradient
      real(wp), allocatable :: dhbdw(:)

      !> Born radii gradient
      real(wp), allocatable :: brdr(:, :, :)

      !> Shape descriptor
      real(wp) :: aDet

      !> Use salt screening
      logical :: lsalt

      !> Use hydrogen bond correction
      logical :: lhb

      !> Interaction kernel
      integer :: kernel

      !> Scaling factor for Born radii
      real(wp) :: bornScale

      !> Analytical linearized Poisson-Boltzmann constant
      real(wp) :: alpbet

      !> Dielectric constant
      real(wp) :: dielectricConst

      !> Debye screening length
      real(wp) :: kappa

      !> Ion radii
      real(wp) :: ionRad

      !> Dielectric screening
      real(wp) :: keps

      !> Free energy shift
      real(wp) :: gshift

      !> Scratch for potential
      real(wp), allocatable :: shift(:)

      !> Interaction matrix
      real(wp), allocatable :: bornMat(:, :)

   contains

      !> Update coordinates and internal state
      procedure :: update

      !> Get complete interaction matrix
      procedure :: addBornMatrix

      !> Add potential shift
      procedure :: addShift

      !> Calculate solvation energy
      procedure :: getEnergy

      !> Obtain the respective energy contributions
      procedure :: getEnergyParts

      !> Calculate derivatives of solvation energy
      procedure :: addGradient

      !> Get complete interaction matrix
      procedure :: addBornDeriv

      !> print
      procedure :: info
   
   end type TBorn


   !> Initialize data straucture
   interface init
      module procedure :: initBorn
   end interface init


   real(wp), parameter :: autoaa = 0.52917726_wp
   real(wp), parameter :: aatoau = 1.0_wp/autoaa
   real(wp),parameter :: autokcal = 627.50947428_wp
   real(wp), parameter :: pi = 3.1415926535897932384626433832795029_wp
   real(wp), parameter :: fourpi = 4.0_wp * pi 

   !> Smoothing dielectric function parameters
   real(wp), parameter :: w = 0.3_wp*aatoau
   real(wp), parameter :: w3 = w*(w*w)
   real(wp), parameter :: ah0 = 0.5_wp
   real(wp), parameter :: ah1 = 3._wp/(4.0_wp*w)
   real(wp), parameter :: ah3 = -1._wp/(4.0_wp*w3)

   !> Solvent density (g/cm^3) and molar mass (g/mol)
   real(wp), parameter :: molcm3toau = 8.92388e-2_wp

   !> Surface tension (mN/m=dyn/cm)
   real(wp), parameter :: surfaceTension = 1.0e-5_wp
   real(wp), parameter :: mNmtokcal = 4.0305201015221386e-4_wp
   real(wp), parameter :: kcaltomNm = 1.0_wp/mNmtokcal
   real(wp), parameter :: automNm = autokcal * kcaltomNm

   !> Surface tension (in au)
   real(wp), parameter :: gammas = 1.0e-5_wp

   !> Salt screening
   real(wp), parameter :: kappaConst = 0.7897e-3_wp


contains


!> Initialize data straucture
subroutine initBorn(self, num, vdwRad, dielectricConst, freeEnergyShift, &
      & descreening, bornScale, bornOffset, surfaceTension, probeRad, rCutoff, &
      & rOffset, nAng, hBondStrength, temperature, kernel, alpb, ionSt, ionRad)

   !> Error source
   character(len=*), parameter :: source = 'solv_gbsa_initBorn'

   !> Instance of the solvation model
   type(TBorn), intent(out) :: self

   !> Atomic numbers
   integer, intent(in) :: num(:)

   !> Van-der-Waals Radii
   real(wp), intent(in) :: vdwRad(:)

   !> Dielectric constant of the solvent
   real(wp), intent(in) :: dielectricConst

   !> State specific free energy offset
   real(wp), intent(in) :: freeEnergyShift

   !> Dielectric descreening parameter
   real(wp), intent(in) :: descreening(:)

   !> Scaling factor for Born radii
   real(wp), intent(in) :: bornScale

   !> Offset parameter for Born radii integration
   real(wp), intent(in) :: bornOffset

   !> Surface tension scaling
   real(wp), intent(in) :: surfaceTension(:)

   !> Probe radius of the solvent
   real(wp), intent(in) :: probeRad

   !> Real-space cutoff for Born radii integration
   real(wp), intent(in) :: rCutoff

   !> Offset for surface integration cutoff
   real(wp), intent(in) :: rOffset

   !> Number of angular grid points for integration
   integer, intent(in) :: nAng

   !> Hydrogen bond magnitude
   real(wp), intent(in) :: hBondStrength(:)

   !> Temperature
   real(wp), intent(in) :: temperature

   !> Generalized Born interaction kernel
   integer, intent(in) :: kernel

   !> Use analytical linearized Poisson-Boltzmann model instead of GB
   logical, intent(in) :: alpb

   !> Ion strength
   real(wp), intent(in), optional :: ionSt

   !> Ion radius
   real(wp), intent(in), optional :: ionRad

   integer :: iat, izp, jat, ij, iang, ierr
   real(wp) :: r

   self%kernel = kernel
   self%gshift = freeEnergyShift
   self%dielectricConst = dielectricConst
   if (alpb) then
      self%alpbet = 0.571412_wp / self%dielectricConst
   else
      self%alpbet = 0.0_wp
   end if
   self%keps = (1.0_wp/self%dielectricConst - 1.0_wp) / (1.0_wp + self%alpbet)

   self%nat = size(num)
   self%at = num
   self%ntpair = self%nat*(self%nat-1)/2
   allocate(self%ppind(2, self%ntpair))
   allocate(self%nnsas(self%nat))
   allocate(self%nnlistr(3, self%ntpair))
   allocate(self%nnlists(self%nat, self%nat))
   allocate(self%ddpair(4, self%ntpair))
   ij = 0
   do iat = 1, self%nat
      do jat = 1, iat-1
         ij = ij+1
         self%ppind(1, ij) = iat
         self%ppind(2, ij) = jat
      enddo
   enddo

   if (present(ionSt)) then
      self%lsalt = ionSt > 0.0_wp
   else
      self%lsalt = .false.
   end if
   if (self%lsalt) then
      allocate(self%ionscr(self%nat))
      allocate(self%discr(self%nat))
      if (present(ionRad)) then
         self%ionRad = ionRad
      else
         self%ionRad = 0.0_wp
      end if
      self%kappa = sqrt(self%dielectricConst*temperature*kappaConst/ionSt)*aatoau
      self%kappa = 1.0_wp/self%kappa
   end if

   self%lrcut = rCutoff
   self%bornScale = bornScale
   allocate(self%vdwr(self%nat))
   allocate(self%rho(self%nat))
   allocate(self%svdw(self%nat))
   allocate(self%brad(self%nat))
   allocate(self%brdr(3, self%nat, self%nat))

   do iat = 1, self%nat
      izp = num(iat)
      self%vdwr(iat) = vdwRad(izp)
      self%rho(iat) = self%vdwr(iat) * descreening(izp)
      self%svdw(iat) = self%vdwr(iat) - bornOffset
   end do

   allocate(self%vdwsa(self%nat))
   allocate(self%trj2(2, self%nat))
   allocate(self%wrp(self%nat))
   allocate(self%gamsasa(self%nat))
   allocate(self%sasa(self%nat))
   allocate(self%dsdr(3, self%nat))
   allocate(self%dsdrt(3, self%nat, self%nat))
   do iat = 1, self%nat
      izp = num(iat)
      self%vdwsa(iat) = vdwRad(izp) + probeRad
      self%trj2(1, iat) = (self%vdwsa(iat)-w)**2
      self%trj2(2, iat) = (self%vdwsa(iat)+w)**2
      r=self%vdwsa(iat)+w
      self%wrp(iat)=(0.25_wp/w+ &
         &            3.0_wp*ah3*(0.2_wp*r*r-0.5_wp*r*self%vdwsa(iat)+ &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
      r=self%vdwsa(iat)-w
      self%wrp(iat)=self%wrp(iat)-(0.25/w+ &
         &    3.0_wp*ah3*(0.2_wp*r*r-0.5_wp*r*self%vdwsa(iat)+ &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
      self%gamsasa(iat) = surfaceTension(izp)
   end do
   self%srcut = 2 * (w + maxval(self%vdwsa)) + rOffset

   call bisectSearch(iang, gridSize, nAng)
   allocate(self%angGrid(3, gridSize(iang)))
   allocate(self%angWeight(gridSize(iang)))
   call getAngGrid(iang, self%angGrid, self%angWeight, ierr)

   allocate(self%hbmag(self%nat))
   do iat = 1, self%nat
      izp = num(iat)
      self%hbmag(iat) = hBondStrength(izp)
   end do
   self%lhb = any(self%hbmag < 0.0_wp)
   if (self%lhb) then
      allocate(self%hbw(self%nat))
      allocate(self%dhbdw(self%nat))
   end if

   allocate(self%shift(self%nat))
   allocate(self%bornMat(self%nat, self%nat))

end subroutine initBorn


subroutine update(self, num, xyz)

   !> Instance of the solvation model
   class(TBorn), intent(inout) :: self

   !> Atomic numbers
   integer, intent(in) :: num(:)

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   ! initialize the neighbor list
   call update_nnlist_gbsa(self%nat, self%ntpair, self%ppind, xyz, &
      & self%lrcut, self%srcut, self%nnsas, self%nnlists, self%nnrad, &
      & self%nnlistr, self%ddpair, .false.)

   call compute_bornr(self%nat, self%nnrad, self%nnlistr, self%ddpair, &
      & self%vdwr, self%rho, self%svdw, self%bornScale, self%brad, self%brdr)

   ! compute solvent accessible surface and its derivatives
   call compute_numsa(self%nat, self%nnsas, self%nnlists, xyz, self%vdwsa, &
      & self%wrp, self%trj2, self%angWeight, self%angGrid, &
      & self%sasa, self%dsdrt)

   ! contract surface gradient
   call gemv(self%dsdrt, self%gamsasa, self%dsdr)
   self%gsasa = dot(self%sasa, self%gamsasa)

   ! compute the Debye-Hueckel ion exclusion term
   if (self%lsalt) then
      call getDebyeHueckel(self%nat, self%dielectricConst, self%kappa, &
         & self%ionRad, self%brad, self%ionscr, self%discr)
   end if

   ! compute the HB term
   if (self%lhb) then
      call compute_fhb(self%nat, self%hbmag, self%vdwsa, self%sasa, &
         & self%hbw, self%dhbdw)
   end if

   if (self%alpbet > 0.0_wp) then
      call getADet(self%nat, xyz, self%vdwr, self%aDet)
   end if

   self%bornMat(:, :) = 0.0_wp
   call self%addBornMatrix(num, xyz, self%bornMat)

end subroutine update


subroutine addBornMatrix(self, num, xyz, bornMat)

   !> Instance of the solvation model
   class(TBorn), intent(inout) :: self

   !> Atomic numbers
   integer, intent(in) :: num(:)

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   !> Born interaction matrix
   real(wp), intent(inout) :: bornMat(:, :)

   integer :: iat

   select case(self%kernel)
   case(gbKernel%still)
      if (self%lsalt) then
         call addBornMatSaltStill(self%nat, self%ntpair, self%ppind, self%ddpair, &
            & self%kappa, self%brad, self%ionscr, bornMat)
      else
         call addBornMatStill(self%nat, self%ntpair, self%ppind, self%ddpair, &
            & self%keps, self%brad, bornMat)
      end if
   case(gbKernel%p16)
      call addBornMatP16(self%nat, self%ntpair, self%ppind, self%ddpair, &
         & self%keps, self%brad, bornMat)
   end select

   ! compute the HB term
   if (self%lhb) then
      do iat = 1, self%nat
         bornMat(iat, iat) = bornMat(iat, iat) + 2*self%hbw(iat)
      enddo
   endif

   ! ALPB shape dependent correction for charged systems
   if (self%alpbet > 0.0_wp) then
      bornMat(:self%nat, :self%nat) = bornMat(:self%nat, :self%nat) &
         & + self%keps * self%alpbet / self%aDet
   end if

end subroutine addBornMatrix


!> Add potential shift
subroutine addShift(self, qat, qsh, atomicShift, shellShift)

   !> Error source
   character(len=*), parameter :: source = 'solv_gbsa_addShift'

   !> Instance of the solvation model
   class(TBorn), intent(inout) :: self

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Atomic potential shift
   real(wp), intent(inout) :: atomicShift(:)

   !> Shell-resolved potential shift
   real(wp), intent(inout) :: shellShift(:)

   call symv(self%bornMat, qat, self%shift)
   atomicShift(:) = atomicShift + self%shift

end subroutine addShift


!> Calculate solvation energy
subroutine getEnergy(self, qat, qsh, energy)

   !> Error source
   character(len=*), parameter :: source = 'solv_gbsa_getEnergy'

   !> Instance of the solvation model
   class(TBorn), intent(inout) :: self

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Total solvation energy
   real(wp), intent(out) :: energy

   call symv(self%bornMat, qat, self%shift, alpha=0.5_wp)
   energy = dot(qat, self%shift) + self%gsasa + self%gshift

end subroutine getEnergy


!> Calculate solvation energy
subroutine getEnergyParts(self, qat, qsh, gborn, ghb, gsasa, gshift)

   !> Error source
   character(len=*), parameter :: source = 'solv_gbsa_getEnergy'

   !> Instance of the solvation model
   class(TBorn), intent(inout) :: self

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Born solvation energy
   real(wp), intent(out) :: gborn

   !> Hydrogen bonding energy
   real(wp), intent(out) :: ghb

   !> Non-polar surface energy
   real(wp), intent(out) :: gsasa

   !> State specific shift
   real(wp), intent(out) :: gshift

   integer :: iat

   ghb = 0.0_wp
   if (self%lhb) then
      do iat = 1, self%nat
         ghb = ghb + self%hbw(iat) * qat(iat)**2
      end do
   end if

   call symv(self%bornMat, qat, self%shift, alpha=0.5_wp)
   gborn = dot(qat, self%shift) - ghb

   gsasa = self%gsasa
   gshift = self%gshift

end subroutine getEnergyParts


!> Calculate derivatives of solvation energy
subroutine addGradient(self, num, xyz, qat, qsh, gradient)

   !> Error source
   character(len=*), parameter :: source = 'solv_gbsa_addGradient'

   !> Instance of the solvation model
   class(TBorn), intent(inout) :: self

   !> Atomic numbers
   integer, intent(in) :: num(:)

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)

   real(wp) :: gborn, ghb

   select case(self%kernel)
   case(gbKernel%still)
      if (self%lsalt) then
         call addGradientSaltStill(self%nat, self%ntpair, self%ppind, self%ddpair, &
            & qat, self%kappa, self%brad, self%brdr, self%ionscr, self%discr, &
            & gborn, gradient)
      else
         call addGradientStill(self%nat, self%ntpair, self%ppind, self%ddpair, &
            & qat, self%keps, self%brad, self%brdr, gborn, gradient)
      end if
   case(gbKernel%p16)
      call addGradientP16(self%nat, self%ntpair, self%ppind, self%ddpair, &
         & qat, self%keps, self%brad, self%brdr, gborn, gradient)
   end select

   gradient = gradient + self%dsdr

   if (self%lhb) then
      call addGradientHBond(self%nat, self%at, qat, self%hbw, self%dhbdw, &
         & self%dsdrt, ghb, gradient)
   else
      ghb = 0.0_wp
   endif

   if (self%alpbet > 0.0_wp) then
      gborn = gborn + sum(qat)**2 * self%alpbet / self%aDet * self%kEps
      call addADetDeriv(self%nat, xyz, self%vdwr, self%kEps*self%alpbet, &
         & qat, gradient)
   end if

end subroutine addGradient


subroutine getADet(nAtom, xyz, rad, aDet)

   !> Number of atoms
   integer, intent(in) :: nAtom

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   !> Atomic radii
   real(wp), intent(in) :: rad(:)

   !> Shape descriptor of the structure
   real(wp), intent(out) :: aDet

   integer :: iat
   real(wp) :: r2, rad2, rad3, totRad3, vec(3), center(3), inertia(3, 3)
   real(wp), parameter :: tof = 2.0_wp/5.0_wp, unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   totRad3 = 0.0_wp
   center(:) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      totRad3 = totRad3 + rad3
      center(:) = center + xyz(:, iat) * rad3
   end do
   center = center / totRad3

   inertia(:, :) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      r2 = sum(vec**2)
      inertia(:, :) = inertia + rad3 * ((r2 + tof*rad2) * unity &
         & - spread(vec, 1, 3) * spread(vec, 2, 3))
   end do

   aDet = sqrt(matDet3x3(inertia)**(1.0_wp/3.0_wp)/(tof*totRad3))

end subroutine getADet


subroutine addADetDeriv(nAtom, xyz, rad, kEps, qvec, gradient)

   !> Number of atoms
   integer, intent(in) :: nAtom

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   !> Atomic radii
   real(wp), intent(in) :: rad(:)

   real(wp), intent(in) :: kEps
   real(wp), intent(in) :: qvec(:)

   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)

   integer :: iat
   real(wp) :: r2, rad2, rad3, totRad3, vec(3), center(3), inertia(3, 3), aDet
   real(wp) :: aDeriv(3, 3), qtotal
   real(wp), parameter :: tof = 2.0_wp/5.0_wp, unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   qtotal = 0.0_wp
   totRad3 = 0.0_wp
   center(:) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      totRad3 = totRad3 + rad3
      center(:) = center + xyz(:, iat) * rad3
      qtotal = qtotal + qvec(iat)
   end do
   center = center / totRad3

   inertia(:, :) = 0.0_wp
   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      r2 = sum(vec**2)
      inertia(:, :) = inertia + rad3 * ((r2 + tof*rad2) * unity &
         & - spread(vec, 1, 3) * spread(vec, 2, 3))
   end do
   aDet = sqrt(matDet3x3(inertia)**(1.0_wp/3.0_wp)/(tof*totRad3))

   aDeriv(:, :) = reshape([&
      & inertia(1,1)*(inertia(2,2)+inertia(3,3))-inertia(1,2)**2-inertia(1,3)**2, &
      & inertia(1,2)*inertia(3,3)-inertia(1,3)*inertia(2,3), & ! xy
      & inertia(1,3)*inertia(2,2)-inertia(1,2)*inertia(3,2), & ! xz
      & inertia(1,2)*inertia(3,3)-inertia(1,3)*inertia(2,3), & ! xy
      & inertia(2,2)*(inertia(1,1)+inertia(3,3))-inertia(1,2)**2-inertia(2,3)**2, &
      & inertia(1,1)*inertia(2,3)-inertia(1,2)*inertia(1,3), & ! yz
      & inertia(1,3)*inertia(2,2)-inertia(1,2)*inertia(3,2), & ! xz
      & inertia(1,1)*inertia(2,3)-inertia(1,2)*inertia(1,3), & ! yz
      & inertia(3,3)*(inertia(1,1)+inertia(2,2))-inertia(1,3)**2-inertia(2,3)**2],&
      & shape=[3, 3]) * (250.0_wp / (48.0_wp * totRad3**3 * aDet**5)) &
      & * (-0.5_wp * kEps * qtotal**2 / aDet**2)

   do iat = 1, nAtom
      rad2 = rad(iat) * rad(iat)
      rad3 = rad2 * rad(iat)
      vec(:) = xyz(:, iat) - center
      gradient(:, iat) = gradient(:, iat) + rad3 * matmul(aderiv, vec)
   end do

end subroutine addADetDeriv


!> compute the Debye-Hueckel ion exclusion term
pure subroutine getDebyeHueckel(nat, dielectricConst, kappa, ionRad, brad, &
      & ionscr, discr)

   integer, intent(in) :: nat
   real(wp), intent(in) :: kappa
   real(wp), intent(in) :: dielectricConst
   real(wp), intent(in) :: brad(:)
   real(wp), intent(in) :: ionRad
   real(wp), intent(out) :: ionscr(:)
   real(wp), intent(out) :: discr(:)

   integer :: i
   real(wp) :: aa, gg

   aa=0.5_wp/dielectricConst
   do i = 1, nat
      gg=kappa*(brad(i)+ionRad)
      ionscr(i)=aa*exp(gg)/(1.0_wp+gg)
      discr(i)=ionscr(i)*kappa*gg/(1.0_wp+gg)
   enddo

end subroutine getDebyeHueckel


!> setup a pairlist and compute pair distances of all neighbors
!  within thresholds lrcut and srcut.
subroutine update_nnlist_gbsa(nat, ntpair, ppind, xyz, lrcut, srcut, &
      & nnsas, nnlists, nnrad, nnlistr, ddpair, parallel)

   integer, intent(in) :: nat
   integer, intent(in) :: ntpair
   integer, intent(in) :: ppind(:, :)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: lrcut
   real(wp), intent(in) :: srcut
   integer, intent(out) :: nnsas(:)
   integer, intent(out) :: nnlists(:, :)
   integer, intent(out) :: nnrad
   integer, intent(out) :: nnlistr(:, :)
   real(wp), intent(out) :: ddpair(:, :)
   logical, intent(in) :: parallel

   if (parallel) then
      call update_nnlist_gbsa_parallel(nat, ntpair, ppind, xyz, &
         & lrcut, srcut, nnsas, nnlists, nnrad, nnlistr, ddpair)
   else
      call update_nnlist_gbsa_sequential(nat, ntpair, ppind, xyz, &
         & lrcut, srcut, nnsas, nnlists, nnrad, nnlistr, ddpair)
   endif

end subroutine update_nnlist_gbsa
!> setup a pairlist and compute pair distances of all neighbors
!  within thresholds lrcut and srcut.
!  OMP parallel version.
subroutine update_nnlist_gbsa_parallel(nat, ntpair, ppind, xyz, lrcut, &
      & srcut, nnsas, nnlists, nnrad, nnlistr, ddpair)
!$ use omp_lib

   integer, intent(in) :: nat
   integer, intent(in) :: ntpair
   integer, intent(in) :: ppind(:, :)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: lrcut
   real(wp), intent(in) :: srcut
   integer, intent(out) :: nnsas(:)
   integer, intent(out) :: nnlists(:, :)
   integer, intent(out) :: nnrad
   integer, intent(out) :: nnlistr(:, :)
   real(wp), intent(out) :: ddpair(:, :)

   integer kk, i1, i2
   real(wp) rcutn2, lrcut2, srcut2
   real(wp) x, y, z, dr2
   integer ip, ip2, thrid, nproc
   integer, allocatable :: npid(:)
   integer, allocatable :: plisttr(:, :, :)
   integer, allocatable :: nntmp(:)
   integer, allocatable :: nnls(:, :)

   nproc=1
!$ nproc=omp_get_max_threads()

   allocate(plisttr(3, ntpair, nproc), nnls(nat, nat))
   allocate(nntmp(nat), npid(nproc))
   npid = 0

   lrcut2 = lrcut*lrcut
   srcut2 = srcut*srcut

   nnsas=0
   nnlists=0
!$omp parallel default(none) &
!$omp&         shared ( xyz,lrcut2,srcut2,ntpair,ppind,nat,nnlists,nnsas,ddpair ) &
!$omp&         private( i1,i2,x,y,z,dr2,ip,ip2,thrid,nntmp,nnls ) &
!$omp&         shared ( plisttr, npid )
   ip=0
   ip2=0
   nntmp=0
   nnls=0
   thrid=1
!$ thrid=omp_get_thread_num() + 1
!$omp do
   do kk=1,ntpair
      i1=ppind(1,kk)
      i2=ppind(2,kk)
      x=xyz(1,i1)-xyz(1,i2)
      y=xyz(2,i1)-xyz(2,i2)
      z=xyz(3,i1)-xyz(3,i2)
      dr2=x**2+y**2+z**2
      ddpair(2,kk)=x
      ddpair(3,kk)=y
      ddpair(4,kk)=z
      ddpair(1,kk)=sqrt(dr2)
      if(dr2.lt.lrcut2) then
         ip = ip + 1
         plisttr(1,ip,thrid)=i1
         plisttr(2,ip,thrid)=i2
         plisttr(3,ip,thrid)=kk
         if(dr2.lt.srcut2) then
            nntmp(i1) = nntmp(i1) + 1
            nntmp(i2) = nntmp(i2) + 1
            nnls(nntmp(i1),i1)=i2
            nnls(nntmp(i2),i2)=i1
         endif
      endif
   enddo
!$omp end do
   npid(thrid)=ip
!$omp critical
   do i1=1,nat
      do i2=1,nntmp(i1)
         nnlists(nnsas(i1)+i2,i1)=nnls(i2,i1)
      enddo
      nnsas(i1)=nnsas(i1)+nntmp(i1)
   enddo
!$omp end critical
!$omp end parallel

   nnrad=0
   do thrid=1,nproc
      do kk = nnrad+1,nnrad+npid(thrid)
         nnlistr(1:3,kk)=plisttr(1:3,kk-nnrad,thrid)
      enddo
      nnrad = nnrad + npid(thrid)
   enddo

   deallocate(nntmp,nnls)

end subroutine update_nnlist_gbsa_parallel
!> setup a pairlist and compute pair distances of all neighbors
!  within thresholds lrcut and srcut
!  Sequential version.
pure subroutine update_nnlist_gbsa_sequential(nat, ntpair, ppind, xyz, lrcut, &
      & srcut, nnsas, nnlists, nnrad, nnlistr, ddpair)

   integer, intent(in) :: nat
   integer, intent(in) :: ntpair
   integer, intent(in) :: ppind(:, :)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: lrcut
   real(wp), intent(in) :: srcut
   integer, intent(out) :: nnsas(:)
   integer, intent(out) :: nnlists(:, :)
   integer, intent(out) :: nnrad
   integer, intent(out) :: nnlistr(:, :)
   real(wp), intent(out) :: ddpair(:, :)

   integer kk, i1, i2
   real(wp) rcutn2, lrcut2, srcut2
   real(wp) x, y, z, dr2
   integer ip, ip2

   lrcut2 = lrcut*lrcut
   srcut2 = srcut*srcut

   nnsas=0
   nnlists=0
   ip=0
   ip2=0
   nnlistr=0
   do kk=1,ntpair
      i1=ppind(1,kk)
      i2=ppind(2,kk)
      x=xyz(1,i1)-xyz(1,i2)
      y=xyz(2,i1)-xyz(2,i2)
      z=xyz(3,i1)-xyz(3,i2)
      dr2=x**2+y**2+z**2
      ddpair(2,kk)=x
      ddpair(3,kk)=y
      ddpair(4,kk)=z
      ddpair(1,kk)=sqrt(dr2)
      if(dr2.lt.lrcut2) then
         ip = ip + 1
         nnlistr(1,ip)=i1
         nnlistr(2,ip)=i2
         nnlistr(3,ip)=kk
         if(dr2.lt.srcut2) then
            nnsas(i1) = nnsas(i1) + 1
            nnsas(i2) = nnsas(i2) + 1
            nnlists(nnsas(i1),i1)=i2
            nnlists(nnsas(i2),i2)=i1
         endif
      endif
   enddo
   nnrad = ip

end subroutine update_nnlist_gbsa_sequential


!> Compute contributions to potential for hydrogen bonding correction
pure subroutine compute_fhb(nat, hbmag, vdwsa, sasa, hbw, dhbdw)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Hydrogen bonding strength
   real(wp), intent(in) :: hbmag(:)

   !> Van-der-Waals radius
   real(wp), intent(in) :: vdwsa(:)

   !> Surface area including surface tension
   real(wp), intent(in) :: sasa(:)

   !> Actual hydrogen bonding contribution
   real(wp), intent(out) :: hbw(:)

   !> Actual hydrogen bonding contribution
   real(wp), intent(out) :: dhbdw(:)

   integer  :: i
   integer  :: iz, nhb
   real(wp) :: hbed, dhbed
   real(wp) :: smaxd, sasad, sasaw
   real(wp) :: sfw, dsfw, w3, w2, w1
   integer  :: j
   real(wp) :: wbh, wah

   hbw(:) = 0.0_wp
   dhbdw(:) = 0.0_wp

   do i = 1, nat
      ! SASA-D for HB
      smaxd = 1.0_wp/(vdwsa(i)*vdwsa(i))
      sasad = sasa(i)*smaxd
      hbw(i) = hbmag(i)*sasad
      dhbdw(i) = hbmag(i)*smaxd
   enddo

end subroutine compute_fhb


!> Compute contributions to energy and gradient for hydrogen bonding correction
pure subroutine addGradientHBond(nat, at, q, hbw, dhbdw, dsdrt, ghb, gradient)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Atomic numbers
   integer, intent(in) :: at(:)

   !> Partial charges
   real(wp), intent(in) :: q(:)

   !> Actual hydrogen bonding contribution
   real(wp), intent(in) :: hbw(:)

   !> Actual hydrogen bonding contribution
   real(wp), intent(in) :: dhbdw(:)

   !> Derivative of the surface area w.r.t. to cartesian coordinates
   real(wp), intent(in) :: dsdrt(:, :, :)

   !> Hydrogen bonding energy
   real(wp), intent(out)   :: ghb

   !> Gradient of hydrogen bonding energy
   real(wp), intent(inout) :: gradient(:, :)

   integer  :: i, j
   real(wp) :: dhbed
   real(wp) :: qq

   ghb=0.0_wp
   do i = 1, nat
      qq = q(i)*q(i)
      ghb = ghb + hbw(i)*qq
   enddo

   do i = 1, nat
      dhbed = dhbdw(i)
      if(abs(dhbed).le.0.0_wp) cycle
      dhbed=dhbed*q(i)*q(i)
      do j = 1, nat
         gradient(:, j) = gradient(:, j) + dsdrt(:, j, i)*dhbed
      enddo
   enddo

end subroutine addGradientHBond


pure subroutine addBornDeriv(self,q,gborn,ghb,dAmatdr,Afac)
   implicit none
   class(TBorn), intent(in) :: self

   real(wp), intent(in)    :: q(self%nat)
   real(wp), intent(inout) :: dAmatdr(3,self%nat,self%nat)
   real(wp), intent(inout) :: Afac(3,self%nat)
   real(wp), intent(out)   :: gborn
   real(wp), intent(out)   :: ghb

   integer :: i,j,k,nnj
   integer :: kk
   real(wp), parameter :: a13=1._wp/3._wp
   real(wp), parameter :: a4=0.25_wp
   real(wp), parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp) :: aa,r2,fgb,fgb2,br3
   real(wp) :: qq,dd,expd,dfgb,dfgb2,dfgb3,ap,bp,qfg
   real(wp) :: gg,expa,aii,egb
   real(wp) :: r0vdw,r01,r02,ar02
   real(wp) :: grddbi,grddbj
   real(wp) :: dr(3),r

   egb = 0._wp

   select case(self%kernel)
   case(gbKernel%still)
      if (self%lsalt) then
         call addBornDerivSaltStill(self%nat, self%ntpair, self%ppind, &
            & self%ddpair, q, self%kappa, self%brad, self%brdr, self%ionscr, &
            & self%discr, gborn, dAmatdr, Afac)
      else
         call addBornDerivStill(self%nat, self%ntpair, self%ppind, self%ddpair, &
            & q, self%keps, self%brad, self%brdr, gborn, dAmatdr, Afac)
      endif
   case(gbKernel%p16)
   end select

   if (self%lhb) then
      call addHBondDeriv(self%nat, q, self%hbw, self%dhbdw, self%dsdrt, &
         & ghb, dAmatdr)
   endif

end subroutine addBornDeriv


pure subroutine addHBondDeriv(nat,q,hbw,dhbdw,dsdrt,ghb,dAmatdr)

   integer, intent(in) :: nat
   real(wp), intent(in) :: q(:)
   real(wp), intent(in) :: hbw(:)
   real(wp), intent(in) :: dhbdw(:)
   real(wp), intent(in) :: dsdrt(:, :, :)
   real(wp), intent(out) :: ghb
   real(wp), intent(inout) :: dAmatdr(:, :, :)

   integer  :: i,j
   real(wp) :: dhbed
   real(wp) :: qq

   ghb=0.0_wp
   do i = 1, nat
      qq = q(i)*q(i)
      ghb = ghb + hbw(i)*qq
   enddo

   do i = 1, nat
      dhbed=dhbdw(i)
      if(abs(dhbed).le.0.0_wp) cycle
      dhbed=dhbed*q(i)
      dAmatdr(:,:,i) = dAmatdr(:,:,i) + dsdrt(:,:,i)*dhbed
   enddo

end subroutine addHBondDeriv


subroutine info(self, unit)

   !> Data structure
   class(TBorn), intent(in) :: self

   !> Unit for IO
   integer, intent(in) :: unit


   write(unit, '(8x, a )') repeat('-',50)
   write(unit, '(8x, a, ":", t40)', advance='no') "Solvation model"
   if (self%alpbet > 0.0_wp) then
      write(unit, '(a)') "ALPB"
   else
      write(unit, '(a)') "GBSA"
   end if
   write(unit, '(8x, a )') repeat('-',50)

   write(unit, '(8x, a, t40, a)') "Solvent", self%solvent
   write(unit, '(8x, a, t40, a)') "Parameter file", self%paramFile
   write(unit, '(8x, a, t40, es14.4)') &
      & "Dielectric constant", self%dielectricConst

   write(unit, '(8x, a, t40)', advance='no') "Reference state"
   select case(self%state)
   case default
      write(unit, '(a)') 'gsolv [1 M gas/solution]'
   case(solutionState%reference)
      write(unit, '(a)') 'gsolv=reference [X=1]'
   case(solutionState%mol1bar)
      write(unit, '(a)') 'gsolv [1 bar gas/1 M solution]'
   end select

   write(unit, '(8x, a, t40, es14.4, 1x, a, t60, es14.4, 1x, a)') &
      & "Free energy shift", self%gshift, "Eh", &
      & self%gshift * autokcal, "kcal/mol"
   write(unit, '(8x, a, t40, es14.4, 1x, a)') &
      & "Temperature", self%temperature, "K"
   write(unit, '(8x, a, t40, es14.4, 1x, a)') &
      & "Density", self%density / (molcm3toau/self%molarMass), "kg/L"
   write(unit, '(8x, a, t40, es14.4, 1x, a)') &
      & "Solvent mass", self%molarMass, "g/mol"

   write(unit, '(8x, a, t40)', advance='no') "Interaction kernel"
   select case(self%kernel)
   case default
      write(unit, '(i0, 1x, a)') self%kernel, '(internal error)'
   case(gbKernel%still)
      write(unit, '(a)') 'Still'
   case(gbKernel%p16)
      write(unit, '(a)') 'P16'
   end select

   write(unit, '(8x, a, t40, es14.4)') &
      "Born radius scaling (c1)", self%bornScale
   write(unit, '(8x, a, t40, a)') "Born radii integrator", "GBOBC"
   write(unit, '(8x, a, t40, es14.4, 1x, a, t60, es14.4, 1x, a)') &
      "Born offset", self%bornOffset, "a0", self%bornOffset/autoaa, "AA"

   write(unit, '(8x, a, t40)', advance='no') "H-bond correction"
   if (any(self%hbmag < 0.0_wp)) then
      write(unit, '(a)') "true"
   else
      write(unit, '(a)') "false"
   end if

   write(unit, '(8x, a, t40)', advance='no') "Ion screening"
   if (self%ionStrength > 0.0_wp) then
      write(unit, '(a)') "true"
   else
      write(unit, '(a)') "false"
   end if

   if (allocated(self%gamsasa)) then
      write(unit, '(8x, a, t40, es14.4, 1x, a, t60, es14.4, 1x, a)') &
         "Surface tension", surfaceTension, "Eh", surfaceTension*automNm, "dyn/cm"
   end if

   write(unit, '(8x, a, t40, i14, 1x, a)') &
      "Grid points", self%nAng, "per atom"

   write(unit,*)
end subroutine info


end module solvation_solv_gbsa

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!


!> Gathers the input data needed to create solvation models
module solvation_solv_input
   use iso_fortran_env, only : wp => real64
   use solvation_solv_kernel, only : gbKernel
   use solvation_solv_state, only : solutionState
   implicit none
   private

   real(wp), parameter :: autoaa = 0.52917726_wp
   real(wp), parameter :: aatoau = 1.0_wp/autoaa


   public :: TSolvInput

   !> Input data for the solvation model
   type :: TSolvInput

      !> Selected solvent
      character(len=:), allocatable :: solvent

      !> Use the analytical linearized Poisson Boltzmann model
      logical :: alpb = .true.

      !> Generalized Born interaction kernel
      integer :: kernel = gbKernel%p16

      !> Use COSMO solvation model instead of Born based one
      logical :: cosmo = .false.

      !> Reference state
      integer :: state = solutionState%gsolv

      !> Temperature
      real(wp) :: temperature = 298.15_wp

      !> Number of grid points
      integer :: nAng = 230

      !> Ion strength
      real(wp) :: ionStrength = 0.0_wp

      !> Ion radius
      real(wp) :: ionRad = 0.0_wp

      !> Onufriev-Bashford-Case correction
      real(wp) :: obcPar(3) = [1.0_wp, 0.8_wp, 4.85_wp]

      !> Dielectric smoothing parameter
      real(wp) :: smoothPar = 0.3_wp * aatoau

      !> Born radii integration cutoff
      real(wp) :: bornCutoff = 35.0_wp * aatoau

      !> SASA integration offset
      real(wp) :: surfaceOffset = 2.0_wp * aatoau

      !> Threshold for surface elements
      real(wp) :: surfaceThr = 1.0e-6_wp

   end type TSolvInput


#ifdef __PGIC__
   !> Create a custom constructor due to PGI 20.7 failing for derived type
   !  constructors using deferred-length character variables
   interface TSolvInput
      module procedure :: pgiWrapper
   end interface TSolvInput
#endif


contains


function pgiWrapper(solvent, alpb, kernel, state, temperature, nAng, &
      & ionStrength, ionRad) result(self)

   !> Selected solvent
   character(len=*), intent(in) :: solvent

   !> Use the analytical linearized Poisson Boltzmann model
   logical, intent(in), optional :: alpb

   !> Generalized Born interaction kernel
   integer, intent(in), optional :: kernel

   !> Reference state
   integer, intent(in), optional :: state

   !> Temperature
   real(wp), intent(in), optional :: temperature

   !> Number of grid points
   integer, intent(in), optional :: nAng

   !> Ion strength
   real(wp), intent(in), optional :: ionStrength

   !> Ion radius
   real(wp), intent(in), optional :: ionRad

   !> Instance of the solvation input data
   type(TSolvInput) :: self

   self%solvent = solvent
   if (present(alpb)) self%alpb = alpb
   if (present(kernel)) self%kernel = kernel
   if (present(state)) self%state = state
   if (present(temperature)) self%temperature = temperature
   if (present(nAng)) self%nAng = nAng
   if (present(ionStrength)) self%ionStrength = ionStrength
   if (present(ionRad)) self%ionRad = ionRad

end function pgiWrapper


end module solvation_solv_input

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!================================================================================!
module gfn0_prints
  use iso_fortran_env,only:wp => real64,stdout => output_unit
  use gfn0_types
  use gfn0_parameter
  use gfn0_basisset
  use wfn_module
  implicit none
  public

  !>  convert Hartree to eV and back
  real(wp),parameter,private :: autoev = 27.21138505_wp
  real(wp),parameter,private :: evtoau = 1.0_wp/autoev


contains
!========================================================================================!
  subroutine pr_wfn_param(iunit,xtbData,basis,wfn)
    integer :: iunit
    type(TxTBData_mod)  :: xtbData
    type(Tbasisset)     :: basis
    type(TWavefunction) :: wfn
    real(wp) :: intcut
    character(len=*),parameter :: scifmt = &
                                  '(10x,":",2x,a,e22.7,1x,a,1x,":")'
    character(len=*),parameter :: dblfmt = &
                                  '(10x,":",2x,a,f18.7,5x,a,1x,":")'
    character(len=*),parameter :: intfmt = &
                                  '(10x,":",2x,a,i18,      10x,":")'
    character(len=*),parameter :: chrfmt = &
                                  '(10x,":",2x,a,a18,      10x,":")'

    intcut = 25.0_wp - 10.0_wp * log10(xtbData%acc)
    intcut = max(20.0_wp,intcut)

    write (iunit,'(/,10x,51("."))')
    write (iunit,'(10x,":",22x,a,22x,":")') "SETUP"
    write (iunit,'(10x,":",49("."),":")')
    write (iunit,intfmt) "# basis functions  ",basis%nbf
    write (iunit,intfmt) "# atomic orbitals  ",basis%nao
    write (iunit,intfmt) "# shells           ",basis%nshell
    write (iunit,intfmt) "# electrons        ",wfn%nel
    write (iunit,dblfmt) "electronic temp.   ",xtbdata%etemp,"K   "
    write (iunit,dblfmt) "accuracy           ",xtbData%acc,"    "
    write (iunit,scifmt) "-> integral cutoff ",intcut,"    "
    write (iunit,'(10x,51("."))')
    write (iunit,*)
    return
  end subroutine pr_wfn_param
!========================================================================================!

subroutine pr_orbital_eigenvalues(iunit,wfn,range)
   implicit none
   integer, intent(in) :: iunit
   integer, intent(in) :: range
   type(TWavefunction),intent(in) :: wfn
   character(len=*),parameter :: hlfmt = '(    a24,f21.7,1x,"Eh",f18.4,1x,"eV")'
   integer :: maxorb,minorb,iorb
   real(wp) :: gap

   minorb = max(wfn%ihomoa - (range+1), 1)
   maxorb = min(wfn%ihomoa +  range, wfn%nao)
   gap = wfn%emo(wfn%ihomoa+1) - wfn%emo(wfn%ihomoa)

   write(iunit,'(a)')
   write(iunit,'(a10,a14,a21,a21)') "#","Occupation","Energy/Eh","Energy/eV"
   write(iunit,'(6x,61("-"))')
   if (minorb .gt. 1) then
      call write_line(1,wfn%focc,wfn%emo,wfn%ihomo)
      if (minorb .gt. 2) &
         write(iunit,'(a10,a14,a21,a21)') "...","...","...","..."
   endif
   do iorb = minorb,maxorb
      call write_line(iorb,wfn%focc,wfn%emo,wfn%ihomo)
   enddo
   if (maxorb .lt. wfn%nao) then
      if (maxorb .lt. wfn%nao-1) then
         if (wfn%focc(maxorb) > 1.0e-7_wp) then
            write(iunit,'(a10,a14,a21,a21)') "...","...","...","..."
         else
            write(iunit,'(a10,a14,a21,a21)') "...",   "","...","..."
         endif
      endif
      call write_line(wfn%nao,wfn%focc,wfn%emo,wfn%ihomo)
   endif
   write(iunit,'(6x,61("-"))')
   write(iunit,hlfmt) "HL-Gap",gap*evtoau,gap
   !write(iunit,hlfmt) "Fermi-level",(wfn%efa+wfn%efb)/2*evtoau,(wfn%efa+wfn%efb)/2
contains
subroutine write_line(iorb,focc,emo,ihomo)
   integer, intent(in) :: iorb
   integer, intent(in) :: ihomo
   real(wp),intent(in) :: focc(:)
   real(wp),intent(in) :: emo (:)
   character(len=*),parameter :: mofmt = '(i10,f14.4,f21.7,f21.4)'
   character(len=*),parameter :: vofmt = '(i10,14x,  f21.7,f21.4)'
   if (focc(iorb) < 1.0e-7_wp) then
      write(iunit,vofmt,advance='no') iorb,             emo(iorb)*evtoau, emo(iorb)
   else
      write(iunit,mofmt,advance='no') iorb, focc(iorb), emo(iorb)*evtoau, emo(iorb)
   endif
   if (iorb == ihomo) then
      write(iunit,'(1x,"(HOMO)")')
   elseif (iorb == ihomo+1) then
      write(iunit,'(1x,"(LUMO)")')
   else
      write(iunit,'(a)')
   endif
end subroutine write_line
end subroutine pr_orbital_eigenvalues

!========================================================================================!

end module gfn0_prints

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0. If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module cn_module
   use iso_fortran_env, only: wp=>real64
   implicit none
   private

   public :: cnType, getCoordinationNumber, cutCoordinationNumber


   interface getCoordinationNumber
   !   module procedure :: getCoordinationNumberWrap
      module procedure :: getCoordinationNumberLP
   end interface getCoordinationNumber


   !> Possible counting functions for calculating coordination numbers
   type :: TCNTypeEnum

      !> Counting function not specified
      integer :: invalid = 0

      !> Original DFT-D3 coordination number
      integer :: exp = 1

      !> Faster decaying error function CN, better for dense systems
      integer :: erf = 2

      !> Error function CN with covalency correction
      integer :: cov = 3

      !> Particular long-ranged version of the DFT-D3 coordination number
      integer :: gfn = 4

   end type TCNTypeEnum

   !> Enumerator for different coordination number types
   type(TCNTypeEnum), parameter :: cnType = TCNTypeEnum()


   abstract interface
   !> Abstract interface for the counting function (and its derivative)
   pure function countingFunction(k, r, r0)
      import :: wp

      !> Constant for counting function
      real(wp), intent(in) :: k

      !> Actual distance
      real(wp), intent(in) :: r

      !> Critical distance
      real(wp), intent(in) :: r0

      !> Value of the counting function in the range of [0,1]
      real(wp) :: countingFunction

   end function countingFunction
   end interface

!========================================================================================!
!> PARAMETER block

   !> convert bohr (a.u.) to Ångström and back
   real(wp),private,parameter :: autoaa = 0.52917726_wp
   real(wp),private,parameter :: aatoau = 1.0_wp/autoaa

   !> Pi
   real(wp),private,parameter :: pi=3.1415926535897932385_wp

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k4=4.10451_wp

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k5=19.08857_wp

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k6=2*11.28174_wp**2


   !> Covalent radii (taken from Pyykko and Atsumi, Chem. Eur. J. 15, 2009,
   !> 188-197), values for metals decreased by 10%.
   real(wp), parameter :: covalentRadD3(1:118) = [ &
      & 0.32_wp,0.46_wp, & ! H,He
      & 1.20_wp,0.94_wp,0.77_wp,0.75_wp,0.71_wp,0.63_wp,0.64_wp,0.67_wp, & ! Li-Ne
      & 1.40_wp,1.25_wp,1.13_wp,1.04_wp,1.10_wp,1.02_wp,0.99_wp,0.96_wp, & ! Na-Ar
      & 1.76_wp,1.54_wp, & ! K,Ca
      &                 1.33_wp,1.22_wp,1.21_wp,1.10_wp,1.07_wp, & ! Sc-
      &                 1.04_wp,1.00_wp,0.99_wp,1.01_wp,1.09_wp, & ! -Zn
      &                 1.12_wp,1.09_wp,1.15_wp,1.10_wp,1.14_wp,1.17_wp, & ! Ga-Kr
      & 1.89_wp,1.67_wp, & ! Rb,Sr
      &                 1.47_wp,1.39_wp,1.32_wp,1.24_wp,1.15_wp, & ! Y-
      &                 1.13_wp,1.13_wp,1.08_wp,1.15_wp,1.23_wp, & ! -Cd
      &                 1.28_wp,1.26_wp,1.26_wp,1.23_wp,1.32_wp,1.31_wp, & ! In-Xe
      & 2.09_wp,1.76_wp, & ! Cs,Ba
      &         1.62_wp,1.47_wp,1.58_wp,1.57_wp,1.56_wp,1.55_wp,1.51_wp, & ! La-Eu
      &         1.52_wp,1.51_wp,1.50_wp,1.49_wp,1.49_wp,1.48_wp,1.53_wp, & ! Gd-Yb
      &                 1.46_wp,1.37_wp,1.31_wp,1.23_wp,1.18_wp, & ! Lu-
      &                 1.16_wp,1.11_wp,1.12_wp,1.13_wp,1.32_wp, & ! -Hg
      &                 1.30_wp,1.30_wp,1.36_wp,1.31_wp,1.38_wp,1.42_wp, & ! Tl-Rn
      & 2.01_wp,1.81_wp, & ! Fr,Ra
      &         1.67_wp,1.58_wp,1.52_wp,1.53_wp,1.54_wp,1.55_wp,1.49_wp, & ! Ac-Am
      &         1.49_wp,1.51_wp,1.51_wp,1.48_wp,1.50_wp,1.56_wp,1.58_wp, & ! Cm-No
      &                 1.45_wp,1.41_wp,1.34_wp,1.29_wp,1.27_wp, & ! Lr-
      &                 1.21_wp,1.16_wp,1.15_wp,1.09_wp,1.22_wp, & ! -Cn
      &                 1.36_wp,1.43_wp,1.46_wp,1.58_wp,1.48_wp,1.57_wp] & ! Nh-Og
      & * aatoau * 4.0_wp / 3.0_wp

   !> Pauling electronegativities, used for the covalent coordination number.
   real(wp), parameter :: paulingEN(1:118) = [ &
      & 2.20_wp,3.00_wp, & ! H,He
      & 0.98_wp,1.57_wp,2.04_wp,2.55_wp,3.04_wp,3.44_wp,3.98_wp,4.50_wp, & ! Li-Ne
      & 0.93_wp,1.31_wp,1.61_wp,1.90_wp,2.19_wp,2.58_wp,3.16_wp,3.50_wp, & ! Na-Ar
      & 0.82_wp,1.00_wp, & ! K,Ca
      &                 1.36_wp,1.54_wp,1.63_wp,1.66_wp,1.55_wp, & ! Sc-
      &                 1.83_wp,1.88_wp,1.91_wp,1.90_wp,1.65_wp, & ! -Zn
      &                 1.81_wp,2.01_wp,2.18_wp,2.55_wp,2.96_wp,3.00_wp, & ! Ga-Kr
      & 0.82_wp,0.95_wp, & ! Rb,Sr
      &                 1.22_wp,1.33_wp,1.60_wp,2.16_wp,1.90_wp, & ! Y-
      &                 2.20_wp,2.28_wp,2.20_wp,1.93_wp,1.69_wp, & ! -Cd
      &                 1.78_wp,1.96_wp,2.05_wp,2.10_wp,2.66_wp,2.60_wp, & ! In-Xe
      & 0.79_wp,0.89_wp, & ! Cs,Ba
      &         1.10_wp,1.12_wp,1.13_wp,1.14_wp,1.15_wp,1.17_wp,1.18_wp, & ! La-Eu
      &         1.20_wp,1.21_wp,1.22_wp,1.23_wp,1.24_wp,1.25_wp,1.26_wp, & ! Gd-Yb
      &                 1.27_wp,1.30_wp,1.50_wp,2.36_wp,1.90_wp, & ! Lu-
      &                 2.20_wp,2.20_wp,2.28_wp,2.54_wp,2.00_wp, & ! -Hg
      &                 1.62_wp,2.33_wp,2.02_wp,2.00_wp,2.20_wp,2.20_wp, & ! Tl-Rn
      ! only dummies below
      & 1.50_wp,1.50_wp, & ! Fr,Ra
      &         1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Ac-Am
      &         1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Cm-No
      &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Rf-
      &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Rf-Cn
      &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp ] ! Nh-Og


!========================================================================================!
contains


!> Geometric fractional coordination number, supports both error function
!  and exponential counting functions.
subroutine getCoordinationNumberWrap(nat, at, xyz, cf, cn, dcndr, cutoff)

   !> Source for error creation
   character(len=*), parameter :: source = &
      & 'getCoordinationNumberWrap'

   !> Molecular structure information
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: xyz(3,nat)

   !> Coordination number type (by counting function)
   integer, intent(in) :: cf

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Real space cutoff for the coordination number
   real(wp), intent(in), optional :: cutoff

   logical :: exitRun
   real(wp) :: rCutoff

   if (present(cutoff)) then
      rCutoff = cutoff
   else
      rCutoff = 40.0_wp
   end if

   !> Actual call to the lattice point version of the CN evaluation
   call getCoordinationNumberLP(nat, at, xyz, rCutoff, cf, cn, dcndr)

end subroutine getCoordinationNumberWrap



!> Geometric fractional coordination number, supports both error function
!  and exponential counting functions.
subroutine getCoordinationNumberLP(nat, at, xyz, cutoff, cf, cn, dcndr)

   !> Molecular structure information
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: xyz(3,nat)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Coordination number type (by counting function)
   integer, intent(in) :: cf

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   real(wp), parameter :: kcn_exp = 16.0_wp
   real(wp), parameter :: kcn_erf = 7.5_wp
   real(wp), parameter :: kcn_gfn = 10.0_wp

   select case(cf)
   case(cnType%exp)
      call ncoord(nat, at, xyz, cutoff, kcn_exp, expCount, dexpCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr)
   case(cnType%erf)
      call ncoord(nat, at, xyz, cutoff, kcn_erf, erfCount, derfCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr)
   case(cnType%cov)
      call ncoord(nat, at, xyz, cutoff, kcn_erf, erfCount, derfCount, &
         & .true., covalentRadD3, paulingEN, cn, dcndr)
   case(cnType%gfn)
      call ncoord(nat, at, xyz, cutoff, kcn_gfn, gfnCount, dgfnCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr )
   end select

end subroutine getCoordinationNumberLP


!> Actual implementation of the coordination number, takes a generic counting
!  function to return the respective CN.
subroutine ncoord(nat, at, xyz, cutoff, kcn, cfunc, dfunc, enscale, &
      & rcov, en, cn, dcndr)

   !> Molecular structure information
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: xyz(3,nat)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Function implementing the counting function
   procedure(countingFunction) :: cfunc

   !> Function implementing the derivative of counting function w.r.t. distance
   procedure(countingFunction) :: dfunc

   !> Use a covalency criterium by Pauling EN's
   logical, intent(in) :: enscale

   !> Steepness of counting function
   real(wp), intent(in) :: kcn

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Electronegativity
   real(wp), intent(in) :: en(:)

   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out) :: dcndr(:, :, :)

   integer :: iat, jat, ati, atj, itr
   real(wp) :: r2, r1, rc, rij(3), countf, countd(3), stress(3, 3), den, cutoff2

   cn = 0.0_wp
   dcndr = 0.0_wp
   cutoff2 = cutoff**2

   !$omp parallel do default(none) private(den) shared(enscale, rcov, en)&
   !$omp reduction(+:cn, dcndr) shared(nat, at, xyz, kcn, cutoff2) &
   !$omp private(jat, itr, ati, atj, r2, rij, r1, rc, countf, countd)
   do iat = 1, nat
      ati = at(iat)
      do jat = 1, iat
         atj = at(jat)

         if (enscale) then
            den = k4*exp(-(abs(en(ati)-en(atj)) + k5)**2/k6)
         else
            den = 1.0_wp
         end if

         rij = xyz(:, iat) - xyz(:, jat)
         r2 = sum(rij**2)
         if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
         r1 = sqrt(r2)

         rc = rcov(ati) + rcov(atj)

         countf = den * cfunc(kcn, r1, rc)
         countd = den * dfunc(kcn, r1, rc) * rij/r1

         cn(iat) = cn(iat) + countf
         if (iat /= jat) then
            cn(jat) = cn(jat) + countf
         end if

         dcndr(:, iat, iat) = dcndr(:, iat, iat) + countd
         dcndr(:, jat, jat) = dcndr(:, jat, jat) - countd
         dcndr(:, iat, jat) = dcndr(:, iat, jat) + countd
         dcndr(:, jat, iat) = dcndr(:, jat, iat) - countd

      end do
   end do
   !$omp end parallel do

end subroutine ncoord


!> Error function counting function for coordination number contributions.
pure function erfCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = 0.5_wp * (1.0_wp + erf(-k*(r-r0)/r0))

end function erfCount


!> Derivative of the counting function w.r.t. the distance.
pure function derfCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp), parameter :: sqrtpi = sqrt(pi)

   real(wp) :: count

   count = -k/sqrtpi/r0*exp(-k**2*(r-r0)**2/r0**2)

end function derfCount


!> Exponential counting function for coordination number contributions.
pure function expCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count =1.0_wp/(1.0_wp+exp(-k*(r0/r-1.0_wp)))

end function expCount


!> Derivative of the counting function w.r.t. the distance.
pure function dexpCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count
   real(wp) :: expterm

   expterm = exp(-k*(r0/r-1._wp))

   count = (-k*r0*expterm)/(r**2*((expterm+1._wp)**2))

end function dexpCount


!> Exponential counting function for coordination number contributions.
pure function gfnCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = expCount(k, r, r0) * expCount(2*k, r, r0+2)

end function gfnCount


!> Derivative of the counting function w.r.t. the distance.
pure function dgfnCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = dexpCount(k, r, r0) * expCount(2*k, r, r0+2) &
      &  + expCount(k, r, r0) * dexpCount(2*k, r, r0+2)

end function dgfnCount


!> Cutoff function for large coordination numbers
pure subroutine cutCoordinationNumber(nAtom, cn, dcndr, maxCN)

   !> number of atoms
   integer, intent(in) :: nAtom

   !> on input coordination number, on output modified CN
   real(wp), intent(inout) :: cn(:)

   !> on input derivative of CN w.r.t. cartesian coordinates,
   !> on output derivative of modified CN
   real(wp), intent(inout), optional :: dcndr(:, :, :)

   !> maximum CN (not strictly obeyed)
   real(wp), intent(in), optional :: maxCN

   real(wp) :: cnmax
   integer :: iAt

   if (present(maxCN)) then
      cnmax = maxCN
   else
      cnmax = 4.5_wp
   end if

   if (cnmax <= 0.0_wp) return

   if (present(dcndr)) then
      do iAt = 1, nAtom
         dcndr(:, :, iAt) = dcndr(:, :, iAt) * dCutCN(cn(iAt), cnmax)
      end do
   end if

   do iAt = 1, nAtom
      cn(iAt) = cutCN(cn(iAt), cnmax)
   end do

end subroutine cutCoordinationNumber


!> Cutting function for the coordination number.
elemental function cutCN(cn, cut) result(cnp)

   !> Current coordination number.
   real(wp), intent(in) :: cn

   !> Cutoff for the CN, this is not the maximum value.
   real(wp), intent(in) :: cut

   !> Cuting function vlaue
   real(wp) :: cnp

   cnp = log(1.0_wp + exp(cut)) - log(1.0_wp + exp(cut - cn))

end function cutCN


!> Derivative of the cutting function w.r.t. coordination number
elemental function dCutCN(cn, cut) result(dcnpdcn)

   !> Current coordination number.
   real(wp), intent(in) :: cn

   !> Cutoff for the CN, this is not the maximum value.
   real(wp), intent(in) :: cut

   !> Derivative of the cutting function
   real(wp) :: dcnpdcn

   dcnpdcn = exp(cut)/(exp(cut) + exp(cn))

end function dCutCn


end module cn_module

!====================================================!
! module gfn0_gbsa
! An interface to GBSA and ALPB calculations for GFN0
!
! NOTE: GBSA or ALPB were never parametrized for GFN0
!       Hence, GBSA parameters for GFN2-xTB and
!       ALPB parameters for GFN-FF are used instead.
!====================================================!

module gfn0_gbsa
  use iso_fortran_env,only:wp => real64,stdout => output_unit
#ifdef WITH_GBSA
  use solvation_solv_input, only : TSolvInput
  use solvation_solv_state, only : solutionState
  use solvation_solv_kernel, only : gbKernel
  use solvation_solv_model, only: TSolvModel, init, newBornModel, info
  use solvation_solv_gbsa, only: TBorn
#endif
  implicit none
  private

#ifndef WITH_GBSA
  !> TBorn placeholder if compiled without GBSA support
  type :: TBorn
    integer :: dummy
  end type TBorn
#endif

  public :: TBorn, gfn0_gbsa_init, gfn0_solvation

!========================================================================================!
!========================================================================================!
contains  !>--- Module routines start here
!========================================================================================!
!========================================================================================!


subroutine gfn0_gbsa_init(nat,at,alpb,solv,gbsa)
!> set up the GBSA (or ALPB) parametrization
   implicit none
   !> INPUT
   integer,intent(in)          :: nat      !> number of atoms
   integer,intent(in)          :: at(nat)  !> atom types
   character(len=*),intent(in) :: solv     !> which solvent to use
   logical,intent(in)          :: alpb     !> use ALPB instead of GBSA?
   !> OUTPUT
   type(TBorn),intent(out)     :: gbsa     !> gbsa type returned 
   !> LOCAL
#ifdef WITH_GBSA
   type(TSolvInput) :: input
   type(TSolvModel) :: model

   if(alpb)then
   input = TSolvInput(solvent=trim(solv), alpb=.true., kernel=gbKernel%p16)
   else
   input = TSolvInput(solvent=trim(solv), alpb=.false., kernel=gbKernel%still)
   endif
   call init(model, input, 0)
   !call info(model,stdout)
   call newBornModel(model, gbsa, at)
#else
   gbsa%dummy = 0
#endif

   return
end subroutine gfn0_gbsa_init

subroutine gfn0_gbsa_print(gbsa,iunit)
   implicit none
   integer :: iunit
   type(TBorn),intent(in)     :: gbsa     !> gbsa type
#ifdef WITH_GBSA
   call gbsa%info(iunit)
#endif
end subroutine gfn0_gbsa_print

!========================================================================================!

subroutine gfn0_solvation(nat,at,xyz,gbsa,esolv,gradient)
!> get energy and gradient contribution from SASA term
   implicit none
   !> INPUT
   integer,intent(in)          :: nat        !> number of atoms
   integer,intent(in)          :: at(nat)    !> atom types 
   real(wp),intent(in)         :: xyz(3,nat) !> coordinats (bohr)
   type(TBorn),intent(inout)   :: gbsa       !> gbsa type returned
   !> OUTPUT
   real(wp),intent(out)        :: esolv      !> solv contribution to E
   real(wp),intent(inout)      :: gradient(3,nat) !> atomic gradient (added to)

#ifdef WITH_GBSA
   call gbsa%update(at, xyz)
   esolv = gbsa%gsasa + gbsa%gshift
   gradient = gradient + gbsa%dsdr
#else
   esolv = 0.0_wp
#endif
end subroutine gfn0_solvation
!========================================================================================!
end module gfn0_gbsa

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!================================================================================!

!====================================================!
! module gfn0_interface
! An interface to GFN0 calculations
!====================================================!
module gfn0_interface
  use iso_fortran_env,only:wp => real64,stdout => output_unit
  use gfn0_module
  implicit none
  private

  !> module types
  public :: gfn0_data
  type :: gfn0_data
    type(TBasisset),allocatable     :: basis   !< basis set info
    type(TxTBData_mod),allocatable  :: xtbData !< main data/parameter frame
    type(Twavefunction),allocatable :: wfn     !< wavefunction data
    type(TBorn),allocatable         :: gbsa    !< gbsa/alpb model
    type(gfn0_partials),allocatable :: part    !< partial derivatives
    logical :: update = .true.
    real(wp),allocatable :: refxyz(:,:)
    real(wp) :: eclassic
    real(wp),allocatable :: gclassic(:,:)
  end type gfn0_data

  public :: gfn0_results
  type :: gfn0_results
    real(wp) :: etot = 0.0_wp
    real(wp) :: ies = 0.0_wp
    real(wp) :: edisp = 0.0_wp
    real(wp) :: erep = 0.0_wp
    real(wp) :: esrb = 0.0_wp
    real(wp) :: esolv = 0.0_wp
    real(wp) :: eel = 0.0_wp
    real(wp) :: gnorm = 0.0_wp
  contains
    procedure :: print => print_gfn0_res
  end type gfn0_results

  !> module routines
  public :: gfn0_init
  public :: gfn0_singlepoint
  interface gfn0_singlepoint
    module procedure :: gfn0_singlepoint_full
    module procedure :: gfn0_singlepoint_wrap
    module procedure :: gfn0_singlepoint_short
  end interface gfn0_singlepoint
  public :: gfn0_occ_singlepoint
  interface gfn0_occ_singlepoint
    module procedure :: gfn0_occ_singlepoint_wrap
  end interface gfn0_occ_singlepoint
 
  public :: gfn0_print_summary

!========================================================================================!
!========================================================================================!
contains  !>--- Module routines start here
!========================================================================================!
!========================================================================================!

  subroutine print_gfn0_res(self,iunit)
    class(gfn0_results) :: self
    integer,intent(in) :: iunit
    write (iunit,*)
    write (iunit,*) "GFN0 calculation summary"
    write (iunit,'(3x,a5,1x,f16.8)') 'IES',self%ies
    write (iunit,'(3x,a5,1x,f16.8)') 'Edisp',self%edisp
    write (iunit,'(3x,a5,1x,f16.8)') 'Erep',self%erep
    write (iunit,'(3x,a5,1x,f16.8)') 'Esrb',self%esrb
    write (iunit,'(3x,a5,1x,f16.8)') 'Esolv',self%esolv
    write (iunit,'(3x,a5,1x,f16.8)') 'Eel',self%eel
    write (iunit,*) '--------------------------'
    write (iunit,'(3x,a5,1x,f16.8)') 'Etot',self%etot
    write (iunit,'(3x,a5,1x,f16.8)') 'gnorm',self%gnorm
    write (iunit,*)
  end subroutine print_gfn0_res

!========================================================================================!

  subroutine gfn0_print_summary(iunit,gdat,res)
    implicit none
    integer, intent(in) :: iunit
    type(gfn0_data),intent(in)    :: gdat
    type(gfn0_results),intent(in),optional :: res
    
    call pr_wfn_param(iunit,gdat%xtbData,gdat%basis,gdat%wfn) 
    if(allocated(gdat%gbsa))then
    call gdat%gbsa%info(iunit)
    endif
    if(allocated(gdat%wfn))then
     call pr_orbital_eigenvalues(iunit,gdat%wfn,9)
    endif
    if(present(res))then
    call res%print(iunit)
    endif

  end subroutine gfn0_print_summary

!========================================================================================!

  subroutine gfn0_init(nat,at,xyz,chrg,uhf,gdat,solv,alpb)
    implicit none
    !> INPUT
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in)  :: uhf
    integer,intent(in)  :: chrg
    character(len=*),intent(in),optional :: solv
    logical,intent(in),optional :: alpb
    !> OUTPUT
    type(gfn0_data),intent(inout) :: gdat

    if (allocated(gdat%basis)) deallocate (gdat%basis)
    if (allocated(gdat%xtbData)) deallocate (gdat%xtbData)
    if (allocated(gdat%wfn)) deallocate (gdat%wfn)
    if (allocated(gdat%gbsa)) deallocate (gdat%gbsa)
    if (allocated(gdat%part)) deallocate (gdat%part)

    allocate (gdat%basis)
    allocate (gdat%xtbData)
    allocate (gdat%wfn)
    call initGFN0Params(nat,at,xyz,chrg,uhf,gdat%basis,gdat%xtbData)
    call wfnsetup(gdat%xtbData,gdat%basis,nat,at,uhf,chrg,gdat%wfn)

    if (present(solv)) then
      allocate(gdat%gbsa)
      if (present(alpb)) then
        call gfn0_gbsa_init(nat,at,alpb,solv,gdat%gbsa)
      else
        call gfn0_gbsa_init(nat,at,.false.,solv,gdat%gbsa)
      end if
    end if

    allocate(gdat%part)
 
    if(allocated(gdat%refxyz))deallocate(gdat%refxyz)
    allocate(gdat%refxyz(3,nat), source=0.0_wp)
    !gdat%refxyz = xyz   
    gdat%update = .true.
    if(allocated(gdat%gclassic))deallocate(gdat%gclassic)
    allocate(gdat%gclassic(3,nat), source=0.0_wp)

    return
  end subroutine gfn0_init
!========================================================================================!

  subroutine gfn0_singlepoint_classical(nat,at,xyz,chrg,uhf,basis,xtbData,wfn,part,gbsa, &
  &          energy,gradient,fail,res)
    implicit none
    !> INPUT
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in)  :: uhf
    integer,intent(in)  :: chrg
    type(TBasisset),intent(inout)     :: basis   !< basis set info
    type(TxTBData_mod),intent(inout)  :: xtbData !< main data/parameter frame
    type(Twavefunction),intent(inout) :: wfn     !< wavefunction data
    type(gfn0_partials),intent(inout) :: part
    type(TBorn),allocatable,intent(inout) :: gbsa
    type(gfn0_results),intent(inout),optional :: res
    !> OUTPUT
    real(wp),intent(out) :: energy
    real(wp),intent(out) :: gradient(3,nat)
    logical,intent(out)  :: fail
    !> LOCAL
    real(wp),allocatable :: cn(:)
    real(wp),allocatable :: dcndr(:,:,:)

    real(wp),allocatable :: qat(:)
    real(wp),allocatable :: dqdr(:,:,:)

    real(wp) :: ies,edisp,erep,esrb,eel,esolv,gnorm
    energy = 0.0_wp
    gradient = 0.0_wp
    fail = .false.
    ies = 0.0_wp
    edisp = 0.0_wp
    erep = 0.0_wp
    esrb = 0.0_wp
    esolv = 0.0_wp
    eel = 0.0_wp
    gnorm = 0.0_wp
!>--- CN and CN gradient
    if(.not.allocated(part%cn)) allocate (part%cn(nat),source=0.0_wp)
    if(.not.allocated(part%dcndr)) allocate (part%dcndr(3,nat,nat),source=0.0_wp)
    call gfn0_getCN(nat,at,xyz,part%cn,part%dcndr)

    if(.not.allocated(part%qat)) allocate (part%qat(nat),source=0.0_wp)
    if(.not.allocated(part%dqdr)) allocate (part%dqdr(3,nat,nat),source=0.0_wp)
!>--- Solvation+EEQ (if required)
    if (allocated(gbsa)) then
      call gfn0_solvation(nat,at,xyz,gbsa,esolv,gradient)
      call gfn0_electrostatics(nat,at,xyz,chrg,xtbData, &
      & part%cn,part%dcndr,ies,gradient,part%qat,part%dqdr,gbsa)
    else
!>--- EEQ charges, gradients and IES energy (gasphase)
      call gfn0_electrostatics(nat,at,xyz,chrg,xtbData, &
      & part%cn,part%dcndr,ies,gradient,part%qat,part%dqdr)
    end if

!>--- D4 two-body dispersion energy
    call gfn0_dispersion(nat,at,xyz,chrg,xtbData, &
    &  part%cn,part%dcndr,edisp,gradient)

!>--- Repulsion energy
    call gfn0_repulsion(nat,at,xyz,xtbData%repulsion,erep,gradient)

!>--- SRB energy
    call gfn0_shortranged(nat,at,xyz,xtbData%srb,part%cn,part%dcndr, &
    &                     esrb,gradient)

!>--- Add up total energy
    energy = ies + edisp + erep + esrb + esolv
    gnorm = sqrt(sum(gradient**2))

    if (present(res)) then
      res%etot = energy
      res%ies = ies
      res%edisp = edisp
      res%erep = erep
      res%esrb = esrb
      res%esolv = esolv
      res%eel = eel
      res%gnorm = gnorm
    end if

    !deallocate (dqdr,qat,dcndr,cn)
  end subroutine gfn0_singlepoint_classical

!========================================================================================!

  subroutine gfn0_singlepoint_full(nat,at,xyz,chrg,uhf,basis,xtbData,wfn,part,gbsa, &
  &          energy,gradient,fail,res)
    implicit none
    !> INPUT
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in)  :: uhf
    integer,intent(in)  :: chrg
    type(TBasisset),intent(inout)     :: basis   !< basis set info
    type(TxTBData_mod),intent(inout)  :: xtbData !< main data/parameter frame
    type(Twavefunction),intent(inout) :: wfn     !< wavefunction data
    type(gfn0_partials),intent(inout) :: part
    type(TBorn),allocatable,intent(inout) :: gbsa
    type(gfn0_results),intent(inout),optional :: res
    !> OUTPUT
    real(wp),intent(out) :: energy
    real(wp),intent(out) :: gradient(3,nat)
    logical,intent(out)  :: fail
    !> LOCAL
    real(wp) :: ies,edisp,erep,esrb,eel,esolv,gnorm

    energy = 0.0_wp
    gradient = 0.0_wp
    fail = .false.
    eel = 0.0_wp
    gnorm = 0.0_wp

!>--- Classical part
    call gfn0_singlepoint_classical(nat,at,xyz,chrg,uhf,basis,xtbData,wfn,part,gbsa, &
  &          energy,gradient,fail,res=res)

!>--- QM part
    !call wfnsetup(xtbData,basis,nat,at,uhf,chrg,wfn)
    call gfn0_eht(nat,at,xyz,xtbData,basis,part%cn,part%dcndr,part%qat,part%dqdr, &
   &                wfn,eel,gradient,fail)

!>--- Add up total energy
    energy = energy + eel
    gnorm = sqrt(sum(gradient**2))

    if (present(res)) then
      res%etot = energy
      res%eel = eel
      res%gnorm = gnorm
    end if

    !deallocate (dqdr,qat,dcndr,cn)
  end subroutine gfn0_singlepoint_full

!========================================================================================!

  subroutine gfn0_singlepoint_wrap(nat,at,xyz,chrg,uhf,gdat, &
&          energy,gradient,fail,res)
    implicit none
    !> INPUT
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in)  :: uhf
    integer,intent(in)  :: chrg
    type(gfn0_data),intent(inout) :: gdat
    type(gfn0_results),intent(inout),optional :: res
    !> OUTPUT
    real(wp),intent(out) :: energy
    real(wp),intent(out) :: gradient(3,nat)
    logical,intent(out)  :: fail
    !> LOCAL
    real(wp) :: eel,gnorm
    
!>--- Check if geometry has changed
    call check_geo(nat,xyz,gdat%refxyz,gdat%update)

    energy = 0.0_wp
    gradient = 0.0_wp
    fail = .false.
    eel = 0.0_wp
    gnorm = 0.0_wp

!>--- Classical part
    if(gdat%update)then
    call gfn0_singlepoint_classical(nat,at,xyz,chrg,uhf, &
  &  gdat%basis, gdat%xtbData, gdat%wfn, gdat%part, gdat%gbsa, &
  &          gdat%eclassic, gdat%gclassic, fail, res=res)
    endif
    energy = gdat%eclassic
    gradient = gdat%gclassic

!>--- QM part
!    call gfn0_eht_occ(nat,at,xyz,occ, gdat%xtbData, gdat%basis, &
!    &   gdat%part%cn, gdat%part%dcndr, gdat%part%qat, gdat%part%dqdr, &
!    &   gdat%wfn, eel,gradient,fail)

    call gfn0_eht_var(nat,at,xyz, gdat%xtbData, gdat%basis, gdat%wfn, gdat%part, &
     &                    eel,gradient,fail, update=gdat%update)


!>--- Add  EHT energy to total
      energy = energy + eel
      gnorm = sqrt(sum(gradient**2))

    if (present(res)) then
      res%etot = energy
      res%eel = eel
      res%gnorm = gnorm
    end if

    gdat%update = .false.
  end subroutine gfn0_singlepoint_wrap

!========================================================================================!
!> shortcut version of the singlepoint call that always sets up the entire parametrization
  subroutine gfn0_singlepoint_short(nat,at,xyz,chrg,uhf,energy,gradient,fail,solv,alpb)
    implicit none
    !> INPUT
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in)  :: uhf
    integer,intent(in)  :: chrg
    character(len=*),intent(in),optional :: solv
    logical,intent(in),optional :: alpb
    !> OUTPUT
    real(wp),intent(out) :: energy
    real(wp),intent(out) :: gradient(3,nat)
    logical,intent(out)  :: fail
    !> LOCAL
    type(gfn0_data) :: gdat

    if (present(solv)) then
      if (present(alpb)) then
        call gfn0_init(nat,at,xyz,chrg,uhf,gdat,solv,alpb)
      else
        call gfn0_init(nat,at,xyz,chrg,uhf,gdat,solv)
      end if
    else
     call gfn0_init(nat,at,xyz,chrg,uhf,gdat) 
    end if
    call gfn0_singlepoint_wrap(nat,at,xyz,chrg,uhf,gdat,energy,gradient,fail)

  end subroutine gfn0_singlepoint_short

!========================================================================================!

  subroutine gfn0_occ_singlepoint_wrap(nat,at,xyz,chrg,uhf,occ,gdat, &
&          energy,gradient,fail,res)
    implicit none
    !> INPUT
    integer,intent(in)  :: nat
    integer,intent(in)  :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in)  :: uhf
    integer,intent(in)  :: chrg
    type(gfn0_data),intent(inout) :: gdat
    real(wp),intent(in) :: occ(gdat%basis%nao)
    type(gfn0_results),intent(inout),optional :: res
    !> OUTPUT
    real(wp),intent(out) :: energy
    real(wp),intent(out) :: gradient(3,nat)
    logical,intent(out)  :: fail
    !> LOCAL
    real(wp) :: ies,edisp,erep,esrb,eel,esolv,gnorm
    integer :: i

!>--- Check if geometry has changed
    call check_geo(nat,xyz,gdat%refxyz,gdat%update)

    energy = 0.0_wp
    gradient = 0.0_wp
    fail = .false.
    eel = 0.0_wp
    gnorm = 0.0_wp

!>--- Classical part
    if(gdat%update)then
    call gfn0_singlepoint_classical(nat,at,xyz,chrg,uhf, &
  &  gdat%basis, gdat%xtbData, gdat%wfn, gdat%part, gdat%gbsa, &
  &          gdat%eclassic, gdat%gclassic, fail, res=res)
    endif
    energy = gdat%eclassic
    gradient = gdat%gclassic

!>--- QM part
!    call gfn0_eht_occ(nat,at,xyz,occ, gdat%xtbData, gdat%basis, &
!    &   gdat%part%cn, gdat%part%dcndr, gdat%part%qat, gdat%part%dqdr, &
!    &   gdat%wfn, eel,gradient,fail)

    call gfn0_eht_var(nat,at,xyz, gdat%xtbData, gdat%basis, gdat%wfn, gdat%part, &
     &                    eel,gradient,fail, update=gdat%update, occ=occ)
 

!>--- Add  EHT energy to total
      energy = energy + eel
      gnorm = sqrt(sum(gradient**2))

    if (present(res)) then
      res%etot = energy
      res%eel = eel
      res%gnorm = gnorm
    end if


    gdat%update = .false. 
  end subroutine gfn0_occ_singlepoint_wrap

!========================================================================================!

  subroutine check_geo(nat,xyz,refxyz,update)
    implicit none
    integer,intent(in) :: nat
    real(wp),intent(in) :: xyz(3,nat)
    real(wp),intent(inout) :: refxyz(3,nat)
    logical,intent(out)  :: update
    real(wp),allocatable :: diff(:,:)
    real(wp),parameter :: thr = 1.0d-8
    integer :: i,j
    update = .false. 
    !allocate(diff(3,nat),source=0.0_wp)
    !diff(:,:) = abs( xyz(:,:) - refxyz(:,:)) 
    !if(any(diff.gt.thr).or.nat==1) then
    !  update = .true.
    !  refxyz = xyz
    !endif
    !deallocate(diff)
    if(nat==1)then
       update = .true. 
       return 
    endif 
    ILOOP : do i=1,nat
      JLOOP : do j=1,3
         if(abs( xyz(j,i) - refxyz(j,i)).gt.thr)then
            update = .true.
            refxyz = xyz
            exit ILOOP
         endif
      enddo JLOOP
    enddo ILOOP
  end subroutine check_geo

!========================================================================================!
end module gfn0_interface

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!


!> D3 van-der-Waals radii
module solvation_param_vdwradd3
   use iso_fortran_env, only : wp => real64
   implicit none
   private

   public :: getVanDerWaalsRadD3, vanDerWaalsRadD3

   !>  convert bohr (a.u.) to Ångström and back
   real(wp),public,parameter :: autoaa = 0.52917726_wp
   real(wp),public,parameter :: aatoau = 1.0_wp/autoaa

   !> Get van-der-Waals Rad for a species
   interface getVanDerWaalsRadD3
      module procedure :: getVanDerWaalsRadD3Number
   end interface getVanDerWaalsRadD3


   !> D3 pairwise van-der-Waals radii (only homoatomic pairs present here)
   real(wp), parameter :: vanDerWaalsRadD3(1:94) = aatoau * [&
      & 1.09155_wp, 0.86735_wp, 1.74780_wp, 1.54910_wp, &
      & 1.60800_wp, 1.45515_wp, 1.31125_wp, 1.24085_wp, &
      & 1.14980_wp, 1.06870_wp, 1.85410_wp, 1.74195_wp, &
      & 2.00530_wp, 1.89585_wp, 1.75085_wp, 1.65535_wp, &
      & 1.55230_wp, 1.45740_wp, 2.12055_wp, 2.05175_wp, &
      & 1.94515_wp, 1.88210_wp, 1.86055_wp, 1.72070_wp, &
      & 1.77310_wp, 1.72105_wp, 1.71635_wp, 1.67310_wp, &
      & 1.65040_wp, 1.61545_wp, 1.97895_wp, 1.93095_wp, &
      & 1.83125_wp, 1.76340_wp, 1.68310_wp, 1.60480_wp, &
      & 2.30880_wp, 2.23820_wp, 2.10980_wp, 2.02985_wp, &
      & 1.92980_wp, 1.87715_wp, 1.78450_wp, 1.73115_wp, &
      & 1.69875_wp, 1.67625_wp, 1.66540_wp, 1.73100_wp, &
      & 2.13115_wp, 2.09370_wp, 2.00750_wp, 1.94505_wp, &
      & 1.86900_wp, 1.79445_wp, 2.52835_wp, 2.59070_wp, &
      & 2.31305_wp, 2.31005_wp, 2.28510_wp, 2.26355_wp, &
      & 2.24480_wp, 2.22575_wp, 2.21170_wp, 2.06215_wp, &
      & 2.12135_wp, 2.07705_wp, 2.13970_wp, 2.12250_wp, &
      & 2.11040_wp, 2.09930_wp, 2.00650_wp, 2.12250_wp, &
      & 2.04900_wp, 1.99275_wp, 1.94775_wp, 1.87450_wp, &
      & 1.72280_wp, 1.67625_wp, 1.62820_wp, 1.67995_wp, &
      & 2.15635_wp, 2.13820_wp, 2.05875_wp, 2.00270_wp, &
      & 1.93220_wp, 1.86080_wp, 2.53980_wp, 2.46470_wp, &
      & 2.35215_wp, 2.21260_wp, 2.22970_wp, 2.19785_wp, &
      & 2.17695_wp, 2.21705_wp]


contains

!> Get van-der-Waals radius for species with a given atomic number
elemental function getVanDerWaalsRadD3Number(number) result(rad)

   !> Atomic number
   integer, intent(in) :: number

   !> van-der-Waals radius
   real(wp) :: rad

   if (number > 0 .and. number <= size(vanDerWaalsRadD3, dim=1)) then
      rad = vanDerWaalsRadD3(number)
   else
      rad = -1.0_wp
   end if

end function getVanDerWaalsRadD3Number


end module solvation_param_vdwradd3

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Cosmo van-der-Waals radii

module solvation_param_vdwradcosmo
   use iso_fortran_env, only : wp => real64
   implicit none
   private

   public :: getVanDerWaalsRadCosmo, vanDerWaalsRadCosmo

   !>  convert bohr (a.u.) to Ångström and back
   real(wp),public,parameter :: autoaa = 0.52917726_wp
   real(wp),public,parameter :: aatoau = 1.0_wp/autoaa

   !> Get van-der-Waals Rad for a species
   interface getVanDerWaalsRadCosmo
      module procedure :: getVanDerWaalsRadCosmoNumber
   end interface getVanDerWaalsRadCosmo


   !> Default value for unoptimized van-der-Waals radii
   real(wp), parameter :: cosmostub = 2.223_wp

   !> COSMO optimized van-der-Waals radii
   real(wp), parameter :: vanDerWaalsRadCosmo(94) = aatoau * [ &
       & 1.3000_wp, 1.6380_wp, 1.5700_wp, 1.0530_wp, &   ! h-be
       & 2.0480_wp, 2.0000_wp, 1.8300_wp, 1.7200_wp, &   ! B-O
       & 1.7200_wp, 1.8018_wp, 1.8000_wp, 1.6380_wp, &   ! F-Mg
       & 2.1530_wp, 2.2000_wp, 2.1060_wp, 2.1600_wp, &   ! Al-S
       & 2.0500_wp, 2.2000_wp, 2.2230_wp, cosmostub, &   ! Cl-Ca
       & cosmostub, 2.2930_wp, cosmostub, cosmostub, &   ! Sc-Cr
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Mn-Ni
       & cosmostub, 1.6260_wp, cosmostub, 2.7000_wp, &   ! Cu-Ge
       & 2.3500_wp, 2.2000_wp, 2.1600_wp, 2.3630_wp, &   ! As-Kr
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rb-Zr
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Nb-Ru
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rh-Cd
       & 2.2580_wp, 2.5500_wp, 2.4100_wp, 2.4100_wp, &   ! In-Te
       & 2.3200_wp, 2.5270_wp, cosmostub, cosmostub, &   ! I-Ba
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! La-Nd
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Pm-Gd
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tb-Er
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tm-Hf
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ta-Os
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ir-Hg
       & cosmostub, 2.3600_wp, 2.4220_wp, 2.3050_wp, &   ! Tl-Po
       & 2.3630_wp, 2.5740_wp, cosmostub, cosmostub, &   ! At-Ra
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ac-U
       & cosmostub, cosmostub]                           ! Np-Pu


contains

!> Get van-der-Waals radius for species with a given atomic number
elemental function getVanDerWaalsRadCosmoNumber(number) result(rad)

   !> Atomic number
   integer, intent(in) :: number

   !> van-der-Waals radius
   real(wp) :: rad

   if (number > 0 .and. number <= size(vanDerWaalsRadCosmo, dim=1)) then
      rad = vanDerWaalsRadCosmo(number)
   else
      rad = -1.0_wp
   end if

end function getVanDerWaalsRadCosmoNumber


end module solvation_param_vdwradcosmo

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!


!> Generic solvation model used to create actual solvation calculators
module solvation_solv_model
   use iso_fortran_env, only: wp => real64,stderr=>error_unit

   use solvation_solv_util, only : lowercase, rdpath

   use solvation_param_vdwradd3, only : vanDerWaalsRadD3
   use solvation_param_vdwradcosmo, only : vanDerWaalsRadCosmo

   use solvation_solv_gbsa, only : TBorn, init_ => init
!   use solvation_solv_cosmo, only : TCosmo, init_ => init
   use solvation_solv_input, only : TSolvInput
   use solvation_solv_kernel, only : gbKernel
   use solvation_solv_state, only : solutionState, getStateShift

   use solvation_type_solvation, only : TSolvation
   use ieee_arithmetic, only : ieee_value,ieee_positive_inf
   implicit none
   private

   public :: TSolvModel, init, info, newSolvationModel, newBornModel


   !> Payload to create actual solvation models
   type, extends(TSolvInput) :: TSolvModel

      !> Meta data: parameter file name
      character(len=:), allocatable :: paramFile

      !> Dielectric constant of the solvent
      real(wp) :: dielectricConst

      !> Molar mass of a solvent molecule (g/mol)
      real(wp) :: molarMass

      !> Density of the solvent
      real(wp) :: density

      !> Free energy shift added to the solvation state specific shift
      real(wp) :: freeEnergyShift

      !> Scaling factor for the Born radii
      real(wp) :: bornScale

      !> Offset parameter for the Born radii integration
      real(wp) :: bornOffset

      !> Probe radius for the integration of the solvent accessible surface area
      real(wp) :: probeRad

      !> Analytical Linearized Poisson Boltzmann alpha constant (zero for GBSA)
      real(wp) :: alpha

      !> Van-der-Waals radii used for various purposes
      real(wp), allocatable :: vdwRad(:)

      !> Surface tension scaling
      real(wp), allocatable :: surfaceTension(:)

      !> Dielectric descreening parameter for GBOBC integrator
      real(wp), allocatable :: descreening(:)

      !> Hydrogen bond strength
      real(wp), allocatable :: hBondStrength(:)

   end type TSolvModel


   !> Initialize solvation model from input
   interface init
      module procedure :: initSolvModel
   end interface init


   !> Define the local data structure for the parameters
   type :: gbsa_parameter
      real(wp) :: epsv = 0.0_wp
      real(wp) :: smass = 0.0_wp
      real(wp) :: rhos = 0.0_wp
      real(wp) :: c1 = 0.0_wp
      real(wp) :: rprobe = 0.0_wp
      real(wp) :: gshift = 0.0_wp
      real(wp) :: soset = 0.0_wp
      real(wp) :: alpha = 0.0_wp
      real(wp) :: gamscale(94) = 0.0_wp
      real(wp) :: sx(94) = 0.0_wp
      real(wp) :: tmp(94) = 0.0_wp
   end type gbsa_parameter

   include 'param_gbsa_acetone.fh'
   include 'param_gbsa_acetonitrile.fh'
   include 'param_gbsa_benzene.fh'
   include 'param_gbsa_ch2cl2.fh'
   include 'param_gbsa_chcl3.fh'
   include 'param_gbsa_cs2.fh'
   include 'param_gbsa_dmso.fh'
   include 'param_gbsa_ether.fh'
   include 'param_gbsa_h2o.fh'
   include 'param_gbsa_methanol.fh'
   include 'param_gbsa_thf.fh'
   include 'param_gbsa_toluene.fh'
   include 'param_gbsa_dmf.fh'
   include 'param_gbsa_nhexan.fh'

   include 'param_alpb_acetone.fh'
   include 'param_alpb_acetonitrile.fh'
   include 'param_alpb_aniline.fh'
   include 'param_alpb_benzaldehyde.fh'
   include 'param_alpb_benzene.fh'
   include 'param_alpb_ch2cl2.fh'
   include 'param_alpb_chcl3.fh'
   include 'param_alpb_cs2.fh'
   include 'param_alpb_dioxane.fh'
   include 'param_alpb_dmf.fh'
   include 'param_alpb_dmso.fh'
   include 'param_alpb_ether.fh'
   include 'param_alpb_ethylacetate.fh'
   include 'param_alpb_furane.fh'
   include 'param_alpb_hexadecane.fh'
   include 'param_alpb_hexane.fh'
   include 'param_alpb_nitromethane.fh'
   include 'param_alpb_octanol.fh'
   include 'param_alpb_phenol.fh'
   include 'param_alpb_thf.fh'
   include 'param_alpb_toluene.fh'
   include 'param_alpb_water.fh'
   include 'param_alpb_woctanol.fh'
   include 'param_alpb_methanol.fh'
   include 'param_alpb_ethanol.fh'


   !>  convert bohr (a.u.) to Ångström and back
   real(wp),public,parameter :: autoaa = 0.52917726_wp
   real(wp),public,parameter :: aatoau = 1.0_wp/autoaa
   !>  convert Hartree to eV and back
   real(wp),parameter :: autoev = 27.21138505_wp
   real(wp),parameter :: evtoau = 1.0_wp/autoev
   !>  convert Hartree to kcal/mol and back
   real(wp),parameter :: autokcal = 627.50947428_wp
   real(wp),parameter :: kcaltoau = 1.0_wp/autokcal

   real(wp), parameter :: pi = 3.1415926535897932384626433832795029_wp
   real(wp), parameter :: fourpi = 4.0_wp * pi

   !> Solvent density (g/cm^3) and molar mass (g/mol)
   real(wp), parameter :: molcm3toau = 8.92388e-2_wp

   !> Surface tension (mN/m=dyn/cm)
   real(wp), parameter :: surfaceTension = 1.0e-5_wp
   real(wp), parameter :: mNmtokcal = 4.0305201015221386e-4_wp
   real(wp), parameter :: kcaltomNm = 1.0_wp/mNmtokcal
   real(wp), parameter :: automNm = autokcal * kcaltomNm

   real(wp),parameter :: lrcut = 35.0_wp * aatoau
   real(wp),parameter :: srcut = 2.0_wp * aatoau


contains


!> Initialize solvation model from input
subroutine initSolvModel(self, input, level)

   !> Error source for traceback
   character(len=*), parameter :: source = 'solv_model_initSolvModel'

   !> Data structure
   type(TSolvModel), intent(out) :: self

   !> Input data
   type(TSolvInput), intent(in) :: input

   !> Method level for solvation model
   integer, intent(in) :: level

   character(len=:), allocatable :: solvent
   logical :: exist

   self%TSolvInput = input
   call normalizeSolventName(solvent, input%solvent)

   if (input%alpb) then
      call getParamFile(solvent, 'alpb', level, self%paramFile)
   end if

   !if (input%cosmo) then
   !   call getParamFile(solvent, 'cosmo', level, self%paramFile)
   !end if

   if (.not.allocated(self%paramFile) .and. (.not.input%cosmo)) then
      call getParamFile(solvent, 'gbsa', level, self%paramFile)
   end if

   if (allocated(self%paramFile)) then
      call readParamFile(self)
   else
      call loadInternalParam(self, solvent, level)
   end if

   self%freeEnergyShift = self%freeEnergyShift + getStateShift(self%state, &
      & self%temperature, self%density, self%molarMass)
end subroutine initSolvModel


!> Try to find a normalized version of an input solvent name
subroutine normalizeSolventName(solvent, input)

   !> Name of the solvent (normalized)
   character(len=:), allocatable, intent(out) :: solvent

   !> Name of the solvent (unnormalized)
   character(len=*), intent(in) :: input

   solvent = trim(lowercase(input))

end subroutine normalizeSolventName


!> Load internal parameters, if no parameter file is present
subroutine loadInternalParam(self, solvent, level)

   !> Error source for traceback
   character(len=*), parameter :: source = 'solv_model_loadInternalParam'

   !> Data structure
   type(TSolvModel), intent(inout) :: self

   !> Name of the solvent (normalized)
   character(len=*), intent(in) :: solvent

   !> Method level for solvation model
   integer, intent(in) :: level

   !> I/O handling

   integer :: iostat

   type(gbsa_parameter), allocatable :: param, stub


   select case(self%kernel)
   case (gbKernel%still)
      if (any(level == [2, 0])) then
         self%paramFile = 'internal GFN2-xTB/GBSA'
         select case(solvent)
         case('acetone');      param = gfn2_acetone
         case('acetonitrile'); param = gfn2_acetonitrile
         case('benzene');      param = gfn2_benzene
         case('ch2cl2','dichlormethane'); param = gfn2_ch2cl2
         case('chcl3','chloroform');      param = gfn2_chcl3
         case('cs2');          param = gfn2_cs2
         case('dmso');         param = gfn2_dmso
         case('ether');        param = gfn2_ether
         case('h2o','water');  param = gfn2_h2o
         case('methanol');     param = gfn2_methanol
         case('thf');          param = gfn2_thf
         case('toluene');      param = gfn2_toluene
         case('dmf');          param = gfn2_dmf
         case('nhexan','n-hexan','nhexane','n-hexane','hexane');
            param = gfn2_nhexan
         end select
      else
         self%paramFile = 'internal GFN1-xTB/GBSA'
         select case(solvent)
         case('acetone');      param = gfn1_acetone
         case('acetonitrile'); param = gfn1_acetonitrile
         case('benzene');      param = gfn1_benzene
         case('ch2cl2','dichlormethane'); param = gfn1_ch2cl2
         case('chcl3','chloroform');      param = gfn1_chcl3
         case('cs2');          param = gfn1_cs2
         case('dmso');         param = gfn1_dmso
         case('ether');        param = gfn1_ether
         case('h2o','water');  param = gfn1_h2o
         case('methanol');     param = gfn1_methanol
         case('thf');          param = gfn1_thf
         case('toluene');      param = gfn1_toluene
         end select
      end if

      if (.not.allocated(param)) then
          write(stderr,*) "solvent: '"//solvent//"' is not parametrized"
          stop source
         return
      end if

   case (gbKernel%p16)
      if (level == 2) then
         self%paramFile = 'internal GFN2-xTB/ALPB'
         select case(solvent)
         case('acetone');      param = gfn2_alpb_acetone
         case('acetonitrile'); param = gfn2_alpb_acetonitrile
         case('aniline');      param = gfn2_alpb_aniline
         case('benzaldehyde');      param = gfn2_alpb_benzaldehyde
         case('benzene');      param = gfn2_alpb_benzene
         case('dioxane');      param = gfn2_alpb_dioxane
         case('ethylacetate');      param = gfn2_alpb_ethylacetate
         case('furane');      param = gfn2_alpb_furane
         case('hexadecane');      param = gfn2_alpb_hexadecane
         case('nitromethane');      param = gfn2_alpb_nitromethane
         case('octanol');      param = gfn2_alpb_octanol
         case('woctanol');      param = gfn2_alpb_woctanol
         case('phenol');      param = gfn2_alpb_phenol 
         case('ch2cl2','dichlormethane'); param = gfn2_alpb_ch2cl2
         case('chcl3','chloroform');      param = gfn2_alpb_chcl3
         case('cs2');          param = gfn2_alpb_cs2
         case('dmso');         param = gfn2_alpb_dmso
         case('ether');        param = gfn2_alpb_ether
         case('h2o','water');  param = gfn2_alpb_water
         case('methanol');     param = gfn2_alpb_methanol 
         case('thf');          param = gfn2_alpb_thf
         case('toluene');      param = gfn2_alpb_toluene
         case('dmf');          param = gfn2_alpb_dmf
         case('ethanol');      param = gfn2_alpb_ethanol
         case('nhexan','n-hexan','nhexane','n-hexane','hexane');
            param = gfn2_alpb_hexane
         end select
      elseif (level == 0) then
         self%paramFile = 'internal GFN-FF/ALPB'
         select case(solvent)
         case('acetone');      param = gfnff_alpb_acetone
         case('acetonitrile'); param = gfnff_alpb_acetonitrile
         case('aniline');      param = gfnff_alpb_aniline
         case('benzaldehyde');      param = gfnff_alpb_benzaldehyde
         case('benzene');      param = gfnff_alpb_benzene
         case('dioxane');      param = gfnff_alpb_dioxane
         case('ethylacetate');      param = gfnff_alpb_ethylacetate
         case('furane');      param = gfnff_alpb_furane
         case('hexadecane');      param = gfnff_alpb_hexadecane
         case('nitromethane');      param = gfnff_alpb_nitromethane
         case('octanol');      param = gfnff_alpb_octanol
         case('woctanol');      param = gfnff_alpb_woctanol
         case('phenol');      param = gfnff_alpb_phenol 
         case('ch2cl2','dichlormethane'); param = gfnff_alpb_ch2cl2
         case('chcl3','chloroform');      param = gfnff_alpb_chcl3
         case('cs2');          param = gfnff_alpb_cs2
         case('dmso');         param = gfnff_alpb_dmso
         case('ether');        param = gfnff_alpb_ether
         case('h2o','water');  param = gfnff_alpb_water
         case('methanol');     param = gfnff_alpb_methanol
         case('ethanol');      param = gfnff_alpb_ethanol
         case('thf');          param = gfnff_alpb_thf
         case('toluene');      param = gfnff_alpb_toluene
         case('dmf');          param = gfnff_alpb_dmf
         case('nhexan','n-hexan','nhexane','n-hexane','hexane');
            param = gfnff_alpb_hexane
      end select
      else
         self%paramFile = 'internal GFN1-xTB/ALPB'
         select case(solvent)
         case('acetone');      param = gfn1_alpb_acetone
         case('acetonitrile'); param = gfn1_alpb_acetonitrile
         case('aniline');      param = gfn1_alpb_aniline
         case('benzaldehyde');      param = gfn1_alpb_benzaldehyde
         case('benzene');      param = gfn1_alpb_benzene
         case('dioxane');      param = gfn1_alpb_dioxane
         case('ethylacetate');      param = gfn1_alpb_ethylacetate
         case('furane');      param = gfn1_alpb_furane
         case('hexadecane');      param = gfn1_alpb_hexadecane
         case('nitromethane');      param = gfn1_alpb_nitromethane
         case('octanol');      param = gfn1_alpb_octanol
         case('woctanol');      param = gfn1_alpb_woctanol
         case('phenol');      param = gfn1_alpb_phenol 
         case('ch2cl2','dichlormethane'); param = gfn1_alpb_ch2cl2
         case('chcl3','chloroform');      param = gfn1_alpb_chcl3
         case('cs2');          param = gfn1_alpb_cs2
         case('dmso');         param = gfn1_alpb_dmso
         case('ether');        param = gfn1_alpb_ether
         case('h2o','water');  param = gfn1_alpb_water
         case('methanol');     param = gfn1_alpb_methanol
         case('ethanol');      param = gfn1_alpb_ethanol
         case('thf');          param = gfn1_alpb_thf
         case('toluene');      param = gfn1_alpb_toluene
         case('dmf');          param = gfn1_alpb_dmf
         case('nhexan','n-hexan','nhexane','n-hexane','hexane');
            param = gfn1_alpb_hexane
         end select
      end if
      
!      if (self%cosmo) then
!         if (allocated(param)) then
!            self%paramFile = self%paramFile//"+COSMO"
!            stub = param
!            param = gfn_cosmo
!            param%epsv = stub%epsv
!            param%smass = stub%smass
!            param%rhos = stub%rhos
!            param%gamscale = stub%gamscale
!         else if ((solvent .eq. "inf") .or. (solvent .eq. "infinity")) then
!            self%paramFile = "internal GFN-xTB/COSMO"
!            param = gfn_cosmo
!            param%epsv = ieee_value(param%epsv,ieee_positive_inf)
!         else
!            self%paramFile = "internal GFN-xTB/COSMO"
!            param = gfn_cosmo
!            read(solvent,*,iostat=iostat) param%epsv
!            if (iostat .ne. 0) then
!               write(stderr,*) solvent// " is neither a solvent name nor a dielectric constant  "
!               stop source
!               return
!            end if
!            if (param%epsv .eq. 0) then
!               write(stderr,*) "You really chose 0 as your dielectric constant?"
!               stop source
!               return
!            end if
!         end if
!      end if

      if (.not.allocated(param)) then
         write(stderr,*) "solvent: '"//solvent//"' is not parametrized"
         stop source
         return
      end if

   end select
   call paramToModel(self, param)

end subroutine loadInternalParam


subroutine readParamFile(self)

   !> Error source for traceback
   character(len=*), parameter :: source = 'solv_model_readParamFile'

   !> Data structure
   type(TSolvModel), intent(inout) :: self

   type(gbsa_parameter) :: param
   integer :: unit, stat, statc, ii

   statc = 0
   !call open_file(unit, self%paramFile, 'r')
   open(newunit=unit, file=self%paramFile, action='read')
   if (unit == -1) then
       write(stderr,*) "Could not open parameter file '"//self%paramFile//"'"
       stop source
      return
   end if

   read(unit,*,iostat=stat) param%epsv
   if (stat /= 0) statc = statc + 1
   read(unit,*,iostat=stat) param%smass
   if (stat /= 0) statc = statc + 1
   read(unit,*,iostat=stat) param%rhos
   if (stat /= 0) statc = statc + 1
   read(unit,*,iostat=stat) param%c1
   if (stat /= 0) statc = statc + 1
   read(unit,*,iostat=stat) param%rprobe
   if (stat /= 0) statc = statc + 1
   read(unit,*,iostat=stat) param%gshift
   if (stat /= 0) statc = statc + 1
   read(unit,*,iostat=stat) param%soset
   if (stat /= 0) statc = statc + 1
   read(unit,*,iostat=stat) param%alpha
   if (stat /= 0) statc = statc + 1
   do ii = 1, 94
      read(unit,*,iostat=stat) param%gamscale(ii), param%sx(ii), param%tmp(ii)
      if (stat /= 0) statc = statc + 1
   enddo

   if (statc /= 0) then
      write(stderr,*) "Could not read parameters from '"//self%paramFile//"'"
      stop source
      return
   end if

   call paramToModel(self, param)

end subroutine readParamFile


subroutine paramToModel(self, param)

   !> Data structure
   type(TSolvModel), intent(inout) :: self

   type(gbsa_parameter), intent(in) :: param

   integer :: ii

   self%dielectricConst = param%epsv
   self%molarMass = param%smass
   self%density = param%rhos/param%smass * molcm3toau
   self%freeEnergyShift = param%gshift * kcaltoau
   self%bornScale = param%c1
   self%bornOffset = param%soset * 0.1_wp*aatoau
   self%probeRad = param%rprobe * aatoau

   if (self%cosmo) then
      self%vdwRad=vanDerWaalsRadCosmo
   else
      self%vdwRad=vanDerWaalsRadD3
   end if

   self%surfaceTension = param%gamscale * fourpi*surfaceTension
   self%descreening = param%sx
   allocate(self%hBondStrength(size(param%tmp)))
   if (any(abs(param%tmp).gt.1.e-3_wp)) then
      do ii = 1, size(param%tmp)
         self%hBondStrength(ii) = -(param%tmp(ii)**2) * kcaltoau
      end do
   else
      self%hBondStrength(:) = 0.0_wp
   end if

end subroutine paramToModel


!> Try to find a suitable parameter file for parsing
subroutine getParamFile(solvent, model, level, pfile)

   !> Error source for traceback
   character(len=*), parameter :: source = 'solv_model_getParamFile'

   !> Name of the solvent (normalized)
   character(len=*), intent(in) :: solvent

   !> Name of the solvation model
   character(len=*), intent(in) :: model

   !> Method level for solvation model
   integer, intent(in) :: level

   !> Parameter file, unallocated if nothing was found
   character(len=:), allocatable, intent(out) :: pfile
   character(len=:), allocatable :: fname

   ! try "param_<model>[level]_<solvent>.txt" first
   select case(level)
   case(2)
      fname = 'param_' // model // '2_' // solvent // '.txt'
   case(1)
      fname = 'param_' // model // '1_' // solvent // '.txt'
   case(0)
      fname = 'param_' // model // '0_' // solvent // '.txt'
   end select

   if (allocated(fname)) then
      call rdpath('.', fname, pfile)
   end if

   if (.not.allocated(pfile)) then
      ! try "param_<model>_<solvent>.txt" next
      fname = 'param_' // model // '_' // solvent // '.txt'
      call rdpath('.', fname, pfile)
   end if

   ! finally try ".param_<model>_<solvent>" which is the old default
   if (.not.allocated(pfile)) then
      select case(level)
      case default
         fname = '.param_' // model // '_' // solvent
      case(2)
         fname = '.param_' // model // '2_' // solvent
      case(0)
         fname = '.param_' // model // '0_' // solvent
      end select

      call rdpath('.', fname, pfile)
   end if

end subroutine getParamFile


!> Print information on the solvation model
subroutine info(self, unit)

   !> Data structure
   class(TSolvModel), intent(in) :: self

   !> Unit for IO
   integer, intent(in) :: unit

   
   write(unit, '(8x, a )') repeat('-',50)
   write(unit, '(8x, a, ":", t40)', advance='no') "Solvation model"
!   if (self%cosmo) then
!      write(unit, '(a)') "COSMO"
!   else
      if (self%alpb) then
         write(unit, '(a)') "ALPB"
      else
         write(unit, '(a)') "GBSA"
      end if
!   end if
   write(unit, '(8x, a )') repeat('-',50)

   write(unit, '(8x, a, t40, a)') "Solvent", self%solvent
   write(unit, '(8x, a, t40, a)') "Parameter file", self%paramFile
   write(unit, '(8x, a, t40, es14.4)') &
      & "Dielectric constant", self%dielectricConst

   write(unit, '(8x, a, t40)', advance='no') "Reference state"
   select case(self%state)
   case default
      write(unit, '(a)') 'gsolv [1 M gas/solution]'
   case(solutionState%reference)
      write(unit, '(a)') 'gsolv=reference [X=1]'
   case(solutionState%mol1bar)
      write(unit, '(a)') 'gsolv [1 bar gas/1 M solution]'
   end select

   write(unit, '(8x, a, t40, es14.4, 1x, a, t60, es14.4, 1x, a)') &
      & "Free energy shift", self%freeEnergyShift, "Eh", &
      & self%freeEnergyShift * autokcal, "kcal/mol"
   write(unit, '(8x, a, t40, es14.4, 1x, a)') &
      & "Temperature", self%temperature, "K"
   write(unit, '(8x, a, t40, es14.4, 1x, a)') &
      & "Density", self%density / (molcm3toau/self%molarMass), "kg/L"
   write(unit, '(8x, a, t40, es14.4, 1x, a)') &
      & "Solvent mass", self%molarMass, "g/mol"

!   if (self%cosmo) then
!      write(unit, '(8x, a, t40, es14.4)') &
!         & "vdW Radii scaling", self%bornScale
!   else
      write(unit, '(8x, a, t40)', advance='no') "Interaction kernel"
      select case(self%kernel)
      case default
         write(unit, '(i0, 1x, a)') self%kernel, '(internal error)'
      case(gbKernel%still)
         write(unit, '(a)') 'Still'
      case(gbKernel%p16)
         write(unit, '(a)') 'P16'
      end select

      write(unit, '(8x, a, t40, es14.4)') &
         "Born radius scaling (c1)", self%bornScale
      write(unit, '(8x, a, t40, a)') "Born radii integrator", "GBOBC"
      write(unit, '(8x, a, t40, es14.4, 1x, a, t60, es14.4, 1x, a)') &
         "Born offset", self%bornOffset, "a0", self%bornOffset/autoaa, "AA"

      write(unit, '(8x, a, t40)', advance='no') "H-bond correction"
      if (any(self%hBondStrength < 0.0_wp)) then
         write(unit, '(a)') "true"
      else
         write(unit, '(a)') "false"
      end if

      write(unit, '(8x, a, t40)', advance='no') "Ion screening"
      if (self%ionStrength > 0.0_wp) then
         write(unit, '(a)') "true"
      else
         write(unit, '(a)') "false"
      end if
!   end if

   if (allocated(self%surfaceTension)) then
      write(unit, '(8x, a, t40, es14.4, 1x, a, t60, es14.4, 1x, a)') &
         "Surface tension", surfaceTension, "Eh", surfaceTension*automNm, "dyn/cm"
   end if

   write(unit, '(8x, a, t40, i14, 1x, a)') &
      "Grid points", self%nAng, "per atom"

end subroutine info


subroutine newSolvationModel(self, model, num)

   !> Error source for traceback
   character(len=*), parameter :: source = 'solv_model_newSolvationModel'

   !> Data structure
   class(TSolvModel), intent(in) :: self

   !> Solvation model to create
   class(TSolvation), allocatable, intent(out) :: model

   !> Atomic numbers
   integer, intent(in) :: num(:)

!   type(TCosmo), allocatable :: cosmo
   type(TBorn), allocatable :: born

!   if (self%cosmo) then
!      allocate(cosmo)
!      call init_(cosmo, num, self%dielectricConst, self%nAng, self%bornScale, &
!         & self%vdwRad, self%surfaceTension, self%probeRad, srcut)
!      call move_alloc(cosmo, model)
!   else
      allocate(born)
      call init_(born, num, self%vdwRad, self%dielectricConst, &
         & self%freeEnergyShift, self%descreening, self%bornScale, &
         & self%bornOffset, self%surfaceTension, self%probeRad, lrcut, srcut, &
         & self%nAng, self%hBondStrength, self%temperature, self%kernel, &
         & self%alpb, self%ionStrength, self%ionRad)
      call move_alloc(born, model)
!   end if

end subroutine newSolvationModel


subroutine newBornModel(self,  model, num)

   !> Error source for traceback
   character(len=*), parameter :: source = 'solv_model_newSolvationModel'

   !> Data structure
   class(TSolvModel), intent(in) :: self

   !> Solvation model to create
   type(TBorn), intent(out) :: model

   !> Atomic numbers
   integer, intent(in) :: num(:)

   call init_(model, num, self%vdwRad, self%dielectricConst, &
      & self%freeEnergyShift, self%descreening, self%bornScale, &
      & self%bornOffset, self%surfaceTension, self%probeRad, lrcut, srcut, &
      & self%nAng, self%hBondStrength, self%temperature, self%kernel, &
      & self%alpb, self%ionStrength, self%ionRad)

   model%solvent     = self%solvent
   model%paramFile   = self%paramFile
   model%state       = self%state
   model%temperature = self%temperature
   model%density     = self%density
   model%molarMass   = self%molarMass
   model%bornOffset  = self%bornOffset
   model%ionStrength = self%ionStrength
   model%nAng        = self%nAng

end subroutine newBornModel


end module solvation_solv_model

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!

!> Abstract solvation model
module solvation_type_solvation
   use iso_fortran_env, only : wp => real64
   implicit none
   private

   public :: TSolvation


   type, abstract :: TSolvation
   contains

      !> Update coordinates and internal state
      procedure(update), deferred :: update

      !> Add potential shift
      procedure(addShift), deferred :: addShift

      !> Calculate solvation energy
      procedure(getEnergy), deferred :: getEnergy

      !> Calculate derivatives of solvation energy
      procedure(addGradient), deferred :: addGradient

   end type TSolvation


   abstract interface
      !> Update coordinates and internal state
      subroutine update(self, num, xyz)
         import :: TSolvation, wp

         !> Instance of the solvation model
         class(TSolvation), intent(inout) :: self

         !> Atomic numbers
         integer, intent(in) :: num(:)

         !> Cartesian coordinates
         real(wp), intent(in) :: xyz(:, :)

      end subroutine update

      !> Add potential shift
      subroutine addShift(self, qat, qsh, atomicShift, shellShift)
         import :: TSolvation, wp

         !> Instance of the solvation model
         class(TSolvation), intent(inout) :: self

         !> Atomic partial charges
         real(wp), intent(in) :: qat(:)

         !> Shell-resolved partial charges
         real(wp), intent(in) :: qsh(:)

         !> Atomic potential shift
         real(wp), intent(inout) :: atomicShift(:)

         !> Shell-resolved potential shift
         real(wp), intent(inout) :: shellShift(:)

      end subroutine addShift


      !> Calculate solvation energy
      subroutine getEnergy(self, qat, qsh, energy)
         import :: TSolvation, wp

         !> Instance of the solvation model
         class(TSolvation), intent(inout) :: self

         !> Atomic partial charges
         real(wp), intent(in) :: qat(:)

         !> Shell-resolved partial charges
         real(wp), intent(in) :: qsh(:)

         !> Total solvation energy
         real(wp), intent(out) :: energy

      end subroutine getEnergy


      !> Calculate derivatives of solvation energy
      subroutine addGradient(self, num, xyz, qat, qsh, gradient)
         import :: TSolvation, wp

         !> Instance of the solvation model
         class(TSolvation), intent(inout) :: self

         !> Atomic numbers
         integer, intent(in) :: num(:)

         !> Cartesian coordinates
         real(wp), intent(in) :: xyz(:, :)

         !> Atomic partial charges
         real(wp), intent(in) :: qat(:)

         !> Shell-resolved partial charges
         real(wp), intent(in) :: qsh(:)

         !> Molecular gradient
         real(wp), intent(inout) :: gradient(:, :)

      end subroutine addGradient

   end interface


end module solvation_type_solvation

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module wfn_module
!> A module that defines the wavefunction type "wfn"
   use iso_fortran_env, only : wp=>real64
   implicit none

   public :: TWavefunction

   private

   type :: TWavefunction
      integer :: n = 0
      integer :: nel = 0
      integer :: nopen = 0
      integer :: nao = 0
      integer :: nshell = 0
      real(wp),allocatable :: P(:,:)    ! density matrix
      real(wp),allocatable :: q(:)      ! partial charges
      real(wp),allocatable :: qsh(:)    ! shell charges
      real(wp),allocatable :: dipm(:,:) ! dipole moments
      real(wp),allocatable :: qp(:,:)   ! quadrupole moments
      real(wp),allocatable :: wbo(:,:)  ! wiberg bond orders
      integer :: ihomo = 0,ihomoa = 0,ihomob = 0 ! HOMO position
      real(wp) :: efa = 0.0_wp, efb = 0.0_wp
      real(wp),allocatable :: focc(:)   ! fractional occupation
      real(wp),allocatable :: focca(:)  ! for alpha space
      real(wp),allocatable :: foccb(:)  ! for beta space
      real(wp),allocatable :: emo(:)    ! orbital energies
      real(wp),allocatable :: C(:,:)    ! molecular orbitals
      real(wp),allocatable :: S(:,:)    ! overlap (not always allocated)
   contains
   procedure :: allocate => allocate_wavefunction
   procedure :: deallocate => deallocate_wavefunction
   procedure :: refresh_occu
   end type TWavefunction

contains

subroutine allocate_wavefunction(self,n,nshell,nao)
   class(TWavefunction),intent(inout) :: self
   integer,intent(in) :: n,nshell,nao
   self%n = n
   self%nshell = nshell
   self%nao = nao
   self%ihomo = 0
   self%ihomoa = 0
   self%ihomob = 0
   call self%deallocate
   allocate( self%P(nao,nao),  source = 0.0_wp )
   allocate( self%q(n),        source = 0.0_wp )
   allocate( self%qsh(nshell), source = 0.0_wp )
   allocate( self%dipm(3,n),   source = 0.0_wp )
   allocate( self%qp(6,n),     source = 0.0_wp )
   allocate( self%wbo(n,n),    source = 0.0_wp )
   allocate( self%focc(nao),   source = 0.0_wp )
   allocate( self%focca(nao),  source = 0.0_wp )
   allocate( self%foccb(nao),  source = 0.0_wp )
   allocate( self%emo(nao),    source = 0.0_wp )
   allocate( self%C(nao,nao),  source = 0.0_wp )
   !> overlap not automatically allocated!
end subroutine allocate_wavefunction

subroutine deallocate_wavefunction(self)
   class(TWavefunction),intent(inout) :: self
   if(allocated(self%P))    deallocate(self%P)
   if(allocated(self%q))    deallocate(self%q)
   if(allocated(self%qsh))  deallocate(self%qsh)
   if(allocated(self%dipm)) deallocate(self%dipm)
   if(allocated(self%qp))   deallocate(self%qp)
   if(allocated(self%wbo))  deallocate(self%wbo)
   if(allocated(self%focc)) deallocate(self%focc)
   if(allocated(self%focca))deallocate(self%focca)
   if(allocated(self%foccb))deallocate(self%foccb)
   if(allocated(self%emo))  deallocate(self%emo)
   if(allocated(self%C))    deallocate(self%C)
   if(allocated(self%S))    deallocate(self%S)
end subroutine deallocate_wavefunction

subroutine refresh_occu(self,nel,uhf)
!(ndim,   nel,    nopen,    ihomoa,    ihomob,    focca,    foccb)
!(wfn%nao,wfn%nel,wfn%nopen,wfn%ihomoa,wfn%ihomob,wfn%focca,wfn%foccb)
   class(TWavefunction),intent(inout) :: self
   integer,intent(in)  :: nel  !> total # of electrons
   integer,intent(in)  :: uhf  !> uhf input parameter
    integer  :: nopen
    integer  :: ndim
    integer  :: ihomoa
    integer  :: ihomob
    integer,allocatable  :: focc(:)
    integer  :: i,na,nb,ihomo

    self%nel = nel
    self%nopen = uhf
    if (self%nopen == 0 .and. mod(self%nel,2) /= 0) self%nopen = 1
        
    nopen = self%nopen
    ndim = self%nao  
    allocate(focc(ndim), source=0)
    focc = 0
    self%focca = 0.0_wp
    self%foccb = 0.0_wp
!>--- even nel
    if (mod(nel,2) .eq. 0) then
      ihomo = nel / 2
      do i = 1,ihomo
        focc(i) = 2
      end do
      if (2 * ihomo .ne. nel) then
        ihomo = ihomo + 1
        focc(ihomo) = 1
        if (nopen .eq. 0) nopen = 1
      end if
      if (nopen .gt. 1) then
        do i = 1,nopen / 2
          focc(ihomo - i + 1) = focc(ihomo - i + 1) - 1
          focc(ihomo + i) = focc(ihomo + i) + 1
        end do
      end if
!>--- odd nel
    else
      na = nel / 2 + (nopen - 1) / 2 + 1
      nb = nel / 2 - (nopen - 1) / 2
      do i = 1,na
        focc(i) = focc(i) + 1
      end do
      do i = 1,nb
        focc(i) = focc(i) + 1
      end do
    end if

    do i = 1,ndim
      if (focc(i) .eq. 2) then
        self%focca(i) = 1.0d0
        self%foccb(i) = 1.0d0
      end if
      if (focc(i) .eq. 1) self%focca(i) = 1.0d0
    end do

    ihomoa = 0
    ihomob = 0
    do i = 1,ndim
      if (self%focca(i) .gt. 0.99) ihomoa = i
      if (self%foccb(i) .gt. 0.99) ihomob = i
    end do

    self%ihomoa = ihomoa
    self%ihomo  = ihomoa
    self%ihomob = ihomob
    self%focc   = self%focca + self%foccb
    deallocate(focc)

end subroutine refresh_occu


end module wfn_module

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module overlap_module
! --------------------------------------------------------------[SAW1907]-
!> Backend implementation for all overlap distribution based integrals,
!  we use a hardcoded horizontal Obara--Saika recursion relation to get
!  the job done, this is working code, so think twice before modifying it!
   use iso_fortran_env, only : wp=>real64
   implicit none

   real(wp),private,parameter :: pi=3.1415926535897932385_wp 
   real(wp),private,parameter ::  sqrtpi  = sqrt(pi) 
   integer, parameter :: maxl = 6
   integer, parameter :: maxl2 = maxl*2

   integer,private,parameter :: lx(84) = (/ &
      & 0, &
      & 1,0,0, &
      & 2,0,0,1,1,0, &
      & 3,0,0,2,2,1,0,1,0,1, &
      & 4,0,0,3,3,1,0,1,0,2,2,0,2,1,1, &
      & 5,0,0,3,3,2,2,0,0,4,4,1,0,0,1,1,3,1,2,2,1, &
      & 6,0,0,3,3,0,5,5,1,0,0,1,4,4,2,0,2,0,3,3,1,2,2,1,4,1,1,2/)
   integer,private,parameter :: ly(84) = (/ &
      & 0, &
      & 0,1,0, &
      & 0,2,0,1,0,1, &
      & 0,3,0,1,0,2,2,0,1,1, &
      & 0,4,0,1,0,3,3,0,1,2,0,2,1,2,1, &
      & 0,5,0,2,0,3,0,3,2,1,0,4,4,1,0,1,1,3,2,1,2, &
      & 0,6,0,3,0,3,1,0,0,1,5,5,2,0,0,2,4,4,2,1,3,1,3,2,1,4,1,2/)
   integer,private,parameter :: lz(84) = (/ &
      & 0, &
      & 0,0,1, &
      & 0,0,2,0,1,1, &
      & 0,0,3,0,1,0,1,2,2,1, &
      & 0,0,4,0,1,0,1,3,3,0,2,2,1,1,2, &
      & 0,0,5,0,2,0,3,2,3,0,1,0,1,4,4,3,1,1,1,2,2, &
      & 0,0,6,0,3,3,0,1,5,5,1,0,0,2,4,4,0,2,1,2,2,3,1,3,1,1,4,2/)
   integer, private, parameter :: lxyz(3, 84) = reshape(&
      & [lx, ly, lz], shape(lxyz), order=[2, 1])
   !     integer,parameter :: iall(4,4) = reshape( (/
   !     1,4,10,20,4,10,20,35,10,20,35,56,20,35,56,84 /), shape(iall) )
   !     s    px   py   pz    dx²   dy²   dz²   dxy   dxz   dyz
   !     1    2    3    4     5     6     7     8     9     10
   !     fx³  fy³  fz³  fx²y  fx²z  fy²x  fy²z  fxz²  fyz²  fxyz
   !     11   12   13   14    15    16    17    18    19    20
   !     gx⁴  gy⁴  gz⁴  gx³y  gx³z  gy³x  gy³z  gz³x  gz³y  gx²y²
   !     21   22   23   24    25    26    27    28    29    30
   !     gx²z²     gy²z²      gx²yz       gy²xz       gz²xy
   !     31        32         33          34          35

   integer,private, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer,private, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

   real(wp),private, parameter :: trafo(6,6) = reshape((/ & ! copied from scf.f, simplyfied
      ! --- dS
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp, &
      ! --- dx²-y²
      & 0.5_wp*sqrt(3.0_wp), &
      &-0.5_wp*sqrt(3.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp, &
      ! --- dz²
      & 0.5_wp,0.5_wp,-1.0_wp, &
      & 0.0_wp,0.0_wp, 0.0_wp, &
      ! --- rest
      & 0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp /), shape(trafo))

   integer, parameter, private :: itt(0:3) = [0,1,4,10]

contains


! --------------------------------------------------------------[SAW1907]-
!> calculates a partial overlap in one cartesian direction
pure elemental function olapp(l,gama) result(s)
   !$acc routine seq
   integer,intent(in) :: l
   real(wp),intent(in) :: gama
   real(wp) :: s
   real(wp) :: gm
   integer  :: lh
   real(wp),parameter :: dftr(0:7) = & ! see OEIS A001147
      & [1._wp,1._wp,3._wp,15._wp,105._wp,945._wp,10395._wp,135135._wp]
   if (mod(l,2).ne.0) then
      s=0._wp
   else
      lh=l/2
      gm=0.5_wp/gama
      s=gm**lh*dftr(lh)
   endif
end function olapp

! --------------------------------------------------------------[SAW1907]-
!> returns center of product Gaussian from two Gaussians by GPT
pure function gpcenter(alp,ra,bet,rb) result(rp)
  !$acc routine seq
   real(wp),intent(in) :: alp,bet
   real(wp),intent(in) :: ra(3),rb(3)
   real(wp) :: rp(3)

   rp = (alp*ra + bet*rb)/(alp+bet)

end function gpcenter

! --------------------------------------------------------------[SAW1907]-
pure subroutine build_kab(ra,alp,rb,bet,gama,kab)
  !$acc routine seq
   !     this computes the center, exponent, and multiplying factor of
   !     a single gaussian which can replace the product of two gaussian
   !     centers a and b, and exponents alpha and beta.
   real(wp),intent(in)  :: ra(3),alp,rb(3),bet
   real(wp),intent(out) :: gama,kab
   real(wp) :: rab2,rab(3),est,gm
   gama  = alp+bet
   gm    = 1.0_wp/gama
   rab   = ra - rb
   rab2  = rab(1)*rab(1) + rab(2)*rab(2) + rab(3)*rab(3)
   est   = rab2*alp*bet*gm
   kab   = exp(-est)*(sqrtpi*sqrt(gm))**3
end subroutine build_kab

! --------------------------------------------------------------[SAW1801]-
pure subroutine dtrf2(s,li,lj)
   use gfn0_math_wrapper
   real(wp),intent(inout) :: s(6,6)
   integer, intent(in)    :: li,lj
   ! CAO-AO transformation
   real(wp), parameter :: trafo(6,6) = reshape((/ & ! copied from scf.f, simplyfied
      ! --- dS
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp, &
      ! --- dx²-y²
      & 0.5_wp*sqrt(3.0_wp), &
      &-0.5_wp*sqrt(3.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp, &
      ! --- dz²
      & 0.5_wp,0.5_wp,-1.0_wp, &
      & 0.0_wp,0.0_wp, 0.0_wp, &
      ! --- rest
      & 0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp /), shape(trafo))

   real(wp) s2(6,6),sspher,dum(6,6)
   integer ii,jj,m,n

   !     transformation not needed for pure s/p overlap -> do nothing
   if (li.lt.2.and.lj.lt.2) return

   ! --- means li.ge.2.or.lj.ge.2, so one of them is a d-shell
   !     assuming its on jat ... a wild guess
   select case(li)
   case(0) ! s-d
      do jj=1,6
         sspher=0
         do m=1,6
            sspher=sspher+trafo(m,jj)*s(m,1)
         enddo
         s2(jj,1)=sspher
      enddo
      s(1:5,1) = s2(2:6,1)
      return
   case(1) ! p-d
      do ii=1,3
         do jj=1,6
            sspher=0
            do m=1,6
               sspher=sspher+trafo(m,jj)*s(m,ii)
            enddo
            s2(jj,ii)=sspher
         enddo
         s(1:5,ii) = s2(2:6,ii)
      enddo
      return
   end select
   !     wasn't there, then try iat ...
   select case(lj)
   case(0) ! d-s
      do jj=1,6
         sspher=0
         do m=1,6
            sspher=sspher+trafo(m,jj)*s(1,m)
         enddo
         s2(1,jj)=sspher
      enddo
      s(1,1:5) = s2(1,2:6)
      return
   case(1) ! d-p
      do ii=1,3
         do jj=1,6
            sspher=0
            do m=1,6
               sspher=sspher+trafo(m,jj)*s(ii,m)
            enddo
            s2(ii,jj)=sspher
         enddo
         s(ii,1:5) = s2(ii,2:6)
      enddo
      return
   end select
   !     if not returned up to here -> d-d
   ! CB: transposing s in first dgemm is important for integrals other than S
   CALL gemm(trafo, s, dum, transa='T')
   CALL gemm(dum, trafo, s2, transb='N')
   s(1:5,1:5) = s2(2:6,2:6)
   return

end subroutine dtrf2

! --------------------------------------------------------------[SAW1801]-
pure subroutine build_hshift2(cfs,a,e,l)
   !$acc routine seq
   integer,intent(in)  :: l
   real(wp), intent(in)  :: a,e
   real(wp), intent(inout) :: cfs(*)
   integer :: i
   real(wp)  :: ae
   ! --- e = center of product function, a = center of single gaussian
   ae = e-a
   select case(l)
   case(0) ! s
      continue
   case(1) ! p
      cfs(1)=ae*cfs(2)
   case(2) ! d
      cfs(1)=ae*ae*cfs(3)
      cfs(2)= 2*ae*cfs(3)
   case(3) ! f
      cfs(1)=ae*ae*ae*cfs(4)
      cfs(2)= 3*ae*ae*cfs(4)
      cfs(3)= 3*ae*cfs(4)
   case(4) ! g
      cfs(1)=ae*ae*ae*ae*cfs(5)
      cfs(2)= 4*ae*ae*ae*cfs(5)
      cfs(3)= 6*ae*ae*cfs(5)
      cfs(4)= 4*ae*cfs(5)
   end select
end subroutine build_hshift2

! --------------------------------------------------------------[SAW1801]-
pure subroutine prod3(a,b,d,la,lb)
   !$acc routine seq
   implicit none
   integer,intent(in)    :: la,lb
   real(wp), intent(in)    :: a(*),b(*)
   real(wp), intent(inout) :: d(*)
   integer :: i
   if(la.ge.4.or.lb.ge.4) goto 40
   if(la.ge.3.or.lb.ge.3) goto 30
   if(la.ge.2.or.lb.ge.2) goto 20
   ! <s|s> = <s>
   d(1)=a(1)*b(1)
   if(la.eq.0.and.lb.eq.0) return
   ! <s|p> = <s|*(|s>+|p>)
   !       = <s> + <p>
   d(2)=a(1)*b(2)+a(2)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|p> = (<s|+<p|)*(|s>+|p>)
   !       = <s> + <p> + <d>
   d(3)=a(2)*b(2)
   return
20 continue
   ! <s|d> = <s|*(|s>+|p>+|d>)
   !       = <s> + <p> + <d>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|d> = (<s|+<p|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f>
   d(3)=d(3)+a(2)*b(2)
   d(4)=a(2)*b(3)+a(3)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|d> = (<s|+<p|+<d|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(5)=a(3)*b(3)
   return
30 continue
   ! <s|f> = <s|*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|f> = (<s|+<p|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=a(2)*b(4)+a(4)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|f> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(5)=d(5)+a(3)*b(3)
   d(6)=a(3)*b(4)+a(4)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|f> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(7)=a(4)*b(4)
   return
40 continue
   ! <s|g> = <s|*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   d(5)=a(1)*b(5)+a(5)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|g> = (<s|+<p|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=d(5)+a(2)*b(4)+a(4)*b(2)
   d(6)=a(2)*b(5)+a(5)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|g> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(5)=d(5)+a(3)*b(3)
   d(6)=d(5)+a(3)*b(4)+a(4)*b(3)
   d(7)=a(3)*b(5)+a(5)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|g> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k>
   d(7)=d(7)+a(4)*b(4)
   d(8)=a(4)*b(5)+a(5)*b(4)
   if(la.le.3.or.lb.le.3) return
   ! <g|g> = (<s|+<p|+<d|+<f|+<g|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k> + <l>
   d(9)=a(5)*b(5)

end subroutine prod3

pure subroutine horizontal_shift(ae, l, cfs)
   integer, intent(in) :: l
   real(wp), intent(in) :: ae
   real(wp), intent(inout) :: cfs(*)
   integer :: i
   select case(l)
   case(0) ! s
      continue
   case(1) ! p
      cfs(1)=cfs(1)+ae*cfs(2)
   case(2) ! d
      cfs(1)=cfs(1)+ae*ae*cfs(3)
      cfs(2)=cfs(2)+ 2*ae*cfs(3)
   case(3) ! f
      cfs(1)=cfs(1)+ae*ae*ae*cfs(4)
      cfs(2)=cfs(2)+ 3*ae*ae*cfs(4)
      cfs(3)=cfs(3)+ 3*ae*cfs(4)
   case(4) ! g
      cfs(1)=cfs(1)+ae*ae*ae*ae*cfs(5)
      cfs(2)=cfs(2)+ 4*ae*ae*ae*cfs(5)
      cfs(3)=cfs(3)+ 6*ae*ae*cfs(5)
      cfs(4)=cfs(4)+ 4*ae*cfs(5)
   end select
end subroutine horizontal_shift

pure subroutine form_product(a, b, la, lb, d)
   integer, intent(in) :: la, lb
   real(wp), intent(in) :: a(*), b(*)
   real(wp), intent(inout) :: d(*)
   integer :: i
   if(la.ge.4.or.lb.ge.4) goto 40
   if(la.ge.3.or.lb.ge.3) goto 30
   if(la.ge.2.or.lb.ge.2) goto 20
   ! <s|s> = <s>
   d(1)=a(1)*b(1)
   if(la.eq.0.and.lb.eq.0) return
   ! <s|p> = <s|*(|s>+|p>)
   !       = <s> + <p>
   d(2)=a(1)*b(2)+a(2)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|p> = (<s|+<p|)*(|s>+|p>)
   !       = <s> + <p> + <d>
   d(3)=a(2)*b(2)
   return
20 continue
   ! <s|d> = <s|*(|s>+|p>+|d>)
   !       = <s> + <p> + <d>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|d> = (<s|+<p|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f>
   d(3)=d(3)+a(2)*b(2)
   d(4)=a(2)*b(3)+a(3)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|d> = (<s|+<p|+<d|)*(|s>+|p>+|d>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(5)=a(3)*b(3)
   return
30 continue
   ! <s|f> = <s|*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|f> = (<s|+<p|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=a(2)*b(4)+a(4)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|f> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(5)=d(5)+a(3)*b(3)
   d(6)=a(3)*b(4)+a(4)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|f> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(7)=a(4)*b(4)
   return
40 continue
   ! <s|g> = <s|*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g>
   d(1)=a(1)*b(1)
   d(2)=a(1)*b(2)+a(2)*b(1)
   d(3)=a(1)*b(3)+a(3)*b(1)
   d(4)=a(1)*b(4)+a(4)*b(1)
   d(5)=a(1)*b(5)+a(5)*b(1)
   if(la.eq.0.or.lb.eq.0) return
   ! <p|g> = (<s|+<p|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h>
   d(3)=d(3)+a(2)*b(2)
   d(4)=d(4)+a(2)*b(3)+a(3)*b(2)
   d(5)=d(5)+a(2)*b(4)+a(4)*b(2)
   d(6)=a(2)*b(5)+a(5)*b(2)
   if(la.le.1.or.lb.le.1) return
   ! <d|g> = (<s|+<p|+<d|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i>
   d(5)=d(5)+a(3)*b(3)
   d(6)=d(5)+a(3)*b(4)+a(4)*b(3)
   d(7)=a(3)*b(5)+a(5)*b(3)
   if(la.le.2.or.lb.le.2) return
   ! <f|g> = (<s|+<p|+<d|+<f|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k>
   d(7)=d(7)+a(4)*b(4)
   d(8)=a(4)*b(5)+a(5)*b(4)
   if(la.le.3.or.lb.le.3) return
   ! <g|g> = (<s|+<p|+<d|+<f|+<g|)*(|s>+|p>+|d>+|f>+|g>)
   !       = <s> + <p> + <d> + <f> + <g> + <h> + <i> + <k> + <l>
   d(9)=a(5)*b(5)

end subroutine form_product


pure subroutine overlap_3d(ri, rj, rp, ai, aj, li, lj, s1d, s3d)
   real(wp), intent(in) :: ri(3)
   real(wp), intent(in) :: rj(3)
   real(wp), intent(in) :: rp(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d

   integer :: i, j, k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), val(3)

   val(:) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp

      call horizontal_shift(rp(k) - ri(k), li(k), vi)
      call horizontal_shift(rp(k) - rj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      do l = 0, li(k) + lj(k)
         val(k) = val(k) + s1d(l) * vv(l)
      end do
   end do

   s3d = val(1) * val(2) * val(3)

end subroutine overlap_3d

pure subroutine multipole_3d(ri, rj, rc, rp, ai, aj, li, lj, s1d, s3d)
   real(wp), intent(in) :: ri(3)
   real(wp), intent(in) :: rj(3)
   real(wp), intent(in) :: rp(3)
   real(wp), intent(in) :: rc(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d(10)

   integer :: k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), val(3, 3), rpc

   val(:, :) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp
      rpc = rp(k) - rc(k)

      call horizontal_shift(rp(k) - ri(k), li(k), vi)
      call horizontal_shift(rp(k) - rj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      do l = 0, li(k) + lj(k)
         val(k, 1) = val(k, 1) + s1d(l) * vv(l)
         val(k, 2) = val(k, 2) + (s1d(l+1) + rpc*s1d(l)) * vv(l)
         val(k, 3) = val(k, 3) + (s1d(l+2) + 2*rpc*s1d(l+1) + rpc*rpc*s1d(l)) * vv(l)
      end do
   end do

   s3d( 1) = val(1, 1) * val(2, 1) * val(3, 1)
   s3d( 2) = val(1, 2) * val(2, 1) * val(3, 1)
   s3d( 3) = val(1, 1) * val(2, 2) * val(3, 1)
   s3d( 4) = val(1, 1) * val(2, 1) * val(3, 2)
   s3d( 5) = val(1, 3) * val(2, 1) * val(3, 1)
   s3d( 6) = val(1, 1) * val(2, 3) * val(3, 1)
   s3d( 7) = val(1, 1) * val(2, 1) * val(3, 3)
   s3d( 8) = val(1, 2) * val(2, 2) * val(3, 1)
   s3d( 9) = val(1, 2) * val(2, 1) * val(3, 2)
   s3d(10) = val(1, 1) * val(2, 2) * val(3, 2)

end subroutine multipole_3d

pure subroutine overlap_grad_3d(ri, rj, rp, ai, aj, li, lj, s1d, s3d, ds3d)
   real(wp), intent(in) :: ri(3)
   real(wp), intent(in) :: rj(3)
   real(wp), intent(in) :: rp(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d
   real(wp), intent(out) :: ds3d(3)

   integer :: k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), val(3)
   real(wp) :: gi(0:maxl), gg(0:maxl2), gra(3)

   val(:) = 0.0_wp
   gra(:) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      gg(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      gi(:) = 0.0_wp

      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp
      gi(li(k)+1) = 2*ai
      if (li(k) > 0) gi(li(k)-1) = -li(k)

      call horizontal_shift(rp(k) - ri(k), li(k)-1, gi)
      call horizontal_shift(rp(k) - ri(k), li(k)+1, gi)
      call horizontal_shift(rp(k) - ri(k), li(k), vi)
      call horizontal_shift(rp(k) - rj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      call form_product(gi, vj, li(k)+1, lj(k), gg)
      do l = 0, li(k) + lj(k) + 1
         val(k) = val(k) + s1d(l) * vv(l)
         gra(k) = gra(k) + s1d(l) * gg(l)
      end do
   end do

   s3d = val(1) * val(2) * val(3)
   ds3d(1) = gra(1) * val(2) * val(3)
   ds3d(2) = val(1) * gra(2) * val(3)
   ds3d(3) = val(1) * val(2) * gra(3)

end subroutine overlap_grad_3d

pure subroutine multipole_grad_3d(ri, rj, rc, rp, ai, aj, li, lj, s1d, s3d, ds3d)
   real(wp), intent(in) :: ri(3)
   real(wp), intent(in) :: rj(3)
   real(wp), intent(in) :: rc(3)
   real(wp), intent(in) :: rp(3)
   real(wp), intent(in) :: ai
   real(wp), intent(in) :: aj
   integer, intent(in) :: li(3)
   integer, intent(in) :: lj(3)
   real(wp), intent(in) :: s1d(0:)
   real(wp), intent(out) :: s3d(10)
   real(wp), intent(out) :: ds3d(3, 10)

   integer :: k, l
   real(wp) :: vi(0:maxl), vj(0:maxl), vv(0:maxl2), val(3, 3), rpc
   real(wp) :: gi(0:maxl), gg(0:maxl2), gra(3, 3)

   val(:, :) = 0.0_wp
   gra(:, :) = 0.0_wp

   do k = 1, 3
      vv(:) = 0.0_wp
      gg(:) = 0.0_wp
      vi(:) = 0.0_wp
      vj(:) = 0.0_wp
      gi(:) = 0.0_wp
      rpc = rp(k) - rc(k)

      vi(li(k)) = 1.0_wp
      vj(lj(k)) = 1.0_wp
      gi(li(k)+1) = 2*ai
      if (li(k) > 0) gi(li(k)-1) = -li(k)

      call horizontal_shift(rp(k) - ri(k), li(k)-1, gi)
      call horizontal_shift(rp(k) - ri(k), li(k)+1, gi)
      call horizontal_shift(rp(k) - ri(k), li(k), vi)
      call horizontal_shift(rp(k) - rj(k), lj(k), vj)
      call form_product(vi, vj, li(k), lj(k), vv)
      call form_product(gi, vj, li(k)+1, lj(k), gg)
      do l = 0, li(k) + lj(k) + 1
         val(k, 1) = val(k, 1) + s1d(l) * vv(l)
         val(k, 2) = val(k, 2) + (s1d(l+1) + rpc*s1d(l)) * vv(l)
         val(k, 3) = val(k, 3) + (s1d(l+2) + 2*rpc*s1d(l+1) + rpc*rpc*s1d(l)) * vv(l)
         gra(k, 1) = gra(k, 1) + s1d(l) * gg(l)
         gra(k, 2) = gra(k, 2) + (s1d(l+1) + rpc*s1d(l)) * gg(l)
         gra(k, 3) = gra(k, 3) + (s1d(l+2) + 2*rpc*s1d(l+1) + rpc*rpc*s1d(l)) * gg(l)
      end do
   end do

   s3d( 1) = val(1, 1) * val(2, 1) * val(3, 1)
   s3d( 2) = val(1, 2) * val(2, 1) * val(3, 1)
   s3d( 3) = val(1, 1) * val(2, 2) * val(3, 1)
   s3d( 4) = val(1, 1) * val(2, 1) * val(3, 2)
   s3d( 5) = val(1, 3) * val(2, 1) * val(3, 1)
   s3d( 6) = val(1, 1) * val(2, 3) * val(3, 1)
   s3d( 7) = val(1, 1) * val(2, 1) * val(3, 3)
   s3d( 8) = val(1, 2) * val(2, 2) * val(3, 1)
   s3d( 9) = val(1, 2) * val(2, 1) * val(3, 2)
   s3d(10) = val(1, 1) * val(2, 2) * val(3, 2)
   ds3d(1, 1) = gra(1, 1) * val(2, 1) * val(3, 1)
   ds3d(2, 1) = val(1, 1) * gra(2, 1) * val(3, 1)
   ds3d(3, 1) = val(1, 1) * val(2, 1) * gra(3, 1)
   ds3d(1, 2) = gra(1, 2) * val(2, 1) * val(3, 1)
   ds3d(2, 2) = val(1, 2) * gra(2, 1) * val(3, 1)
   ds3d(3, 2) = val(1, 2) * val(2, 1) * gra(3, 1)
   ds3d(1, 3) = gra(1, 1) * val(2, 2) * val(3, 1)
   ds3d(2, 3) = val(1, 1) * gra(2, 2) * val(3, 1)
   ds3d(3, 3) = val(1, 1) * val(2, 2) * gra(3, 1)
   ds3d(1, 4) = gra(1, 1) * val(2, 1) * val(3, 2)
   ds3d(2, 4) = val(1, 1) * gra(2, 1) * val(3, 2)
   ds3d(3, 4) = val(1, 1) * val(2, 1) * gra(3, 2)
   ds3d(1, 5) = gra(1, 3) * val(2, 1) * val(3, 1)
   ds3d(2, 5) = val(1, 3) * gra(2, 1) * val(3, 1)
   ds3d(3, 5) = val(1, 3) * val(2, 1) * gra(3, 1)
   ds3d(1, 6) = gra(1, 1) * val(2, 3) * val(3, 1)
   ds3d(2, 6) = val(1, 1) * gra(2, 3) * val(3, 1)
   ds3d(3, 6) = val(1, 1) * val(2, 3) * gra(3, 1)
   ds3d(1, 7) = gra(1, 1) * val(2, 1) * val(3, 3)
   ds3d(2, 7) = val(1, 1) * gra(2, 1) * val(3, 3)
   ds3d(3, 7) = val(1, 1) * val(2, 1) * gra(3, 3)
   ds3d(1, 8) = gra(1, 2) * val(2, 2) * val(3, 1)
   ds3d(2, 8) = val(1, 2) * gra(2, 2) * val(3, 1)
   ds3d(3, 8) = val(1, 2) * val(2, 2) * gra(3, 1)
   ds3d(1, 9) = gra(1, 2) * val(2, 1) * val(3, 2)
   ds3d(2, 9) = val(1, 2) * gra(2, 1) * val(3, 2)
   ds3d(3, 9) = val(1, 2) * val(2, 1) * gra(3, 2)
   ds3d(1,10) = gra(1, 1) * val(2, 2) * val(3, 2)
   ds3d(2,10) = val(1, 1) * gra(2, 2) * val(3, 2)
   ds3d(3,10) = val(1, 1) * val(2, 2) * gra(3, 2)

end subroutine multipole_grad_3d


! --------------------------------------------------------------[SAW1801]-
!> move gradient operator from center a to center b
!  might look complicated, but take it from me: integrals are usually complicated.
pure subroutine shiftintg(g,s,r)
   !$acc routine seq
   real(wp),intent(inout) :: g(3,19)
   real(wp),intent(in)    :: s(10),r(3)
   g(:,11)=g(:,2)-r(1)*g(:,1)
   g(:,12)=g(:,3)-r(2)*g(:,1)
   g(:,13)=g(:,4)-r(3)*g(:,1)
   g(:,14)=g(:,5)-2*r(1)*g(:,2)+r(1)**2*g(:,1)
   g(:,15)=g(:,6)-2*r(2)*g(:,3)+r(2)**2*g(:,1)
   g(:,16)=g(:,7)-2*r(3)*g(:,4)+r(3)**2*g(:,1)
   g(:,17)=g(:,8)-r(1)*g(:,3)-r(2)*g(:,2)+r(1)*r(2)*g(:,1)
   g(:,18)=g(:,9)-r(1)*g(:,4)-r(3)*g(:,2)+r(1)*r(3)*g(:,1)
   g(:,19)=g(:,10)-r(2)*g(:,4)-r(3)*g(:,3)+r(2)*r(3)*g(:,1)
   g(1,11)=g(1,11)-s(1)
   g(2,12)=g(2,12)-s(1)
   g(3,13)=g(3,13)-s(1)
   g(1,14)=g(1,14)-2*s(2)+2*r(1)*s(1)
   g(2,15)=g(2,15)-2*s(3)+2*r(2)*s(1)
   g(3,16)=g(3,16)-2*s(4)+2*r(3)*s(1)
   g(1,17)=g(1,17)-s(3)+r(2)*s(1)
   g(2,17)=g(2,17)-s(2)+r(1)*s(1)
   g(1,18)=g(1,18)-s(4)+r(3)*s(1)
   g(3,18)=g(3,18)-s(2)+r(1)*s(1)
   g(2,19)=g(2,19)-s(4)+r(3)*s(1)
   g(3,19)=g(3,19)-s(3)+r(2)*s(1)
end subroutine shiftintg


pure subroutine get_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj,point,intcut, &
      &                nprim,primcount,alp,cont,sint)
   integer, intent(in)  :: icao
   integer, intent(in)  :: jcao
   integer, intent(in)  :: naoi
   integer, intent(in)  :: naoj
   integer, intent(in)  :: ishtyp
   integer, intent(in)  :: jshtyp
   real(wp),intent(in)  :: ri(3)
   real(wp),intent(in)  :: rj(3)
   real(wp),intent(in)  :: point(3)
   real(wp),intent(in)  :: intcut
   real(wp),intent(out) :: sint(:,:)

   integer, intent(in)  :: nprim(:)
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)

   integer  :: ip,iprim,mli,jp,jprim,mlj,k,iptyp,jptyp
   real(wp) :: rij(3),rij2,alpi,alpj,ci,cj,cc,kab,rp(3),t(0:8)
   real(wp) :: ab,est,saw(10)

   real(wp),parameter :: max_r2 = 2000.0_wp
   real(wp),parameter :: sqrtpi = sqrt(pi)

   sint = 0.0_wp
   iptyp = itt(ishtyp)
   jptyp = itt(jshtyp)

   rij = ri - rj
   rij2 = rij(1)**2 + rij(2)**2 + rij(3)**2

   if(rij2.gt.max_r2) return

   do ip = 1, nprim(icao+1)
      iprim = ip + primcount(icao+1)
      ! exponent the same for each l component
      alpi = alp(iprim)
      do jp = 1, nprim(jcao+1)
         jprim=jp+primcount(jcao+1)
         ! exponent the same for each l component
         alpj=alp(jprim)
         ab=1.0_wp/(alpi+alpj)
         est=rij2*alpi*alpj*ab
         if(est.gt.intcut) cycle
         kab = exp(-est)*(sqrtpi*sqrt(ab))**3
         rp = (alpi*ri + alpj*rj)*ab
         do k = 0, ishtyp + jshtyp
            t(k) = olapp(k, alpi+alpj)
         end do
         ! now compute integrals
         do mli=1,naoi
            iprim = ip + primcount(icao+mli)
            ! coefficients NOT the same (contain CAO2SAO lin. comb. coefficients)
            ci = cont(iprim)
            do mlj=1,naoj
               jprim = jp + primcount(jcao+mlj)
               saw = 0.0_wp
               ! prim-prim  integrals
               call multipole_3d(ri,rj,point,rp,alpi,alpj, &
                  & lxyz(:,iptyp+mli),lxyz(:,jptyp+mlj),t,saw)
               cc = kab*cont(jprim)*ci
               sint(mlj,mli) = sint(mlj,mli)+saw(1)*cc! pbc_w(jat,iat)
            enddo ! mlj
         enddo ! mli
      enddo ! jp
   enddo ! ip

end subroutine get_overlap

pure subroutine get_grad_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj,point,intcut, &
      &                     nprim,primcount,alp,cont,sdq,sdqg)
   integer, intent(in)  :: icao
   integer, intent(in)  :: jcao
   integer, intent(in)  :: naoi
   integer, intent(in)  :: naoj
   integer, intent(in)  :: ishtyp
   integer, intent(in)  :: jshtyp
   real(wp),intent(in)  :: ri(3)
   real(wp),intent(in)  :: rj(3)
   real(wp),intent(in)  :: point(3)
   real(wp),intent(in)  :: intcut
   real(wp),intent(out) :: sdq(:,:)
   real(wp),intent(out) :: sdqg(:,:,:)

   integer, intent(in)  :: nprim(:)
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)

   integer  :: ip,iprim,mli,jp,jprim,mlj,k,iptyp,jptyp
   real(wp) :: rij(3),rij2,alpi,alpj,ci,cj,cc,kab,rp(3),t(0:8)
   real(wp) :: ab,est,saw,sawg(3)

   real(wp),parameter :: max_r2 = 2000.0_wp
   real(wp),parameter :: sqrtpi = sqrt(pi)

   sdqg = 0.0_wp
   sdq  = 0.0_wp
   iptyp = itt(ishtyp)
   jptyp = itt(jshtyp)

   rij = ri - rj
   rij2 = rij(1)**2 + rij(2)**2 + rij(3)**2

   if(rij2.gt.max_r2) return

   do ip=1,nprim(icao+1)
      iprim=ip+primcount(icao+1)
      ! exponent the same for each l component
      alpi=alp(iprim)
      do jp=1,nprim(jcao+1)
         jprim=jp+primcount(jcao+1)
         ! exponent the same for each l component
         alpj=alp(jprim)
         ab = 1.0_wp/(alpi+alpj)
         est=alpi*alpj*rij2*ab
         if(est.gt.intcut) cycle
         kab = exp(-est)*(sqrtpi*sqrt(ab))**3
         rp = (alpi*ri + alpj*rj)*ab
         do k = 0, ishtyp + jshtyp + 1
            t(k) = olapp(k, alpi+alpj)
         end do
         !--------------- compute gradient ----------
         ! now compute integrals  for different components of i(e.g., px,py,pz)
         do mli=1,naoi
            iprim=ip+primcount(icao+mli)
            ! coefficients NOT the same (contain CAO2SAO lin. comb. coefficients)
            ci=cont(iprim)
            do mlj=1,naoj
               jprim=jp+primcount(jcao+mlj)
               cc=kab*cont(jprim)*ci
               saw=0;sawg=0
               call overlap_grad_3d(ri,rj,rp,alpi,alpj,lxyz(:,iptyp+mli),lxyz(:,jptyp+mlj),t,saw,sawg)
               sdq(mlj,mli) = sdq(mlj,mli)+saw*cc
               sdqg(:,mlj,mli) = sdqg(:,mlj,mli) &
                  & + sawg(:)*cc
            enddo ! mlj : Cartesian component of j prims
         enddo  ! mli : Cartesian component of i prims
      enddo ! jp : loop over j prims
   enddo  ! ip : loop over i prims
end subroutine get_grad_overlap


pure subroutine get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj,point, &
      &                           intcut,nprim,primcount,alp,cont,ss,dd,qq)
   integer, intent(in)  :: icao
   integer, intent(in)  :: jcao
   integer, intent(in)  :: naoi
   integer, intent(in)  :: naoj
   integer, intent(in)  :: ishtyp
   integer, intent(in)  :: jshtyp
   real(wp),intent(in)  :: ri(3)
   real(wp),intent(in)  :: rj(3)
   real(wp),intent(in)  :: point(3)
   real(wp),intent(in)  :: intcut
   real(wp),intent(out) :: ss(:,:)
   real(wp),intent(out) :: dd(:,:,:)
   real(wp),intent(out) :: qq(:,:,:)

   integer, intent(in)  :: nprim(:)
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)

   integer  :: ip,iprim,mli,jp,jprim,mlj,k,iptyp,jptyp
   real(wp) :: rij(3),rp(3),rij2,alpi,alpj,ci,cj,cc,kab,t(0:8)
   real(wp) :: ab,est,saw(10),sawg(3,10)

   real(wp),parameter :: max_r2 = 2000.0_wp
   real(wp),parameter :: sqrtpi = sqrt(pi)

   ss = 0.0_wp
   dd = 0.0_wp
   qq = 0.0_wp
   iptyp = itt(ishtyp)
   jptyp = itt(jshtyp)

   rij = ri - rj
   rij2 = rij(1)**2 + rij(2)**2 + rij(3)**2

   if(rij2.gt.max_r2) return

   ! we go through the primitives (because the screening is the same for all of them)
   do ip = 1,nprim(icao+1)
      iprim = ip+primcount(icao+1)
      ! exponent the same for each l component
      alpi = alp(iprim)
      do jp = 1,nprim(jcao+1)
         jprim = jp+primcount(jcao+1)
         ! exponent the same for each l component
         alpj = alp(jprim)
         ab = 1.0_wp/(alpi+alpj)
         est = alpi*alpj*rij2*ab
         if(est.gt.intcut) cycle
         kab = exp(-est)*(sqrtpi*sqrt(ab))**3
         rp = (alpi*ri + alpj*rj)*ab
         do k = 0, ishtyp + jshtyp + 2
            t(k) = olapp(k, alpi+alpj)
         end do
         !--------------- compute gradient ----------
         ! now compute integrals  for different components of i(e.g., px,py,pz)
         do mli = 1,naoi
            iprim = ip+primcount(icao+mli)
            ! coefficients NOT the same (contain CAO2SAO lin. comb. coefficients)
            ci = cont(iprim)
            do mlj = 1,naoj
               jprim = jp+primcount(jcao+mlj)
               cc = kab*cont(jprim)*ci
               saw = 0;sawg = 0
               call multipole_3d(ri,rj,point,rp,alpi,alpj, &
                  & lxyz(:,iptyp+mli),lxyz(:,jptyp+mlj),t,saw)
               ss(mlj,mli) = ss(mlj,mli) + saw(1)*cc
               dd(:,mlj,mli) = dd(:,mlj,mli) + saw(2:4)*cc
               qq(:,mlj,mli) = qq(:,mlj,mli) + saw(5:10)*cc
            enddo ! mlj : Cartesian component of j prims
         enddo  ! mli : Cartesian component of i prims
      enddo ! jp : loop over j prims
   enddo  ! ip : loop over i prims
end subroutine get_multiints


pure subroutine get_grad_multiint(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj, &
      &                           intcut,nprim,primcount,alp,cont,sdq,sdqg)
   integer, intent(in)  :: icao
   integer, intent(in)  :: jcao
   integer, intent(in)  :: naoi
   integer, intent(in)  :: naoj
   integer, intent(in)  :: ishtyp
   integer, intent(in)  :: jshtyp
   real(wp),intent(in)  :: ri(3)
   real(wp),intent(in)  :: rj(3)
   real(wp),intent(in)  :: intcut
   real(wp),intent(out) :: sdq(:,:,:)
   real(wp),intent(out) :: sdqg(:,:,:,:)

   integer, intent(in)  :: nprim(:)
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)

   integer  :: ip,iprim,mli,jp,jprim,mlj,k,iptyp,jptyp
   real(wp) :: rij(3),rp(3),rij2,alpi,alpj,ci,cj,cc,kab,t(0:8)
   real(wp) :: ab,est,saw(10),sawg(3,10)

   real(wp),parameter :: max_r2 = 2000.0_wp
   real(wp),parameter :: sqrtpi = sqrt(pi)

   sdqg = 0.0_wp
   sdq  = 0.0_wp
   iptyp = itt(ishtyp)
   jptyp = itt(jshtyp)

   rij = ri - rj
   rij2 = rij(1)**2 + rij(2)**2 + rij(3)**2

   if(rij2.gt.max_r2) return

   ! we go through the primitives (because the screening is the same for all of them)
   do ip = 1,nprim(icao+1)
      iprim = ip+primcount(icao+1)
      ! exponent the same for each l component
      alpi = alp(iprim)
      do jp = 1,nprim(jcao+1)
         jprim = jp+primcount(jcao+1)
         ! exponent the same for each l component
         alpj = alp(jprim)
         ab = 1.0_wp/(alpi+alpj)
         est = alpi*alpj*rij2*ab
         if(est.gt.intcut) cycle
         kab = exp(-est)*(sqrtpi*sqrt(ab))**3
         rp = (alpi*ri + alpj*rj)*ab
         do k = 0, ishtyp + jshtyp + 3
            t(k) = olapp(k, alpi+alpj)
         end do
         !--------------- compute gradient ----------
         ! now compute integrals  for different components of i(e.g., px,py,pz)
         do mli = 1,naoi
            iprim = ip+primcount(icao+mli)
            ! coefficients NOT the same (contain CAO2SAO lin. comb. coefficients)
            ci = cont(iprim)
            do mlj = 1,naoj
               jprim = jp+primcount(jcao+mlj)
               cc = kab*cont(jprim)*ci
               saw = 0;sawg = 0
               call multipole_grad_3d(ri,rj,rj,rp,alpi,alpj, &
                  & lxyz(:,iptyp+mli),lxyz(:,jptyp+mlj),t,saw,sawg)
               sdq(:,mlj,mli) = sdq(:,mlj,mli) + saw*cc
               sdqg(:,:10,mlj,mli) = sdqg(:,:10,mlj,mli) + sawg*cc
            enddo ! mlj : Cartesian component of j prims
         enddo  ! mli : Cartesian component of i prims
      enddo ! jp : loop over j prims
   enddo  ! ip : loop over i prims
   do mli = 1,naoi
      do mlj = 1,naoj
         call shiftintg(sdqg(:,:,mlj,mli),sdq(:,mlj,mli),rij)
      enddo
   enddo
end subroutine get_grad_multiint


!> computes the dipole and quadrupole integrals and performs screening to
!  determine, which contribute to potential
subroutine sdqint(nShell,angShell,nat,at,nbf,nao,xyz,intcut,caoshell,saoshell, &
      &           nprim,primcount,alp,cont,sint,dpint,qpint)
   integer, intent(in) :: nShell(:)
   integer, intent(in) :: angShell(:,:)
   !> # of atoms
   integer, intent(in)  :: nat
   !> # of spherical AOs (SAOs)
   integer, intent(in)  :: nao
   !> # of Cartesian AOs (CAOs)
   integer, intent(in)  :: nbf
   integer, intent(in)  :: at(nat)
   !> cartesian coordinates
   real(wp),intent(in)  :: xyz(3,nat)
   !> integral cutoff according to prefactor from Gaussian product theorem
   real(wp),intent(in)  :: intcut
   !> map shell of atom to index in CAO space (lowest Cart. component is taken)
   integer, intent(in)  :: caoshell(:,:)
   !> map shell of atom to index in SAO space (lowest m_l component is taken)
   integer, intent(in)  :: saoshell(:,:)
   integer, intent(in)  :: nprim(:)
   !> index of first primitive (over entire system) of given CAO
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)
   !> overlap integral matrix
   real(wp),intent(out) :: sint(nao,nao)
   !> dipole integral matrix
   real(wp),intent(out) :: dpint(3,nao,nao)
   !> quadrupole integral matrix
   real(wp),intent(out) :: qpint(6,nao,nao)


   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,km,mi,mj,ij
   real(wp) tmp1,tmp2,tmp3,tmp4,step,step2
   real(wp) dx,dy,dz,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,thr2,f,ci,cc,cj,alpi,rab2,ab,est
   integer, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

   real(wp)  ra(3),rb(3),f1,f2,point(3)
   real(wp) dtmp(3),qtmp(6),ss(6,6),dd(3,6,6),qq(6,6,6),tmp(6,6)
   integer ip,jp,iat,jat,izp,jzp,ish,jsh,icao,jcao,iao,jao,jshmax
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   integer itt(0:3)
   parameter(itt  =(/0,1,4,10/))
   real(wp) :: saw(10)


   ! integrals
   sint = 0.0_wp
   dpint = 0.0_wp
   qpint = 0.0_wp
   ! --- Aufpunkt for moment operator
   point = 0.0_wp

   !$OMP PARALLEL DO schedule(runtime) &
   !$omp PRIVATE (iat,jat,izp,cc,ci,ra,rb,saw, &
   !$omp& rab2,jzp,ish,ishtyp,icao,naoi,iptyp, &
   !$omp& jsh,jshmax,jshtyp,jcao,naoj,jptyp,ss,dd,qq, &
   !$omp& est,alpi,alpj,ab,iprim,jprim,ip,jp, &
   !$omp& mli,mlj,tmp,tmp1,tmp2,iao,jao,ii,jj,k,ij) &
   !$omp shared (sint,dpint,qpint)
   do iat = 1,nat
      ra(1:3) = xyz(1:3,iat)
      izp = at(iat)
      do jat = 1,iat-1
         rb(1:3) = xyz(1:3,jat)
         jzp = at(jat)
         rab2 = sum( (rb-ra)**2 )
         !           ints < 1.d-9 for RAB > 40 Bohr
         if(rab2.gt.2000) cycle
         do ish = 1,nShell(izp)
            ishtyp = angShell(ish,izp)
            icao = caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            do jsh = 1,nShell(jzp)
               jshtyp = angShell(jsh,jzp)
               jcao = caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)
               ss = 0.0_wp
               dd = 0.0_wp
               qq = 0.0_wp
               call get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ra,rb,point, &
                  &               intcut,nprim,primcount,alp,cont,ss,dd,qq)
               !transform from CAO to SAO
               call dtrf2(ss,ishtyp,jshtyp)
               do k = 1,3
                  tmp(1:6,1:6) = dd(k,1:6,1:6)
                  call dtrf2(tmp,ishtyp,jshtyp)
                  dd(k,1:6,1:6) = tmp(1:6,1:6)
               enddo
               do k = 1,6
                  tmp(1:6,1:6) = qq(k,1:6,1:6)
                  call dtrf2(tmp,ishtyp,jshtyp)
                  qq(k,1:6,1:6) = tmp(1:6,1:6)
               enddo
               do ii = 1,llao2(ishtyp)
                  iao = ii+saoshell(ish,iat)
                  do jj = 1,llao2(jshtyp)
                     jao = jj+saoshell(jsh,jat)
                     sint(iao, jao) = sint(iao, jao) + ss(jj, ii)
                     sint(jao, iao) = sint(jao, iao) + ss(jj, ii)
                     dpint(1:3, iao, jao) = dpint(1:3, iao, jao) + dd(1:3, jj, ii)
                     dpint(1:3, jao, iao) = dpint(1:3, jao, iao) + dd(1:3, jj, ii)
                     qpint(1:6, iao, jao) = qpint(1:6, iao, jao) + qq(1:6, jj, ii)
                     qpint(1:6, jao, iao) = qpint(1:6, jao, iao) + qq(1:6, jj, ii)
                  enddo
               enddo
            enddo
         enddo
      enddo
   enddo

   ! diagonal elements
   do iat = 1, nat
      ra = xyz(:, iat)
      izp = at(iat)
      do ish = 1, nShell(izp)
         ishtyp = angShell(ish,izp)
         do iao = 1, llao2(ishtyp)
            i = iao+saoshell(ish,iat)
            sint(i,i) = 1.0_wp + sint(i,i)
         end do

         icao = caoshell(ish,iat)
         naoi = llao(ishtyp)
         iptyp = itt(ishtyp)
         do jsh = 1, ish
            jshtyp = angShell(jsh,izp)
            jcao = caoshell(jsh,iat)
            naoj = llao(jshtyp)
            jptyp = itt(jshtyp)
            ss = 0.0_wp
            dd = 0.0_wp
            qq = 0.0_wp
            call get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ra,ra,point, &
               &               intcut,nprim,primcount,alp,cont,ss,dd,qq)
            !transform from CAO to SAO
            !call dtrf2(ss,ishtyp,jshtyp)
            do k = 1,3
               tmp(1:6, 1:6) = dd(k,1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               dd(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do k = 1,6
               tmp(1:6, 1:6) = qq(k, 1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               qq(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do ii = 1, llao2(ishtyp)
               iao = ii + saoshell(ish,iat)
               do jj = 1, llao2(jshtyp)
                  jao = jj + saoshell(jsh,iat)
                  if (jao > iao .and. ish ==  jsh) cycle
                  dpint(1:3, iao, jao) = dpint(1:3, iao, jao) + dd(1:3, jj, ii)
                  if (iao /= jao) then
                     dpint(1:3, jao, iao) = dpint(1:3, jao, iao) + dd(1:3, jj, ii)
                  end if
                  qpint(1:6, iao, jao) = qq(1:6, jj, ii)
                  if (jao /= iao) then
                     qpint(1:6, jao, iao) = qq(1:6, jj, ii)
                  end if
               end do
            end do
         end do
      end do
   end do

end subroutine sdqint


pure subroutine build_sdq_ints_gpu(a,b,c,alpi,alpj,la,lb,kab,t,e,lx,ly,lz,v)
   !$acc routine seq
   !     aufpunkte,ref point,intarray
   integer,intent(in)  :: la,lb
   real(wp), intent(in)  :: alpi,alpj
   real(wp), intent(in)  :: a(3),b(3),c(3)
   real(wp), intent(in)  :: kab,t(0:8),e(3)
   integer, intent(in)  :: lx(84),ly(84),lz(84)
   real(wp), intent(out) :: v(10)
   !     local variables
   real(wp)  :: dd(0:8),va(3),val(3,3)
   real(wp)  :: aa(0:3,3),bb(0:3,3)
   integer :: i,j,ij(3),ii(3),jj(3),lmax

   val = 0

   aa = 0
   bb = 0
   dd = 0
   ii = [lx(la),ly(la),lz(la)]
   jj = [lx(lb),ly(lb),lz(lb)]
   ij = ii+jj
   aa(ii(1),1)=1.0_wp
   aa(ii(2),2)=1.0_wp
   aa(ii(3),3)=1.0_wp
   bb(jj(1),1)=1.0_wp
   bb(jj(2),2)=1.0_wp
   bb(jj(3),3)=1.0_wp

   do i = 1, 3
      ! calculate cartesian prefactor for first gaussian
      call build_hshift2(aa(:,i),a(i),e(i),ii(i))    ! <a|
      ! calculate cartesian prefactor for second gaussian
      call build_hshift2(bb(:,i),b(i),e(i),jj(i))    ! |b>
      ! form their product
      call prod3(aa(:,i),bb(:,i),dd(:),ii(i),jj(i))
      lmax = ij(i)
      do j = 0, lmax
         !    <a|b> <a|x|b>             <a|x²|b>
         va = [t(j), t(j+1) + e(i)*t(j), t(j+2) + 2*e(i)*t(j+1) + e(i)*e(i)*t(j)]
         val(i,1:3) = val(i,1:3) + dd(j)*va(1:3)
      enddo
   enddo
   v( 1)=kab*(val(1,1)*val(2,1)*val(3,1))
   v( 2)=kab*(val(1,2)*val(2,1)*val(3,1))
   v( 3)=kab*(val(1,1)*val(2,2)*val(3,1))
   v( 4)=kab*(val(1,1)*val(2,1)*val(3,2))
   v( 5)=kab*(val(1,3)*val(2,1)*val(3,1))
   v( 6)=kab*(val(1,1)*val(2,3)*val(3,1))
   v( 7)=kab*(val(1,1)*val(2,1)*val(3,3))
   v( 8)=kab*(val(1,2)*val(2,2)*val(3,1))
   v( 9)=kab*(val(1,2)*val(2,1)*val(3,2))
   v(10)=kab*(val(1,1)*val(2,2)*val(3,2))
end subroutine build_sdq_ints_gpu


!> Computes the overlap dipole and quadrupole integrals
subroutine sdqint_gpu(nShell, angShell, nat, at, nbf, nao, xyz, trans, &
      & intcut, caoshell, saoshell, nprim, primcount, alp, cont, &
      & sint, dpint, qpint)
   integer, intent(in) :: nShell(:)
   integer, intent(in) :: angShell(:,:)
   !> # of atoms
   integer, intent(in)  :: nat
   !> # of spherical AOs (SAOs)
   integer, intent(in)  :: nao
   !> # of Cartesian AOs (CAOs)
   integer, intent(in)  :: nbf
   integer, intent(in)  :: at(:)
   !> Cartesian coordinates
   real(wp),intent(in)  :: xyz(:, :)
   !> Integral cutoff according to prefactor from Gaussian product theorem
   real(wp),intent(in)  :: intcut
   real(wp),intent(in)  :: trans(:, :)
   !> Map shell of atom to index in CAO space (lowest Cart. component is taken)
   integer, intent(in)  :: caoshell(:,:)
   !> Map shell of atom to index in SAO space (lowest m_l component is taken)
   integer, intent(in)  :: saoshell(:,:)
   integer, intent(in)  :: nprim(:)
   !> Index of first primitive (over entire system) of given CAO
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)
   !> Overlap integral matrix
   real(wp),intent(out) :: sint(:, :)
   !> Dipole integral matrix
   real(wp),intent(out) :: dpint(:, :, :)
   !> Quadrupole integral matrix
   real(wp),intent(out) :: qpint(:, :, :)


   integer i,j,k,l,m,ii,jj,ij,ioff,joff,kk
   real(wp) thr2,ci,cc,cj,alpi,rab2,ab,est,alpj

   real(wp) ra(3),rb(3),point(3)
   real(wp) dtmp(3),qtmp(6),ss(6,6),dd(6,6,3),qq(6,6,6),tmp(6,6),dd2(3,6,6)
   integer ip,jp,iat,jat,izp,jzp,ish,jsh,icao,jcao,iao,jao,jshmax
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   integer :: il, jl, itr
   real(wp) :: zi, zj, zetaij, km, hii, hjj, hav, shpoly
   integer itt(0:3)
   parameter(itt  =(/0,1,4,10/))
   real(wp) :: saw(10)

   real(wp) :: gama,kab,t(0:8),e(3)
   real(wp),parameter :: sqrtpi = sqrt(pi)

   real(wp) s2(6,6),dum(6,6),sspher

   !$acc enter data create(sint(:, :), dpint(:, :, :), qpint(:, :, :)) &
   !$acc copyin(xyz, at, nShell, trans, caoshell, saoshell, &
   !$acc& nprim, primcount, alp, cont, intcut, point, angShell(:, :))

   !$acc kernels default(present)
   ! integrals
   sint = 0.0_wp
   dpint = 0.0_wp
   qpint = 0.0_wp
   !$acc end kernels
   ! --- Aufpunkt for moment operator
   point = 0.0_wp

   !$acc parallel vector_length(32) private(ss,dd,qq,rb,iat,jat,izp,ci,ra,& 
   !$acc& rab2,jzp,ish,ishtyp,icao,naoi,iptyp, &
   !$acc& jsh,jshmax,jshtyp,jcao,naoj,jptyp,shpoly, &
   !$acc& est,alpi,alpj,ab,iprim,jprim,ip,jp,il,jl,hii,hjj,km,zi,zj,zetaij,hav, &
   !$acc& mli,mlj,iao,jao,ii,jj,k,ij,itr,ioff,joff,t,e,saw,s2,dum)

   !$acc loop gang collapse(2)
   do iat = 1, nat
      do jat = 1, nat
         if (jat.ge.iat) cycle
         ra(1:3) = xyz(1:3,iat)
         izp = at(iat)
         jzp = at(jat)
         do ish = 1, nShell(izp)
            ishtyp = angShell(ish,izp)
            icao = caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            do jsh = 1, nShell(jzp)
               jshtyp = angShell(jsh,jzp)
               jcao = caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1

               !$acc loop private(ss,dd,qq,s2,dum)
               do itr = 1, size(trans, dim=2)
                  !$acc cache(ss,dd,qq,s2,dum)
                  rb(1:3) = xyz(1:3,jat) + trans(:, itr)
                  rab2 = sum( (rb-ra)**2 )

                  ss = 0.0_wp
                  dd = 0.0_wp
                  qq = 0.0_wp

                  !call get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ra,rb,point, &
                  !   &               intcut,nprim,primcount,alp,cont,ss,dd,qq)
                  !$acc loop vector private(saw,t,e) independent collapse(2)
                  do ip = 1,nprim(icao+1)
                    do jp = 1,nprim(jcao+1)

                      iprim = ip+primcount(icao+1)
                      jprim = jp+primcount(jcao+1)
                      alpi = alp(iprim)
                      alpj = alp(jprim)

                      gama = alpi+alpj
                      ab = 1.0_wp/(gama)
                      e = (alpi * ra + alpj * rb)/(alpi + alpj)
                      t(0:8) = olapp([(j,j=0,8)],gama)
                      est = rab2*alpi*alpj*ab
                      kab = exp(-est)*(sqrtpi*sqrt(ab))**3

                      do mli = 1,naoi
                        do mlj = 1,naoj
                          saw = 0.0_wp

                          ! prim-prim quadrupole and dipole integrals
                          call build_sdq_ints_gpu(ra,rb,point,alpi,alpj, &
                            & iptyp+mli,jptyp+mlj,kab,t,e,lx,ly,lz,saw)

                          iprim = ip+primcount(icao+mli)
                          jprim = jp+primcount(jcao+mlj)
                          ci = cont(iprim) ! coefficients NOT the same (contain CAO2SAO lin. comb. coefficients)
                          cc = cont(jprim)*ci
                          ! from primitive integrals fill CAO-CAO matrix for ish-jsh block
                          !                             ! overlap
                          !$acc atomic
                          ss(mlj,mli) = ss(mlj,mli)+saw(1)*cc
                          !$acc end atomic
                          ! dipole
                          do k=1,3
                            !$acc atomic
                            dd(mlj,mli,k) = dd(mlj,mli,k)+saw(k+1)*cc
                            !$acc end atomic
                          enddo
                          do k = 1,6
                            ! quadrupole
                            !$acc atomic
                            qq(mlj,mli,k) = qq(mlj,mli,k)+saw(k+4)*cc
                            !$acc end atomic
                          enddo
                        enddo ! mlj
                      enddo ! mli
                    enddo ! jp
                  enddo ! ip

                  !transform from CAO to SAO
                  !call dtrf2(ss,ishtyp,jshtyp)
                  ! DTRF2(S)
                  !select case(ishtyp)
                  !case(0) ! s-d
                  if (ishtyp.ge.2.or.jshtyp.ge.2) then
                    if (ishtyp.eq.0) then
                      !ss
                      do jj=1,6
                        sspher=0
                        do m=1,6
                          sspher=sspher+trafo(m,jj)*ss(m,1)
                        enddo
                        s2(jj,1)=sspher
                      enddo
                      ss(1:5,1) = s2(2:6,1)

                      !dd
                      do k = 1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*dd(m,1,k)
                          enddo
                          s2(jj,1)=sspher
                        enddo
                        dd(1:5,1,k) = s2(2:6,1)
                      enddo

                      !qq
                      do k = 1,6
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*qq(m,1,k)
                          enddo
                          s2(jj,1)=sspher
                        enddo
                        qq(1:5,1,k) = s2(2:6,1)
                      enddo

                    !case(1) ! p-d
                    else if (ishtyp.eq.1) then
                      !ss
                      do ii=1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*ss(m,ii)
                          enddo
                          s2(jj,ii)=sspher
                        enddo
                        ss(1:5,ii) = s2(2:6,ii)
                      enddo

                      ! dd
                      do k = 1,3
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*dd(m,ii,k)
                            enddo
                            s2(jj,ii)=sspher
                          enddo
                          dd(1:5,ii,k) = s2(2:6,ii)
                        enddo
                      enddo

                      !qq
                      do k = 1,6
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*qq(m,ii,k)
                            enddo
                            s2(jj,ii)=sspher
                          enddo
                          qq(1:5,ii,k) = s2(2:6,ii)
                        enddo
                      enddo
                      !return
                      !end select
                      !     wasn't there, then try iat ...
                      !select case(jshtyp)
                      !case(0) ! d-s
                    else if (jshtyp.eq.0) then
                      !ss
                      do jj=1,6
                        sspher=0
                        do m=1,6
                          sspher=sspher+trafo(m,jj)*ss(1,m)
                        enddo
                        s2(1,jj)=sspher
                      enddo
                      ss(1,1:5) = s2(1,2:6)

                      !dd
                      do k = 1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*dd(1,m,k)
                          enddo
                          s2(1,jj)=sspher
                        enddo
                        dd(1,1:5,k) = s2(1,2:6)
                      enddo

                      !qq
                      do k = 1,6
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*qq(1,m,k)
                          enddo
                          s2(1,jj)=sspher
                        enddo
                        qq(1,1:5,k) = s2(1,2:6)
                      enddo
                      !return
                      !case(1) ! d-p
                    else if (jshtyp.eq.1) then

                      !ss
                      do ii=1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*ss(ii,m)
                          enddo
                          s2(ii,jj)=sspher
                        enddo
                        ss(ii,1:5) = s2(ii,2:6)
                      enddo

                      !dd
                      do k = 1,3
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*dd(ii,m,k)
                            enddo
                            s2(ii,jj)=sspher
                          enddo
                          dd(ii,1:5,k) = s2(ii,2:6)
                        enddo
                      enddo

                      !qq
                      do k = 1,6
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*qq(ii,m,k)
                            enddo
                            s2(ii,jj)=sspher
                          enddo
                          qq(ii,1:5,k) = s2(ii,2:6)
                        enddo
                      enddo

                    else
                      !  return
                      !end select
                      !     if not returned up to here -> d-d
                      ! CB: transposing s in first dgemm is important for integrals other than S

                      !CALL mctc_gemm(trafo, s, dum, transa='T')

                      !ss -----------
                      do i=1,6
                        do j=1,6
                          sspher = 0.0_wp
                          do k=1,6
                            sspher = sspher + trafo(k,i) * ss(k,j)
                          enddo
                          dum(i,j) = sspher
                        enddo
                      enddo

                      !CALL mctc_gemm(dum, trafo, s2, transb='N')

                      do i=1,6
                        do j=1,6
                          sspher = 0.0_wp
                          do k=1,6
                            sspher = sspher + dum(i,k) * trafo(k,j)
                          enddo
                          s2(i,j) = sspher
                        enddo
                      enddo

                      do i=1,5
                        do j=1,5
                          ss(j,i) = s2(j+1,i+1)
                        enddo
                      enddo
                      ! end ss -----------

                      !dd --------
                      do kk = 1,3
                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + trafo(k,i) * dd(k,j,kk)
                            enddo
                            dum(i,j) = sspher
                          enddo
                        enddo

                        !CALL mctc_gemm(dum, trafo, s2, transb='N')

                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + dum(i,k) * trafo(k,j)
                            enddo
                            s2(i,j) = sspher
                          enddo
                        enddo

                        do i=1,5
                          do j=1,5
                            dd(j,i,kk) = s2(j+1,i+1)
                          enddo
                        enddo
                      enddo
                      !end dd --------------

                      !qq ---------------
                      do kk = 1,6
                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + trafo(k,i) * qq(k,j,kk)
                            enddo
                            dum(i,j) = sspher
                          enddo
                        enddo

                        !CALL mctc_gemm(dum, trafo, s2, transb='N')

                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + dum(i,k) * trafo(k,j)
                            enddo
                            s2(i,j) = sspher
                          enddo
                        enddo

                        do i=1,5
                          do j=1,5
                            qq(j,i,kk) = s2(j+1,i+1)
                          enddo
                        enddo
                      enddo
                      !end qq -----------------

                    endif
                  endif

                  ioff = saoshell(ish,iat)
                  joff = saoshell(jsh,jat)

                  ! would be good to change data order of sint,dpint,qpint for 
                  ! memory coalescence
                  !$acc loop vector collapse(2)
                  do ii = 1,llao2(ishtyp)
                     do jj = 1,llao2(jshtyp)
                       iao = ii + ioff
                       jao = jj + joff
                       !$acc atomic
                       sint(iao, jao) = sint(iao, jao) + ss(jj, ii)
                       !$acc atomic
                       sint(jao, iao) = sint(jao, iao) + ss(jj, ii)
                       do k = 1,3
                         !$acc atomic
                         dpint(k, iao, jao) = dpint(k, iao, jao) + dd(jj, ii, k)
                         !$acc atomic
                         dpint(k, jao, iao) = dpint(k, jao, iao) + dd(jj, ii, k)
                       enddo
                       do k = 1,6
                         !$acc atomic
                         qpint(k, iao, jao) = qpint(k, iao, jao) + qq(jj, ii, k)
                         !$acc atomic
                         qpint(k, jao, iao) = qpint(k, jao, iao) + qq(jj, ii, k)
                       enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
   enddo
   !$acc end parallel

   !$acc exit data copyout(sint(:, :), dpint(:, :, :), qpint(:, :, :))

   ! dd array is transposed in ACC region, so dd2 is created for the diagonal
   ! elements, which is still running on CPU

   ! diagonal elements
   do iat = 1, nat
      ra = xyz(:, iat)
      izp = at(iat)
      do ish = 1, nShell(izp)
         ishtyp = angShell(ish,izp)
         do iao = 1, llao2(ishtyp)
            i = iao+saoshell(ish,iat)
            ii = i*(1+i)/2
            sint(i,i) = 1.0_wp + sint(i,i)
         end do

         icao = caoshell(ish,iat)
         naoi = llao(ishtyp)
         iptyp = itt(ishtyp)
         do jsh = 1, ish
            jshtyp = angShell(jsh,izp)
            jcao = caoshell(jsh,iat)
            naoj = llao(jshtyp)
            jptyp = itt(jshtyp)
            ss = 0.0_wp
            dd2 = 0.0_wp
            qq = 0.0_wp
            call get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ra,ra,point, &
               &               intcut,nprim,primcount,alp,cont,ss,dd2,qq)
            !transform from CAO to SAO
            !call dtrf2(ss,ishtyp,jshtyp)
            do k = 1,3
               tmp(1:6, 1:6) = dd2(k,1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               dd2(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do k = 1,6
               tmp(1:6, 1:6) = qq(k, 1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               qq(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do ii = 1, llao2(ishtyp)
               iao = ii + saoshell(ish,iat)
               do jj = 1, llao2(jshtyp)
                  jao = jj + saoshell(jsh,iat)
                  if (jao > iao .and. ish ==  jsh) cycle
                  dpint(1:3, iao, jao) = dpint(1:3, iao, jao) + dd2(1:3, jj, ii)
                  if (iao /= jao) then
                     dpint(1:3, jao, iao) = dpint(1:3, jao, iao) + dd2(1:3, jj, ii)
                  end if
                  qpint(1:6, iao, jao) = qq(1:6, jj, ii)
                  if (jao /= iao) then
                     qpint(1:6, jao, iao) = qq(1:6, jj, ii)
                  end if
               end do
            end do
         end do
      end do
   end do

   !$acc exit data delete(xyz, at, nShell, caoshell, saoshell, &
   !$acc& nprim, primcount, alp, cont, intcut, trans, point, angShell(:, :))

end subroutine sdqint_gpu


end module overlap_module

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfn0_lidep
!----------------------------------------------------------------------------------------------
!> module gfn0_lineardep
!>
!> Contains some routines related to problems that can arise due to
!> linear dependencies in the basis set, i.e., if any of the eigenvalues
!> of the diagonalized overlap matrix approach zero.
!> With these routines we can get cut-off eigenvalues of the overlap that are too small
!> and generate a transformation matrix X. With this matrix X we
!> can then transform our Hamiltionian to H'=X**(T)*H*X, which can then be diagonalized
!> without need for the Overlap.
!>
!> For more information see Chapter 3.4.5 "Orthogonalization of the Basis" in Szabo/Ostlund
!>
!> P.Pracht, May 2019
!----------------------------------------------------------------------------------------------
   use iso_fortran_env, only : wp=>real64
   implicit none

   !> cut-off threshold for small overlap eigenvalues
   real(wp) :: lidethr = 0.00001_wp 
   !> global logical if the orthogonal basis should be used
   logical  :: orthog = .false.

   contains
!----------------------------------------------------------------------------------------------
!  subroutine cholesky
!
!  Try to perform a Cholesky-factorization A = U**T*U, where
!  A has to be a symmetric positive definite matrix and U is  
!  the normalized upper triangular matrix.
!  The Cholesky decomposition is used here ONLY to test if
!  A is positive definite. 
!  This check is usefull to pre-test if the overlap will
!  have near linear dependencies, and is faster than checking the
!  eigenvalues of the overlap.
!
!  INPUT  - ndim  dimension of the matrix A
!         - A     symmetric matrix with the dimension A(ndim,ndim)
!                 A is not modified and will be the same on In- and Output
!
!  OUTPUT - fail  logical to indicate whether the Cholesky-factorization
!                 was successful
!
!----------------------------------------------------------------------------------------------
subroutine cholesky(iunit,printl,ndim,A,fail)
    implicit none
  !---
    integer,intent(in)  :: iunit
    integer,intent(in)  :: ndim
    real(wp),intent(in) :: A(ndim,ndim)
    logical,intent(out) :: fail
    logical,intent(in)  :: printl
  !---
    integer :: ierr
    real(wp),allocatable  :: U(:,:)

    if(printl) &
    & write(iunit,'(2x,a)',advance='no')'Checking positiv definite overlap ...'

  !---
    allocate(U(ndim,ndim))
    fail=.false.
    U=A
    call dpotrf('U',ndim,U,ndim,ierr) !LAPACK routine  A = U**T*U
                                      !on input U=A, retruns U

    if(printl) then
      write(iunit,'(2x,a)')'done.'
      write(iunit,*)
    endif

    if(ierr /= 0) then
      fail=.true.
      if(printl)then
      write(iunit,'(a)') '**** WARNING ****'
      write(iunit,'(a)') ' Cholesky factorization of the overlap failed!'
      write(iunit,'(a)') ' It is possible that there are near linear dependecies in the basis.'
      write(iunit,'(a)') ' Therefore GFN0 will work with an orthogonal basis by using'
      write(iunit,'(a)') ' canonical orthogonalization.'
      write(iunit,'(a)') '**** WARNING ****'
      write(iunit,'(a)')
      endif
    endif
    deallocate(U)
    return
end subroutine cholesky

!----------------------------------------------------------------------------------------------
!  subroutine renorm
!
!  Re-normalize the matirx A according to the diagonal elements.
!
!  INPUT  - ndim  dimension of the matrix A
!         - A     symmetric matrix with the dimension A(ndim,ndim)
!
!  OUTPUT - 
!
!----------------------------------------------------------------------------------------------
subroutine renorm(ndim,A)
    implicit none
  !---
    integer,intent(in)  :: ndim
    real(wp),intent(inout) :: A(ndim,ndim)
  !---
    integer :: ierr,i,j,k,l

    !do i=1,ndim
    !   A(:,i)=A(:,i)/A(i,i)
    !enddo
    do i=1,ndim
      do j=1,i-1
        A(i,j)=A(i,j)/A(i,i)
        A(j,i)=A(i,j)
      enddo
    enddo
    return
end subroutine renorm


!----------------------------------------------------------------------------------------------
!  subroutine canorthog
!
!  In order to get the orthogonal basis we need a transformation
!  matrix X. In practice, this X can be modified to circumvent 
!  near linear dependencies. This can hoever only be done if the 
!  so-called 'canonical orthogonalization' is used, i.e.,
!  X is initially determined as X = U*s**(-1/2), where
!  U is a unitary matix and s**(-1/2) is the inverse square root
!  of the diagonalized overlap matrix S.
!  As a sanity check, X**T*S*X = 1 has to be valid.
!  See Szabo/Ostlund, equation 3.169 and following.
!  This routine determines X = U*s**(-1/2) from the overlap S.
!
!  INPUT  - ndim    dimension of the matrices S and X
!         - S       overlap matrix with the dimension S(ndim,ndim)
!
!  OUTPUT - X       transformation matrix X, with the dimension X(ndim,newdim) 
!         - newdim  new dimension of trafo X
!         - fail    logical to indicate whether the setup of matrix X
!                   was successful
!
!----------------------------------------------------------------------------------------------
subroutine canorthog(iunit,ndim,S,X,newdim,printl,fail)
    implicit none
   !---   
    integer,intent(in)   :: iunit
    integer,intent(in)   :: ndim
    real(wp),intent(in)  :: S(ndim,ndim)
    real(wp),intent(out) :: X(ndim,ndim)
    logical,intent(out)  :: fail
    integer,intent(out)  :: newdim 
    logical,intent(in)   :: printl
   !---
    integer :: i
    real(wp),allocatable :: U(:,:)
    real(wp),allocatable :: ssq(:)
    real(wp),allocatable :: sisq(:)
    real(wp),allocatable :: P(:,:),P2(:,:)
   !---
    allocate(U(ndim,ndim),ssq(ndim),sisq(ndim))
    fail=.false.
    X=0.0d0
   !--- diagonalize overlap and get eigenvectors U and eigenvalues s
    if(printl) &
    & write(iunit,'(2x,a)',advance='no')'Diagonalization of the Overlap   ...'
    call canorthog2(ndim,S,U,ssq,fail)
    if(fail)then
       if(printl) write(iunit,'(2x,a)')'failed.'
       return
    else
      if(printl) write(iunit,'(2x,a)')'done.'
    endif

   !--- restructure U and ssq
    call sorteigen(ndim,ssq,U)

   !--- cut-off small eigenvalues and build the inverse square root s**(-1/2)
    newdim=ndim
    call lidepcut(iunit,ndim,ssq,U,sisq,newdim,printl)
    !call prmat(6,e,nbf,1,"eigenvalues")
    !call prmat(6,U,ndim,ndim,"U")
   !--- sanity check stuff
    !newdim=ndim
    !do i=1,ndim
    !   sisq(i)=1.0d0 / sqrt(ssq(i))
    !enddo
 
   !--- get X and its new dimensions
    if(printl) &
    & write(iunit,'(2x,a)',advance='no')'Building transformation matrix X ...'
    call buildtrafoX(ndim,ssq,U,sisq,newdim,X)
    !call prmat(6,X,ndim,ndim,"X")
    if(printl) then
     write(iunit,'(2x,a)')'done.'
     write(iunit,'(a)')
    endif
   !--- more sanity check stuff
    !call prmat(6,X,ndim,ndim,"Trafo X")
    !allocate(P(ndim,ndim),P2(ndim,ndim))
    !call gemm('N','N',ndim,newdim,ndim,1.0d0,S,ndim,X,ndim,0.0d0,P,ndim)
    !call gemm('T','N',ndim,ndim,newdim,1.0d0,X,ndim,P,ndim,0.0d0,P2,ndim)
    !call prmat(6,P2,ndim,ndim,"X**T*S*X")
    !deallocate(P2,P)
    !stop

    deallocate(sisq,ssq,U)
    return
end subroutine canorthog

!----------------------------------------------------------------------------------------------
!  subroutine canorthog2
!
!  Diagonalizes the overlap matrix S and returns the unitary transformation
!  matrix U and the eigenvalues s, i.e., U**T*S*U = s is performed.
!  
!
!  INPUT  - ndim  dimension of the matrices S and X
!         - S     overlap matrix with the dimension S(ndim,ndim)
!
!  OUTPUT - X     transformation matrix U, with the dimension U(ndim,ndim) 
!         - ssq   eigenvalues s of matrix S
!         - fail  logical to indicate whether the setup of U and 
!                 was successful
!
!----------------------------------------------------------------------------------------------
subroutine canorthog2(ndim,S,U,ssq,fail)
    implicit none
   !---   
    integer,intent(in)   :: ndim
    real(wp),intent(in)  :: S(ndim,ndim)
    real(wp),intent(out) :: U(ndim,ndim)
    real(wp),intent(out) :: ssq(ndim)
    logical,intent(out)  :: fail
   !---
    integer :: ierr
    integer :: lwork
    real(wp),dimension(1) :: wdim
    real(wp),allocatable  :: work(:)

   !---
    fail=.false.
    U=S
    ssq=0.0d0
   !--- determine optimal work space
   !--- only calculates the optimal size of the 'work' array
    call lapack_syev('v','l',ndim,U,ndim,ssq,wdim,-1,ierr)
    if(ierr /= 0)then
       fail=.true.
       return
    endif
    lwork=int(wdim(1))
    allocate(work(lwork))

   !--- diagonalize overlap s = U**T*S*U
    call lapack_syev('v','l',ndim,U,ndim,ssq,work,lwork,ierr)
    if(ierr /= 0)then
       fail=.true.
       return
    endif
    !!write(iunit,*) ssq
    return
end subroutine canorthog2


!----------------------------------------------------------------------------------------------
!  subroutine sorteigen
!
!  We are allowed to order the eigenvalues in any way in the diagonal matrix s,
!  provided we order the columns of U in the same way.
!  Sort the overlap eigenvalues form highest to lowest and also
!  sort the eigenvectors accordingly. 
!  s is typically structured in ascending order from DSYEV, 
!  hence, this order only has to be reversed.
!  
!
!  INPUT     - ndim  dimension of eigenvalue array s and matrix U
!
!  IN/OUTPUT - s     eigenvalues of the overlap with the dimension s(ndim)
!            - U     eigenvectors of the overlap with the dimension U(ndim,ndim)
!
!----------------------------------------------------------------------------------------------
subroutine sorteigen(ndim,s,U)
    implicit none
   !---
    integer,intent(in)     :: ndim
    real(wp),intent(inout) :: s(ndim)
    real(wp),intent(inout) :: U(ndim,ndim)
   !---
    integer  :: i,j,k,l,imax
    real(wp) :: smax
    real(wp) :: Umax
   !---
    imax=ndim-1
    do i=1,imax
      smax=s(i)
      k=i
      l=i+1
      do j=l,ndim
         if(s(j).le.smax) cycle
         k=j
         smax=s(j)
      enddo
      Umax=s(i)
      s(i)=s(k)
      s(k)=Umax
      do j=1,ndim
         Umax=U(j,i)
         U(j,i)=U(j,k)
         U(j,k)=Umax
      enddo
    enddo
  !---
    return
end subroutine sorteigen



!----------------------------------------------------------------------------------------------
!  subroutine lidepcut
!
!  Cut-off small eigenvalues, which can be necessary to prevent linear dependencies
!  
!
!  INPUT     - ndim    dimension of eigenvalue array s and matrix U
!            - printl  print some output?
!
!  IN/OUTPUT - s     eigenvalues of the overlap with the dimension s(ndim)
!                    on OUTPUT this is s**(1/2)
!            - U     eigenvectors of the overlap with the dimension U(ndim,ndim)
!
!  OUTPUT    - sisq  array that contains inverse square root of the eigenvalues s**(-1/2)
!
!----------------------------------------------------------------------------------------------
subroutine lidepcut(iunit,ndim,s,U,sisq,newdim,printl)
    implicit none
   !---
    integer,intent(in)     :: iunit
    integer,intent(in)     :: ndim
    real(wp),intent(inout) :: s(ndim)
    real(wp),intent(inout) :: U(ndim,ndim)
    real(wp),intent(out)   :: sisq(ndim)
    integer,intent(out)    :: newdim
    logical,intent(in)     :: printl
   !--- 
    integer  :: i,j,imax
    real(wp) :: eigen
    real(wp) :: ehig,elow
   !---
    !lidethr=1.0d-4

    sisq=0.0d0
    newdim=ndim
   !--- min and max eigenvalues of the overlap
    ehig = s(1)
    elow = s(ndim)
   !--- cut eigenvalues and eigenvectors that are below the predefined threshold
    if(printl) &
    & write(iunit,'(2x,a)',advance='no')'Cutting off small eigenvalues    ...'
    do i=1,ndim
      eigen = s(i)
      if(eigen > set%lidethr) then
        eigen = sqrt(eigen)
        s(i) = eigen
        sisq(i) = 1.0d0 / eigen
      else
        s(i) = 0.0d0
        sisq(i) = 0.0d0
        U(1:ndim,i) = 0.0d0
        newdim=newdim-1
      endif
    enddo
    if(printl)then
    write(iunit,'(2x,a)')'done.'
   !--- some printout
    write(iunit,'(2x,a)')'Maximum eigenvalues of the overlap:'
    write(iunit,'(4x,a,f10.4)')'Largest eigenvalue              : ',ehig
    write(iunit,'(4x,a,f10.4)')'Smallest eigenvalue             : ',elow
    write(iunit,'(2x,a,e14.4)')'Eigenvalue cut-off threshold      : ',set%lidethr
    write(iunit,'(2x,a,i6)')   'Initial number of eigenvectors    : ',ndim
    write(iunit,'(2x,a,i6)')   'Removed eigenvectors              : ',ndim-newdim
    write(iunit,'(2x,a,i6)')   'Number of remaining eigenvectors  : ',newdim
    write(iunit,'(4x,a,f10.4)')'New smallest eigenvalue         : ',s(newdim)**2
    endif
   !---
    return
end subroutine lidepcut


!----------------------------------------------------------------------------------------------
!  subroutine buildtrafoX
!
!  Generate the transofrmation matrix X from U and s**(-1/2).
!  See Szabo/Ostlund Eq. 3.171
!  
!
!  INPUT     - ndim  dimension of eigenvalue array s and matrix U
!            - ssq   square-root of the overlap eigenvalues with the dimension s(ndim)
!            - U     eigenvectors of the overlap with the dimension U(ndim,ndim)
!            - sisq  inverse square root of the overlap eigenvalues s**(-1/2)
!
!  OUTPUT    - X     transformation matrix X=U*s**(-1/2)
!
!----------------------------------------------------------------------------------------------
subroutine buildtrafoX(ndim,ssq,U,sisq,newdim,X)
    implicit none
   !---
    integer,intent(in)     :: ndim
    integer,intent(in)     :: newdim
    real(wp),intent(in)    :: ssq(ndim)
    real(wp),intent(in)    :: U(ndim,ndim)
    real(wp),intent(in)    :: sisq(ndim)
    real(wp),intent(out)   :: X(ndim,ndim)
   !---
    integer :: i,j,k,l
   !---
    X=0.0d0
    do i=1,ndim
     do j=1,newdim
      X(i,j)=U(i,j) * sisq(j)
     enddo
    enddo
   !---
    return
end subroutine buildtrafoX



!----------------------------------------------------------------------------------------------
!  subroutine orthgsolve
!
!  Modification of the solv routine.
!  Diagonalization of H is done with the trafo matrix X = U*s**(-1/2), i.e.,
!  in the orthogonal basis.
!  See Szabo/Ostlund equation 3.176:
!  (X**T*F*X)*C' = (X**T*S*X)*C'*e
!  which is possible since X**T*S*X=1
!
!  INPUT  - full    some logical to indicate was should be done in this routine
!         - ndim    original dimension of the matrices H,S,X,P and vector e
!         - cutdim  new second dimension of the rectangular trafo matrix X
!         - ihomo 
!         - acc     accuracy setting
!         - H       Hamiltonian matrix
!         - X       trafo matrix with dimensions X(ndim,cutdim)
!         - S       overlap matrix with the dimension S(ndim,ndim)
!         - e       eigenvalues
!         
!
!  OUTPUT - fail    logical to indicate whether the diagonalization
!                   was successful
!         - 
!
!----------------------------------------------------------------------------------------------
subroutine orthgsolve(full,ndim,cutdim,ihomo,acc,H,S,X,P,e,fail)
   implicit none
   integer, intent(in)   :: ndim
   integer, intent(in)   :: cutdim
   logical, intent(in)   :: full
   integer, intent(in)   :: ihomo
   real(wp),intent(inout):: H(ndim,ndim)
   real(wp),intent(in)   :: S(ndim,ndim)
   real(wp),intent(inout):: X(ndim,ndim)
   real(wp),intent(out)  :: P(ndim,ndim)
   real(wp),intent(out)  :: e(ndim)
   real(wp),intent(in)   :: acc
   logical, intent(out)  :: fail

   integer :: i,j,info,lwork,liwork,nfound,iu
   integer :: nbf,xbf
   integer, allocatable :: iwork(:),ifail(:)
   real(wp),allocatable :: aux  (:)
   real(wp),allocatable :: Haux(:,:),Paux(:,:)
   fail =.false.


  !--- DIAG IN ORTHOGONAL BASIS WITH X=U*s^-1/2 TRAFO
    nbf = ndim
    xbf = cutdim
    lwork  = 1 + 6*nbf + 2*nbf**2
    allocate (aux(lwork))
  !--- calculate F'=X**T*F*X  

    call blas_gemm('n','n',nbf,xbf,nbf,1.0d0,H,nbf,X,nbf,0.0d0,P,nbf)
    call blas_gemm('t','n',xbf,xbf,nbf,1.0d0,X,nbf,P,nbf,0.0d0,H,xbf)
    
  !--- Caluclate C' and ε from F'*C' = C'*ε
    call lapack_syev('v','u',xbf,H,xbf,e,aux,lwork,info)
    if(info.ne.0)then
       fail=.true.
       return
    endif
  !--- calculate C = X*C'
    P=0.0d0
    call blas_gemm('N','N',nbf,xbf,xbf,1.0d0,X,nbf,H,xbf,0.0d0,P,nbf)
    H=P
    deallocate(aux)
    return
end subroutine orthgsolve


subroutine orthgsolve2(full,ndim,cutdim,ihomo,acc,H,S,X,P,e,fail)
   implicit none
   integer, intent(in)   :: ndim
   integer, intent(in)   :: cutdim
   logical, intent(in)   :: full
   integer, intent(in)   :: ihomo
   real(wp),intent(inout):: H(ndim,ndim)
   real(wp),intent(in)   :: S(ndim,ndim)
   real(wp),intent(inout):: X(ndim,ndim)
   real(wp),intent(out)  :: P(ndim,ndim)
   real(wp),intent(out)  :: e(ndim)
   real(wp),intent(in)   :: acc
   logical, intent(out)  :: fail

   integer :: i,j,info,lwork,liwork,nfound,iu
   integer :: nbf,xbf
   integer, allocatable :: iwork(:),ifail(:)
   real(wp),allocatable :: aux  (:)
   real(wp),allocatable :: Haux(:,:),Paux(:,:),Xaux(:,:)
   fail =.false.


  !--- DIAG IN ORTHOGONAL BASIS WITH X=U*s^-1/2 TRAFO
    nbf = ndim
    xbf = cutdim
    lwork  = 1 + 6*nbf + 2*nbf**2
    allocate (aux(lwork))
  !--- calculate F'=X**T*F*X  
    allocate(Xaux(nbf,xbf),Paux(nbf,xbf))
    Xaux=X(:,1:xbf)
    call blas_gemm('n','n',nbf,xbf,nbf,1.0d0,H,nbf,Xaux,nbf,0.0d0,Paux,nbf)
    allocate(Haux(xbf,xbf))
    call blas_gemm('t','n',xbf,xbf,nbf,1.0d0,Xaux,nbf,Paux,nbf,0.0d0,Haux,xbf)

  !--- Caluclate C' and ε from F'*C' = C'*ε
    call lapack_syev('v','u',xbf,Haux,xbf,e,aux,lwork,info)
    !call prmat(6,e,nbf,1,"eigenvalues")

    if(info.ne.0)then
       fail=.true.
       return
    endif
  !--- calculate C = X*C'
    P=0.0d0
    call blas_gemm('N','N',nbf,xbf,xbf,1.0d0,Xaux,nbf,Haux,xbf,0.0d0,P,nbf)
    H=P

    deallocate(Haux,Paux,Xaux)
    deallocate(aux)
    return
end subroutine orthgsolve2


!----------------------------------------------------------------------------------------------
!----------------------------------------------------------------------------------------------
end module gfn0_lineardep

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!

!> Implementation of the Born radii integrator
module solvation_solv_born
   use iso_fortran_env, only: wp => real64
   implicit none
   private

   public :: compute_bornr

   !> van der Waals to Lee-Richard's surface correction (GBOBCII parameter)
   real(wp), parameter :: alp = 1._wp
   real(wp), parameter :: bet = 0.8_wp
   real(wp), parameter :: gam = 4.85_wp

contains


subroutine compute_bornr(nat, nnrad, nnlistr, ddpair, vdwr, rho, svdw, c1, &
      & brad, brdr)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of neighbours to consider for radii
   integer, intent(in) :: nnrad

   !> Neighbourlist
   integer, intent(in) :: nnlistr(:, :)

   !> Position and distances
   real(wp), intent(in) :: ddpair(:, :)

   !> Van-der-Waals radii
   real(wp), intent(in) :: vdwr(:)

   !> Descreened van-der-Waals radii
   real(wp), intent(in) :: rho(:)

   !> van-der-Waals radii with offset
   real(wp), intent(in) :: svdw(:)

   !> Scaling factor for the Born radii
   real(wp), intent(in) :: c1

   !> Born radii
   real(wp), intent(out) :: brad(:)

   !> Derivative of Born radii w.r.t. cartesian coordinates
   real(wp), intent(out) :: brdr(:, :, :)

   integer :: iat
   real(wp) :: br, dpsi, svdwi, vdwri, s1, v1, s2, arg, arg2
   real(wp) :: th, ch, alpi, beti, gami

   call compute_psi(nat, nnrad, nnlistr, ddpair, vdwr, rho, brad, brdr)

   do iat = 1, nat

      br = brad(iat)

      svdwi = svdw(iat)
      vdwri = vdwr(iat)
      s1 = 1.0_wp/svdwi
      v1 = 1.0_wp/vdwri
      s2 = 0.5_wp*svdwi

      br = br*s2

      arg2 = br*(gam*br-bet)
      arg = br*(alp+arg2)
      arg2 = 2.0_wp*arg2+alp+gam*br*br

      th = tanh(arg)
      ch = cosh(arg)

      br = 1.0_wp/(s1-v1*th)
      ! Include GBMV2-like scaling
      br = c1*br

      dpsi = ch*(s1-v1*th)
      dpsi = s2*v1*arg2/(dpsi*dpsi)
      dpsi = c1*dpsi

      brad(iat) = br
      !call mctc_scal(brdr(:, :, iat), dpsi)
      brdr(:,:, iat) = brdr(:, :, iat) * dpsi

   end do

end subroutine compute_bornr


pure subroutine compute_psi(nat, nnrad, nnlistr, ddpair, vdwr, rho, psi, dpsidr)

   !> Number of atoms
   integer, intent(in) :: nat

   !> Number of neighbours to consider for radii
   integer, intent(in) :: nnrad

   !> Neighbourlist
   integer, intent(in) :: nnlistr(:, :)

   !> Position and distances
   real(wp), intent(in) :: ddpair(:, :)

   !> Van-der-Waals radii
   real(wp), intent(in) :: vdwr(:)

   !> Descreened van-der-Waals radii
   real(wp), intent(in) :: rho(:)

   !> Integrated value of Psi
   real(wp), intent(out) :: psi(:)

   !> Derivative of Psi w.r.t. cartesian coordinates
   real(wp), intent(out) :: dpsidr(:, :, :)

   real(wp), allocatable :: dpsitr(:, :)
   integer  :: kk
   integer  :: i, ii, jj, nn
   real(wp) :: dr(3), r, rhoi, rhoj
   real(wp) :: gi, gj, ap, am, lnab, rhab, ab, dgi, dgj
   real(wp) :: drjj(3)
   real(wp) :: rh1, rhr1, r24, rh2, r1, aprh1, r12
   real(wp) :: rvdwi, rvdwj
   integer  :: ovij, ovji, ov

   allocate(dpsitr(3, nat))
   psi(:) = 0.0_wp
   dpsidr(:, :, :) = 0.0_wp
   dpsitr(:, :) = 0.0_wp

   do kk = 1, nnrad

      ii = nnlistr(1, kk)
      jj = nnlistr(2, kk)
      nn = nnlistr(3, kk)

      r = ddpair(1, nn)
      dr(:) = ddpair(2:4, nn)

      rhoi = rho(ii)
      rhoj = rho(jj)
      rvdwi = vdwr(ii)
      rvdwj = vdwr(jj)

      ovij = 1
      ovji = 1
      if(r.ge.(rvdwi+rhoj)) ovij = 0
      if(r.ge.(rhoi+rvdwj)) ovji = 0
      ov = ovij+10*ovji

      select case(ov)
      case(0) ! ij do not overlap; ji do not overlap
         ! nonoverlaping spheres
         if(abs(rhoi-rhoj).lt.1.d-8) then
            ! equal reduced radii
            r1 = 1.0_wp/r
            ap = r+rhoj
            am = r-rhoj
            ab = ap*am
            rhab = rhoj/ab
            lnab = 0.5_wp*log(am/ap)*r1
            gi = rhab+lnab
            dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
            ! accumulate psi
            psi(ii) = psi(ii)+gi
            psi(jj) = psi(jj)+gi
            ! accumulate psi gradient
            drjj(:) = dgi*dr(:)
            dpsitr(:, ii) = dpsitr(:, ii)+drjj(:)
            dpsidr(:, jj, ii) = dpsidr(:, jj, ii)-drjj(:)
            dpsitr(:, jj) = dpsitr(:, jj)-drjj(:)
            dpsidr(:, ii, jj) = dpsidr(:, ii, jj)+drjj(:)
         else
            ! unequal reduced radii
            ! ij contribution
            r1 = 1.0_wp/r
            ap = r+rhoj
            am = r-rhoj
            ab = ap*am
            rhab = rhoj/ab
            lnab = 0.5_wp*log(am/ap)*r1
            gi = rhab+lnab
            dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
            ! ji contribution
            ap = r+rhoi
            am = r-rhoi
            ab = ap*am
            rhab = rhoi/ab
            lnab = 0.5_wp*log(am/ap)*r1
            gj = rhab+lnab
            dgj = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
            ! accumulate psi
            psi(ii) = psi(ii)+gi
            psi(jj) = psi(jj)+gj
            ! accumulate psi gradient
            drjj(:) = dgi*dr(:)
            dpsitr(:, ii) = dpsitr(:, ii)+drjj(:)
            dpsidr(:, jj, ii) = dpsidr(:, jj, ii)-drjj(:)

            drjj(:) = dgj*dr(:)
            dpsitr(:, jj) = dpsitr(:, jj)-drjj(:)
            dpsidr(:, ii, jj) = dpsidr(:, ii, jj)+drjj(:)
         endif

      case(10) ! ij do not overlap; ji overlap

         ! ij contribution
         r1 = 1.0_wp/r
         ap = r+rhoj
         am = r-rhoj
         ab = ap*am
         rhab = rhoj/ab
         lnab = 0.5_wp*log(am/ap)*r1
         gi = rhab+lnab
         dgi = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
         ! accumulate psi
         psi(ii) = psi(ii)+gi
         ! accumulate psi gradient
         drjj(:) = dgi*dr(:)
         dpsitr(:, ii) = dpsitr(:, ii)+drjj(:)
         dpsidr(:, jj, ii) = dpsidr(:, jj, ii)-drjj(:)

         if((r+rhoi).gt.rvdwj) then
            ! ji contribution
            r1 = 1.0_wp/r
            r12 = 0.5_wp*r1
            r24 = r12*r12

            ap = r+rhoi
            am = r-rhoi
            rh1 = 1.0_wp/rvdwj
            rhr1 = 1.0_wp/ap
            aprh1 = ap*rh1
            lnab = log(aprh1)

            gj = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

            dgj = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
               &         rhoi*r24*(rhr1-rh1*aprh1)+ &
               &         r12*(r1*lnab-rhr1)
            dgj = dgj*r1
            ! accumulate psi
            psi(jj) = psi(jj)+gj
            ! accumulate psi gradient
            drjj(:) = dgj*dr(:)
            dpsitr(:, jj) = dpsitr(:, jj)-drjj(:)
            dpsidr(:, ii, jj) = dpsidr(:, ii, jj)+drjj(:)
         endif

      case(1) ! ij overlap; ji do not overlap

         if((r+rhoj).gt.rvdwi) then
            ! ij contribution
            r1 = 1.0_wp/r
            r12 = 0.5_wp*r1
            r24 = r12*r12

            ap = r+rhoj
            am = r-rhoj
            rh1 = 1.0_wp/rvdwi
            rhr1 = 1.0_wp/ap
            aprh1 = ap*rh1
            lnab = log(aprh1)

            gi = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

            dgi = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
               &         rhoj*r24*(rhr1-rh1*aprh1)+ &
               &         r12*(r1*lnab-rhr1)
            dgi = dgi*r1
            ! accumulate psi
            psi(ii) = psi(ii)+gi
            ! accumulate psi gradient
            drjj(:) = dgi*dr(:)
            dpsitr(:, ii) = dpsitr(:, ii)+drjj(:)
            dpsidr(:, jj, ii) = dpsidr(:, jj, ii)-drjj(:)
         endif

         ! ji contribution
         ap = r+rhoi
         am = r-rhoi
         ab = ap*am
         rhab = rhoi/ab
         lnab = 0.5_wp*log(am/ap)*r1
         gj = rhab+lnab
         dgj = -2.0_wp*rhab/ab+(rhab-lnab)*r1*r1
         ! accumulate psi
         psi(jj) = psi(jj)+gj
         ! accumulate psi gradient
         drjj(:) = dgj*dr(:)
         dpsitr(:, jj) = dpsitr(:, jj)-drjj(:)
         dpsidr(:, ii, jj) = dpsidr(:, ii, jj)+drjj(:)

      case(11) ! ij and ji overlap
         ! overlaping spheres
         if((r+rhoj).gt.rvdwi) then
            ! ij contribution
            r1 = 1.0_wp/r
            r12 = 0.5_wp*r1
            r24 = r12*r12

            ap = r+rhoj
            am = r-rhoj
            rh1 = 1.0_wp/rvdwi
            rhr1 = 1.0_wp/ap
            aprh1 = ap*rh1
            lnab = log(aprh1)

            gi = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

            dgi = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
               &         rhoj*r24*(rhr1-rh1*aprh1)+ &
               &         r12*(r1*lnab-rhr1)
            dgi = dgi*r1
            ! accumulate psi
            psi(ii) = psi(ii)+gi
            ! accumulate psi gradient
            drjj(:) = dgi*dr(:)
            dpsitr(:, ii) = dpsitr(:, ii)+drjj(:)
            dpsidr(:, jj, ii) = dpsidr(:, jj, ii)-drjj(:)
         endif

         if((r+rhoi).gt.rvdwj) then
            ! ji contribution
            r1 = 1.0_wp/r
            r12 = 0.5_wp*r1
            r24 = r12*r12

            ap = r+rhoi
            am = r-rhoi
            rh1 = 1.0_wp/rvdwj
            rhr1 = 1.0_wp/ap
            aprh1 = ap*rh1
            lnab = log(aprh1)

            gj = rh1-rhr1+r12*(0.5_wp*am*(rhr1-rh1*aprh1)-lnab)

            dgj = rhr1*rhr1*(1.0_wp-0.25_wp*am*r1*(1.0_wp+aprh1*aprh1))+ &
               &         rhoi*r24*(rhr1-rh1*aprh1)+ &
               &         r12*(r1*lnab-rhr1)
            dgj = dgj*r1
            ! accumulate psi
            psi(jj) = psi(jj)+gj
            ! accumulate psi gradient
            drjj(:) = dgj*dr(:)
            dpsitr(:, jj) = dpsitr(:, jj)-drjj(:)
            dpsidr(:, ii, jj) = dpsidr(:, ii, jj)+drjj(:)
         endif

      end select

   enddo

   ! save one-center terms
   do i = 1, nat
      dpsidr(:, i, i) = dpsitr(:, i)
   enddo

end subroutine compute_psi

end module solvation_solv_born

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original source code can be found under the GNU LGPL 3.0 license
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfn0_basisset
   use iso_fortran_env, only : wp=>real64

   use gfn0_types
   use slater_module

   implicit none

   public :: TBasisset
   public :: newBasisset

   private

   real(wp),private,parameter :: pi=3.1415926535897932385_wp

   type :: TBasisset
      integer  :: maxao = 0
      integer  :: n = 0
      integer  :: nbf = 0
      integer  :: nao = 0
      integer  :: nshell = 0
      ! ------------------------------------------------------------------------
      !  This variables describe the ATOMS
      integer, allocatable :: caoshell(:,:)  ! atom number -> basis function
      integer, allocatable :: saoshell(:,:)  ! atom number -> AO
      integer, allocatable :: fila(:,:)      ! atom number -> basis function
      integer, allocatable :: fila2(:,:)     ! atom number -> AO
      integer, allocatable :: shells(:,:)    ! atom number -> shell
      ! ------------------------------------------------------------------------
      !  This variables describe the indivdual SHELLS
      integer, allocatable :: lsh(:)   ! shell -> azimudal quantum number
      integer, allocatable :: ash(:)   ! shell -> atom number
      real(wp),allocatable :: zeta(:)  ! shell -> exponent
      real(wp),allocatable :: level(:) ! shell -> level energy
      real(wp),allocatable :: minalp(:)! shell -> most diffuse exponent
      integer, allocatable :: sh2bf(:,:) ! shell -> BF
      integer, allocatable :: sh2ao(:,:) ! shell -> AO
      integer, allocatable :: valsh(:) ! shell -> shell type
      ! ------------------------------------------------------------------------
      !  This variables describe the SPHERICAL atomic orbitals
      real(wp),allocatable :: aoexp(:)    ! AO -> exponent
      integer, allocatable :: ao2sh(:)    ! AO -> shell
      integer, allocatable :: lao2(:)     ! AO -> azimudal quantum number
      integer, allocatable :: aoat2(:)    ! AO -> atom number
      real(wp),allocatable :: hdiag2(:)   ! AO -> level energy
      integer, allocatable :: valao2(:)   ! AO -> AO type
      ! ------------------------------------------------------------------------
      !  This variables describe the CARTESIAN basis functions
      integer, allocatable :: primcount(:) ! BF -> primitive count
      real(wp),allocatable :: hdiag(:)     ! BF -> level energy
      integer, allocatable :: nprim(:)     ! BF -> primitive number
      integer, allocatable :: aoat(:)      ! BF -> atom
      integer, allocatable :: valao(:)     ! BF -> BF type
      integer, allocatable :: lao(:)       ! BF -> azimudal quantum number
      ! ------------------------------------------------------------------------
      !  This variables decribe the PRIMITIV basis functions
      real(wp),allocatable :: alp(:)  ! primitive -> primitive exponent
      real(wp),allocatable :: cont(:) ! primitive -> contraction coeffient
   contains
   procedure :: allocate => allocate_basisset
   procedure :: deallocate => deallocate_basisset
   end type TBasisset

contains

!========================================================================================!
!========================================================================================!

subroutine allocate_basisset(self,n,nbf,nao,nshell)
   implicit none
   class(TBasisset),intent(inout) :: self
   integer,intent(in) :: n,nbf,nao,nshell
   self%n=n
   self%nbf=nbf
   self%nao=nao
   self%nshell=nshell
   call self%deallocate
   allocate( self%shells(2,n),    source = 0 )
   allocate( self%sh2ao(2,nshell),source = 0 )
   allocate( self%sh2bf(2,nshell),source = 0 )
   allocate( self%minalp(nshell), source = 0.0_wp )
   allocate( self%level(nshell),  source = 0.0_wp )
   allocate( self%zeta(nshell),   source = 0.0_wp )
   allocate( self%valsh(nshell),  source = 0 )
   allocate( self%hdiag(nbf),     source = 0.0_wp )
   allocate( self%alp(9*nbf),     source = 0.0_wp )
   allocate( self%cont(9*nbf),    source = 0.0_wp )
   allocate( self%hdiag2(nao),    source = 0.0_wp )
   allocate( self%aoexp(nao),     source = 0.0_wp )
   allocate( self%ash(nao),       source = 0 )
   allocate( self%lsh(nao),       source = 0 )
   allocate( self%ao2sh(nao),     source = 0 )
   allocate( self%nprim(nbf),     source = 0 )
   allocate( self%primcount(nbf), source = 0 )
   allocate( self%caoshell(5,n),  source = 0 )
   allocate( self%saoshell(5,n),  source = 0 )
   allocate( self%fila(2,n),      source = 0 )
   allocate( self%fila2(2,n),     source = 0 )
   allocate( self%lao(nbf),       source = 0 )
   allocate( self%aoat(nbf),      source = 0 )
   allocate( self%valao(nbf),     source = 0 )
   allocate( self%lao2(nao),      source = 0 )
   allocate( self%aoat2(nao),     source = 0 )
   allocate( self%valao2(nbf),    source = 0 )
end subroutine allocate_basisset

subroutine deallocate_basisset(self)
   implicit none
   class(TBasisset),intent(inout) :: self
   if(allocated(self%shells))    deallocate(self%shells)
   if(allocated(self%sh2ao))     deallocate(self%sh2ao)
   if(allocated(self%sh2bf))     deallocate(self%sh2bf)
   if(allocated(self%minalp))    deallocate(self%minalp)
   if(allocated(self%valsh))     deallocate(self%valsh)
   if(allocated(self%hdiag))     deallocate(self%hdiag)
   if(allocated(self%alp))       deallocate(self%alp)
   if(allocated(self%cont))      deallocate(self%cont)
   if(allocated(self%hdiag2))    deallocate(self%hdiag2)
   if(allocated(self%aoexp))     deallocate(self%aoexp)
   if(allocated(self%ash))       deallocate(self%ash)
   if(allocated(self%lsh))       deallocate(self%lsh)
   if(allocated(self%ao2sh))     deallocate(self%ao2sh)
   if(allocated(self%nprim))     deallocate(self%nprim)
   if(allocated(self%primcount)) deallocate(self%primcount)
   if(allocated(self%caoshell))  deallocate(self%caoshell)
   if(allocated(self%saoshell))  deallocate(self%saoshell)
   if(allocated(self%fila))      deallocate(self%fila)
   if(allocated(self%fila2))     deallocate(self%fila2)
   if(allocated(self%lao))       deallocate(self%lao)
   if(allocated(self%lao2))      deallocate(self%lao2)
   if(allocated(self%aoat))      deallocate(self%aoat2)
   if(allocated(self%valao))     deallocate(self%valao)
   if(allocated(self%valao2))    deallocate(self%valao2)
   if(allocated(self%zeta))      deallocate(self%zeta)
   if(allocated(self%level))     deallocate(self%level)
end subroutine deallocate_basisset

!========================================================================================!
subroutine newBasisset(xtbData,n,at,basis,ok)
   type(TxTBData_mod), intent(in) :: xtbData
   type(TBasisset),intent(inout) :: basis
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   logical, intent(out) :: ok

   integer  :: elem,valao
   integer  :: i,j,m,l,iat,ati,ish,ibf,iao,ipr,p,nprim,thisprimR,idum,npq,npqR,pqn
   real(wp) :: a(10),c(10),zeta,k1,k2,split1,pp,zqfR,zcnfR,qi,level
   real(wp) :: aR(10),cR(10),ss
   real(wp) :: as(10),cs(10)
   integer :: info

   call xbasis0(xtbData,n,at,basis)

   basis%hdiag(1:basis%nbf)=1.d+42

   ibf=0
   iao=0
   ipr=0
   ish=0
   ok=.true.

   atoms: do iat=1,n
      ati = at(iat)
      basis%shells(1,iat)=ish+1
      basis%fila  (1,iat)=ibf+1
      basis%fila2 (1,iat)=iao+1
      shells: do m=1,xtbData%nShell(ati)
         ish = ish+1
         ! principle QN
         npq=xtbData%hamiltonian%principalQuantumNumber(m,ati)
         l=xtbData%hamiltonian%angShell(m,ati)

         level = xtbData%hamiltonian%selfEnergy(m,ati)
         zeta  = xtbData%hamiltonian%slaterExponent(m,ati)
         valao = xtbData%hamiltonian%valenceShell(m,ati)
         if (valao /= 0) then
            nprim = xtbData%hamiltonian%numberOfPrimitives(m,ati)
         else
            thisprimR = xtbData%hamiltonian%numberOfPrimitives(m,ati)
         end if

         basis%lsh(ish) = l
         basis%ash(ish) = iat
         basis%sh2bf(1,ish) = ibf
         basis%sh2ao(1,ish) = iao
         basis%caoshell(m,iat)=ibf
         basis%saoshell(m,iat)=iao

         ! add new shellwise information, for easier reference
         basis%level(ish) = level
         basis%zeta (ish) = zeta
         basis%valsh(ish) = valao

         ! H-He
         if(l.eq.0.and.ati.le.2.and.valao/=0)then
            ! s
            call slaterToGauss(nprim, npq, l, zeta, a, c, .true., info)
            basis%minalp(ish) = minval(a(:nprim))

            ibf =ibf+1
            basis%primcount(ibf) = ipr
            basis%valao    (ibf) = valao
            basis%aoat     (ibf) = iat
            basis%lao      (ibf) = 1
            basis%nprim    (ibf) = nprim
            basis%hdiag    (ibf) = level

            do p=1,nprim
               ipr=ipr+1
               basis%alp (ipr)=a(p)
               basis%cont(ipr)=c(p)
            enddo

            iao = iao+1
            basis%valao2(iao) = valao
            basis%aoat2 (iao) = iat
            basis%lao2  (iao) = 1
            basis%hdiag2(iao) = level
            basis%aoexp (iao) = zeta
            basis%ao2sh (iao) = ish
         endif

         if(l.eq.0.and.ati.le.2.and.valao==0)then
            ! diff s
            call slaterToGauss(thisprimR, npq, l, zeta, aR, cR, .true., info)
            call atovlp(0,nprim,thisprimR,a,aR,c,cR,ss)
            basis%minalp(ish) = min(minval(a(:nprim)),minval(aR(:thisprimR)))

            ibf =ibf+1
            basis%primcount(ibf) = ipr
            basis%valao    (ibf) = valao
            basis%aoat     (ibf) = iat
            basis%lao      (ibf) = 1
            basis%nprim    (ibf) = thisprimR+nprim
            basis%hdiag    (ibf) = level

            idum=ipr+1
            do p=1,thisprimR
               ipr=ipr+1
               basis%alp (ipr)=aR(p)
               basis%cont(ipr)=cR(p)
            enddo
            do p=1,nprim
               ipr=ipr+1
               basis%alp (ipr)=a(p)
               basis%cont(ipr)=-ss*c(p)
            enddo
            call atovlp(0,basis%nprim(ibf),basis%nprim(ibf), &
               &        basis%alp(idum),basis%alp(idum), &
               &        basis%cont(idum),basis%cont(idum),ss)
            do p=1,basis%nprim(ibf)
               basis%cont(idum-1+p)=basis%cont(idum-1+p)/sqrt(ss)
            enddo

            iao = iao+1
            basis%valao2(iao) = valao
            basis%aoat2 (iao) = iat
            basis%lao2  (iao) = 1
            basis%hdiag2(iao) = level
            basis%aoexp (iao) = zeta
            basis%ao2sh (iao) = ish
         endif

         ! p polarization
         if(l.eq.1.and.ati.le.2)then
            call slaterToGauss(nprim, npq, l, zeta, a, c, .true., info)
            basis%minalp(ish) = minval(a(:nprim))
            do j=2,4
               ibf=ibf+1
               basis%primcount(ibf) = ipr
               basis%aoat     (ibf) = iat
               basis%lao      (ibf) = j
               basis%valao    (ibf) = -valao
               basis%nprim    (ibf) = nprim
               basis%hdiag    (ibf) = level

               do p=1,nprim
                  ipr=ipr+1
                  basis%alp (ipr)=a(p)
                  basis%cont(ipr)=c(p)
               enddo

               iao = iao+1
               basis%valao2(iao) = -valao
               basis%aoat2 (iao) = iat
               basis%lao2  (iao) = j
               basis%hdiag2(iao) = level
               basis%aoexp (iao) = zeta
               basis%ao2sh (iao) = ish
            enddo
         endif

         ! general sp
         if(l.eq.0.and.ati.gt.2 .and. valao/=0)then
            ! s
            call slaterToGauss(nprim, npq, l, zeta, as, cs, .true., info)
            basis%minalp(ish) = minval(as(:nprim))

            ibf=ibf+1
            basis%primcount(ibf) = ipr
            basis%valao    (ibf) = valao
            basis%aoat     (ibf) = iat
            basis%lao      (ibf) = 1
            basis%nprim    (ibf) = nprim
            basis%hdiag    (ibf) = level

            do p=1,nprim
               ipr=ipr+1
               basis%alp (ipr)=as(p)
               basis%cont(ipr)=cs(p)
            enddo

            iao = iao+1
            basis%valao2(iao) = valao
            basis%aoat2 (iao) = iat
            basis%lao2  (iao) = 1
            basis%hdiag2(iao) = level
            basis%aoexp (iao) = zeta
            basis%ao2sh (iao) = ish
         endif
         ! p
         if(l.eq.1.and.ati.gt.2)then
            call slaterToGauss(nprim, npq, l, zeta, a, c, .true., info)
            basis%minalp(ish) = minval(a(:nprim))
            do j=2,4
               ibf=ibf+1
               basis%primcount(ibf) = ipr
               basis%valao    (ibf) = valao
               basis%aoat     (ibf) = iat
               basis%lao      (ibf) = j
               basis%nprim    (ibf) = nprim
               basis%hdiag    (ibf) = level

               do p=1,nprim
                  ipr=ipr+1
                  basis%alp (ipr)=a(p)
                  basis%cont(ipr)=c(p)
               enddo

               iao = iao+1
               basis%valao2(iao) = valao
               basis%aoat2 (iao) = iat
               basis%lao2  (iao) = j
               basis%hdiag2(iao) = level
               basis%aoexp (iao) = zeta
               basis%ao2sh (iao) = ish
            enddo
         endif

         ! DZ s
         if(l.eq.0 .and. ati > 2 .and. valao==0)then
            call slaterToGauss(thisprimR, npq, l, zeta, aR, cR, .true., info)
            call atovlp(0,nprim,thisprimR,as,aR,cs,cR,ss)
            basis%minalp(ish) = min(minval(as(:nprim)),minval(aR(:thisprimR)))

            ibf=ibf+1
            basis%primcount(ibf) = ipr
            basis%valao    (ibf) = valao
            basis%aoat     (ibf) = iat
            basis%lao      (ibf) = 1
            basis%nprim    (ibf) = thisprimR+nprim
            basis%hdiag    (ibf) = level

            idum=ipr+1
            do p=1,thisprimR
               ipr=ipr+1
               basis%alp (ipr)=aR(p)
               basis%cont(ipr)=cR(p)
            enddo
            do p=1,nprim
               ipr=ipr+1
               basis%alp (ipr)=as(p)
               basis%cont(ipr)=-ss*cs(p)
            enddo
            call atovlp(0,basis%nprim(ibf),basis%nprim(ibf), &
               &        basis%alp(idum),basis%alp(idum), &
               &        basis%cont(idum),basis%cont(idum),ss)
            do p=1,basis%nprim(ibf)
               basis%cont(idum-1+p)=basis%cont(idum-1+p)/sqrt(ss)
            enddo

            iao = iao+1
            basis%valao2(iao) = valao
            basis%aoat2 (iao) = iat
            basis%lao2  (iao) = 1
            basis%hdiag2(iao) = level
            basis%aoexp (iao) = zeta
            basis%ao2sh (iao) = ish
         endif

         ! d
         if(l.eq.2)then
            call set_d_function(basis,iat,ish,iao,ibf,ipr, &
               &                npq,l,nprim,zeta,level,valao)
         endif

         ! f
         if(l.eq.3)then
            call set_f_function(basis,iat,ish,iao,ibf,ipr, &
               &                npq,l,nprim,zeta,level,1)
         endif

         basis%sh2bf(2,ish) = ibf-basis%sh2bf(1,ish)
         basis%sh2ao(2,ish) = iao-basis%sh2ao(1,ish)
      enddo shells
      basis%shells(2,iat)=ish
      basis%fila  (2,iat)=ibf
      basis%fila2 (2,iat)=iao
   enddo atoms

   ok = all(basis%alp(:ipr) > 0.0_wp) .and. basis%nbf == ibf .and. basis%nao == iao

end subroutine newBasisset


! ========================================================================
!> determine basisset limits
subroutine xbasis0(xtbData,n,at,basis)
   type(TxTBData_mod), intent(in) :: xtbData
   type(TBasisset),intent(inout) :: basis
   integer,intent(in)  :: n
   integer,intent(in)  :: at(n)
   integer :: nbf
   integer :: nao
   integer :: nshell

   integer i,j,k,l

   call dim_basis(xtbData,n,at,nshell,nao,nbf)

   call basis%allocate(n,nbf,nao,nshell)

end subroutine xbasis0

subroutine dim_basis(xtbData,n,at,nshell,nao,nbf)
   type(TxTBData_mod), intent(in) :: xtbData
   integer,intent(in)  :: n
   integer,intent(in)  :: at(n)
   integer,intent(out) :: nshell
   integer,intent(out) :: nao
   integer,intent(out) :: nbf

   integer i,j,k,l

   nao=0
   nbf=0
   nshell=0

   do i=1,n
      k=0
      do j=1,xtbData%nShell(at(i))
         l = xtbData%hamiltonian%angShell(j,at(i))
         k = k + 1
         nshell=nshell+1
         select case(l)
         case(0) ! s
            nbf = nbf+1
            nao = nao+1
         case(1) ! p
            nbf = nbf+3
            nao = nao+3
         case(2) ! d
            nbf = nbf+6
            nao = nao+5
         case(3) ! f
            nbf = nbf+10
            nao = nao+7
         case(4) ! g
            nbf = nbf+15
            nao = nao+9
         end select
      enddo
      if(k.eq.0) then
         write(*,*) 'no basis found for atom', i,' Z= ',at(i)
         error stop 
      endif
   enddo

end subroutine dim_basis


! ------------------------------------------------------------------------
!  Helper functions

subroutine atovlp(l,npri,nprj,alpa,alpb,conta,contb,ss)
   integer l,npri,nprj
   real(wp) alpa(*),alpb(*)
   real(wp) conta(*),contb(*)
   real(wp) ss

   integer ii,jj
   real(wp) ab,s00,sss,ab05

   SS=0.0_wp
   do ii=1,npri
      do jj=1,nprj
         ab =1./(alpa(ii)+alpb(jj))
         s00=(pi*ab)**1.50_wp
         if(l.eq.0)then
            sss=s00
         endif
         if(l.eq.1)then
            ab05=ab*0.5_wp
            sss=s00*ab05
         endif
         SS=SS+SSS*conta(ii)*contb(jj)
      enddo
   enddo

end subroutine atovlp

subroutine set_s_function(basis,iat,ish,iao,ibf,ipr,npq,l,nprim,zeta,level,valao)
   type(TBasisset), intent(inout) :: basis
   integer, intent(in)    :: iat
   integer, intent(in)    :: ish
   integer, intent(inout) :: ibf
   integer, intent(inout) :: iao
   integer, intent(inout) :: ipr
   integer, intent(in)    :: npq
   integer, intent(in)    :: l
   integer, intent(in)    :: nprim
   integer, intent(in)    :: valao
   real(wp),intent(in)    :: zeta
   real(wp),intent(in)    :: level
   integer  :: p
   real(wp) :: alp(10),cont(10)
   integer :: info

   call slaterToGauss(nprim, npq, l, zeta, alp, cont, .true., info)
   basis%minalp(ish) = minval(alp(:nprim))

   ibf = ibf+1
   basis%primcount(ibf) = ipr
   basis%valao    (ibf) = valao
   basis%aoat     (ibf) = iat
   basis%lao      (ibf) = 1
   basis%nprim    (ibf) = nprim
   basis%hdiag    (ibf) = level

   do p=1,nprim
      ipr = ipr+1
      basis%alp (ipr)=alp (p)
      basis%cont(ipr)=cont(p)
   enddo

   iao = iao+1
   basis%valao2(iao) = valao
   basis%aoat2 (iao) = iat
   basis%lao2  (iao) = 1
   basis%hdiag2(iao) = level
   basis%aoexp (iao) = zeta
   basis%ao2sh (iao) = ish
end subroutine set_s_function

subroutine set_p_function(basis,iat,ish,iao,ibf,ipr,npq,l,nprim,zeta,level,valao)
   type(TBasisset), intent(inout) :: basis
   integer, intent(in)    :: iat
   integer, intent(in)    :: ish
   integer, intent(inout) :: ibf
   integer, intent(inout) :: iao
   integer, intent(inout) :: ipr
   integer, intent(in)    :: npq
   integer, intent(in)    :: l
   integer, intent(in)    :: nprim
   integer, intent(in)    :: valao
   real(wp),intent(in)    :: zeta
   real(wp),intent(in)    :: level
   integer  :: j,p
   real(wp) :: alp(10),cont(10)
   integer :: info

   call slaterToGauss(nprim, npq, l, zeta, alp, cont, .true., info)
   basis%minalp(ish) = minval(alp(:nprim))

   do j = 2, 4

      ibf = ibf+1
      basis%primcount(ibf) = ipr
      basis%valao    (ibf) = valao
      basis%aoat     (ibf) = iat
      basis%lao      (ibf) = j
      basis%nprim    (ibf) = nprim
      basis%hdiag    (ibf) = level

      do p=1,nprim
         ipr = ipr+1
         basis%alp (ipr)=alp (p)
         basis%cont(ipr)=cont(p)
      enddo

      iao = iao+1
      basis%valao2(iao) = valao
      basis%aoat2 (iao) = iat
      basis%lao2  (iao) = j
      basis%hdiag2(iao) = level
      basis%aoexp (iao) = zeta
      basis%ao2sh (iao) = ish

   enddo
end subroutine set_p_function

subroutine set_d_function(basis,iat,ish,iao,ibf,ipr,npq,l,nprim,zeta,level,valao)
   type(TBasisset), intent(inout) :: basis
   integer, intent(in)    :: iat
   integer, intent(in)    :: ish
   integer, intent(inout) :: ibf
   integer, intent(inout) :: iao
   integer, intent(inout) :: ipr
   integer, intent(in)    :: npq
   integer, intent(in)    :: l
   integer, intent(in)    :: nprim
   integer, intent(in)    :: valao
   real(wp),intent(in)    :: zeta
   real(wp),intent(in)    :: level
   integer  :: j,p
   real(wp) :: alp(10),cont(10)
   real(wp) :: trafo(5:10) = &
      & [1.0_wp, 1.0_wp, 1.0_wp, sqrt(3.0_wp), sqrt(3.0_wp), sqrt(3.0_wp)]
   integer :: info

   call slaterToGauss(nprim, npq, l, zeta, alp, cont, .true., info)
   basis%minalp(ish) = minval(alp(:nprim))

   do j = 5, 10

      ibf = ibf+1
      basis%primcount(ibf) = ipr
      basis%valao    (ibf) = valao
      basis%aoat     (ibf) = iat
      basis%lao      (ibf) = j
      basis%nprim    (ibf) = nprim
      basis%hdiag    (ibf) = level

      do p=1,nprim
         ipr = ipr+1
         basis%alp (ipr)=alp (p)
         basis%cont(ipr)=cont(p)*trafo(j)
      enddo

      if (j .eq. 5) cycle

      iao = iao+1
      basis%valao2(iao) = valao
      basis%aoat2 (iao) = iat
      basis%lao2  (iao) = j-1
      basis%hdiag2(iao) = level
      basis%aoexp (iao) = zeta
      basis%ao2sh (iao) = ish

   enddo
end subroutine set_d_function

subroutine set_f_function(basis,iat,ish,iao,ibf,ipr,npq,l,nprim,zeta,level,valao)
   type(TBasisset), intent(inout) :: basis
   integer, intent(in)    :: iat
   integer, intent(in)    :: ish
   integer, intent(inout) :: ibf
   integer, intent(inout) :: iao
   integer, intent(inout) :: ipr
   integer, intent(in)    :: npq
   integer, intent(in)    :: l
   integer, intent(in)    :: nprim
   integer, intent(in)    :: valao
   real(wp),intent(in)    :: zeta
   real(wp),intent(in)    :: level
   integer  :: j,p
   real(wp) :: alp(10),cont(10)
   real(wp) :: trafo(11:20) = &
      & [1.0_wp, 1.0_wp, 1.0_wp, sqrt(5.0_wp), sqrt(5.0_wp), &
      &  sqrt(5.0_wp), sqrt(5.0_wp), sqrt(5.0_wp), sqrt(5.0_wp), sqrt(15.0_wp)]
   integer :: info

   call slaterToGauss(nprim, npq, l, zeta, alp, cont, .true., info)
   basis%minalp(ish) = minval(alp(:nprim))

   do j = 11, 20

      ibf = ibf+1
      basis%primcount(ibf) = ipr
      basis%valao    (ibf) = valao
      basis%aoat     (ibf) = iat
      basis%lao      (ibf) = j
      basis%nprim    (ibf) = nprim
      basis%hdiag    (ibf) = level

      do p=1,nprim
         ipr = ipr+1
         basis%alp (ipr)=alp (p)
         basis%cont(ipr)=cont(p)*trafo(j)
      enddo

      if (j.ge.11 .and. j.le.13) cycle

      iao = iao+1
      basis%valao2(iao) = valao
      basis%aoat2 (iao) = iat
      basis%lao2  (iao) = j-3
      basis%hdiag2(iao) = level
      basis%aoexp (iao) = zeta
      basis%ao2sh (iao) = ish

   enddo
end subroutine set_f_function

!========================================================================================!
!========================================================================================!
end module gfn0_basisset

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!================================================================================!
module gfn0_math_wrapper
!> module gfn0_math_wrapper
!> contains some interfaces to LAPACK and BLAS routines
!> which must be included via a suitable library.
  use iso_fortran_env,only:wp => real64,sp => real32,stderr => error_unit
  implicit none
  public

  interface contract
    module procedure contract312
    module procedure contract323
  end interface contract

  interface dot
    module procedure sdot_wrap
    module procedure ddot_wrap
  end interface dot

  interface symv
    module procedure ssymv_wrap
    module procedure dsymv_wrap
  end interface symv

  interface gemv
    module procedure sgemv_wrap
    module procedure dgemv_wrap
    module procedure dgemv312_wrap
  end interface gemv

  interface gemm
    module procedure sgemm_wrap
    module procedure dgemm_wrap
  end interface gemm

  interface sytrf_wrap
    module procedure ssytrf_wrap
    module procedure dsytrf_wrap
  end interface sytrf_wrap
  interface lapack_sytrf
    pure subroutine ssytrf(uplo,n,a,lda,ipiv,work,lwork,info)
      import :: sp
      real(sp),intent(inout) :: a(lda,*)
      character(len=1),intent(in) :: uplo
      integer,intent(out) :: ipiv(*)
      integer,intent(out) :: info
      integer,intent(in) :: n
      integer,intent(in) :: lda
      real(sp),intent(inout) :: work(*)
      integer,intent(in) :: lwork
    end subroutine ssytrf
    pure subroutine dsytrf(uplo,n,a,lda,ipiv,work,lwork,info)
      import :: wp
      real(wp),intent(inout) :: a(lda,*)
      character(len=1),intent(in) :: uplo
      integer,intent(out) :: ipiv(*)
      integer,intent(out) :: info
      integer,intent(in) :: n
      integer,intent(in) :: lda
      real(wp),intent(inout) :: work(*)
      integer,intent(in) :: lwork
    end subroutine dsytrf
  end interface lapack_sytrf

  interface lapack_sytri
    module procedure ssytri_wrap
    module procedure dsytri_wrap
  end interface lapack_sytri

  interface sytrs_wrap
    module procedure ssytrs_wrap
    module procedure ssytrs1_wrap
    module procedure ssytrs3_wrap
    module procedure dsytrs_wrap
    module procedure dsytrs1_wrap
    module procedure dsytrs3_wrap
  end interface sytrs_wrap
  interface lapack_sytrs
    pure subroutine ssytrs(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
      import :: sp
      real(sp),intent(in) :: a(lda,*)
      real(sp),intent(inout) :: b(ldb,*)
      integer,intent(in) :: ipiv(*)
      character(len=1),intent(in) :: uplo
      integer,intent(out) :: info
      integer,intent(in) :: n
      integer,intent(in) :: nrhs
      integer,intent(in) :: lda
      integer,intent(in) :: ldb
    end subroutine ssytrs
    pure subroutine dsytrs(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
      import :: wp
      real(wp),intent(in) :: a(lda,*)
      real(wp),intent(inout) :: b(ldb,*)
      integer,intent(in) :: ipiv(*)
      character(len=1),intent(in) :: uplo
      integer,intent(out) :: info
      integer,intent(in) :: n
      integer,intent(in) :: nrhs
      integer,intent(in) :: lda
      integer,intent(in) :: ldb
    end subroutine dsytrs
  end interface lapack_sytrs

  interface lapack_sygvd
    module procedure ssygvd_wrap
    module procedure dsygvd_wrap
  end interface lapack_sygvd

contains

!========================================================================================!

!> Determinat of 3×3 matrix
  pure function matDet3x3(a) result(det)

    !> Matrix
    real(wp),intent(in) :: a(3,3)

    !> Determinant
    real(wp) :: det

    det = a(1,1)*a(2,2)*a(3,3)  &
       & -a(1,1)*a(2,3)*a(3,2)  &
       & -a(1,2)*a(2,1)*a(3,3)  &
       & +a(1,2)*a(2,3)*a(3,1)  &
       & +a(1,3)*a(2,1)*a(3,2)  &
       & -a(1,3)*a(2,2)*a(3,1)

  end function matDet3x3

!========================================================================================!
  subroutine contract312(amat,bvec,cvec,alpha,beta)
    !> note: this routine does the same as the gemv312 routines
    real(wp),intent(in),contiguous,target :: amat(:,:,:)
    real(wp),intent(in),contiguous :: bvec(:)
    real(wp),intent(inout),contiguous,target :: cvec(:,:)
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    real(wp),pointer :: aptr(:,:)
    real(wp),pointer :: cptr(:)

    integer :: nn,mm
    real(wp) :: aa,bb
    !> BLAS
    external :: dgemv

    aa = 1.0_wp
    if (present(alpha)) aa = alpha
    bb = 0.0_wp
    if (present(beta)) bb = beta

    nn = size(amat,dim=1)*size(amat,dim=2)
    mm = size(amat,dim=3)
    aptr(1:size(amat,dim=1)*size(amat,dim=2),1:size(amat,dim=3)) => amat
    cptr(1:size(cvec,dim=1)*size(cvec,dim=2)) => cvec

    call dgemv('n',nn,mm,aa,aptr,nn,bvec,1,bb,cptr,1)

  end subroutine contract312
!========================================================================================!
  subroutine contract323(amat,bmat,cmat,alpha,beta)

    real(wp),intent(in),contiguous,target :: amat(:,:,:)
    real(wp),intent(in),contiguous :: bmat(:,:)
    real(wp),intent(inout),contiguous,target :: cmat(:,:,:)
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    real(wp),pointer :: aptr(:,:)
    real(wp),pointer :: cptr(:,:)

    integer :: nn,mm,kk
    real(wp) :: aa,bb
    !> BLAS
    external :: dgemm

    aa = 1.0_wp
    if (present(alpha)) aa = alpha
    bb = 0.0_wp
    if (present(beta)) bb = beta

    nn = size(amat,dim=1)*size(amat,dim=2)
    mm = size(amat,dim=3)
    kk = size(cmat,dim=3)
    aptr(1:size(amat,dim=1)*size(amat,dim=2),1:size(amat,dim=3)) => amat
    cptr(1:size(cmat,dim=1)*size(cmat,dim=2),1:size(cmat,dim=3)) => cmat

    call dgemm('n','n',nn,kk,mm,aa,aptr,nn,bmat,mm,bb,cptr,nn)

  end subroutine contract323
!========================================================================================!
!> The DOT routines perform the dot product of two vectors
!> dot = ∑ᵢ xᵢyᵢ
  function sdot_wrap(xvec,yvec) result(dotp)
    real(sp) :: dotp
    real(sp),intent(in) :: xvec(:)
    real(sp),intent(in) :: yvec(:)
    integer :: incx,incy,n
    !> BLAS
    real(sp),external :: sdot
    incx = 1
    incy = 1
    n = size(xvec)
    dotp = sdot(n,xvec,incx,yvec,incy)
  end function sdot_wrap
  function ddot_wrap(xvec,yvec) result(dotp)
    real(wp) :: dotp
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(in) :: yvec(:)
    integer :: incx,incy,n
    !> BLAS
    real(wp),external :: ddot
    incx = 1
    incy = 1
    n = size(xvec)
    dotp = ddot(n,xvec,incx,yvec,incy)
  end function ddot_wrap
!=======================================================================================!
!> SYMV  performs the matrix-vector  operation
!>
!>   y := α*A*x + β*y,
!>
!> where α and β are scalars, x and y are n element vectors and
!> A is an n by n symmetric matrix.
  subroutine ssymv_wrap(amat,xvec,yvec,uplo,alpha,beta)
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(in) :: xvec(:)
    real(sp),intent(inout) :: yvec(:)
    character(len=1),intent(in),optional :: uplo
    real(sp),intent(in),optional :: alpha
    real(sp),intent(in),optional :: beta
    character(len=1) :: ula
    real(sp) :: a,b
    integer :: incx,incy,n,lda
    !> BLAS
    external :: ssymv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_sp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    n = size(amat,2)
    call ssymv(ula,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine ssymv_wrap
  subroutine dsymv_wrap(amat,xvec,yvec,uplo,alpha,beta)
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(inout) :: yvec(:)
    character(len=1),intent(in),optional :: uplo
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    character(len=1) :: ula
    real(wp) :: a,b
    integer :: incx,incy,n,lda
    !> BLAS
    external :: dsymv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_wp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    n = size(amat,2)
    call dsymv(ula,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine dsymv_wrap
!=======================================================================================!
!>  SYTRF computes the factorization of a real symmetric matrix A using
!>  the Bunch-Kaufman diagonal pivoting method.  The form of the
!>  factorization is
!>
!>     A = U**T*D*U  or  A = L*D*L**T
!>
!>  where U (or L) is a product of permutation and unit upper (lower)
!>  triangular matrices, and D is symmetric and block diagonal with
!>  1-by-1 and 2-by-2 diagonal blocks.

!  subroutine ssytrf_wrap(uplo,n,a,lda,ipiv,work,lwork,info)
!    real(sp),intent(inout) :: a(lda,*)
!    character(len=1),intent(in) :: uplo
!    integer,intent(out) :: ipiv(*)
!    integer,intent(out) :: info
!    integer,intent(in) :: n
!    integer,intent(in) :: lda
!    real(sp),intent(inout) :: work(*)
!    integer,intent(in) :: lwork
!    !> LAPACK
!    external :: ssytrf
!    call ssytrf(uplo,n,a,lda,ipiv,work,lwork,info)
!  end subroutine ssytrf_wrap
  subroutine ssytrf_wrap(amat,ipiv,info,uplo)
    character(len=*),parameter :: source = 'lapack_sytrf'
    real(sp),intent(inout) :: amat(:,:)
    integer,intent(out) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    character(len=1) :: ula
    integer :: n,lda,lwork,stat_alloc,stat_dealloc
    real(sp),allocatable :: work(:)
    real(sp) :: test(1)
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    lda = max(1,size(amat,1))
    n = size(amat,2)
    stat_alloc = 0
    lwork = -1
    call lapack_sytrf(ula,n,amat,lda,ipiv,test,lwork,info)
    if (info == 0) then
      lwork = nint(test(1))
      if (stat_alloc == 0) then
        allocate (work(lwork),stat=stat_alloc)
      end if
      if (stat_alloc == 0) then
        call lapack_sytrf(ula,n,amat,lda,ipiv,work,lwork,info)
      else
        info = -1000
      end if
      deallocate (work,stat=stat_dealloc)
    end if
    if (info /= 0) then
      write (stderr,'("Factorisation of matrix failed ",a)') source
    end if
  end subroutine ssytrf_wrap

!  subroutine dsytrf_wrap(uplo,n,a,lda,ipiv,work,lwork,info)
!    real(wp),intent(inout) :: a(lda,*)
!    character(len=1),intent(in) :: uplo
!    integer,intent(out) :: ipiv(*)
!    integer,intent(out) :: info
!    integer,intent(in) :: n
!    integer,intent(in) :: lda
!    real(wp),intent(inout) :: work(*)
!    integer,intent(in) :: lwork
!    !> LAPACK
!    external :: dsytrf
!    call dsytrf(uplo,n,a,lda,ipiv,work,lwork,info)
!  end subroutine dsytrf_wrap
  subroutine dsytrf_wrap(amat,ipiv,info,uplo)
    character(len=*),parameter :: source = 'lapack_sytrf'
    real(wp),intent(inout) :: amat(:,:)
    integer,intent(out) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    character(len=1) :: ula
    integer :: n,lda,lwork,stat_alloc,stat_dealloc
    real(wp),allocatable :: work(:)
    real(wp) :: test(1)
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    lda = max(1,size(amat,1))
    n = size(amat,2)
    stat_alloc = 0
    lwork = -1
    call lapack_sytrf(ula,n,amat,lda,ipiv,test,lwork,info)
    if (info == 0) then
      lwork = nint(test(1))
      if (stat_alloc == 0) then
        allocate (work(lwork),stat=stat_alloc)
      end if
      if (stat_alloc == 0) then
        call lapack_sytrf(ula,n,amat,lda,ipiv,work,lwork,info)
      else
        info = -1000
      end if
      deallocate (work,stat=stat_dealloc)
    end if
    if (info /= 0) then
      write (stderr,'("Factorisation of matrix failed ",a)') source
    end if
  end subroutine dsytrf_wrap

!=======================================================================================!
!> SYTRI computes the inverse of a real symmetric indefinite matrix
!> A using the factorization A = U*D*U**T or A = L*D*L**T computed by
!> SYTRF.
  subroutine ssytri_wrap(uplo,n,a,lda,ipiv,work,info)
    real(sp),intent(inout) :: a(lda,*)
    integer,intent(in) :: ipiv(*)
    character(len=1),intent(in) :: uplo
    integer,intent(out) :: info
    integer,intent(in) :: n
    integer,intent(in) :: lda
    real(sp),intent(in) :: work(*)
    !> LAPACK
    external :: ssytri
    call ssytri(uplo,n,a,lda,ipiv,work,info)
  end subroutine ssytri_wrap
  subroutine dsytri_wrap(uplo,n,a,lda,ipiv,work,info)
    real(wp),intent(inout) :: a(lda,*)
    integer,intent(in) :: ipiv(*)
    character(len=1),intent(in) :: uplo
    integer,intent(out) :: info
    integer,intent(in) :: n
    integer,intent(in) :: lda
    real(wp),intent(in) :: work(*)
    !> LAPACK
    external :: dsytri
    call dsytri(uplo,n,a,lda,ipiv,work,info)
  end subroutine dsytri_wrap

!=======================================================================================!
!> DSYTRS solves a system of linear equations A*X = B with a real
!> symmetric matrix A using the factorization A = U*D*U**T or
!>  A = L*D*L**T computed by DSYTRF.
  subroutine ssytrs_wrap(amat,bmat,ipiv,info,uplo)
    character(len=*),parameter :: source = 'lapack_sytrs'
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(inout) :: bmat(:,:)
    integer,intent(in) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    character(len=1) :: ula
    integer :: n,nrhs,lda,ldb
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    lda = max(1,size(amat,1))
    ldb = max(1,size(bmat,1))
    n = size(amat,2)
    nrhs = size(bmat,2)
    call lapack_sytrs(ula,n,nrhs,amat,lda,ipiv,bmat,ldb,info)
    if (info /= 0) then
      write (stderr,'("Solving linear system failed ",a)') source
    end if
  end subroutine ssytrs_wrap
  subroutine ssytrs1_wrap(amat,bvec,ipiv,info,uplo)
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(inout),target :: bvec(:)
    integer,intent(in) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    real(sp),pointer :: bptr(:,:)
    bptr(1:size(bvec),1:1) => bvec
    call ssytrs_wrap(amat,bptr,ipiv,info,uplo)
  end subroutine ssytrs1_wrap
  subroutine ssytrs3_wrap(amat,bmat,ipiv,info,uplo)
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(inout),contiguous,target :: bmat(:,:,:)
    integer,intent(in) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    real(sp),pointer :: bptr(:,:)
    bptr(1:size(bmat,1),1:size(bmat,2)*size(bmat,3)) => bmat
    call ssytrs_wrap(amat,bptr,ipiv,info,uplo)
  end subroutine ssytrs3_wrap

  subroutine dsytrs_wrap(amat,bmat,ipiv,info,uplo)
    character(len=*),parameter :: source = 'lapack_sytrs'
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(inout) :: bmat(:,:)
    integer,intent(in) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    character(len=1) :: ula
    integer :: n,nrhs,lda,ldb
    if (present(uplo)) then
      ula = uplo
    else
      ula = 'u'
    end if
    lda = max(1,size(amat,1))
    ldb = max(1,size(bmat,1))
    n = size(amat,2)
    nrhs = size(bmat,2)
    call lapack_sytrs(ula,n,nrhs,amat,lda,ipiv,bmat,ldb,info)
    if (info /= 0) then
      write (stderr,'("Solving linear system failed ",a)') source
    end if
  end subroutine dsytrs_wrap
  subroutine dsytrs1_wrap(amat,bvec,ipiv,info,uplo)
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(inout),target :: bvec(:)
    integer,intent(in) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    real(wp),pointer :: bptr(:,:)
    bptr(1:size(bvec),1:1) => bvec
    call dsytrs_wrap(amat,bptr,ipiv,info,uplo)
  end subroutine dsytrs1_wrap
  subroutine dsytrs3_wrap(amat,bmat,ipiv,info,uplo)
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(inout),contiguous,target :: bmat(:,:,:)
    integer,intent(in) :: ipiv(:)
    integer,intent(out) :: info
    character(len=1),intent(in),optional :: uplo
    real(wp),pointer :: bptr(:,:)
    bptr(1:size(bmat,1),1:size(bmat,2)*size(bmat,3)) => bmat
    call dsytrs_wrap(amat,bptr,ipiv,info,uplo)
  end subroutine dsytrs3_wrap

!=======================================================================================!
!> DGEMV  performs one of the matrix-vector operations
!>
!>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
!>
!> where alpha and beta are scalars, x and y are vectors and A is an
!> m by n matrix.
  subroutine sgemv_wrap(amat,xvec,yvec,alpha,beta,trans)
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(in) :: xvec(:)
    real(sp),intent(inout) :: yvec(:)
    real(sp),intent(in),optional :: alpha
    real(sp),intent(in),optional :: beta
    character(len=1),intent(in),optional :: trans
    real(sp) :: a,b
    character(len=1) :: tra
    integer :: incx,incy,m,n,lda
    !> BLAS
    external :: sgemv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_sp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(trans)) then
      tra = trans
    else
      tra = 'n'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    m = size(amat,1)
    n = size(amat,2)
    call sgemv(tra,m,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine sgemv_wrap
  subroutine dgemv_wrap(amat,xvec,yvec,alpha,beta,trans)
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(inout) :: yvec(:)
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    character(len=1),intent(in),optional :: trans
    real(wp) :: a,b
    character(len=1) :: tra
    integer :: incx,incy,m,n,lda
    !> BLAS
    external :: dgemv
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_wp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0
    end if
    if (present(trans)) then
      tra = trans
    else
      tra = 'n'
    end if
    incx = 1
    incy = 1
    lda = max(1,size(amat,1))
    m = size(amat,1)
    n = size(amat,2)
    call dgemv(tra,m,n,a,amat,lda,xvec,incx,b,yvec,incy)
  end subroutine dgemv_wrap
  subroutine dgemv312_wrap(amat,xvec,yvec,alpha,beta,trans)
    real(wp),intent(in),contiguous,target :: amat(:,:,:)
    real(wp),intent(in) :: xvec(:)
    real(wp),intent(inout),contiguous,target :: yvec(:,:)
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    character(len=1),intent(in),optional :: trans
    real(wp),pointer :: aptr(:,:),yptr(:)
    character(len=1) :: tra
    if (present(trans)) then
      tra = trans
    else
      tra = 'n'
    end if
    if (any(tra == ['n','N'])) then
      aptr(1:size(amat,1)*size(amat,2),1:size(amat,3)) => amat
      yptr(1:size(yvec,1)*size(yvec,2)) => yvec
    else
      aptr(1:size(amat,1),1:size(amat,2)*size(amat,3)) => amat
      yptr(1:size(yvec,1)*size(yvec,2)) => yvec
    end if
    call dgemv_wrap(aptr,xvec,yptr,alpha,beta,tra)
  end subroutine dgemv312_wrap
!=======================================================================================!
!     DGEMM  performs one of the matrix-matrix operations
!
!        C := alpha*op( A )*op( B ) + beta*C,
!
!     where  op( X ) is one of
!
!        op( X ) = X   or   op( X ) = X**T,
!
!     alpha and beta are scalars, and A, B and C are matrices, with op( A )
!     an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
  pure subroutine dgemm_wrap(amat,bmat,cmat,transa,transb,alpha,beta)
    real(wp),intent(in) :: amat(:,:)
    real(wp),intent(in) :: bmat(:,:)
    real(wp),intent(inout) :: cmat(:,:)
    character(len=1),intent(in),optional :: transa
    character(len=1),intent(in),optional :: transb
    real(wp),intent(in),optional :: alpha
    real(wp),intent(in),optional :: beta
    character(len=1) :: tra,trb
    real(wp) :: a,b
    integer :: m,n,k,lda,ldb,ldc
    !> BLAS
    interface
      pure subroutine dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb, &
            & beta,c,ldc)
        import :: wp
        real(wp),intent(in) :: a(lda,*)
        real(wp),intent(in) :: b(ldb,*)
        real(wp),intent(inout) :: c(ldc,*)
        character(len=1),intent(in) :: transa
        character(len=1),intent(in) :: transb
        real(wp),intent(in) :: alpha
        real(wp),intent(in) :: beta
        integer,intent(in) :: m
        integer,intent(in) :: n
        integer,intent(in) :: k
        integer,intent(in) :: lda
        integer,intent(in) :: ldb
        integer,intent(in) :: ldc
      end subroutine dgemm
    end interface
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_wp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0.0_wp
    end if
    if (present(transa)) then
      tra = transa
    else
      tra = 'n'
    end if
    if (present(transb)) then
      trb = transb
    else
      trb = 'n'
    end if
    if ((tra .eq. 'n'.or.tra .eq. 'N')) then
      k = size(amat,2)
    else
      k = size(amat,1)
    end if
    lda = max(1,size(amat,1))
    ldb = max(1,size(bmat,1))
    ldc = max(1,size(cmat,1))
    m = size(cmat,1)
    n = size(cmat,2)

    call dgemm(tra,trb,m,n,k,a,amat,lda,bmat,ldb,b,cmat,ldc)
  end subroutine dgemm_wrap
  pure subroutine sgemm_wrap(amat,bmat,cmat,transa,transb,alpha,beta)
    real(sp),intent(in) :: amat(:,:)
    real(sp),intent(in) :: bmat(:,:)
    real(sp),intent(inout) :: cmat(:,:)
    character(len=1),intent(in),optional :: transa
    character(len=1),intent(in),optional :: transb
    real(sp),intent(in),optional :: alpha
    real(sp),intent(in),optional :: beta
    character(len=1) :: tra,trb
    real(sp) :: a,b
    integer :: m,n,k,lda,ldb,ldc
    !> BLAS
    interface
      pure subroutine sgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb, &
            & beta,c,ldc)
        import :: sp
        real(sp),intent(in) :: a(lda,*)
        real(sp),intent(in) :: b(ldb,*)
        real(sp),intent(inout) :: c(ldc,*)
        character(len=1),intent(in) :: transa
        character(len=1),intent(in) :: transb
        real(sp),intent(in) :: alpha
        real(sp),intent(in) :: beta
        integer,intent(in) :: m
        integer,intent(in) :: n
        integer,intent(in) :: k
        integer,intent(in) :: lda
        integer,intent(in) :: ldb
        integer,intent(in) :: ldc
      end subroutine sgemm
    end interface
    if (present(alpha)) then
      a = alpha
    else
      a = 1.0_sp
    end if
    if (present(beta)) then
      b = beta
    else
      b = 0.0_sp
    end if
    if (present(transa)) then
      tra = transa
    else
      tra = 'n'
    end if
    if (present(transb)) then
      trb = transb
    else
      trb = 'n'
    end if
    if ((tra .eq. 'n'.or.tra .eq. 'N')) then
      k = size(amat,2)
    else
      k = size(amat,1)
    end if
    lda = max(1,size(amat,1))
    ldb = max(1,size(bmat,1))
    ldc = max(1,size(cmat,1))
    m = size(cmat,1)
    n = size(cmat,2)
    call sgemm(tra,trb,m,n,k,a,amat,lda,bmat,ldb,b,cmat,ldc)
  end subroutine sgemm_wrap
!=======================================================================================!
! SYGVD computes all the eigenvalues, and optionally, the eigenvectors
! of a real generalized symmetric-definite eigenproblem, of the form
! A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
! B are assumed to be symmetric and B is also positive definite.
! If eigenvectors are desired, it uses a divide and conquer algorithm.
  subroutine ssygvd_wrap(itype,jobz,uplo,n,a,lda,b,ldb,w,info)
    real(sp),intent(inout) :: a(lda,*)
    real(sp),intent(inout) :: b(ldb,*)
    real(sp),intent(out) :: w(*)
    integer,intent(in) :: itype
    character(len=1),intent(in) :: jobz
    character(len=1),intent(in) :: uplo
    integer,intent(out) :: info
    integer,intent(in) :: n
    integer,intent(in) :: lda
    integer,intent(in) :: ldb
    real(sp),allocatable :: work(:)
    integer              :: lwork
    integer,allocatable  :: iwork(:)
    integer              :: liwork
    !> LAPACK
    interface
      pure subroutine ssygvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork, &
            & iwork,liwork,info)
        import :: sp
        real(sp),intent(inout) :: a(lda,*)
        real(sp),intent(inout) :: b(ldb,*)
        real(sp),intent(out) :: w(*)
        integer,intent(in) :: itype
        character(len=1),intent(in) :: jobz
        character(len=1),intent(in) :: uplo
        integer,intent(out) :: info
        integer,intent(in) :: n
        integer,intent(in) :: lda
        integer,intent(in) :: ldb
        real(sp),intent(inout) :: work(*)
        integer,intent(in) :: lwork
        integer,intent(inout) :: iwork(*)
        integer,intent(in) :: liwork
      end subroutine ssygvd
    end interface
    allocate (work(1),iwork(1))
    !>--- workspace query
    call ssygvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work, &
   &           -1,iwork,liwork,info)
    lwork = int(work(1))
    liwork = iwork(1)
    deallocate (work,iwork)
    allocate (work(lwork),iwork(liwork))
    call ssygvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work, &
   &           lwork,iwork,liwork,info)
    deallocate (work,iwork)
  end subroutine ssygvd_wrap

  subroutine dsygvd_wrap(itype,jobz,uplo,n,a,lda,b,ldb,w,info)
    real(wp),intent(inout) :: a(lda,*)
    real(wp),intent(inout) :: b(ldb,*)
    real(wp),intent(out) :: w(*)
    integer,intent(in) :: itype
    character(len=1),intent(in) :: jobz
    character(len=1),intent(in) :: uplo
    integer,intent(out) :: info
    integer,intent(in) :: n
    integer,intent(in)   :: lda
    integer,intent(in)   :: ldb
    real(wp),allocatable :: work(:)
    integer              :: lwork
    integer,allocatable  :: iwork(:)
    integer              :: liwork
    !> LAPACK
    interface
      pure subroutine dsygvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork, &
            & iwork,liwork,info)
        import :: wp
        real(wp),intent(inout) :: a(lda,*)
        real(wp),intent(inout) :: b(ldb,*)
        real(wp),intent(out) :: w(*)
        integer,intent(in) :: itype
        character(len=1),intent(in) :: jobz
        character(len=1),intent(in) :: uplo
        integer,intent(out) :: info
        integer,intent(in) :: n
        integer,intent(in) :: lda
        integer,intent(in) :: ldb
        real(wp),intent(inout) :: work(*)
        integer,intent(in) :: lwork
        integer,intent(inout) :: iwork(*)
        integer,intent(in) :: liwork
      end subroutine dsygvd
    end interface
    allocate (work(1),iwork(1))
    !>--- workspace query
    call dsygvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work, &
   &           -1,iwork,liwork,info)
    lwork = int(work(1))
    liwork = iwork(1)
    deallocate (work,iwork)
    allocate (work(lwork),iwork(liwork))
    call dsygvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work, &
   &           lwork,iwork,liwork,info)
    deallocate (work,iwork)
  end subroutine dsygvd_wrap

!=======================================================================================!
end module gfn0_math_wrapper

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!

!> Implements search algorithms
module solvation_solv_search
   use iso_fortran_env, only : wp => real64
   implicit none
   private

   public :: bisectSearch


   interface bisectSearch
      module procedure :: bisectSearchReal
      module procedure :: bisectSearchInteger
   end interface bisectSearch


contains


!> Integer case for bisection search
pure subroutine bisectSearchInteger(j, xx, x)

   !> Located element such that xx(j) <= x < xx(j+1)
   integer, intent(out) :: j

   !> Array of values in monotonic order to search through
   integer, intent(in) :: xx(:)

   !> Value to locate j for
   integer, intent(in) :: x

   integer :: n
   integer :: jlower, jupper, jcurr

   n = size(xx)
   if (n == 0) then
      j = 0
      return
   end if

   if (x < xx(1)) then
      j = 0
   else if (x == xx(1)) then
      j = 1
   else if (x == xx(n)) then
      j = n - 1
   else if (x > xx(n)) then
      j = n
   else
      jlower=0
      jcurr=n+1
      do while ((jcurr-jlower) > 1)
         jupper=(jcurr+jlower)/2
         if((xx(n) >= xx(1)).eqv.(x >= xx(jupper)))then
            jlower = jupper
         else
            jcurr = jupper
         end if
      end do
      j = jlower
   end if

end subroutine bisectSearchInteger


!> Real case for bisection search
pure subroutine bisectSearchReal(j, xx, x, tol)

   !> Located element such that xx(j) <= x < xx(j+1)
   integer, intent(out) :: j

   !> Array of values in monotonic order to search through
   real(wp), intent(in) :: xx(:)

   !> Value to locate j for
   real(wp), intent(in) :: x

   !> Tolerance for equality comparision
   real(wp), intent(in), optional :: tol

   integer :: n
   integer :: jlower, jupper, jcurr
   real(wp) :: rTol
   logical :: ascending

   n = size(xx)
   if (n == 0) then
      j = 0
      return
   end if

   if (present(tol)) then
      rTol = tol
   else
      rTol = epsilon(0.0_wp)
   end if

   if (x < xx(1) - rTol) then
      j = 0
   else if (abs(x - xx(1)) <= rTol) then
      j = 1
   else if (abs(x - xx(n)) <= rTol) then
      j = n - 1
   else if (x > xx(n) + rTol) then
      j = n
   else
      ascending = (xx(n) >=  xx(1))
      jlower = 0
      jcurr = n+1
      do while ((jcurr-jlower) > 1)
         jupper = (jcurr+jlower)/2
         if (ascending .eqv. (x >= xx(jupper) + rTol)) then
            jlower = jupper
         else
            jcurr = jupper
         end if
      end do
      j = jlower
   end if

end subroutine bisectSearchReal


end module solvation_solv_search

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!================================================================================!
module gfn0_module
  use iso_fortran_env,only:wp => real64,stdout => output_unit

  use gfn0_types
  use gfn0_parameter
  use gfn0_basisset
  use wfn_module
  use gfn0_qm
  use gfn0_prints
  use gfn0_gbsa
  use gfn0_occ
  implicit none
  private

  !> interface to other modules
  public :: TxTBData_mod
  public :: TBasisset
  public :: Twavefunction,wfnsetup
  public :: gfn0_partials
  public :: pr_wfn_param
  public :: pr_orbital_eigenvalues
  public :: gfn0_eht_occ
  public :: generate_config
  public :: gfn0_gbsa_init
  public :: TBorn
  public :: gfn0_solvation

  !> from this module
  public :: initGFN0Params
  public :: gfn0_getCN
  public :: gfn0_electrostatics
  public :: gfn0_dispersion
  public :: gfn0_repulsion
  public :: gfn0_shortranged
  public :: gfn0_eht
  public :: gfn0_eht_var

  !> privat params
  real(wp),private,parameter :: autoev = 27.21138505_wp
  real(wp),private,parameter :: evtoau = 1.0_wp / autoev

contains

!========================================================================================!

  subroutine initGFN0Params(nat,at,xyz,chrg,uhf,basis,xtbData)
!> subroutine initGFN0Params
!> Initialize parametrization and basisset for calculation
!> Note, this information is independent of
!> the molecular geometry, charge and uhf configuration
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in) :: chrg
    integer,intent(in) :: uhf

    type(TBasisset),intent(out)   :: basis   !< basis set info
    type(TxTBData_mod),intent(out) :: xtbData !< main data/parameter frame

    logical :: ok

    !> Get the parametrization
    call initGFN0(xtbData)

    !> Get the basisset
    call newBasisset(xtbData,nat,at,basis,ok)

    return
  end subroutine initGFN0Params

!========================================================================================!

  subroutine gfn0_getCN(nat,at,xyz,cn,dcndr)
!> subroutine gfn0_getCN
!> Calculate coordination number and its Cartesian derivative
    use cn_module
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    !> Coordination number
    real(wp),intent(out) :: cn(:)
    !> Derivative of the coordination number w.r.t. Cartesian coordinates
    real(wp),intent(out) :: dcndr(:,:,:)

    call getCoordinationNumber(nat,at,xyz,40.0_wp,cnType%erf,cn,dcndr)
    call cutCoordinationNumber(nat,cn,dcndr,maxCN=8.0_wp)
    return
  end subroutine gfn0_getCN

!========================================================================================!

  subroutine gfn0_electrostatics(nat,at,xyz,chrg,xtbData, &
     & cn,dcndr,energy,gradient,qat,dqdr,gbsa)
!> subroutine gfn0_electrostatics
!> Calculate atomic charges using the charge equilibirum model (EEQ).
!> Also returns the Cartesian derivative dqdr, as well as the
!> respective isotropic electrostatic energies (IES) and its gradient.
    use eeq_module
    !> INPUTS
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in) :: chrg
    type(TxTBData_mod),intent(in) :: xtbData
    !> Coordination number
    real(wp),intent(in) :: cn(:)
    !> Derivative of the coordination number w.r.t. Cartesian coordinates
    real(wp),intent(in) :: dcndr(:,:,:)
    !> gbsa object
    type(TBorn),intent(inout),optional :: gbsa
    !> OUTPUTS
    !> Electrostatic energy
    real(wp),intent(inout),optional :: energy
    !> Molecular gradient
    real(wp),intent(inout),optional :: gradient(:,:)
    !> Atomic partial charges
    real(wp),intent(out),optional :: qat(:)
    !> Derivative of the partial charges w.r.t. Cartesian coordinates
    real(wp),intent(out),optional :: dqdr(:,:,:)

    if (.not. present(gbsa)) then
      call chargeEquilibration(nat,at,xyz,chrg,cn,dcndr, &
         & xtbData%coulomb%electronegativity,  & !chi
         & xtbData%coulomb%kcn,                & !kcn
         & xtbData%coulomb%chemicalHardness,   & !gam
         & xtbData%coulomb%chargeWidth,        & !rad
         & energy,gradient,qat,dqdr)
    else
      call chargeEquilibration(nat,at,xyz,chrg,cn,dcndr, &
         & xtbData%coulomb%electronegativity,  & !chi
         & xtbData%coulomb%kcn,                & !kcn
         & xtbData%coulomb%chemicalHardness,   & !gam
         & xtbData%coulomb%chargeWidth,        & !rad
         & energy,gradient,qat,dqdr,gbsa=gbsa)
    end if
    return
  end subroutine gfn0_electrostatics
!========================================================================================!

  subroutine gfn0_dispersion(nat,at,xyz,chrg,xtbData, &
     &  cn,dcndr,energy,gradient)
!> subroutine gfn0_dispersion
!> Calculate two-body D4 dispersion interaction energy and the
!> respective Cartesian gradient.
!> The D4 calculation in GFN0 uses a SEPARATE set of
!> EEQ charges that are set up with the erf-type CN used
!> in the rest of GFN0 terms, AND a set of CNs only
!> for the D4 calculation.
    use eeq_module
    use dftd4param,only:D4gam,D4chi,D4kcn,D4alp
    use gfn0_dftd4,only:d4_gradient
    use cn_module
    !> INPUTS
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    integer,intent(in) :: chrg
    type(TxTBData_mod),intent(in) :: xtbData !< main data/parameter frame
    !> Coordination number
    real(wp),intent(in) :: cn(:)
    !> Derivative of the coordination number w.r.t. Cartesian coordinates
    real(wp),intent(in) :: dcndr(:,:,:)

    !> OUTPUTS
    !> Electrostatic energy
    real(wp),intent(inout) :: energy
    !> Molecular gradient
    real(wp),intent(inout) :: gradient(:,:)

    !> Atomic partial charges
    real(wp),allocatable :: qat(:)
    !> Derivative of the partial charges w.r.t. Cartesian coordinates
    real(wp),allocatable :: dqdr(:,:,:)
    !> Coordination number (only for D4 calc.)
    real(wp),allocatable :: ccn(:)
    !> Derivative of the coordination number w.r.t. Cartesian coordinates (only for D4 calc.)
    real(wp),allocatable :: dccndr(:,:,:)

    !> dummy argument
    real(wp) :: edum
    real(wp),allocatable :: gdum(:,:)
    integer :: i

    allocate (qat(nat),dqdr(3,nat,nat),source=0.0_wp)
    allocate (ccn(nat),dccndr(3,nat,nat),source=0.0_wp)
    allocate (gdum(3,nat),source=0.0_wp)

    !> get EEQ charges for D4 parametrization, but GFN0 erf-type CN!
    call chargeEquilibration(nat,at,xyz,chrg,cn,dcndr, &
       & D4chi,D4kcn,D4gam,D4alp,&
       & edum,gdum,qat,dqdr)

    !> get D4 covalent coordination number (ccn & dccndr)
    call getCoordinationNumber(nat,at,xyz,40.0_wp,cnType%cov,ccn,dccndr)

    !> calculate two-body D4 contribution
    call d4_gradient(nat,at,xyz,xtbData%dispersion,60.0_wp, &
       &  ccn,dccndr,qat,dqdr,energy,gradient)

    deallocate (gdum)
    deallocate (dccndr,ccn,dqdr,qat)

  end subroutine gfn0_dispersion

!========================================================================================!

  subroutine gfn0_repulsion(nat,at,xyz,repData,erep,gradient)
!> subroutine gfn0_repulsion
!> calculate the repulsion energy and respective gradients
!> This is a classical term only dependent on the
!> molecular geometry and fully parametrized
    implicit none

    !> number of atoms of the molecule
    integer,intent(in) :: nat
    !> atom types by atomic number
    integer,intent(in) :: at(nat)
    !> Cartesian coordinates
    real(wp),intent(in) :: xyz(3,nat)
    !> Repulsion potential parameters
    type(TRepulsionData),intent(in) :: repData

    !> Cartesian gradient
    real(wp),intent(inout) :: gradient(:,:)
    real(wp),intent(out) :: erep

    integer :: i,j,k,lin
    integer :: iat,jat,ati,atj
    real(wp) :: ri(3),dr(3)
    real(wp) :: rij(3)
    real(wp) :: r2,r,r2top34,r2top34top2
    real(wp) :: den2,den4
    real(wp) :: alpha
    real(wp) :: repab
    real(wp) :: expterm
    real(wp) :: dtmp
    real(wp),parameter :: rthr = 1600.0_wp
    real(wp) :: w,t(3)
    integer  :: latrep(3),tx,ty,tz,itr

    w = 1.0_wp
    !> initialize
    erep = 0.0_wp
    do i = 1,nat
      ati = at(i)
      do j = 1,i
        rij = xyz(:,i) - xyz(:,j)
        r2 = sum(rij**2)
        if (r2 .gt. rthr .or. r2 .lt. 1.0e-6_wp) cycle
        atj = at(j)
        r = sqrt(r2)
        den2 = (repData%electronegativity(ati) - repData%electronegativity(atj))**2
        den4 = den2**2
        alpha = sqrt(repData%alpha(ati) * repData%alpha(atj)) &
                * (1.0_wp + (0.01_wp * den2 + 0.01_wp * den4) * repData%enScale)
        repab = repData%zeff(ati) * repData%zeff(atj)
        r2top34 = r2**0.75_wp
        r2top34top2 = r2top34**2
        expterm = exp(-alpha * r2top34) * repab
        !> save repulsion energy
        erep = erep + expterm / r * w
        !> save repulsion gradient
        dtmp = expterm * (1.5_wp * alpha * r2top34 + 1) / r2top34top2 * w
        gradient(:,i) = gradient(:,i) - dtmp * rij
        gradient(:,j) = gradient(:,j) + dtmp * rij
      end do !> j atom
    end do !> i atom
    return
  end subroutine gfn0_repulsion

!========================================================================================!

  subroutine gfn0_shortranged(nat,at,xyz,srb, &
     &       cn,dcndr,esrb,gradient)
!> subroutine gfn0_shortranranged
!> short-ranged bond (SRB) correction
!> The SRB term is fully classical and depends on the
!> atomic CNs.
    use gfn0_srb
    use gfn0_math_wrapper,only:contract
    implicit none

    !> number of atoms of the molecule
    integer,intent(in) :: nat
    !> atom types by atomic number
    integer,intent(in) :: at(nat)
    !> Cartesian coordinates
    real(wp),intent(in) :: xyz(3,nat)
    !> Coordination number and gradient
    real(wp),intent(in) :: cn(:)
    real(wp),intent(in) :: dcndr(:,:,:)
    !> SRB param object
    type(TShortRangeData),intent(in) :: srb
    !> SRB energy and gradient
    real(wp),intent(out) :: esrb
    real(wp),intent(inout) :: gradient(:,:)

    integer :: i,j,k,wsAt
    integer :: iat,jat,ati,atj
    integer :: nsrb,itr
    real(wp) :: den
    real(wp) :: expterm
    ! distances
    real(wp) :: rij(3)
    real(wp) :: r2,r,dr,rab
    real(wp) :: dtmp,pre
    real(wp) :: w
    ! allocatables
    real(wp),allocatable :: dEdr0(:)
    real(wp),allocatable :: rab0(:)
    real(wp),allocatable :: drab0dr(:,:,:)
    integer,allocatable :: srblist(:,:)

    !> initialize
    esrb = 0.0_wp

    w = 1.0_wp

    call build_srblist(nat,at,xyz,nsrb,srblist)
    if (nsrb .eq. 0) return

    !> get memory
    allocate (dEdr0(nsrb),source=0.0_wp)
    allocate (drab0dr(3,nat,nsrb),source=0.0_wp)
    allocate (rab0(nsrb),source=0.0_wp)
    !> get approximated distances rab and gradients
    call approx_rab(nat,at,xyz,cn,dcndr,nsrb,srblist, &
    &               srb%shift,rab0,drab0dr)
    do i = 1,nsrb
      iat = srblist(1,i)
      jat = srblist(2,i)
      ati = at(iat)
      atj = at(jat)
      den = paulingEN(ati) - paulingEN(atj)
      pre = srb%steepness * (1.0_wp + srb%enScale * den**2)
      rij = xyz(:,iat) - xyz(:,jat)
      rab = norm2(rij)
      dr = rab - rab0(i)
      expterm = srb%prefactor * exp(-pre * dr**2)
      !> save SRB energy
      esrb = esrb + expterm * w
      dtmp = 2.0_wp * pre * dr * expterm * w
      gradient(:,iat) = gradient(:,iat) - dtmp * rij / rab
      gradient(:,jat) = gradient(:,jat) + dtmp * rij / rab
      !> three body gradient
      dEdr0(i) = dEdr0(i) + dtmp
    end do !> i

    !> construct gradient
    call contract(drab0dr,dEdr0,gradient,beta=1.0_wp)

    return
  end subroutine gfn0_shortranged

!========================================================================================!

  subroutine gfn0_eht(nat,at,xyz,xtbData,basis,cn,dcndr,qat,dqdr, &
     &                wfn,eel,gradient,fail)
!> subroutine gfn0_eht
!> Set up the H0 hamiltonian and overlap,
!> and from that get the "QM" part of the energy
    use wfn_module
    use gfn0_math_wrapper,only:contract
    !> INPUT
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    real(wp),intent(in) :: cn(:)
    real(wp),intent(in) :: dcndr(:,:,:)
    real(wp),intent(in) :: qat(:)
    real(wp),intent(in) :: dqdr(:,:,:)
    type(TBasisset),intent(in)   :: basis
    type(TxTBData_mod),intent(in) :: xtbData
    type(Twavefunction),intent(inout) :: wfn
    !> OUTPUT
    real(wp),intent(out) :: eel
    real(wp),intent(inout) :: gradient(:,:)
    logical,intent(out)  :: fail

    !> LOCAL
    integer :: i,j,k
    real(wp) :: intcut,scfconv
    real(wp) :: et,efa,efb,nfoda,nfodb,ga,gb
    integer :: maxshell,nao,naop
    real(wp),allocatable :: selfEnergy(:,:)
    real(wp),allocatable :: dSEdcn(:,:)
    real(wp),allocatable :: dSEdq(:,:)
    real(wp),allocatable :: S(:,:)
    real(wp),allocatable :: H0(:)
    real(wp),allocatable :: dHdcn(:)
    real(wp),allocatable :: dHdq(:)
    real(wp),allocatable :: Pew(:,:)
    real(wp),allocatable :: tmp(:)

    eel = 0.0_wp
    fail = .false.

    !>---  Numerical stuff and cutoffs
    intcut = 25.0_wp - 10.0_wp * log10(xtbData%acc)
    intcut = max(20.0_wp,intcut)
    scfconv = 1.e-6_wp * xtbData%acc

    !>--- allocation
    nao = basis%nao
    naop = basis%nao * (basis%nao + 1) / 2
    allocate (H0(naop),source=0.0_wp)
    allocate (S(nao,nao),source=0.0_wp)
    maxshell = maxval(xtbData%nshell)
    allocate (selfEnergy(maxshell,nat),source=0.0_wp)
    allocate (dSEdcn(maxshell,nat),source=0.0_wp)
    allocate (dSEdq(maxshell,nat),source=0.0_wp)

    et = xtbData%etemp
    wfn%q = qat

    !>--- Setup, AO integrals of S and H0
    call getSelfEnergy(xtbData%hamiltonian,xtbData%nShell,at,cn,wfn%q, &
       & selfEnergy,dSEdcn,dSEdq)
    call build_SH0(xtbData%nShell,xtbData%hamiltonian,selfEnergy, &
          & nat,at,basis,nao,xyz,intcut,S,H0)
    if (allocated(wfn%S)) wfn%S = S

    !>--- Diagonalization
    call solve(nao,H0,S,wfn%C,wfn%P,wfn%emo,fail)
    if (fail) return

    !>--- Fermi Smearing and electronic energy
    if (et .gt. 0.1_wp) then
      if (wfn%ihomoa + 1 .le. nao) then
        call fermismear(.false.,nao,wfn%ihomoa,et,wfn%emo,wfn%focca,nfoda,efa,ga)
      end if
      if (wfn%ihomob + 1 .le. nao) then
        call fermismear(.false.,nao,wfn%ihomob,et,wfn%emo,wfn%foccb,nfodb,efb,gb)
      end if
      wfn%focc = wfn%focca + wfn%foccb
    end if
    call dmat(nao,wfn%focc,wfn%C,wfn%P)
    eel = sum(wfn%focc * wfn%emo) * evtoau + ga + gb

    !>--- Gradient Setup
    allocate (dHdcn(nat),dHdq(nat),pew(nao,nao),tmp(nao), &
       &      source=0.0_wp)
    tmp = wfn%focc * wfn%emo * evtoau
    !> setup energy weighted density matrix = Pew for gradient calculation
    call dmat(nao,tmp,wfn%C,Pew)
    call build_dSH0(xtbData%nShell,xtbData%hamiltonian,selfEnergy, &
        & dSEdcn,dSEdq,nat,basis,intcut,nao,at,xyz, &
        & wfn%P,Pew,gradient,dHdcn,dHdq)

    !>--- Gradient Contraction
    call contract(dcndr,dhdcn,gradient,beta=1.0_wp)
    call contract(dqdr,dhdq,gradient,beta=1.0_wp)

    !>--- deallocation
    deallocate (tmp,Pew,dHdq,dHdcn)
    deallocate (dSEdq,dSEdcn,selfEnergy)
    deallocate (S,H0)

    return
  end subroutine gfn0_eht
!========================================================================================!
  subroutine gfn0_eht_var(nat,at,xyz,xtbData,basis,wfn,part, &
     &                    eel,gradient,fail,update,occ)
!> subroutine gfn0_eht_var
!> Set up the H0 hamiltonian and overlap,
!> and from that get the "QM" part of the energy
    use wfn_module
    use gfn0_math_wrapper,only:contract
    !> INPUT
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    type(TBasisset),intent(in)   :: basis
    type(TxTBData_mod),intent(in) :: xtbData
    type(Twavefunction),intent(inout) :: wfn
    type(gfn0_partials),intent(inout) :: part
    logical,intent(in),optional :: update
    real(wp),intent(in),optional :: occ(basis%nao)
    !> OUTPUT
    real(wp),intent(out) :: eel
    real(wp),intent(inout) :: gradient(:,:)
    logical,intent(out)  :: fail

    !> LOCAL
    integer :: i,j,k
    real(wp) :: intcut,scfconv
    real(wp) :: et,efa,efb,nfoda,nfodb,ga,gb
    integer :: maxshell,nao,naop
    real(wp),allocatable :: S(:,:)
    real(wp),allocatable :: H0(:)
    real(wp),allocatable :: dHdcn(:)
    real(wp),allocatable :: dHdq(:)
    real(wp),allocatable :: Pew(:,:)
    real(wp),allocatable :: tmp(:)
    integer :: ihomoa,ihomob
    integer,allocatable  :: nmaxa(:),nmaxb(:)
    logical :: refresh

    eel = 0.0_wp
    fail = .false.
    if(present(update))then
      refresh = update
    else
      refresh = .true.
    endif 

    !>---  Numerical stuff and cutoffs
    intcut = 25.0_wp - 10.0_wp * log10(xtbData%acc)
    intcut = max(20.0_wp,intcut)
    scfconv = 1.e-6_wp * xtbData%acc

    !>--- allocation
    nao = basis%nao
    naop = basis%nao * (basis%nao + 1) / 2
    if (refresh) then
      allocate (H0(naop),source=0.0_wp)
      allocate (S(nao,nao),source=0.0_wp)
      maxshell = maxval(xtbData%nshell)

      if (.not. allocated(part%selfEnergy)) &
      &  allocate (part%selfEnergy(maxshell,nat),source=0.0_wp)
      if (.not. allocated(part%dSEdcn)) &
      &  allocate (part%dSEdcn(maxshell,nat),source=0.0_wp)
      if (.not. allocated(part%dSEdq)) &
      &  allocate (part%dSEdq(maxshell,nat),source=0.0_wp)

      wfn%q = part%qat

      !>--- Setup, AO integrals of S and H0
      call getSelfEnergy(xtbData%hamiltonian,xtbData%nShell,at,part%cn,wfn%q, &
         & part%selfEnergy,part%dSEdcn,part%dSEdq)
      call build_SH0(xtbData%nShell,xtbData%hamiltonian,part%selfEnergy, &
            & nat,at,basis,nao,xyz,intcut,S,H0)
      if (allocated(wfn%S)) wfn%S = S

      !>--- Diagonalization
      call solve(nao,H0,S,wfn%C,wfn%P,wfn%emo,fail)
      deallocate (S,H0)
      if (fail) return
    end if

    !>--- Electronic energy
    et = xtbData%etemp
    eel = 0.0_wp
    allocate (dHdcn(nat),dHdq(nat),Pew(nao,nao),tmp(nao),source=0.0_wp)
    if (present(occ)) then
      if(et .gt. 0.1_wp)then
        call occ_nmax(nao,occ,nmaxa,nmaxb,ihomoa,ihomob)
        if(ihomoa + 1 .le. nao )then
          call fermismear(.false.,nao,ihomoa,nmaxa,et,wfn%emo,wfn%focca,TS=ga)
        endif
        if(ihomob + 1 .le. nao )then
          call fermismear(.false.,nao,ihomob,nmaxb,et,wfn%emo,wfn%foccb,TS=gb)
        endif
        wfn%focc = wfn%focca + wfn%foccb
        !eel = ga + gb
      else  
        wfn%focc = occ
      endif
      !write(*,*) sum(occ),ihomoa,ihomob
    else
      if (et .gt. 0.1_wp) then
        if (wfn%ihomoa + 1 .le. nao) then
          call fermismear(.false.,nao,wfn%ihomoa,et,wfn%emo,wfn%focca,nfoda,efa,ga)
        end if
        if (wfn%ihomob + 1 .le. nao) then
          call fermismear(.false.,nao,wfn%ihomob,et,wfn%emo,wfn%foccb,nfodb,efb,gb)
        end if
        wfn%focc = wfn%focca + wfn%foccb
      end if
      eel = ga + gb
    end if
    !write(*,*) wfn%focc
    tmp = wfn%focc
    call dmat(nao,tmp,wfn%C,wfn%P)
    eel = eel + sum(tmp * wfn%emo) * evtoau
    tmp(:) = wfn%focc(:) * wfn%emo * evtoau


    !>--- Gradient Setup
    !> setup energy weighted density matrix = Pew for gradient calculation
    call dmat(nao,tmp,wfn%C,Pew)
    call build_dSH0(xtbData%nShell,xtbData%hamiltonian, &
        & part%selfEnergy,part%dSEdcn,part%dSEdq, &
        & nat,basis,intcut,nao,at,xyz, &
        & wfn%P,Pew,gradient,dHdcn,dHdq)

    !>--- Gradient Contraction
    call contract(part%dcndr,dhdcn,gradient,beta=1.0_wp)
    call contract(part%dqdr,dhdq,gradient,beta=1.0_wp)

    !>--- deallocation
    if(allocated(nmaxa)) deallocate(nmaxa)
    if(allocated(nmaxb)) deallocate(nmaxb)
    deallocate (tmp,Pew,dHdq,dHdcn)
    !deallocate (dSEdq,dSEdcn,selfEnergy)

    return
  end subroutine gfn0_eht_var
!========================================================================================!
end module gfn0_module

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert, Stefan Grimme, Eike Caldeweyher
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfn0_dftd4
   use iso_fortran_env, only: wp=>real64,stdout=>output_unit
   use gfn0_types, only: TDispersionData
   use gfn0_math_wrapper, only: gemv,contract
   use dftd4param, gam=>chemical_hardness
   implicit none
   private

   public :: newD4Model
   public :: d4_gradient
  
   real(wp),private,parameter :: autoaa = 0.52917726_wp
   real(wp),private,parameter :: aatoau = 1.0_wp/autoaa
   real(wp),private,parameter :: pi=3.1415926535897932385_wp

contains

subroutine newD4Model(dispm,g_a,g_c,mode)
   type(TDispersionData), intent(inout) :: dispm
   real(wp),intent(in)  :: g_a,g_c
   integer, intent(in)  :: mode

   integer  :: i,ia,is,icn,j,ii,jj
   integer  :: cncount(0:18)
   real(wp) :: sec_al(23),iz,c6,alpha(23)
   real(wp) :: tmp_hq(7,118)

   intrinsic :: nint

   !call init(dispm) !< see "initGFN0Dispersion"

   secq = 0.0_wp
   select case(mode)
   case(p_refq_hirshfeld,p_refq_periodic)
!     print'(1x,''* using PBE0/def2-TZVP Hirshfeld charges'')'
      refq = dftq
      refh = dfth
      secq = dfts
!  case(2)
!     refq = pbcq
!     refh = pbch
!     secq = pbcs
   case(p_refq_gasteiger)
!     print'(1x,''* using classical Gasteiger charges'')'
      refq = gffq
      refh = gffh
      secq = gffs
   case(p_refq_goedecker)
      refq = clsq
      refh = clsh
      secq = clss
   case(p_refq_gfn2xtb_gbsa_h2o)
!     print'(1x,''* using GFN2-xTB//GBSA(H2O) charges'')'
      refq = solq
      refh = solh
      secq = sols
   end select

   select case(mode)
   case(p_refq_hirshfeld,p_refq_periodic)
      dispm%q = dftq
      tmp_hq = dfth
   case(p_refq_gasteiger)
      dispm%q = gffq
      tmp_hq = gffh
   case(p_refq_goedecker)
      dispm%q = clsq
      tmp_hq = clsh
   case(p_refq_gfn2xtb_gbsa_h2o)
      dispm%q = solq
      tmp_hq = solh
   case default
      dispm%q = refq
      tmp_hq = refh
   end select

   dispm%atoms = 0
   dispm%nref = 0
  
   do ia = 1, 118
      cncount = 0
      cncount(0) = 1
      dispm%nref(ia) = refn(ia)
      do j = 1, refn(ia)
         is = refsys(j,ia)
         iz = zeff(is)
         sec_al = sscale(is)*secaiw(:,is) &
            &  * zeta(g_a,gam(is)*g_c,secq(is)+iz,tmp_hq(j,ia)+iz)
         dispm%cn(j,ia) = refcovcn(j,ia)
         icn =nint(refcn(j,ia))
         cncount(icn) = cncount(icn) + 1
         dispm%alpha(:,j,ia) = max(ascale(j,ia)*(alphaiw(:,j,ia)-hcount(j,ia)*sec_al),0.0_wp)
      enddo
      do j = 1, refn(ia)
         icn = cncount(nint(refcn(j,ia)))
         dispm%ncount(j,ia) = icn*(icn+1)/2
      enddo
   end do

   ! integrate C6 coefficients
   do i = 1, 118
      do j = 1, i
         do ii = 1, dispm%nref(i)
            do jj = 1, dispm%nref(j)
               alpha = dispm%alpha(:,ii,i)*dispm%alpha(:,jj,j)
               c6 = thopi * trapzd(alpha)
               dispm%c6(jj,ii,j,i) = c6
               dispm%c6(ii,jj,i,j) = c6
            enddo
         enddo
      enddo
   enddo

end subroutine newD4Model

subroutine d4dim(dispm,nat,at,ndim)
   type(TDispersionData), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   integer, intent(out) :: ndim

   integer :: i

   ndim = 0

   do i = 1, nat
      ndim = ndim + dispm%nref(at(i))
   enddo

end subroutine d4dim

subroutine prmolc6(molc6,molc8,molpol,nat,at,  &
      & cn,covcn,q,qlmom,c6ab,alpha,rvdw,hvol)
   real(wp),intent(in)  :: molc6
   real(wp),intent(in)  :: molc8
   real(wp),intent(in)  :: molpol
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in),optional :: cn(nat)
   real(wp),intent(in),optional :: covcn(nat)
   real(wp),intent(in),optional :: q(nat)
   real(wp),intent(in),optional :: qlmom(3,nat)
   real(wp),intent(in),optional :: c6ab(nat,nat)
   real(wp),intent(in),optional :: alpha(nat)
   real(wp),intent(in),optional :: rvdw(nat)
   real(wp),intent(in),optional :: hvol(nat)
   integer :: i
   if(present(cn).or.present(covcn).or.present(q).or.present(c6ab) &
   &   .or.present(alpha).or.present(rvdw).or.present(hvol)) then
   write(stdout,'(a)')
   write(stdout,'(''   #   Z   '')',advance='no')
   if(present(cn))   write(stdout,'(''        CN'')',advance='no')
   if(present(covcn))write(stdout,'(''     covCN'')',advance='no')
   if(present(q))    write(stdout,'(''         q'')',advance='no')
   if(present(qlmom))write(stdout,   '(''   n(s)'')',advance='no')
   if(present(qlmom))write(stdout,   '(''   n(p)'')',advance='no')
   if(present(qlmom))write(stdout,   '(''   n(d)'')',advance='no')
   if(present(c6ab)) write(stdout,'(''      C6AA'')',advance='no')
   if(present(alpha))write(stdout,'(''      α(0)'')',advance='no')
   if(present(rvdw)) write(stdout,'(''    RvdW/Å'')',advance='no')
   if(present(hvol)) write(stdout,'(''    relVol'')',advance='no')
   write(*,'(a)')
   do i=1,nat
      write(*,'(i4,1x,i3,1x,a2)',advance='no') &
      &     i,at(i),toSymbol(at(i))
      if(present(cn))   write(stdout,'(f10.3)',advance='no')cn(i)
      if(present(covcn))write(stdout,'(f10.3)',advance='no')covcn(i)
      if(present(q))    write(stdout,'(f10.3)',advance='no')q(i)
      if(present(qlmom))write(stdout, '(f7.3)',advance='no')qlmom(1,i)
      if(present(qlmom))write(stdout, '(f7.3)',advance='no')qlmom(2,i)
      if(present(qlmom))write(stdout, '(f7.3)',advance='no')qlmom(3,i)
      if(present(c6ab)) write(stdout,'(f10.3)',advance='no')c6ab(i,i)
      if(present(alpha))write(stdout,'(f10.3)',advance='no')alpha(i)
      if(present(rvdw)) write(stdout,'(f10.3)',advance='no')rvdw(i)*autoaa
      if(present(hvol)) write(stdout,'(f10.3)',advance='no')hvol(i)
      write(*,'(a)')
   enddo
   endif
   write(stdout,'(/,1x,''Mol. C6AA /au·bohr⁶  :'',f18.6,'// &
   &         '/,1x,''Mol. C8AA /au·bohr⁸  :'',f18.6,'// &
   &         '/,1x,''Mol. α(0) /au        :'',f18.6,/)') &
   &          molc6,molc8,molpol
end subroutine prmolc6

pure elemental function zeta(a,c,qref,qmod)
   !$acc routine seq
   real(wp),intent(in) :: qmod,qref
   real(wp),intent(in) :: a,c
   real(wp)            :: zeta

   intrinsic :: exp

   if (qmod.lt.0._wp) then
      zeta = exp( a )
   else
      zeta = exp( a * ( 1._wp - exp( c * ( 1._wp - qref/qmod ) ) ) )
   endif

end function zeta

pure elemental function dzeta(a,c,qref,qmod)
   !$acc routine seq
   real(wp),intent(in) :: qmod,qref
   real(wp),intent(in) :: a,c
   real(wp)            :: dzeta

   intrinsic :: exp

   if (qmod.lt.0._wp) then
      dzeta = 0._wp
   else
      dzeta = - a * c * exp( c * ( 1._wp - qref/qmod ) ) &
      &           * zeta(a,c,qref,qmod) * qref / ( qmod**2 )
   endif

end function dzeta

pure function trapzd(pol)
   real(wp),intent(in) :: pol(23)
   real(wp)            :: trapzd

   real(wp)            :: tmp1, tmp2
   real(wp),parameter  :: freq(23) = (/ &
&   0.000001_wp,0.050000_wp,0.100000_wp, &
&   0.200000_wp,0.300000_wp,0.400000_wp, &
&   0.500000_wp,0.600000_wp,0.700000_wp, &
&   0.800000_wp,0.900000_wp,1.000000_wp, &
&   1.200000_wp,1.400000_wp,1.600000_wp, &
&   1.800000_wp,2.000000_wp,2.500000_wp, &
&   3.000000_wp,4.000000_wp,5.000000_wp, &
&   7.500000_wp,10.00000_wp /)
!  just precalculate all weights and get the job done
   real(wp),parameter :: weights(23) = 0.5_wp * (/ &
&  ( freq (2) - freq (1) ),  &
&  ( freq (2) - freq (1) ) + ( freq (3) - freq (2) ),  &
&  ( freq (3) - freq (2) ) + ( freq (4) - freq (3) ),  &
&  ( freq (4) - freq (3) ) + ( freq (5) - freq (4) ),  &
&  ( freq (5) - freq (4) ) + ( freq (6) - freq (5) ),  &
&  ( freq (6) - freq (5) ) + ( freq (7) - freq (6) ),  &
&  ( freq (7) - freq (6) ) + ( freq (8) - freq (7) ),  &
&  ( freq (8) - freq (7) ) + ( freq (9) - freq (8) ),  &
&  ( freq (9) - freq (8) ) + ( freq(10) - freq (9) ),  &
&  ( freq(10) - freq (9) ) + ( freq(11) - freq(10) ),  &
&  ( freq(11) - freq(10) ) + ( freq(12) - freq(11) ),  &
&  ( freq(12) - freq(11) ) + ( freq(13) - freq(12) ),  &
&  ( freq(13) - freq(12) ) + ( freq(14) - freq(13) ),  &
&  ( freq(14) - freq(13) ) + ( freq(15) - freq(14) ),  &
&  ( freq(15) - freq(14) ) + ( freq(16) - freq(15) ),  &
&  ( freq(16) - freq(15) ) + ( freq(17) - freq(16) ),  &
&  ( freq(17) - freq(16) ) + ( freq(18) - freq(17) ),  &
&  ( freq(18) - freq(17) ) + ( freq(19) - freq(18) ),  &
&  ( freq(19) - freq(18) ) + ( freq(20) - freq(19) ),  &
&  ( freq(20) - freq(19) ) + ( freq(21) - freq(20) ),  &
&  ( freq(21) - freq(20) ) + ( freq(22) - freq(21) ),  &
&  ( freq(22) - freq(21) ) + ( freq(23) - freq(22) ),  &
&  ( freq(23) - freq(22) ) /)

!!  do average between trap(1)-trap(22) .and. trap(2)-trap(23)
!   tmp1 = 0.5_wp * ( &
!&  ( freq (2) - freq (1) ) * ( pol (2) + pol (1) )+ &
!&  ( freq (4) - freq (3) ) * ( pol (4) + pol (3) )+ &
!&  ( freq (6) - freq (5) ) * ( pol (6) + pol (5) )+ &
!&  ( freq (8) - freq (7) ) * ( pol (8) + pol (7) )+ &
!&  ( freq(10) - freq (9) ) * ( pol(10) + pol (9) )+ &
!&  ( freq(12) - freq(11) ) * ( pol(12) + pol(11) )+ &
!&  ( freq(14) - freq(13) ) * ( pol(14) + pol(13) )+ &
!&  ( freq(16) - freq(15) ) * ( pol(16) + pol(15) )+ &
!&  ( freq(18) - freq(17) ) * ( pol(18) + pol(17) )+ &
!&  ( freq(20) - freq(19) ) * ( pol(20) + pol(19) )+ &
!&  ( freq(22) - freq(21) ) * ( pol(22) + pol(21) ))
!   tmp2 = 0.5_wp * ( &
!&  ( freq (3) - freq (2) ) * ( pol (3) + pol (2) )+ &
!&  ( freq (5) - freq (4) ) * ( pol (5) + pol (4) )+ &
!&  ( freq (7) - freq (6) ) * ( pol (7) + pol (6) )+ &
!&  ( freq (9) - freq (8) ) * ( pol (9) + pol (8) )+ &
!&  ( freq(11) - freq(10) ) * ( pol(11) + pol(10) )+ &
!&  ( freq(13) - freq(12) ) * ( pol(13) + pol(12) )+ &
!&  ( freq(15) - freq(14) ) * ( pol(15) + pol(14) )+ &
!&  ( freq(17) - freq(16) ) * ( pol(17) + pol(16) )+ &
!&  ( freq(19) - freq(18) ) * ( pol(19) + pol(18) )+ &
!&  ( freq(21) - freq(20) ) * ( pol(21) + pol(20) )+ &
!&  ( freq(23) - freq(22) ) * ( pol(23) + pol(22) ))

   trapzd = sum(pol*weights)

end function trapzd

pure elemental function cngw(wf,cn,cnref)
   !$acc routine seq
   real(wp),intent(in) :: wf,cn,cnref
   real(wp)            :: cngw ! CN-gaussian-weight

   intrinsic :: exp

   cngw = exp ( -wf * ( cn - cnref )**2 )

end function cngw

pure elemental function dcngw(wf,cn,cnref)
   real(wp),intent(in) :: wf,cn,cnref
   real(wp) :: dcngw

   dcngw = 2*wf*(cnref-cn)*cngw(wf,cn,cnref)

end function dcngw

!* BJ damping function ala DFT-D3(BJ)
!  f(n,rab) = sn*rab**n/(rab**n + R0**n)  w/ R0 = a1*sqrt(C6/C8)+a2
!  see: https://doi.org/10.1002/jcc.21759
pure elemental function fdmpr_bj(n,r,c) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp) :: fdmp
   fdmp = 1.0_wp / ( r**n + c**n )
end function fdmpr_bj
pure elemental function fdmprdr_bj(n,r,c) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp) :: dfdmp
   dfdmp = -n*r**(n-1) * fdmpr_bj(n,r,c)**2
end function fdmprdr_bj

!* original DFT-D3(0) damping
!  f(n,rab) = sn/(1+6*(4/3*R0/rab)**alp)  w/ R0 of unknown origin
pure elemental function fdmpr_zero(n,r,c,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: fdmp
   fdmp = 1.0_wp / (r**n*(1 + six * (c/r)**(n+alp)))
end function fdmpr_zero
pure elemental function fdmprdr_zero(n,r,c,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: dfdmp
   dfdmp = -( n*r**(n-1)*(1+six*(c/r)**(alp)) &
             - alp*r**n/c*six*(c/r)**(alp-1) ) &
           * fdmpr_zero(n,r,c,alp)**2
!  fdmp = 1.0_wp / (r**n*(1 + 6.0_wp * (c/r)**(n+alp)))
end function fdmprdr_zero

!* fermi damping function from TS and MBD methods
!  f(n,rab) = sn/(1+exp[-alp*(rab/R0-1)]) w/ R0 as experimenal vdW-Radii
pure elemental function fdmpr_fermi(n,r,c,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: fdmp
   fdmp = 1.0_wp / (r**n*(1.0_wp+exp(-alp*(r/c - 1.0))))
end function fdmpr_fermi
pure elemental function fdmprdr_fermi(n,r,c,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: dfdmp
   dfdmp = -(-alp/c*r**n*exp(-alp*(r/c - 1.0)) &
             + n*r**(n-1)*(1.0_wp+exp(-alp*(r/c - 1.0)))) &
             * fdmpr_fermi(n,r,c,alp)**2
end function fdmprdr_fermi

!* optimized power zero damping (M. Head-Gordon)
!  f(n,rab) = sn*rab**(n+alp)/(rab**(n+alp) + R0**(n+alp))
!  see: https://dx.doi.org/10.1021/acs.jpclett.7b00176
pure elemental function fdmpr_op(n,r,c,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: fdmp
   fdmp = r**alp / (r**(n+alp)*c**(n+alp))
end function fdmpr_op
pure elemental function fdmprdr_op(n,r,c,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: dfdmp
   dfdmp = (alp*r*(alp-1) - (n+alp)*r**alp*r**(n+alp-1)) &
           * fdmpr_op(n,r,c,alp)**2
!  fdmp = r**alp / (r**(n+alp)*c**(n+alp))
end function fdmprdr_op

!* Sherrill's M-zero damping function
!  f(n,rab) = sn/(1+6*(4/3*R0/rab+a2*R0)**(-alp))
!  see: https://dx.doi.org/10.1021/acs.jpclett.6b00780
pure elemental function fdmpr_zerom(n,r,c,rsn,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp),intent(in)  :: rsn
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: fdmp
   fdmp = 1.0_wp / (r**n*(1 + six * (r/c+rsn*c)**(-alp)))
end function fdmpr_zerom
pure elemental function fdmprdr_zerom(n,r,c,rsn,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp),intent(in)  :: rsn
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: dfdmp
   dfdmp = -( n*r**(n-1)*(1+six*(r/c+rsn*c)**(-alp)) &
              - alp*r**n/c*six*(r/c+rsn*c)**(-alp-1) ) &
           * fdmpr_zerom(n,r,c,rsn,alp)**2
end function fdmprdr_zerom


!> Calculate the weights of the reference system and the derivatives w.r.t.
!  coordination number for later use.
subroutine weight_references(dispm, nat, atoms, g_a, g_c, wf, q, cn, zeff, gam, &
      &                      zetavec, zerovec, zetadcn, zerodcn, zetadq)
   type(TDispersionData), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> Atomic numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> Charge scaling height.
   real(wp), intent(in) :: g_a
   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c
   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf
   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)
   !> Partial charge of every atom.
   real(wp), intent(in) :: q(:)
   real(wp), intent(in) :: zeff(:)
   real(wp), intent(in) :: gam(:)
   !> weighting and scaling function for the atomic reference systems
   real(wp), intent(out) :: zetaVec(:, :)
   !> weighting and scaling function for the atomic reference systems for q=0
   real(wp), intent(out) :: zeroVec(:, :)
   !> derivative of the weight'n'scale function w.r.t. the partial charges
   real(wp), intent(out) :: zetadq(:, :)
   !> derivative of the weight'n'scale function w.r.t. the coordination number
   real(wp), intent(out) :: zetadcn(:, :)
   !> derivative of the weight'n'scale function w.r.t. the CN for q=0
   real(wp), intent(out) :: zerodcn(:, :)

   integer :: iat, ati, iref, icount
   real(wp) :: norm, dnorm, twf, gw, expw, expd, gwk, dgwk
   real(wp) :: gi, zi

   zetavec = 0.0_wp
   zerovec = 0.0_wp
   zetadcn = 0.0_wp
   zerodcn = 0.0_wp
   zetadq  = 0.0_wp

   !$omp parallel do shared(zetavec, zetadcn, zetadq, zerodcn) &
   !$omp shared(nat, atoms, dispm, cn, q, g_a, g_c, wf, zerovec) &
   !$omp private(iat, ati, zi, gi, norm, dnorm, iref, icount, twf, gw, expw, &
   !$omp& expd, gwk, dgwk)
   do iat = 1, nat
      ati = atoms(iat)

      zi = zeff(ati)
      gi = g_c * gam(ati)

      norm = 0.0_wp
      dnorm = 0.0_wp
      ! acc loop vector
      do iref = 1, dispm%nref(ati)
         ! acc loop seq private(twf, gw)
         do icount = 1, dispm%ncount(iref, ati)
            twf = icount * wf
            gw = cngw(twf, cn(iat), dispm%cn(iref, ati))
            norm = norm + gw
            dnorm = dnorm + 2*twf*(dispm%cn(iref, ati) - cn(iat)) * gw
         enddo
      end do
      norm = 1.0_wp / norm
      ! acc loop vector private(expw, expd)
      do iref = 1, dispm%nref(ati)
         expw = 0.0_wp
         expd = 0.0_wp
         ! acc loop seq private(twf, gw)
         do icount = 1, dispm%ncount(iref, ati)
            twf = icount * wf
            gw = cngw(twf, cn(iat), dispm%cn(iref, ati))
            expw = expw + gw
            expd = expd + 2*twf*(dispm%cn(iref, ati) - cn(iat)) * gw
         enddo

         gwk = expw * norm
         if (gwk /= gwk) then
            if (maxval(dispm%cn(:dispm%nref(ati), ati)) &
               & == dispm%cn(iref, ati)) then
               gwk = 1.0_wp
            else
               gwk = 0.0_wp
            endif
         endif
         zetavec(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,q(iat)+zi) * gwk
         zerovec(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,zi) * gwk

         dgwk = expd*norm-expw*dnorm*norm**2
         if (dgwk /= dgwk) then
            dgwk = 0.0_wp
         endif
         zetadcn(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,q(iat)+zi) * dgwk
         zetadq(iref, iat) = dzeta(g_a,gi,dispm%q(iref,ati)+zi,q(iat)+zi) * gwk
         zerodcn(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,zi) * dgwk

      end do
   end do

end subroutine weight_references

!> calculate atomic dispersion coefficients and their derivatives w.r.t.
!  the coordination number.
subroutine get_atomic_c6(dispm, nat, atoms, zetavec, zetadcn, zetadq, &
      & c6, dc6dcn, dc6dq)
   type(TDispersionData), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> weighting and scaling function for the atomic reference systems
   real(wp), intent(in) :: zetaVec(:, :)
   !> derivative of the weight'n'scale function w.r.t. the partial charges
   real(wp), intent(in) :: zetadq(:, :)
   !> derivative of the weight'n'scale function w.r.t. the coordination number
   real(wp), intent(in) :: zetadcn(:, :)
   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)
   !> derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out) :: dc6dcn(:, :)
   !> derivative of the C6 w.r.t. the partial charge
   real(wp), intent(out) :: dc6dq(:, :)

   integer :: iat, jat, ati, atj, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj, dc6dqi, dc6dqj

   c6 = 0.0_wp
   dc6dcn = 0.0_wp
   dc6dq = 0.0_wp

   !$omp parallel do default(none) shared(c6, dc6dcn, dc6dq) &
   !$omp shared(nat, atoms, dispm, zetavec, zetadcn, zetadq) &
   !$omp private(iat, ati, jat, atj, dc6, dc6dcni, dc6dcnj, dc6dqi, dc6dqj, &
   !$omp& iref, jref, refc6)
   do iat = 1, nat
      do jat = 1, nat
         if (jat > iat) cycle
         ati = atoms(iat)
         atj = atoms(jat)
         dc6 = 0.0_wp
         dc6dcni = 0.0_wp
         dc6dcnj = 0.0_wp
         dc6dqi = 0.0_wp
         dc6dqj = 0.0_wp
         do iref = 1, dispm%nref(ati)
            do jref = 1, dispm%nref(atj)
               refc6 = dispm%c6(iref, jref, ati, atj)
               dc6 = dc6 + zetavec(iref, iat) * zetavec(jref, jat) * refc6
               dc6dcni = dc6dcni + zetadcn(iref, iat) * zetavec(jref, jat) * refc6
               dc6dcnj = dc6dcnj + zetavec(iref, iat) * zetadcn(jref, jat) * refc6
               dc6dqi = dc6dqi + zetadq(iref, iat) * zetavec(jref, jat) * refc6
               dc6dqj = dc6dqj + zetavec(iref, iat) * zetadq(jref, jat) * refc6
            end do
         end do
         c6(iat, jat) = dc6
         c6(jat, iat) = dc6
         dc6dcn(iat, jat) = dc6dcni
         dc6dcn(jat, iat) = dc6dcnj
         dc6dq(iat, jat) = dc6dqi
         dc6dq(jat, iat) = dc6dqj
      end do
   end do
end subroutine get_atomic_c6

!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine d4_gradient(nat, at, xyz, dispm, cutoff, &
      &  cn, dcndr, q, dqdr, energy, gradient)

   !> Molecular Structure information.
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: xyz(3,nat)

   !> D4 and damping parameters
   type(TDispersionData), intent(in) :: dispm

   !> Cutoff for pairwise interactions
   real(wp), intent(in) :: cutoff

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> Derivative of CN w.r.t. atomic coordinates.
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Partial charge of every atom.
   real(wp), intent(in) :: q(:)

   !> Derivative of partial charges w.r.t. atomic coordinates.
   real(wp), intent(in), optional :: dqdr(:, :, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energy

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   integer :: max_ref

   !> Charge scaling height.
   real(wp) :: g_a

   !> Charge scaling steepness.
   real(wp) :: g_c

   !> Exponent for the Gaussian weighting.
   real(wp) :: wf

   !> DFT-D parameters
   real(wp) :: a1,a2,s6,s8,s10

   real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
   real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: energies(:), energies3(:), dEdcn(:), dEdq(:)
   integer :: i

   g_a = dispm%g_a
   g_c = dispm%g_c
   wf  = dispm%wf 
   a1 = dispm%a1
   a2 = dispm%a2
   s6 = dispm%s6
   s8 = dispm%s8
   s10= dispm%s10

   max_ref = maxval(dispm%nref(at))
   allocate(zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &     zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &     c6(nat, nat), dc6dcn(nat, nat), dc6dq(nat, nat), &
      &     energies(nat), dEdcn(nat), dEdq(nat), source=0.0_wp)

   call weight_references(dispm, nat, at, g_a, g_c, wf, q, cn, zeff, gam, &
      & zetavec, zerovec, zetadcn, zerodcn, zetadq)

   call get_atomic_c6(dispm, nat, at, zetavec, zetadcn, zetadq, &
      & c6, dc6dcn, dc6dq)

   call disp_gradient(nat, at, xyz, a1,a2,s6,s8,s10, cutoff, sqrtZr4r2, &
      & c6, dc6dcn, dc6dq, energies, gradient, dEdcn, dEdq)

   !call gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
   call contract(dcndr, dEdcn, gradient, beta=1.0_wp)
   if (present(dqdr)) then
      !call gemv(dqdr, dEdq, gradient, beta=1.0_wp)
       call contract(dqdr, dEdq, gradient, beta=1.0_wp)
   end if

   energy = energy + sum(energies)

   deallocate( dEdq, dEdcn, energies, &
   &           dc6dq, dc6dcn, c6, zerodq, zerodcn, &
   &           zerovec, zetadq, zetadcn, zetavec)
end subroutine d4_gradient


subroutine disp_gradient &
      & (nat, at, xyz, a1,a2,s6,s8,s10, cutoff, r4r2, c6, dc6dcn, dc6dq, &
      &  energies, gradient, dEdcn, dEdq)

   !> Molecular Structure information.
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: xyz(3,nat)

   !> D4 damping parameters
   real(wp),intent(in) :: a1,a2 
   real(wp),intent(in) :: s6,s8,s10

   real(wp), intent(in) :: r4r2(:)

   !> Cutoff for pairwise interactions
   real(wp), intent(in) :: cutoff

   real(wp), intent(in) :: c6(:, :)

   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(in) :: dc6dq(:, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energies(:)

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   real(wp), intent(inout) :: dEdcn(:)

   real(wp), intent(inout) :: dEdq(:)

   integer :: iat, jat, ati, atj, itr

   real(wp) :: cutoff2
   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   cutoff2 = cutoff**2
   !$omp parallel do default(none) &
   !$omp reduction(+:energies, gradient, dEdcn, dEdq) &
   !$omp shared(nat, at, xyz, cutoff2, a1,a2,s6,s8,s10, r4r2, c6, dc6dcn, dc6dq) &
   !$omp private(iat, jat, ati, atj, r2, rij, r4r2ij, r0, t6, t8, t10, &
   !$omp&        d6, d8, d10, disp, ddisp, dE, dG)
   do iat = 1, nat
      ati = at(iat)
      do jat = 1, iat
         atj = at(jat)

         r4r2ij = 3.0_wp*r4r2(ati)*r4r2(atj)
         r0 = a1*sqrt(r4r2ij) + a2
         rij = xyz(:, iat) - xyz(:, jat)
         r2 = sum(rij**2)
         if (r2 > cutoff2 .or. r2 < 1.0e-10_wp) cycle

         t6 = 1.0_wp/((r2**3)+(r0**6))
         t8 = 1.0_wp/((r2**4)+(r0**8))
         t10 = 1.0_wp/((r2**5)+(r0**10))

         d6 = (-6.0_wp)*(r2**2)*(t6**2)
         d8 = (-8.0_wp)*(r2**3)*(t8**2)
         d10 = (-10.0_wp)*(r2**4)*(t10**2)

         disp = s6*t6 + s8*r4r2ij*t8 &
            &  + s10*49.0_wp/40.0_wp*r4r2ij**2*t10
         ddisp= s6*d6 + s8*r4r2ij*d8 &
            & + s10*49.0_wp/40.0_wp*r4r2ij**2*d10

         dE = -c6(iat, jat)*disp * 0.5_wp
         dG = -c6(iat, jat)*ddisp*rij

         energies(iat) = energies(iat) + dE
         dEdcn(iat) = dEdcn(iat) - dc6dcn(iat, jat) * disp
         dEdq(iat) = dEdq(iat) - dc6dq(iat, jat) * disp
         if (iat /= jat) then
            energies(jat) = energies(jat) + dE
            dEdcn(jat) = dEdcn(jat) - dc6dcn(jat, iat) * disp
            dEdq(jat) = dEdq(jat) - dc6dq(jat, iat) * disp
            gradient(:, iat) = gradient(:, iat) + dG
            gradient(:, jat) = gradient(:, jat) - dG
         end if

      end do
   end do
   !$omp end parallel do

end subroutine disp_gradient

end module gfn0_dftd4

module gfn0
    use gfn0_interface
    implicit none

contains


subroutine gfn0_sp(nat, uhf, ichrg, numbers, positions, fail, energy, grad)
    integer,intent(in) :: nat
    integer,intent(in) :: uhf
    integer,intent(in) :: ichrg
    integer,intent(in) :: numbers(nat)
    double precision,intent(in) :: positions(3, nat)      ! Bohr
    !f2py depend(positions) :: nat=shape(positions,1)
    !f2py depend(numbers) :: nat=size(numbers)

    logical,intent(out) :: fail
    double precision,intent(out) :: energy          ! Hartree
    double precision,intent(out) :: grad(3, nat)    ! Hartree / Bohr
    type(gfn0_results) :: res
    type(gfn0_data) :: gdat

    call gfn0_init(nat,numbers,positions,ichrg,uhf,gdat)
    !call gfn0_init(nat,numners,positions,ichrg,uhf,gdat,solv='h2o',alpb=.false.)
    call gfn0_singlepoint(nat,numbers,positions,ichrg,uhf,gdat,energy,grad,fail,res)
end subroutine gfn0_sp


! subroutine gfn0_alpb(nat, ichrg, numbers, posotions, sol, energy, grad, io)
!     ......
! end subroutine gfn0_alpb

end module gfn0

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!

module solvation_solv_util

  implicit none

  character,parameter :: space = ' '
#ifdef _WIN32
  character,parameter :: pathdel = ';'
  character,parameter :: pathsep = '\'
#else
  character,parameter :: pathdel = ':'
  character,parameter :: pathsep = '/'
#endif

contains
!========================================================================================!

  subroutine rdpath(path,arg,fname,ex)
    implicit none
    character(len=*),intent(in)  :: arg
    character(len=*),intent(in)  :: path
    character(len=:),allocatable,intent(out) :: fname
    logical,intent(out),optional :: ex

!* temporary variables
    character(len=:),allocatable :: scratch1
    character(len=:),allocatable :: scratch2
    character(len=:),allocatable :: fpath
    logical :: exist
    integer :: i

    scratch1 = path
    do
      i = index(scratch1,pathdel)
      if (i .eq. 0) then
        scratch2 = scratch1
      else
        scratch2 = scratch1(:i - 1)
        scratch1 = scratch1(i + 1:)
      end if
      fpath = scratch2//pathsep//arg
      inquire (file=fpath,exist=exist)
      if (exist) exit
!     print*,fpath,space,scratch1,exist
      if (i .eq. 0) exit
    end do

!  print*,fpath,exist

    if (exist) fname = fpath
    if (present(ex)) ex = exist

  end subroutine rdpath

!========================================================================================!

  function lowercase(s)
    implicit none
    character(len=*),intent(in) :: s
    character(len=:),allocatable :: sout
    character(len=:),allocatable :: lowerCase
    integer :: ic,i
    character(26),Parameter :: high = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
    character(26),Parameter :: low = 'abcdefghijklmnopqrstuvwxyz'
    sout = s
    do i = 1,LEN_TRIM(s)
      ic = INDEX(high,s(i:i))
      if (ic > 0) sout(i:i) = low(ic:ic)
    end do
    call move_alloc(sout,lowerCase)
  end function lowercase

!========================================================================================!

end module solvation_solv_util

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!================================================================================!
module gfn0_occ
  use iso_fortran_env,only:wp => real64,stdout => output_unit,stderr => error_unit

  use gfn0_types
  use gfn0_parameter
  use gfn0_basisset
  use wfn_module
  use gfn0_qm
  use gfn0_math_wrapper,only:contract
  implicit none
  private

  !> from this module
  public :: gfn0_eht_occ
  public :: generate_config

  !> privat params
  real(wp),private,parameter :: autoev = 27.21138505_wp
  real(wp),private,parameter :: evtoau = 1.0_wp / autoev

contains

!========================================================================================!

  subroutine gfn0_eht_occ(nat,at,xyz,occ,xtbData,basis,cn,dcndr,qat,dqdr, &
     &                wfn,eel,gradient,fail)
!> subroutine gfn0_eht_occ
!> Set up the H0 hamiltonian and overlap,
!> and from that get the "QM" part of the energy
!> Takes an occupation matrix as input and can calculate
!> the energy for given occupations
!> No Fermi smearing is conducted!
    !> INPUT
    type(TBasisset),intent(in)   :: basis
    type(TxTBData_mod),intent(in) :: xtbData
    type(Twavefunction),intent(inout) :: wfn
    integer,intent(in) :: nat
    integer,intent(in) :: at(nat)
    real(wp),intent(in) :: xyz(3,nat)
    real(wp),intent(in) :: occ(basis%nao)
    real(wp),intent(in) :: cn(:)
    real(wp),intent(in) :: dcndr(:,:,:)
    real(wp),intent(in) :: qat(:)
    real(wp),intent(in) :: dqdr(:,:,:)
    !> OUTPUT
    real(wp),intent(out) :: eel
    real(wp),intent(inout) :: gradient(3,nat)
    logical,intent(out)  :: fail

    !> LOCAL
    integer :: i,j,k
    real(wp) :: intcut,scfconv
    real(wp) :: et,efa,efb,nfoda,nfodb,ga,gb
    integer :: maxshell,nao,naop
    real(wp),allocatable :: selfEnergy(:,:)
    real(wp),allocatable :: dSEdcn(:,:)
    real(wp),allocatable :: dSEdq(:,:)
    real(wp),allocatable :: S(:,:)
    real(wp),allocatable :: H0(:)
    real(wp),allocatable :: dHdcn(:)
    real(wp),allocatable :: dHdq(:)
    real(wp),allocatable :: Pew(:,:)
    real(wp),allocatable :: tmp(:)

    eel = 0.0_wp
    fail = .false.

    !>---  Numerical stuff and cutoffs
    intcut = 25.0_wp - 10.0_wp * log10(xtbData%acc)
    intcut = max(20.0_wp,intcut)
    scfconv = 1.e-6_wp * xtbData%acc

    !>--- allocation
    nao = basis%nao
    naop = basis%nao * (basis%nao + 1) / 2
    allocate (H0(naop),source=0.0_wp)
    allocate (S(nao,nao),source=0.0_wp)
    maxshell = maxval(xtbData%nshell)
    allocate (selfEnergy(maxshell,nat),source=0.0_wp)
    allocate (dSEdcn(maxshell,nat),source=0.0_wp)
    allocate (dSEdq(maxshell,nat),source=0.0_wp)

    et = xtbData%etemp
    wfn%q = qat

    !>--- Setup, AO integrals of S and H0
    call getSelfEnergy(xtbData%hamiltonian,xtbData%nShell,at,cn,wfn%q, &
       & selfEnergy,dSEdcn,dSEdq)
    call build_SH0(xtbData%nShell,xtbData%hamiltonian,selfEnergy, &
          & nat,at,basis,nao,xyz,intcut,S,H0)
    if(allocated(wfn%S)) wfn%S = S

    !>--- Diagonalization
    call solve(nao,H0,S,wfn%C,wfn%P,wfn%emo,fail)
    if (fail) return

!==========! GRADIENT(S) !=========!
    allocate (dHdcn(nat),dHdq(nat),pew(nao,nao),tmp(nao), source=0.0_wp)

      !>--- setup
      dHdcn = 0.0_wp
      dHdq = 0.0_wp
      tmp(:) = occ(:)

      !>--- No Fermi Smearing this time!
      call dmat(nao,tmp,wfn%C,wfn%P)
      eel = sum(tmp * wfn%emo) * evtoau

      !> setup energy weighted density matrix = Pew for gradient calculation
      tmp(:) = occ(:) * wfn%emo * evtoau
      Pew = 0.0_wp
      call dmat(nao,tmp,wfn%C,Pew)
      call build_dSH0(xtbData%nShell,xtbData%hamiltonian,selfEnergy, &
          & dSEdcn,dSEdq,nat,basis,intcut,nao,at,xyz, &
          & wfn%P,Pew,gradient,dHdcn,dHdq)

      !>--- Gradient Contraction
      call contract(dcndr,dhdcn,gradient,beta=1.0_wp)
      call contract(dqdr,dhdq,gradient,beta=1.0_wp)

    !>--- deallocation
    deallocate (tmp,Pew,dHdcn,dHdq)
    deallocate (dSEdq,dSEdcn,selfEnergy)
    deallocate (S,H0)

    return
  end subroutine gfn0_eht_occ
!========================================================================================!

  subroutine generate_config(nel,nao,occ,active)
    implicit none
    !> INPUT
    integer,intent(in) :: nel
    integer,intent(in) :: nao
    integer,intent(in) :: active(:)
    !> OUTPUT
    real(wp),intent(out) :: occ(nao)
    !> LOCAL
    integer :: i,l,dl
    integer :: nel_active,dnel

    occ = 0.0_wp

    l = size(active,1)
    nel_active = sum(active)

    if ((nel_active > nel) .or. (l > nao)) then
      error stop 'error in generate_config()'
    end if
 
    do i=1,l
      if((active(i) > 2) .or. (active(i)<0))then
       write (stderr,*) 'error in generate_config()'
       write (stderr,*) 'unphysical occupation in ',i
       error stop
      endif
    enddo


    dnel = nel - nel_active
    if (MOD(dnel,2) .ne. 0) then
      write (stderr,*) 'error in generate_config()'
      write (stderr,*) 'mismatching number of electrons'
      error stop
    end if

    dl = dnel / 2
    if ((dl + l) > nao) then
      error stop 'error in generate_config()'
    end if
    !>--- fill doubly occupied levels first
    do i = 1,dl
      occ(i) = 2.0_wp
    end do
    !>--- add the active (user-set) configuration
    do i = dl + 1,dl + l
      occ(i) = float(active(i - dl))
    end do

  end subroutine generate_config

!========================================================================================!
end module gfn0_occ

!================================================================================!
! This file is part of gfn0.
!
! Copyright (C) 2022-2023 Philipp Pracht
!
! gfn0 is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! gfn0 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with gfn0.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------!
!> The original (unmodified) source code can be found under the GNU LGPL 3.0 license
!> Copyright (C) 2019-2020 Sebastian Ehlert
!> at https://github.com/grimme-lab/xtb
!================================================================================!
module gfn0_types
!> Types for storing xTB method parametrization data
   use iso_fortran_env, only : wp=>real64
   implicit none
   private

   public :: TxTBData_mod,TxTBParameter
   public :: TRepulsionData, TCoulombData, THamiltonianData
   public :: TDispersionData,TShortRangeData
   public :: newData, getData
   public :: gfn0_partials

   interface newData
      module procedure :: newAtomicData
      module procedure :: newShellData
   end interface newData


   interface getData
      module procedure :: getAtomicData
      module procedure :: getShellData
   end interface getData

!========================================================================================!

   !> Data for the repulsion contribution
   type :: TRepulsionData

      !> Repulsion exponent for heavy elements
      real(wp) :: kExp

      !> Repulsion exponent for light elements
      real(wp) :: kExpLight

      !> Repulsion exponent
      real(wp) :: rExp

      !> Electronegativity scaling of repulsion
      real(wp) :: enScale

      !> Exponents of repulsion term
      real(wp), allocatable :: alpha(:)

      !> Effective nuclear charge
      real(wp), allocatable :: zeff(:)

      !> Electronegativitity for scaling of repulsion
      real(wp), allocatable :: electronegativity(:)

      !> FIXME: real space cutoff should not be part of data
      real(wp) :: cutoff

   end type TRepulsionData

!========================================================================================!

   !> Data for the evaluation of the xTB core Hamiltonian
   type :: THamiltonianData

      !> Scaling factors for different interacting shells
      real(wp) :: kScale(0:3, 0:3)

      !> Scaling factor for diffuse or polarisation function
      real(wp) :: kDiff

      !> Shell dependence of the EN polynom
      real(wp) :: enScale(0:3, 0:3)

      !> Quartic contribution to EN polynom
      real(wp) :: enscale4

      !> Exponent for shell exponent weighting
      real(wp) :: wExp

      !> Principal quantum number of each shell
      integer, allocatable :: principalQuantumNumber(:, :)

      !> Angular momentum of each shell
      integer, allocatable :: angShell(:, :)

      !> Valence character of each shell
      integer, allocatable :: valenceShell(:, :)

      !> Number of primitives for expansion of Slater functions
      integer, allocatable :: numberOfPrimitives(:, :)

      !> Exponent of the Slater function
      real(wp), allocatable :: slaterExponent(:, :)

      !> Atomic level information
      real(wp), allocatable :: selfEnergy(:, :)

      !> Reference occupation of the atom
      real(wp), allocatable :: referenceOcc(:, :)

      !> Coordination number dependence of the atomic levels
      real(wp), allocatable :: kCN(:, :)

      !> Electronegativity used in the shell polynomials
      real(wp), allocatable :: electronegativity(:)

      !> Atomic radii used in the shell polynomials
      real(wp), allocatable :: atomicRad(:)

      !> Shell polynomials to scale Hamiltonian elements
      real(wp), allocatable :: shellPoly(:, :)

      !> Pair parameters to scale Hamiltonian elements
      real(wp), allocatable :: pairParam(:, :)

      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kQShell(:, :)

      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kQAtom(:)

   end type THamiltonianData

!========================================================================================!

   !> Data for the evalutation of the Coulomb interactions
   type :: TCoulombData

      !> Use electronegativity equlibration for reference density
      logical :: enEquilibration

      !> Include second order electrostatics
      logical :: secondOrder

      !> Include third order electrostatics
      logical :: thirdOrder

      !> Third order electrostatics is shell resolved
      logical :: shellResolved

      !> Exponent of the generalized gamma function
      real(wp) :: gExp

      !> Atomic hardnesses used in second order electrostatics
      real(wp), allocatable :: chemicalHardness(:)

      !> Scaling factors for shell electrostatics
      real(wp), allocatable :: shellHardness(:, :)

      !> Third order Hubbard derivatives
      real(wp), allocatable :: thirdOrderAtom(:)

      !> Shell resolved third order Hubbard derivatives
      real(wp), allocatable :: thirdOrderShell(:, :)

      !> Charge widths for EEQ model
      real(wp), allocatable :: chargeWidth(:)

      !> Electronegativity for EEQ model
      real(wp), allocatable :: electronegativity(:)

      !> Coordination number dependence of the EN
      real(wp), allocatable :: kCN(:)

   end type TCoulombData

!========================================================================================!
   !> Data for the dispersion contribution
   type :: TDispersionData

      !> Damping parameters
      real(wp) :: s6  = 1.0_wp
      real(wp) :: s8  = 0.0_wp
      real(wp) :: s10 = 0.0_wp
      real(wp) :: a1  = 0.0_wp
      real(wp) :: a2  = 0.0_wp
      real(wp) :: s9  = 0.0_wp
      integer  :: alp = 16

      !> Weighting factor for Gaussian interpolation
      real(wp) :: wf

      !> Charge steepness
      real(wp) :: g_a

      !> Charge height
      real(wp) :: g_c

      !> Reference data for the dispersion
      integer, allocatable :: atoms(:)
      integer, allocatable :: nref(:)
      integer, allocatable :: ncount(:, :)
      real(wp), allocatable :: cn(:, :)
      real(wp), allocatable :: q(:, :)
      real(wp), allocatable :: alpha(:, :, :)
      real(wp), allocatable :: c6(:, :, :, :)

   end type TDispersionData

!========================================================================================!
   !> Short range basis correction
   type TShortRangeData

      !> Additional offset for the reference bond lengths
      real(wp) :: shift

      !> Scaling factor for the energy contribution
      real(wp) :: prefactor

      !> Steepness of the EN dependence
      real(wp) :: steepness

      !> Scaling factor for electronegativity differences
      real(wp) :: enScale

   end type TShortRangeData


!========================================================================================!

   !> Parametrisation data for the xTB method
   type :: TxTBData_mod

      !> Name of the parametrisation
      character(len=:), allocatable :: name

      !> Reference to the publication
      character(len=:), allocatable :: doi

      !> Internal version number
      integer :: level

      !> accuaracy selection
      real(wp) :: acc = 1.0_wp

      !> electronic temperature
      real(wp) :: etemp = 300.0_wp

      !> Number of shells
      integer, allocatable :: nShell(:)

      !> Parametrisation data for repulsive interactions
      type(TRepulsionData) :: repulsion

      !> Parametrisation data for core Hamiltonian
      type(THamiltonianData) :: hamiltonian

      !> Parametrisation data for Coulombic interactions
      type(TCoulombData) :: coulomb

      !> Parametrization for Dispersion interactions
      type(TDispersionData) :: dispersion

      !> Parametrisation data for the short range basis correction (optional)
      type(TShortRangeData), allocatable :: srb

   contains

      !> Write informative printout for the parametrisation data
      procedure :: writeInfo

   end type TxTBData_mod

!========================================================================================!

   !> global default parameter data
   type :: TxTBParameter
      real(wp) :: kshell(0:3) = 0.0_wp
      real(wp) :: ksp = 0.0_wp
      real(wp) :: ksd = 0.0_wp
      real(wp) :: kpd = 0.0_wp
      real(wp) :: kdiff = 0.0_wp
      real(wp) :: kdiffa = 0.0_wp
      real(wp) :: kdiffb = 0.0_wp
      real(wp) :: enshell(0:3) = 0.0_wp
      real(wp) :: enscale4 = 0.0_wp
      real(wp) :: cnshell(2, 0:3) = 0.0_wp
      real(wp) :: gam3shell(2, 0:3) = 0.0_wp
      real(wp) :: srbshift = 0.0_wp
      real(wp) :: srbpre = 0.0_wp
      real(wp) :: srbexp = 0.0_wp
      real(wp) :: srbken = 0.0_wp
      real(wp) :: wllscal = 0.0_wp
      real(wp) :: gscal = 0.0_wp
      real(wp) :: zcnf = 0.0_wp
      real(wp) :: tscal = 0.0_wp
      real(wp) :: kcn = 0.0_wp
      real(wp) :: fpol = 0.0_wp
      real(wp) :: ken = 0.0_wp
      real(wp) :: lshift = 0.0_wp
      real(wp) :: lshifta = 0.0_wp
      real(wp) :: split = 0.0_wp
      real(wp) :: zqf = 0.0_wp
      real(wp) :: alphaj = 0.0_wp
      real(wp) :: kexpo = 0.0_wp
      real(wp) :: dispa = 0.0_wp
      real(wp) :: dispb = 0.0_wp
      real(wp) :: dispc = 0.0_wp
      real(wp) :: dispatm = 0.0_wp
      real(wp) :: xbdamp = 0.0_wp
      real(wp) :: xbrad = 0.0_wp
      real(wp) :: aesshift = 0.0_wp
      real(wp) :: aesexp = 0.0_wp
      real(wp) :: aesrmax = 0.0_wp
      real(wp) :: aesdmp3 = 0.0_wp
      real(wp) :: aesdmp5 = 0.0_wp
      real(wp) :: ipeashift = 0.0_wp
      real(wp) :: renscale = 0.0_wp
   end type TxTBParameter

!========================================================================================!
   type :: gfn0_partials
    real(wp),allocatable :: cn(:)
    real(wp),allocatable :: dcndr(:,:,:)
    real(wp),allocatable :: qat(:)
    real(wp),allocatable :: dqdr(:,:,:)
    real(wp),allocatable :: selfEnergy(:,:)
    real(wp),allocatable :: dSEdcn(:,:)
    real(wp),allocatable :: dSEdq(:,:)
   end type gfn0_partials 

!========================================================================================!

contains
!========================================================================================!
!========================================================================================!

subroutine writeInfo(self, unit, num)

   !> Instance of the parametrisation data
   class(TxTBData_mod), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Atomic numbers
   integer, intent(in), optional :: num(:)

   character(len=*), parameter :: rnum = '(f12.6)'
   character(len=*), parameter :: offset = '(8x)'
   character(len=*), parameter :: head = '(6x,"*",1x,a,":")'
   character(len=*), parameter :: rfmt = '('//offset//',a,t36,'//rnum//')'
   character(len=*), parameter :: afmt = '('//offset//',a,t36,4x,a)'
   character(len=:), allocatable :: name
   integer :: ii, jj

   write(unit, '(a)')
   if (allocated(self%name)) then
      allocate(character(len=2*len(self%name)-1) :: name)
      name = repeat(' ', len(name))
      do ii = 1, len(self%name)
         jj = 2*ii-1
         name(jj:jj) = self%name(ii:ii)
      end do
   else
      name = repeat(' ', 10)
      write(name, '(i0)') self%level
      name = 'xTB level '//trim(name)
   end if
   call generic_header(unit, name, 49, 10)

   write(unit, '(a)')
   if (allocated(self%doi)) then
      write(unit, afmt) "Reference", self%doi
   end if

   write(unit, head) "Hamiltonian"
   write(unit, rfmt, advance='no') "H0-scaling (s, p, d)"
   do ii = 0, 2
      write(unit, rnum, advance='no') self%hamiltonian%kScale(ii, ii)
   end do
   write(unit, '(a)')
   write(unit, rfmt) "zeta-weighting", self%hamiltonian%wExp

   write(unit, head) "Dispersion"
   write(unit, rfmt) "s8", self%dispersion%s8
   write(unit, rfmt) "a1", self%dispersion%a1
   write(unit, rfmt) "a2", self%dispersion%a2
   write(unit, rfmt) "s9", self%dispersion%s9

   write(unit, head) "Repulsion"
   write(unit, rfmt, advance='no') "kExp", self%repulsion%kExp
   if (self%repulsion%kExpLight /= self%repulsion%kExp) then
      write(unit, rnum, advance='no') self%repulsion%kExpLight
   end if
   write(unit, '(a)')
   write(unit, rfmt) "rExp", self%repulsion%rExp

   write(unit, head) "Coulomb"
   write(unit, rfmt) "alpha", self%coulomb%gExp
   if (allocated(self%coulomb%thirdOrderShell)) then
      write(unit, afmt) "third order", "shell-resolved"
   else if (allocated(self%coulomb%thirdOrderAtom)) then
      write(unit, afmt) "third order", "atomic"
   else
      write(unit, afmt) "third order", "false"
   end if

   if (allocated(self%srb)) then
      write(unit, head) "Polar bond correction"
      write(unit, rfmt) "rad-shift", self%srb%shift
      write(unit, rfmt) "strength", self%srb%prefactor
      write(unit, rfmt) "en-exp", self%srb%steepness
      write(unit, rfmt) "en-scale", self%srb%enScale
   end if

   write(unit, '(a)')

contains
   subroutine generic_header(iunit,string,width,offset)
   implicit none
   integer,intent(in) :: iunit
   integer,intent(in) :: offset
   integer,intent(in) :: width
   character(len=*),intent(in) :: string
   character(len=width) :: dum1,dum2
   character(len=2*width) :: outstring
   character(len=width) :: formatstr
   integer :: strlen,ifront,iback
   strlen = len(string)
   ifront = (width - strlen)/2
   iback  = width - ifront - strlen
   write(dum1,*) width
   write(dum2,*) offset
   write(formatstr,'(i0,"x,a,",i0,"x")') ifront,iback
   write(outstring,'("|",'//formatstr//',"|")') string
   write(iunit,'('//dum2//'x,1x,'//dum1//'("-"),1x)')
   write(iunit,'('//dum2//'x,a)') trim(outstring)
   write(iunit,'('//dum2//'x,1x,'//dum1//'("-"),1x)')
   end subroutine generic_header
end subroutine writeInfo


subroutine newAtomicData(vec, num, data)

   real(wp), allocatable, intent(out) :: vec(:)

   integer, intent(in) :: num(:)

   real(wp), intent(in) :: data(:)

   allocate(vec(size(num)))
   call getAtomicData(vec, num, data)

end subroutine newAtomicData


subroutine getAtomicData(vec, num, data)

   real(wp), intent(out) :: vec(:)

   integer, intent(in) :: num(:)

   real(wp), intent(in) :: data(:)

   integer :: ii, izp

   do ii = 1, size(vec, dim=1)
      izp = num(ii)
      vec(ii) = data(izp)
   end do

end subroutine getAtomicData


subroutine newShellData(vec, num, nshell, data)

   real(wp), allocatable, intent(out) :: vec(:, :)

   integer, intent(in) :: num(:)

   integer, intent(in) :: nshell(:)

   real(wp), intent(in) :: data(:, :)

   allocate(vec(maxval(nshell), size(num)))
   call getShellData(vec, num, nshell, data)

end subroutine newShellData


subroutine getShellData(vec, num, nshell, data)

   real(wp), intent(out) :: vec(:, :)

   integer, intent(in) :: num(:)

   integer, intent(in) :: nshell(:)

   real(wp), intent(in) :: data(:, :)

   integer :: ii, ish, izp

   vec(:, :) = 0.0_wp
   do ii = 1, size(vec, dim=2)
      izp = num(ii)
      do ish = 1, nshell(izp)
         vec(ish, ii) = data(ish, izp)
      end do
   end do

end subroutine getShellData


end module gfn0_types
